/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this. Coverage indexes are emitted as 4 bytes,
  // COVERAGE_IDX_VAL handles this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  #define COVERAGE_IDX_VAL(X) X & 255, (unsigned(X) >> 8) & 255, (unsigned(X) >> 16) & 255, (unsigned(X) >> 24) & 255
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*123 cases */, 5|128,10/*1285*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1290
/*     5*/  OPC_Scope, 121|128,9/*1273*/, /*->1281*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0,  // 0 #6
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0,  // 0 #6
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0,  // 0 #6
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0,  // 0 #6
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0,  // 0 #6
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0,  // 0 #6
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0,  // 0 #5
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0,  // 0 #5
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0,  // 0 #5
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0,  // 0 #5
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0,  // 0 #5
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0,  // 0 #5
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0,  // 0 #5
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0,  // 0 #5
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0,  // 0 #5
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0,  // 0 #5
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0,  // 0 #5
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0,  // 0 #5
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0,  // 0 #5
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0,  // 0 #5
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0,  // 0 #5
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0,  // 0 #5
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0,  // 0 #5
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0,  // 0 #5
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0,  // 0 #5
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0,  // 0 #5
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0,  // 0 #5
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0,  // 0 #5
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0,  // 0 #5
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0,  // 0 #5
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0,  // 0 #5
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0,  // 0 #5
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0,  // 0 #5
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0,  // 0 #5
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0,  // 0 #5
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0,  // 0 #5
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0,  // 0 #5
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0,  // 0 #5
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0,  // 0 #5
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 81|128,1/*209*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1280
/*  1071*/    OPC_RecordMemRef,
/*  1072*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1073*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1074*/    OPC_Scope, 101, /*->1177*/ // 2 children in Scope
/*  1076*/     OPC_CheckChild1TypeI32,
/*  1077*/     OPC_Scope, 19, /*->1098*/ // 5 children in Scope
/*  1079*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  1081*/      OPC_CheckPredicate1,  // Predicate_atomic_load_aext_8
/*  1082*/      OPC_MoveParent,
/*  1083*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1084*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1086*/      OPC_EmitMergeInputChains1_0,
/*  1087*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1089*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1098*/     /*Scope*/ 19, /*->1118*/
/*  1099*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  1101*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  1102*/      OPC_MoveParent,
/*  1103*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1104*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1106*/      OPC_EmitMergeInputChains1_0,
/*  1107*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1109*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1118*/     /*Scope*/ 19, /*->1138*/
/*  1119*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  1121*/      OPC_CheckPredicate2,  // Predicate_atomic_load_aext_16
/*  1122*/      OPC_MoveParent,
/*  1123*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1124*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1126*/      OPC_EmitMergeInputChains1_0,
/*  1127*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1129*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1138*/     /*Scope*/ 19, /*->1158*/
/*  1139*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  1141*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  1142*/      OPC_MoveParent,
/*  1143*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1144*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1146*/      OPC_EmitMergeInputChains1_0,
/*  1147*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1149*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1158*/     /*Scope*/ 17, /*->1176*/
/*  1159*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1160*/      OPC_MoveParent,
/*  1161*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1162*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1164*/      OPC_EmitMergeInputChains1_0,
/*  1165*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1176*/     0, /*End of Scope*/
/*  1177*/    /*Scope*/ 101, /*->1279*/
/*  1178*/     OPC_CheckChild1TypeI64,
/*  1179*/     OPC_Scope, 19, /*->1200*/ // 5 children in Scope
/*  1181*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  1183*/      OPC_CheckPredicate1,  // Predicate_atomic_load_aext_8
/*  1184*/      OPC_MoveParent,
/*  1185*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1186*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1188*/      OPC_EmitMergeInputChains1_0,
/*  1189*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1191*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1200*/     /*Scope*/ 19, /*->1220*/
/*  1201*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  1203*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  1204*/      OPC_MoveParent,
/*  1205*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1206*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1208*/      OPC_EmitMergeInputChains1_0,
/*  1209*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1211*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1220*/     /*Scope*/ 19, /*->1240*/
/*  1221*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  1223*/      OPC_CheckPredicate2,  // Predicate_atomic_load_aext_16
/*  1224*/      OPC_MoveParent,
/*  1225*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1226*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1228*/      OPC_EmitMergeInputChains1_0,
/*  1229*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1231*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1240*/     /*Scope*/ 19, /*->1260*/
/*  1241*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  1243*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  1244*/      OPC_MoveParent,
/*  1245*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1246*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1248*/      OPC_EmitMergeInputChains1_0,
/*  1249*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1251*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1260*/     /*Scope*/ 17, /*->1278*/
/*  1261*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1262*/      OPC_MoveParent,
/*  1263*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1264*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1266*/      OPC_EmitMergeInputChains1_0,
/*  1267*/      OPC_EmitInteger32, 0,  // 0 #4
/*  1269*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    0, /*End of Scope*/
/*  1280*/   0, // EndSwitchOpcode
/*  1281*/  /*Scope*/ 7, /*->1289*/
/*  1282*/   OPC_RecordChild0, // #0 = $src
/*  1283*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1289*/  0, /*End of Scope*/
/*  1290*/ /*SwitchOpcode*/ 47|128,7/*943*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2237
/*  1294*/  OPC_Scope, 35|128,7/*931*/, /*->2228*/ // 2 children in Scope
/*  1297*/   OPC_MoveChild0,
/*  1298*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1426
/*  1302*/    OPC_MoveChild0,
/*  1303*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1306*/    OPC_RecordMemRef,
/*  1307*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1308*/    OPC_CheckFoldableChainNode,
/*  1309*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1310*/    OPC_Scope, 56, /*->1368*/ // 2 children in Scope
/*  1312*/     OPC_CheckChild1TypeI32,
/*  1313*/     OPC_MoveChild2,
/*  1314*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1317*/     OPC_RecordChild0, // #2 = $exp
/*  1318*/     OPC_MoveSibling3,
/*  1319*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1322*/     OPC_RecordChild0, // #3 = $new
/*  1323*/     OPC_MoveParent,
/*  1324*/     OPC_Scope, 20, /*->1346*/ // 2 children in Scope
/*  1326*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1327*/      OPC_MoveParent,
/*  1328*/      OPC_MoveParent,
/*  1329*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1330*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1332*/      OPC_EmitMergeInputChains1_0,
/*  1333*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1335*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1346*/     /*Scope*/ 20, /*->1367*/
/*  1347*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1348*/      OPC_MoveParent,
/*  1349*/      OPC_MoveParent,
/*  1350*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1351*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1353*/      OPC_EmitMergeInputChains1_0,
/*  1354*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1356*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1367*/     0, /*End of Scope*/
/*  1368*/    /*Scope*/ 56, /*->1425*/
/*  1369*/     OPC_CheckChild1TypeI64,
/*  1370*/     OPC_MoveChild2,
/*  1371*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1374*/     OPC_RecordChild0, // #2 = $exp
/*  1375*/     OPC_MoveSibling3,
/*  1376*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1379*/     OPC_RecordChild0, // #3 = $new
/*  1380*/     OPC_MoveParent,
/*  1381*/     OPC_Scope, 20, /*->1403*/ // 2 children in Scope
/*  1383*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1384*/      OPC_MoveParent,
/*  1385*/      OPC_MoveParent,
/*  1386*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1387*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1389*/      OPC_EmitMergeInputChains1_0,
/*  1390*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1392*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1403*/     /*Scope*/ 20, /*->1424*/
/*  1404*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1405*/      OPC_MoveParent,
/*  1406*/      OPC_MoveParent,
/*  1407*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1408*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1410*/      OPC_EmitMergeInputChains1_0,
/*  1411*/      OPC_EmitInteger32, 0,  // 0 #6
/*  1413*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1424*/     0, /*End of Scope*/
/*  1425*/    0, /*End of Scope*/
/*  1426*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1530
/*  1429*/    OPC_RecordMemRef,
/*  1430*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1431*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1432*/    OPC_Scope, 47, /*->1481*/ // 2 children in Scope
/*  1434*/     OPC_CheckChild1TypeI32,
/*  1435*/     OPC_MoveChild2,
/*  1436*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1439*/     OPC_RecordChild0, // #2 = $val
/*  1440*/     OPC_MoveParent,
/*  1441*/     OPC_Scope, 18, /*->1461*/ // 2 children in Scope
/*  1443*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1444*/      OPC_MoveParent,
/*  1445*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1446*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1448*/      OPC_EmitMergeInputChains1_0,
/*  1449*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1451*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1461*/     /*Scope*/ 18, /*->1480*/
/*  1462*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1463*/      OPC_MoveParent,
/*  1464*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1465*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1467*/      OPC_EmitMergeInputChains1_0,
/*  1468*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1470*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1480*/     0, /*End of Scope*/
/*  1481*/    /*Scope*/ 47, /*->1529*/
/*  1482*/     OPC_CheckChild1TypeI64,
/*  1483*/     OPC_MoveChild2,
/*  1484*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1487*/     OPC_RecordChild0, // #2 = $val
/*  1488*/     OPC_MoveParent,
/*  1489*/     OPC_Scope, 18, /*->1509*/ // 2 children in Scope
/*  1491*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1492*/      OPC_MoveParent,
/*  1493*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1494*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1496*/      OPC_EmitMergeInputChains1_0,
/*  1497*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1499*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1509*/     /*Scope*/ 18, /*->1528*/
/*  1510*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1511*/      OPC_MoveParent,
/*  1512*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1513*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1515*/      OPC_EmitMergeInputChains1_0,
/*  1516*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1518*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1528*/     0, /*End of Scope*/
/*  1529*/    0, /*End of Scope*/
/*  1530*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1634
/*  1533*/    OPC_RecordMemRef,
/*  1534*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1535*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1536*/    OPC_Scope, 47, /*->1585*/ // 2 children in Scope
/*  1538*/     OPC_CheckChild1TypeI32,
/*  1539*/     OPC_MoveChild2,
/*  1540*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1543*/     OPC_RecordChild0, // #2 = $val
/*  1544*/     OPC_MoveParent,
/*  1545*/     OPC_Scope, 18, /*->1565*/ // 2 children in Scope
/*  1547*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1548*/      OPC_MoveParent,
/*  1549*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1550*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1552*/      OPC_EmitMergeInputChains1_0,
/*  1553*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1555*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1565*/     /*Scope*/ 18, /*->1584*/
/*  1566*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1567*/      OPC_MoveParent,
/*  1568*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1569*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1571*/      OPC_EmitMergeInputChains1_0,
/*  1572*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1574*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1584*/     0, /*End of Scope*/
/*  1585*/    /*Scope*/ 47, /*->1633*/
/*  1586*/     OPC_CheckChild1TypeI64,
/*  1587*/     OPC_MoveChild2,
/*  1588*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1591*/     OPC_RecordChild0, // #2 = $val
/*  1592*/     OPC_MoveParent,
/*  1593*/     OPC_Scope, 18, /*->1613*/ // 2 children in Scope
/*  1595*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1596*/      OPC_MoveParent,
/*  1597*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1598*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1600*/      OPC_EmitMergeInputChains1_0,
/*  1601*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1603*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1613*/     /*Scope*/ 18, /*->1632*/
/*  1614*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1615*/      OPC_MoveParent,
/*  1616*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1617*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1619*/      OPC_EmitMergeInputChains1_0,
/*  1620*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1622*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1632*/     0, /*End of Scope*/
/*  1633*/    0, /*End of Scope*/
/*  1634*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1738
/*  1637*/    OPC_RecordMemRef,
/*  1638*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1639*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1640*/    OPC_Scope, 47, /*->1689*/ // 2 children in Scope
/*  1642*/     OPC_CheckChild1TypeI32,
/*  1643*/     OPC_MoveChild2,
/*  1644*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1647*/     OPC_RecordChild0, // #2 = $val
/*  1648*/     OPC_MoveParent,
/*  1649*/     OPC_Scope, 18, /*->1669*/ // 2 children in Scope
/*  1651*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1652*/      OPC_MoveParent,
/*  1653*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1654*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1656*/      OPC_EmitMergeInputChains1_0,
/*  1657*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1659*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1669*/     /*Scope*/ 18, /*->1688*/
/*  1670*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1671*/      OPC_MoveParent,
/*  1672*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1673*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1675*/      OPC_EmitMergeInputChains1_0,
/*  1676*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1678*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1688*/     0, /*End of Scope*/
/*  1689*/    /*Scope*/ 47, /*->1737*/
/*  1690*/     OPC_CheckChild1TypeI64,
/*  1691*/     OPC_MoveChild2,
/*  1692*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1695*/     OPC_RecordChild0, // #2 = $val
/*  1696*/     OPC_MoveParent,
/*  1697*/     OPC_Scope, 18, /*->1717*/ // 2 children in Scope
/*  1699*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1700*/      OPC_MoveParent,
/*  1701*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1702*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1704*/      OPC_EmitMergeInputChains1_0,
/*  1705*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1717*/     /*Scope*/ 18, /*->1736*/
/*  1718*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1719*/      OPC_MoveParent,
/*  1720*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1721*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1723*/      OPC_EmitMergeInputChains1_0,
/*  1724*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1726*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1736*/     0, /*End of Scope*/
/*  1737*/    0, /*End of Scope*/
/*  1738*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1842
/*  1741*/    OPC_RecordMemRef,
/*  1742*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1743*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1744*/    OPC_Scope, 47, /*->1793*/ // 2 children in Scope
/*  1746*/     OPC_CheckChild1TypeI32,
/*  1747*/     OPC_MoveChild2,
/*  1748*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1751*/     OPC_RecordChild0, // #2 = $val
/*  1752*/     OPC_MoveParent,
/*  1753*/     OPC_Scope, 18, /*->1773*/ // 2 children in Scope
/*  1755*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1756*/      OPC_MoveParent,
/*  1757*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1758*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1760*/      OPC_EmitMergeInputChains1_0,
/*  1761*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1763*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1773*/     /*Scope*/ 18, /*->1792*/
/*  1774*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1775*/      OPC_MoveParent,
/*  1776*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1777*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1779*/      OPC_EmitMergeInputChains1_0,
/*  1780*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1782*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1792*/     0, /*End of Scope*/
/*  1793*/    /*Scope*/ 47, /*->1841*/
/*  1794*/     OPC_CheckChild1TypeI64,
/*  1795*/     OPC_MoveChild2,
/*  1796*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1799*/     OPC_RecordChild0, // #2 = $val
/*  1800*/     OPC_MoveParent,
/*  1801*/     OPC_Scope, 18, /*->1821*/ // 2 children in Scope
/*  1803*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1804*/      OPC_MoveParent,
/*  1805*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1806*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1808*/      OPC_EmitMergeInputChains1_0,
/*  1809*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1811*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1821*/     /*Scope*/ 18, /*->1840*/
/*  1822*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1823*/      OPC_MoveParent,
/*  1824*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1825*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1827*/      OPC_EmitMergeInputChains1_0,
/*  1828*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1830*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1840*/     0, /*End of Scope*/
/*  1841*/    0, /*End of Scope*/
/*  1842*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1946
/*  1845*/    OPC_RecordMemRef,
/*  1846*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1847*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1848*/    OPC_Scope, 47, /*->1897*/ // 2 children in Scope
/*  1850*/     OPC_CheckChild1TypeI32,
/*  1851*/     OPC_MoveChild2,
/*  1852*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1855*/     OPC_RecordChild0, // #2 = $val
/*  1856*/     OPC_MoveParent,
/*  1857*/     OPC_Scope, 18, /*->1877*/ // 2 children in Scope
/*  1859*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1860*/      OPC_MoveParent,
/*  1861*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1862*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1864*/      OPC_EmitMergeInputChains1_0,
/*  1865*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1867*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1877*/     /*Scope*/ 18, /*->1896*/
/*  1878*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1879*/      OPC_MoveParent,
/*  1880*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1881*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1883*/      OPC_EmitMergeInputChains1_0,
/*  1884*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1886*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1896*/     0, /*End of Scope*/
/*  1897*/    /*Scope*/ 47, /*->1945*/
/*  1898*/     OPC_CheckChild1TypeI64,
/*  1899*/     OPC_MoveChild2,
/*  1900*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1903*/     OPC_RecordChild0, // #2 = $val
/*  1904*/     OPC_MoveParent,
/*  1905*/     OPC_Scope, 18, /*->1925*/ // 2 children in Scope
/*  1907*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1908*/      OPC_MoveParent,
/*  1909*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1910*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1912*/      OPC_EmitMergeInputChains1_0,
/*  1913*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1915*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1925*/     /*Scope*/ 18, /*->1944*/
/*  1926*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1927*/      OPC_MoveParent,
/*  1928*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1929*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1931*/      OPC_EmitMergeInputChains1_0,
/*  1932*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1934*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1944*/     0, /*End of Scope*/
/*  1945*/    0, /*End of Scope*/
/*  1946*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->2050
/*  1949*/    OPC_RecordMemRef,
/*  1950*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1951*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1952*/    OPC_Scope, 47, /*->2001*/ // 2 children in Scope
/*  1954*/     OPC_CheckChild1TypeI32,
/*  1955*/     OPC_MoveChild2,
/*  1956*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1959*/     OPC_RecordChild0, // #2 = $val
/*  1960*/     OPC_MoveParent,
/*  1961*/     OPC_Scope, 18, /*->1981*/ // 2 children in Scope
/*  1963*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1964*/      OPC_MoveParent,
/*  1965*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1966*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1968*/      OPC_EmitMergeInputChains1_0,
/*  1969*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1981*/     /*Scope*/ 18, /*->2000*/
/*  1982*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1983*/      OPC_MoveParent,
/*  1984*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1985*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1987*/      OPC_EmitMergeInputChains1_0,
/*  1988*/      OPC_EmitInteger32, 0,  // 0 #5
/*  1990*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  2000*/     0, /*End of Scope*/
/*  2001*/    /*Scope*/ 47, /*->2049*/
/*  2002*/     OPC_CheckChild1TypeI64,
/*  2003*/     OPC_MoveChild2,
/*  2004*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  2007*/     OPC_RecordChild0, // #2 = $val
/*  2008*/     OPC_MoveParent,
/*  2009*/     OPC_Scope, 18, /*->2029*/ // 2 children in Scope
/*  2011*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  2012*/      OPC_MoveParent,
/*  2013*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2014*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2016*/      OPC_EmitMergeInputChains1_0,
/*  2017*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2019*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2029*/     /*Scope*/ 18, /*->2048*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  2048*/     0, /*End of Scope*/
/*  2049*/    0, /*End of Scope*/
/*  2050*/   /*SwitchOpcode*/ 45|128,1/*173*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2227
/*  2054*/    OPC_RecordMemRef,
/*  2055*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  2056*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  2057*/    OPC_Scope, 83, /*->2142*/ // 2 children in Scope
/*  2059*/     OPC_CheckChild1TypeI32,
/*  2060*/     OPC_Scope, 19, /*->2081*/ // 4 children in Scope
/*  2062*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  2064*/      OPC_CheckPredicate1,  // Predicate_atomic_load_aext_8
/*  2065*/      OPC_MoveParent,
/*  2066*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2067*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2069*/      OPC_EmitMergeInputChains1_0,
/*  2070*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2072*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2081*/     /*Scope*/ 19, /*->2101*/
/*  2082*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  2084*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  2085*/      OPC_MoveParent,
/*  2086*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2087*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2089*/      OPC_EmitMergeInputChains1_0,
/*  2090*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2092*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2101*/     /*Scope*/ 19, /*->2121*/
/*  2102*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  2104*/      OPC_CheckPredicate2,  // Predicate_atomic_load_aext_16
/*  2105*/      OPC_MoveParent,
/*  2106*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2107*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2109*/      OPC_EmitMergeInputChains1_0,
/*  2110*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2112*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2121*/     /*Scope*/ 19, /*->2141*/
/*  2122*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  2124*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  2125*/      OPC_MoveParent,
/*  2126*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2127*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  2129*/      OPC_EmitMergeInputChains1_0,
/*  2130*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2132*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2141*/     0, /*End of Scope*/
/*  2142*/    /*Scope*/ 83, /*->2226*/
/*  2143*/     OPC_CheckChild1TypeI64,
/*  2144*/     OPC_Scope, 19, /*->2165*/ // 4 children in Scope
/*  2146*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  2148*/      OPC_CheckPredicate1,  // Predicate_atomic_load_aext_8
/*  2149*/      OPC_MoveParent,
/*  2150*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2151*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2153*/      OPC_EmitMergeInputChains1_0,
/*  2154*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2156*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2165*/     /*Scope*/ 19, /*->2185*/
/*  2166*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  2168*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  2169*/      OPC_MoveParent,
/*  2170*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2171*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2173*/      OPC_EmitMergeInputChains1_0,
/*  2174*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2176*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2185*/     /*Scope*/ 19, /*->2205*/
/*  2186*/      OPC_CheckPredicate, 15, // Predicate_atomic_load_aext
/*  2188*/      OPC_CheckPredicate2,  // Predicate_atomic_load_aext_16
/*  2189*/      OPC_MoveParent,
/*  2190*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2191*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2193*/      OPC_EmitMergeInputChains1_0,
/*  2194*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2196*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2205*/     /*Scope*/ 19, /*->2225*/
/*  2206*/      OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  2208*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  2209*/      OPC_MoveParent,
/*  2210*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2211*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2213*/      OPC_EmitMergeInputChains1_0,
/*  2214*/      OPC_EmitInteger32, 0,  // 0 #4
/*  2216*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2225*/     0, /*End of Scope*/
/*  2226*/    0, /*End of Scope*/
/*  2227*/   0, // EndSwitchOpcode
/*  2228*/  /*Scope*/ 7, /*->2236*/
/*  2229*/   OPC_RecordChild0, // #0 = $src
/*  2230*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2236*/  0, /*End of Scope*/
/*  2237*/ /*SwitchOpcode*/ 52|128,7/*948*/, TARGET_VAL(ISD::STORE),// ->3189
/*  2241*/  OPC_RecordMemRef,
/*  2242*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2243*/  OPC_Scope, 123|128,1/*251*/, /*->2497*/ // 2 children in Scope
/*  2246*/   OPC_MoveChild1,
/*  2247*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2250*/   OPC_RecordChild0, // #1 = $vec
/*  2251*/   OPC_Scope, 62, /*->2315*/ // 4 children in Scope
/*  2253*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  2255*/    OPC_RecordChild1, // #2 = $idx
/*  2256*/    OPC_MoveChild1,
/*  2257*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2260*/    OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/*  2262*/    OPC_CheckTypeI32,
/*  2263*/    OPC_MoveParent,
/*  2264*/    OPC_CheckTypeI32,
/*  2265*/    OPC_MoveParent,
/*  2266*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2267*/    OPC_Scope, 22, /*->2291*/ // 2 children in Scope
/*  2269*/     OPC_CheckChild2TypeI32,
/*  2270*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2271*/     OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2273*/     OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2274*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2275*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2277*/     OPC_EmitMergeInputChains1_0,
/*  2278*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2280*/     OPC_EmitConvertToTarget2, // #7
/*  2281*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2291*/    /*Scope*/ 22, /*->2314*/
/*  2292*/     OPC_CheckChild2TypeI64,
/*  2293*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2294*/     OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2296*/     OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2297*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2298*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2300*/     OPC_EmitMergeInputChains1_0,
/*  2301*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2303*/     OPC_EmitConvertToTarget2, // #7
/*  2304*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2314*/    0, /*End of Scope*/
/*  2315*/   /*Scope*/ 62, /*->2378*/
/*  2316*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  2318*/    OPC_RecordChild1, // #2 = $idx
/*  2319*/    OPC_MoveChild1,
/*  2320*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2323*/    OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/*  2325*/    OPC_CheckTypeI32,
/*  2326*/    OPC_MoveParent,
/*  2327*/    OPC_CheckTypeI32,
/*  2328*/    OPC_MoveParent,
/*  2329*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2330*/    OPC_Scope, 22, /*->2354*/ // 2 children in Scope
/*  2332*/     OPC_CheckChild2TypeI32,
/*  2333*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2334*/     OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2336*/     OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2337*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2338*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2340*/     OPC_EmitMergeInputChains1_0,
/*  2341*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2343*/     OPC_EmitConvertToTarget2, // #7
/*  2344*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2354*/    /*Scope*/ 22, /*->2377*/
/*  2355*/     OPC_CheckChild2TypeI64,
/*  2356*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2357*/     OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2359*/     OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2360*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2361*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2363*/     OPC_EmitMergeInputChains1_0,
/*  2364*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2366*/     OPC_EmitConvertToTarget2, // #7
/*  2367*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2377*/    0, /*End of Scope*/
/*  2378*/   /*Scope*/ 58, /*->2437*/
/*  2379*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  2381*/    OPC_RecordChild1, // #2 = $idx
/*  2382*/    OPC_MoveChild1,
/*  2383*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2386*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/*  2388*/    OPC_CheckTypeI32,
/*  2389*/    OPC_MoveParent,
/*  2390*/    OPC_CheckTypeI32,
/*  2391*/    OPC_MoveParent,
/*  2392*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2393*/    OPC_Scope, 20, /*->2415*/ // 2 children in Scope
/*  2395*/     OPC_CheckChild2TypeI32,
/*  2396*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2397*/     OPC_CheckPredicate5,  // Predicate_store
/*  2398*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2399*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2401*/     OPC_EmitMergeInputChains1_0,
/*  2402*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2404*/     OPC_EmitConvertToTarget2, // #7
/*  2405*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2415*/    /*Scope*/ 20, /*->2436*/
/*  2416*/     OPC_CheckChild2TypeI64,
/*  2417*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2418*/     OPC_CheckPredicate5,  // Predicate_store
/*  2419*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2420*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2422*/     OPC_EmitMergeInputChains1_0,
/*  2423*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2425*/     OPC_EmitConvertToTarget2, // #7
/*  2426*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2436*/    0, /*End of Scope*/
/*  2437*/   /*Scope*/ 58, /*->2496*/
/*  2438*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  2440*/    OPC_RecordChild1, // #2 = $idx
/*  2441*/    OPC_MoveChild1,
/*  2442*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2445*/    OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/*  2447*/    OPC_CheckTypeI32,
/*  2448*/    OPC_MoveParent,
/*  2449*/    OPC_CheckTypeI64,
/*  2450*/    OPC_MoveParent,
/*  2451*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2452*/    OPC_Scope, 20, /*->2474*/ // 2 children in Scope
/*  2454*/     OPC_CheckChild2TypeI32,
/*  2455*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2456*/     OPC_CheckPredicate5,  // Predicate_store
/*  2457*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2458*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2460*/     OPC_EmitMergeInputChains1_0,
/*  2461*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2463*/     OPC_EmitConvertToTarget2, // #7
/*  2464*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2474*/    /*Scope*/ 20, /*->2495*/
/*  2475*/     OPC_CheckChild2TypeI64,
/*  2476*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2477*/     OPC_CheckPredicate5,  // Predicate_store
/*  2478*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2479*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2481*/     OPC_EmitMergeInputChains1_0,
/*  2482*/     OPC_EmitInteger32, 0,  // 0 #6
/*  2484*/     OPC_EmitConvertToTarget2, // #7
/*  2485*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2495*/    0, /*End of Scope*/
/*  2496*/   0, /*End of Scope*/
/*  2497*/  /*Scope*/ 49|128,5/*689*/, /*->3188*/
/*  2499*/   OPC_RecordChild1, // #1 = $val
/*  2500*/   OPC_Scope, 126, /*->2628*/ // 11 children in Scope
/*  2502*/    OPC_CheckChild1TypeI32,
/*  2503*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2504*/    OPC_Scope, 60, /*->2566*/ // 2 children in Scope
/*  2506*/     OPC_CheckChild2TypeI32,
/*  2507*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2508*/     OPC_Scope, 16, /*->2526*/ // 2 children in Scope
/*  2510*/      OPC_CheckPredicate5,  // Predicate_store
/*  2511*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2512*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2514*/      OPC_EmitMergeInputChains1_0,
/*  2515*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2517*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2526*/     /*Scope*/ 38, /*->2565*/
/*  2527*/      OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2529*/      OPC_Scope, 16, /*->2547*/ // 2 children in Scope
/*  2531*/       OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2532*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2533*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2535*/       OPC_EmitMergeInputChains1_0,
/*  2536*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2538*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2547*/      /*Scope*/ 16, /*->2564*/
/*  2548*/       OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2549*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2550*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2552*/       OPC_EmitMergeInputChains1_0,
/*  2553*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2555*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2564*/      0, /*End of Scope*/
/*  2565*/     0, /*End of Scope*/
/*  2566*/    /*Scope*/ 60, /*->2627*/
/*  2567*/     OPC_CheckChild2TypeI64,
/*  2568*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2569*/     OPC_Scope, 16, /*->2587*/ // 2 children in Scope
/*  2571*/      OPC_CheckPredicate5,  // Predicate_store
/*  2572*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2573*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2575*/      OPC_EmitMergeInputChains1_0,
/*  2576*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2578*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2587*/     /*Scope*/ 38, /*->2626*/
/*  2588*/      OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2590*/      OPC_Scope, 16, /*->2608*/ // 2 children in Scope
/*  2592*/       OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2593*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2594*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2596*/       OPC_EmitMergeInputChains1_0,
/*  2597*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2599*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2608*/      /*Scope*/ 16, /*->2625*/
/*  2609*/       OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2610*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2611*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2613*/       OPC_EmitMergeInputChains1_0,
/*  2614*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2616*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2625*/      0, /*End of Scope*/
/*  2626*/     0, /*End of Scope*/
/*  2627*/    0, /*End of Scope*/
/*  2628*/   /*Scope*/ 32|128,1/*160*/, /*->2790*/
/*  2630*/    OPC_CheckChild1TypeI64,
/*  2631*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2632*/    OPC_Scope, 77, /*->2711*/ // 2 children in Scope
/*  2634*/     OPC_CheckChild2TypeI32,
/*  2635*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2636*/     OPC_Scope, 16, /*->2654*/ // 2 children in Scope
/*  2638*/      OPC_CheckPredicate5,  // Predicate_store
/*  2639*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2640*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2642*/      OPC_EmitMergeInputChains1_0,
/*  2643*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2645*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2654*/     /*Scope*/ 55, /*->2710*/
/*  2655*/      OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2657*/      OPC_Scope, 16, /*->2675*/ // 3 children in Scope
/*  2659*/       OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2660*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2661*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2663*/       OPC_EmitMergeInputChains1_0,
/*  2664*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2666*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2675*/      /*Scope*/ 16, /*->2692*/
/*  2676*/       OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2677*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2678*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2680*/       OPC_EmitMergeInputChains1_0,
/*  2681*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2683*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2692*/      /*Scope*/ 16, /*->2709*/
/*  2693*/       OPC_CheckPredicate3,  // Predicate_truncstorei32
/*  2694*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2695*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2697*/       OPC_EmitMergeInputChains1_0,
/*  2698*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2700*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2709*/      0, /*End of Scope*/
/*  2710*/     0, /*End of Scope*/
/*  2711*/    /*Scope*/ 77, /*->2789*/
/*  2712*/     OPC_CheckChild2TypeI64,
/*  2713*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2714*/     OPC_Scope, 16, /*->2732*/ // 2 children in Scope
/*  2716*/      OPC_CheckPredicate5,  // Predicate_store
/*  2717*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2718*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2720*/      OPC_EmitMergeInputChains1_0,
/*  2721*/      OPC_EmitInteger32, 0,  // 0 #5
/*  2723*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2732*/     /*Scope*/ 55, /*->2788*/
/*  2733*/      OPC_CheckPredicate, 16, // Predicate_truncstore
/*  2735*/      OPC_Scope, 16, /*->2753*/ // 3 children in Scope
/*  2737*/       OPC_CheckPredicate1,  // Predicate_truncstorei8
/*  2738*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2739*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2741*/       OPC_EmitMergeInputChains1_0,
/*  2742*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2744*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2753*/      /*Scope*/ 16, /*->2770*/
/*  2754*/       OPC_CheckPredicate2,  // Predicate_truncstorei16
/*  2755*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2756*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2758*/       OPC_EmitMergeInputChains1_0,
/*  2759*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2761*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2770*/      /*Scope*/ 16, /*->2787*/
/*  2771*/       OPC_CheckPredicate3,  // Predicate_truncstorei32
/*  2772*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2773*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2775*/       OPC_EmitMergeInputChains1_0,
/*  2776*/       OPC_EmitInteger32, 0,  // 0 #5
/*  2778*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2787*/      0, /*End of Scope*/
/*  2788*/     0, /*End of Scope*/
/*  2789*/    0, /*End of Scope*/
/*  2790*/   /*Scope*/ 43, /*->2834*/
/*  2791*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/*  2793*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2794*/    OPC_Scope, 18, /*->2814*/ // 2 children in Scope
/*  2796*/     OPC_CheckChild2TypeI32,
/*  2797*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2798*/     OPC_CheckPredicate5,  // Predicate_store
/*  2799*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2800*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2802*/     OPC_EmitMergeInputChains1_0,
/*  2803*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2805*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2814*/    /*Scope*/ 18, /*->2833*/
/*  2815*/     OPC_CheckChild2TypeI64,
/*  2816*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2817*/     OPC_CheckPredicate5,  // Predicate_store
/*  2818*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2819*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2821*/     OPC_EmitMergeInputChains1_0,
/*  2822*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2824*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2833*/    0, /*End of Scope*/
/*  2834*/   /*Scope*/ 43, /*->2878*/
/*  2835*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/*  2837*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2838*/    OPC_Scope, 18, /*->2858*/ // 2 children in Scope
/*  2840*/     OPC_CheckChild2TypeI32,
/*  2841*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2842*/     OPC_CheckPredicate5,  // Predicate_store
/*  2843*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2844*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2846*/     OPC_EmitMergeInputChains1_0,
/*  2847*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2849*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2858*/    /*Scope*/ 18, /*->2877*/
/*  2859*/     OPC_CheckChild2TypeI64,
/*  2860*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2861*/     OPC_CheckPredicate5,  // Predicate_store
/*  2862*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2863*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2865*/     OPC_EmitMergeInputChains1_0,
/*  2866*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2868*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2877*/    0, /*End of Scope*/
/*  2878*/   /*Scope*/ 43, /*->2922*/
/*  2879*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  2881*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2882*/    OPC_Scope, 18, /*->2902*/ // 2 children in Scope
/*  2884*/     OPC_CheckChild2TypeI32,
/*  2885*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2886*/     OPC_CheckPredicate5,  // Predicate_store
/*  2887*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2888*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2890*/     OPC_EmitMergeInputChains1_0,
/*  2891*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2893*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2902*/    /*Scope*/ 18, /*->2921*/
/*  2903*/     OPC_CheckChild2TypeI64,
/*  2904*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2905*/     OPC_CheckPredicate5,  // Predicate_store
/*  2906*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2907*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2909*/     OPC_EmitMergeInputChains1_0,
/*  2910*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2912*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2921*/    0, /*End of Scope*/
/*  2922*/   /*Scope*/ 43, /*->2966*/
/*  2923*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  2925*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2926*/    OPC_Scope, 18, /*->2946*/ // 2 children in Scope
/*  2928*/     OPC_CheckChild2TypeI32,
/*  2929*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2930*/     OPC_CheckPredicate5,  // Predicate_store
/*  2931*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2932*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2934*/     OPC_EmitMergeInputChains1_0,
/*  2935*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2937*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2946*/    /*Scope*/ 18, /*->2965*/
/*  2947*/     OPC_CheckChild2TypeI64,
/*  2948*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2949*/     OPC_CheckPredicate5,  // Predicate_store
/*  2950*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2951*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2953*/     OPC_EmitMergeInputChains1_0,
/*  2954*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2956*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2965*/    0, /*End of Scope*/
/*  2966*/   /*Scope*/ 43, /*->3010*/
/*  2967*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  2969*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2970*/    OPC_Scope, 18, /*->2990*/ // 2 children in Scope
/*  2972*/     OPC_CheckChild2TypeI32,
/*  2973*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2974*/     OPC_CheckPredicate5,  // Predicate_store
/*  2975*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2976*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2978*/     OPC_EmitMergeInputChains1_0,
/*  2979*/     OPC_EmitInteger32, 0,  // 0 #5
/*  2981*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2990*/    /*Scope*/ 18, /*->3009*/
/*  2991*/     OPC_CheckChild2TypeI64,
/*  2992*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2993*/     OPC_CheckPredicate5,  // Predicate_store
/*  2994*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2995*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2997*/     OPC_EmitMergeInputChains1_0,
/*  2998*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3000*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  3009*/    0, /*End of Scope*/
/*  3010*/   /*Scope*/ 43, /*->3054*/
/*  3011*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  3013*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3014*/    OPC_Scope, 18, /*->3034*/ // 2 children in Scope
/*  3016*/     OPC_CheckChild2TypeI32,
/*  3017*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3018*/     OPC_CheckPredicate5,  // Predicate_store
/*  3019*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3020*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3022*/     OPC_EmitMergeInputChains1_0,
/*  3023*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3025*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3034*/    /*Scope*/ 18, /*->3053*/
/*  3035*/     OPC_CheckChild2TypeI64,
/*  3036*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3037*/     OPC_CheckPredicate5,  // Predicate_store
/*  3038*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3039*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3041*/     OPC_EmitMergeInputChains1_0,
/*  3042*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3044*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  3053*/    0, /*End of Scope*/
/*  3054*/   /*Scope*/ 43, /*->3098*/
/*  3055*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/*  3057*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3058*/    OPC_Scope, 18, /*->3078*/ // 2 children in Scope
/*  3060*/     OPC_CheckChild2TypeI32,
/*  3061*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3062*/     OPC_CheckPredicate5,  // Predicate_store
/*  3063*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3064*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3066*/     OPC_EmitMergeInputChains1_0,
/*  3067*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3069*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3078*/    /*Scope*/ 18, /*->3097*/
/*  3079*/     OPC_CheckChild2TypeI64,
/*  3080*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3081*/     OPC_CheckPredicate5,  // Predicate_store
/*  3082*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3083*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3085*/     OPC_EmitMergeInputChains1_0,
/*  3086*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3088*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  3097*/    0, /*End of Scope*/
/*  3098*/   /*Scope*/ 44, /*->3143*/
/*  3099*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  3102*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3103*/    OPC_Scope, 18, /*->3123*/ // 2 children in Scope
/*  3105*/     OPC_CheckChild2TypeI32,
/*  3106*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3107*/     OPC_CheckPredicate5,  // Predicate_store
/*  3108*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3109*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3111*/     OPC_EmitMergeInputChains1_0,
/*  3112*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3114*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3123*/    /*Scope*/ 18, /*->3142*/
/*  3124*/     OPC_CheckChild2TypeI64,
/*  3125*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3126*/     OPC_CheckPredicate5,  // Predicate_store
/*  3127*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3128*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3130*/     OPC_EmitMergeInputChains1_0,
/*  3131*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3133*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  3142*/    0, /*End of Scope*/
/*  3143*/   /*Scope*/ 43, /*->3187*/
/*  3144*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/*  3146*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3147*/    OPC_Scope, 18, /*->3167*/ // 2 children in Scope
/*  3149*/     OPC_CheckChild2TypeI32,
/*  3150*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3151*/     OPC_CheckPredicate5,  // Predicate_store
/*  3152*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3153*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3155*/     OPC_EmitMergeInputChains1_0,
/*  3156*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3158*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3167*/    /*Scope*/ 18, /*->3186*/
/*  3168*/     OPC_CheckChild2TypeI64,
/*  3169*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3170*/     OPC_CheckPredicate5,  // Predicate_store
/*  3171*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3172*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3174*/     OPC_EmitMergeInputChains1_0,
/*  3175*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3177*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3186*/    0, /*End of Scope*/
/*  3187*/   0, /*End of Scope*/
/*  3188*/  0, /*End of Scope*/
/*  3189*/ /*SwitchOpcode*/ 7|128,2/*263*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3456
/*  3193*/  OPC_Scope, 40, /*->3235*/ // 3 children in Scope
/*  3195*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3196*/   OPC_CheckChild1Integer, 6|128,79|128,1/*26502*/, 
/*  3200*/   OPC_MoveChild2,
/*  3201*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3204*/   OPC_RecordChild0, // #1 = $table1
/*  3205*/   OPC_MoveChild0,
/*  3206*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3209*/   OPC_MoveParent,
/*  3210*/   OPC_MoveSibling3,
/*  3211*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3214*/   OPC_RecordChild0, // #2 = $table2
/*  3215*/   OPC_MoveChild0,
/*  3216*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3219*/   OPC_MoveParent,
/*  3220*/   OPC_MoveParent,
/*  3221*/   OPC_RecordChild4, // #3 = $d
/*  3222*/   OPC_RecordChild5, // #4 = $s
/*  3223*/   OPC_RecordChild6, // #5 = $n
/*  3224*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3225*/   OPC_EmitMergeInputChains1_0,
/*  3226*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 13251:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3235*/  /*Scope*/ 44, /*->3280*/
/*  3236*/   OPC_RecordMemRef,
/*  3237*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3238*/   OPC_CheckChild1Integer, 2|128,79|128,1/*26498*/, 
/*  3242*/   OPC_RecordChild2, // #1 = $val
/*  3243*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3244*/   OPC_Scope, 16, /*->3262*/ // 2 children in Scope
/*  3246*/    OPC_CheckChild3TypeI32,
/*  3247*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3248*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3250*/    OPC_EmitMergeInputChains1_0,
/*  3251*/    OPC_EmitInteger32, 0,  // 0 #5
/*  3253*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 13249:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3262*/   /*Scope*/ 16, /*->3279*/
/*  3263*/    OPC_CheckChild3TypeI64,
/*  3264*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3265*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3267*/    OPC_EmitMergeInputChains1_0,
/*  3268*/    OPC_EmitInteger32, 0,  // 0 #5
/*  3270*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 13249:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3279*/   0, /*End of Scope*/
/*  3280*/  /*Scope*/ 45|128,1/*173*/, /*->3455*/
/*  3282*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3283*/   OPC_Scope, 26, /*->3311*/ // 6 children in Scope
/*  3285*/    OPC_CheckChild1Integer, 30|128,79|128,1/*26526*/, 
/*  3289*/    OPC_MoveChild2,
/*  3290*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3293*/    OPC_RecordChild0, // #1 = $table
/*  3294*/    OPC_MoveChild0,
/*  3295*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3298*/    OPC_MoveParent,
/*  3299*/    OPC_MoveParent,
/*  3300*/    OPC_RecordChild3, // #2 = $i
/*  3301*/    OPC_RecordChild4, // #3 = $val
/*  3302*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3303*/    OPC_EmitMergeInputChains1_0,
/*  3304*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13263:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3311*/   /*Scope*/ 28, /*->3340*/
/*  3312*/    OPC_CheckChild1Integer, 12|128,79|128,1/*26508*/, 
/*  3316*/    OPC_MoveChild2,
/*  3317*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3320*/    OPC_RecordChild0, // #1 = $table
/*  3321*/    OPC_MoveChild0,
/*  3322*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3325*/    OPC_MoveParent,
/*  3326*/    OPC_MoveParent,
/*  3327*/    OPC_RecordChild3, // #2 = $i
/*  3328*/    OPC_RecordChild4, // #3 = $val
/*  3329*/    OPC_RecordChild5, // #4 = $n
/*  3330*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3331*/    OPC_EmitMergeInputChains1_0,
/*  3332*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13254:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3340*/   /*Scope*/ 26, /*->3367*/
/*  3341*/    OPC_CheckChild1Integer, 28|128,79|128,1/*26524*/, 
/*  3345*/    OPC_MoveChild2,
/*  3346*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3349*/    OPC_RecordChild0, // #1 = $table
/*  3350*/    OPC_MoveChild0,
/*  3351*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3354*/    OPC_MoveParent,
/*  3355*/    OPC_MoveParent,
/*  3356*/    OPC_RecordChild3, // #2 = $i
/*  3357*/    OPC_RecordChild4, // #3 = $val
/*  3358*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3359*/    OPC_EmitMergeInputChains1_0,
/*  3360*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13262:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3367*/   /*Scope*/ 28, /*->3396*/
/*  3368*/    OPC_CheckChild1Integer, 10|128,79|128,1/*26506*/, 
/*  3372*/    OPC_MoveChild2,
/*  3373*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3376*/    OPC_RecordChild0, // #1 = $table
/*  3377*/    OPC_MoveChild0,
/*  3378*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3381*/    OPC_MoveParent,
/*  3382*/    OPC_MoveParent,
/*  3383*/    OPC_RecordChild3, // #2 = $i
/*  3384*/    OPC_RecordChild4, // #3 = $val
/*  3385*/    OPC_RecordChild5, // #4 = $n
/*  3386*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3387*/    OPC_EmitMergeInputChains1_0,
/*  3388*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13253:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3396*/   /*Scope*/ 27, /*->3424*/
/*  3397*/    OPC_CheckChild1Integer, 26|128,79|128,1/*26522*/, 
/*  3401*/    OPC_MoveChild2,
/*  3402*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3405*/    OPC_RecordChild0, // #1 = $table
/*  3406*/    OPC_MoveChild0,
/*  3407*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3410*/    OPC_MoveParent,
/*  3411*/    OPC_MoveParent,
/*  3412*/    OPC_RecordChild3, // #2 = $i
/*  3413*/    OPC_RecordChild4, // #3 = $val
/*  3414*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3416*/    OPC_EmitMergeInputChains1_0,
/*  3417*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 13261:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3424*/   /*Scope*/ 29, /*->3454*/
/*  3425*/    OPC_CheckChild1Integer, 8|128,79|128,1/*26504*/, 
/*  3429*/    OPC_MoveChild2,
/*  3430*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3433*/    OPC_RecordChild0, // #1 = $table
/*  3434*/    OPC_MoveChild0,
/*  3435*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3438*/    OPC_MoveParent,
/*  3439*/    OPC_MoveParent,
/*  3440*/    OPC_RecordChild3, // #2 = $i
/*  3441*/    OPC_RecordChild4, // #3 = $val
/*  3442*/    OPC_RecordChild5, // #4 = $n
/*  3443*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3445*/    OPC_EmitMergeInputChains1_0,
/*  3446*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 13252:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3454*/   0, /*End of Scope*/
/*  3455*/  0, /*End of Scope*/
/*  3456*/ /*SwitchOpcode*/ 81|128,3/*465*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3925
/*  3460*/  OPC_Scope, 22|128,1/*150*/, /*->3613*/ // 3 children in Scope
/*  3463*/   OPC_RecordMemRef,
/*  3464*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3465*/   OPC_Scope, 45, /*->3512*/ // 3 children in Scope
/*  3467*/    OPC_CheckChild1Integer, 62|128,78|128,1/*26430*/, 
/*  3471*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3472*/    OPC_Scope, 18, /*->3492*/ // 2 children in Scope
/*  3474*/     OPC_CheckChild2TypeI32,
/*  3475*/     OPC_RecordChild3, // #2 = $count
/*  3476*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3477*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3479*/     OPC_EmitMergeInputChains1_0,
/*  3480*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3482*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13215:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3492*/    /*Scope*/ 18, /*->3511*/
/*  3493*/     OPC_CheckChild2TypeI64,
/*  3494*/     OPC_RecordChild3, // #2 = $count
/*  3495*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3496*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3498*/     OPC_EmitMergeInputChains1_0,
/*  3499*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3501*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13215:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3511*/    0, /*End of Scope*/
/*  3512*/   /*Scope*/ 49, /*->3562*/
/*  3513*/    OPC_CheckChild1Integer, 64|128,78|128,1/*26432*/, 
/*  3517*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3518*/    OPC_Scope, 20, /*->3540*/ // 2 children in Scope
/*  3520*/     OPC_CheckChild2TypeI32,
/*  3521*/     OPC_RecordChild3, // #2 = $exp
/*  3522*/     OPC_RecordChild4, // #3 = $timeout
/*  3523*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3524*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3526*/     OPC_EmitMergeInputChains1_0,
/*  3527*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3529*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13216:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3540*/    /*Scope*/ 20, /*->3561*/
/*  3541*/     OPC_CheckChild2TypeI64,
/*  3542*/     OPC_RecordChild3, // #2 = $exp
/*  3543*/     OPC_RecordChild4, // #3 = $timeout
/*  3544*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3545*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3547*/     OPC_EmitMergeInputChains1_0,
/*  3548*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3550*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13216:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3561*/    0, /*End of Scope*/
/*  3562*/   /*Scope*/ 49, /*->3612*/
/*  3563*/    OPC_CheckChild1Integer, 66|128,78|128,1/*26434*/, 
/*  3567*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3568*/    OPC_Scope, 20, /*->3590*/ // 2 children in Scope
/*  3570*/     OPC_CheckChild2TypeI32,
/*  3571*/     OPC_RecordChild3, // #2 = $exp
/*  3572*/     OPC_RecordChild4, // #3 = $timeout
/*  3573*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3574*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3576*/     OPC_EmitMergeInputChains1_0,
/*  3577*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3579*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13217:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3590*/    /*Scope*/ 20, /*->3611*/
/*  3591*/     OPC_CheckChild2TypeI64,
/*  3592*/     OPC_RecordChild3, // #2 = $exp
/*  3593*/     OPC_RecordChild4, // #3 = $timeout
/*  3594*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3595*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3597*/     OPC_EmitMergeInputChains1_0,
/*  3598*/     OPC_EmitInteger32, 0,  // 0 #6
/*  3600*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13217:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3611*/    0, /*End of Scope*/
/*  3612*/   0, /*End of Scope*/
/*  3613*/  /*Scope*/ 9|128,2/*265*/, /*->3880*/
/*  3615*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3616*/   OPC_Scope, 26, /*->3644*/ // 9 children in Scope
/*  3618*/    OPC_CheckChild1Integer, 18|128,79|128,1/*26514*/, 
/*  3622*/    OPC_MoveChild2,
/*  3623*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3626*/    OPC_RecordChild0, // #1 = $table
/*  3627*/    OPC_MoveChild0,
/*  3628*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3631*/    OPC_MoveParent,
/*  3632*/    OPC_MoveParent,
/*  3633*/    OPC_RecordChild3, // #2 = $i
/*  3634*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3635*/    OPC_EmitMergeInputChains1_0,
/*  3636*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 13257:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3644*/   /*Scope*/ 27, /*->3672*/
/*  3645*/    OPC_CheckChild1Integer, 24|128,79|128,1/*26520*/, 
/*  3649*/    OPC_MoveChild2,
/*  3650*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3653*/    OPC_RecordChild0, // #1 = $table
/*  3654*/    OPC_MoveChild0,
/*  3655*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3658*/    OPC_MoveParent,
/*  3659*/    OPC_MoveParent,
/*  3660*/    OPC_RecordChild3, // #2 = $val
/*  3661*/    OPC_RecordChild4, // #3 = $n
/*  3662*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3663*/    OPC_EmitMergeInputChains1_0,
/*  3664*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13260:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3672*/   /*Scope*/ 26, /*->3699*/
/*  3673*/    OPC_CheckChild1Integer, 16|128,79|128,1/*26512*/, 
/*  3677*/    OPC_MoveChild2,
/*  3678*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3681*/    OPC_RecordChild0, // #1 = $table
/*  3682*/    OPC_MoveChild0,
/*  3683*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3686*/    OPC_MoveParent,
/*  3687*/    OPC_MoveParent,
/*  3688*/    OPC_RecordChild3, // #2 = $i
/*  3689*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3690*/    OPC_EmitMergeInputChains1_0,
/*  3691*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 13256:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3699*/   /*Scope*/ 27, /*->3727*/
/*  3700*/    OPC_CheckChild1Integer, 22|128,79|128,1/*26518*/, 
/*  3704*/    OPC_MoveChild2,
/*  3705*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3708*/    OPC_RecordChild0, // #1 = $table
/*  3709*/    OPC_MoveChild0,
/*  3710*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3713*/    OPC_MoveParent,
/*  3714*/    OPC_MoveParent,
/*  3715*/    OPC_RecordChild3, // #2 = $val
/*  3716*/    OPC_RecordChild4, // #3 = $n
/*  3717*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3718*/    OPC_EmitMergeInputChains1_0,
/*  3719*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13259:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3727*/   /*Scope*/ 27, /*->3755*/
/*  3728*/    OPC_CheckChild1Integer, 14|128,79|128,1/*26510*/, 
/*  3732*/    OPC_MoveChild2,
/*  3733*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3736*/    OPC_RecordChild0, // #1 = $table
/*  3737*/    OPC_MoveChild0,
/*  3738*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3741*/    OPC_MoveParent,
/*  3742*/    OPC_MoveParent,
/*  3743*/    OPC_RecordChild3, // #2 = $i
/*  3744*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3746*/    OPC_EmitMergeInputChains1_0,
/*  3747*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 13255:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3755*/   /*Scope*/ 28, /*->3784*/
/*  3756*/    OPC_CheckChild1Integer, 20|128,79|128,1/*26516*/, 
/*  3760*/    OPC_MoveChild2,
/*  3761*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3764*/    OPC_RecordChild0, // #1 = $table
/*  3765*/    OPC_MoveChild0,
/*  3766*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3769*/    OPC_MoveParent,
/*  3770*/    OPC_MoveParent,
/*  3771*/    OPC_RecordChild3, // #2 = $val
/*  3772*/    OPC_RecordChild4, // #3 = $n
/*  3773*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3775*/    OPC_EmitMergeInputChains1_0,
/*  3776*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13258:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3784*/   /*Scope*/ 23, /*->3808*/
/*  3785*/    OPC_CheckChild1Integer, 32|128,79|128,1/*26528*/, 
/*  3789*/    OPC_MoveChild2,
/*  3790*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3793*/    OPC_RecordChild0, // #1 = $table
/*  3794*/    OPC_MoveChild0,
/*  3795*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3798*/    OPC_MoveParent,
/*  3799*/    OPC_MoveParent,
/*  3800*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3801*/    OPC_EmitMergeInputChains1_0,
/*  3802*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  /*MVT::i32*/7, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 13264:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3808*/   /*Scope*/ 32, /*->3841*/
/*  3809*/    OPC_CheckChild1Integer, 70|128,78|128,1/*26438*/, 
/*  3813*/    OPC_RecordChild2, // #1 = $flags
/*  3814*/    OPC_MoveChild2,
/*  3815*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3818*/    OPC_MoveParent,
/*  3819*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->3830
/*  3822*/     OPC_EmitMergeInputChains1_0,
/*  3823*/     OPC_EmitConvertToTarget1, // #2
/*  3824*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8862MEMORY_SIZE_A32),
                   /*MVT::i32*/7, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13219:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8862MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3830*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->3840
/*  3832*/     OPC_EmitMergeInputChains1_0,
/*  3833*/     OPC_EmitConvertToTarget1, // #2
/*  3834*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8863MEMORY_SIZE_A64),
                   /*MVT::i64*/8, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 13219:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8863MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3840*/    0, // EndSwitchType
/*  3841*/   /*Scope*/ 37, /*->3879*/
/*  3842*/    OPC_CheckChild1Integer, 68|128,78|128,1/*26436*/, 
/*  3846*/    OPC_RecordChild2, // #1 = $flags
/*  3847*/    OPC_MoveChild2,
/*  3848*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3851*/    OPC_MoveParent,
/*  3852*/    OPC_RecordChild3, // #2 = $delta
/*  3853*/    OPC_SwitchType /*2 cases */, 10, /*MVT::i32*/7, // ->3866
/*  3856*/     OPC_CheckChild3TypeI32,
/*  3857*/     OPC_EmitMergeInputChains1_0,
/*  3858*/     OPC_EmitConvertToTarget1, // #3
/*  3859*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8862MEMORY_GROW_A32),
                   /*MVT::i32*/7, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 13218:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8862MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3866*/    /*SwitchType*/ 10, /*MVT::i64*/8, // ->3878
/*  3868*/     OPC_CheckChild3TypeI64,
/*  3869*/     OPC_EmitMergeInputChains1_0,
/*  3870*/     OPC_EmitConvertToTarget1, // #3
/*  3871*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8863MEMORY_GROW_A64),
                   /*MVT::i64*/8, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 13218:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8863MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3878*/    0, // EndSwitchType
/*  3879*/   0, /*End of Scope*/
/*  3880*/  /*Scope*/ 43, /*->3924*/
/*  3881*/   OPC_RecordMemRef,
/*  3882*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3883*/   OPC_CheckChild1Integer, 58|128,78|128,1/*26426*/, 
/*  3887*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3888*/   OPC_Scope, 16, /*->3906*/ // 2 children in Scope
/*  3890*/    OPC_CheckChild2TypeI32,
/*  3891*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3892*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3894*/    OPC_EmitMergeInputChains1_0,
/*  3895*/    OPC_EmitInteger32, 0,  // 0 #4
/*  3897*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 13213:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3906*/   /*Scope*/ 16, /*->3923*/
/*  3907*/    OPC_CheckChild2TypeI64,
/*  3908*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3909*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3911*/    OPC_EmitMergeInputChains1_0,
/*  3912*/    OPC_EmitInteger32, 0,  // 0 #4
/*  3914*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 13213:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3923*/   0, /*End of Scope*/
/*  3924*/  0, /*End of Scope*/
/*  3925*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4214
/*  3929*/  OPC_RecordMemRef,
/*  3930*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3931*/  OPC_Scope, 119, /*->4052*/ // 2 children in Scope
/*  3933*/   OPC_MoveChild1,
/*  3934*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3937*/   OPC_RecordChild0, // #1 = $val
/*  3938*/   OPC_MoveParent,
/*  3939*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3940*/   OPC_Scope, 54, /*->3996*/ // 2 children in Scope
/*  3942*/    OPC_CheckChild2TypeI32,
/*  3943*/    OPC_Scope, 16, /*->3961*/ // 3 children in Scope
/*  3945*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3946*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3947*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3949*/     OPC_EmitMergeInputChains1_0,
/*  3950*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3952*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3961*/    /*Scope*/ 16, /*->3978*/
/*  3962*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3963*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3964*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3966*/     OPC_EmitMergeInputChains1_0,
/*  3967*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3969*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3978*/    /*Scope*/ 16, /*->3995*/
/*  3979*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3980*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3981*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3983*/     OPC_EmitMergeInputChains1_0,
/*  3984*/     OPC_EmitInteger32, 0,  // 0 #5
/*  3986*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3995*/    0, /*End of Scope*/
/*  3996*/   /*Scope*/ 54, /*->4051*/
/*  3997*/    OPC_CheckChild2TypeI64,
/*  3998*/    OPC_Scope, 16, /*->4016*/ // 3 children in Scope
/*  4000*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  4001*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4002*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4004*/     OPC_EmitMergeInputChains1_0,
/*  4005*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4007*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4016*/    /*Scope*/ 16, /*->4033*/
/*  4017*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  4018*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4019*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4021*/     OPC_EmitMergeInputChains1_0,
/*  4022*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4024*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4033*/    /*Scope*/ 16, /*->4050*/
/*  4034*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  4035*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4036*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4038*/     OPC_EmitMergeInputChains1_0,
/*  4039*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4041*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4050*/    0, /*End of Scope*/
/*  4051*/   0, /*End of Scope*/
/*  4052*/  /*Scope*/ 31|128,1/*159*/, /*->4213*/
/*  4054*/   OPC_RecordChild1, // #1 = $val
/*  4055*/   OPC_Scope, 114, /*->4171*/ // 2 children in Scope
/*  4057*/    OPC_CheckChild1TypeI32,
/*  4058*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4059*/    OPC_Scope, 54, /*->4115*/ // 2 children in Scope
/*  4061*/     OPC_CheckChild2TypeI32,
/*  4062*/     OPC_Scope, 16, /*->4080*/ // 3 children in Scope
/*  4064*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  4065*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4066*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4068*/      OPC_EmitMergeInputChains1_0,
/*  4069*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4071*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4080*/     /*Scope*/ 16, /*->4097*/
/*  4081*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  4082*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4083*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4085*/      OPC_EmitMergeInputChains1_0,
/*  4086*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4088*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4097*/     /*Scope*/ 16, /*->4114*/
/*  4098*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  4099*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4100*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4102*/      OPC_EmitMergeInputChains1_0,
/*  4103*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4105*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  4114*/     0, /*End of Scope*/
/*  4115*/    /*Scope*/ 54, /*->4170*/
/*  4116*/     OPC_CheckChild2TypeI64,
/*  4117*/     OPC_Scope, 16, /*->4135*/ // 3 children in Scope
/*  4119*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  4120*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4121*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4123*/      OPC_EmitMergeInputChains1_0,
/*  4124*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4126*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4135*/     /*Scope*/ 16, /*->4152*/
/*  4136*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  4137*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4138*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4140*/      OPC_EmitMergeInputChains1_0,
/*  4141*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4143*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4152*/     /*Scope*/ 16, /*->4169*/
/*  4153*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  4154*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4155*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4157*/      OPC_EmitMergeInputChains1_0,
/*  4158*/      OPC_EmitInteger32, 0,  // 0 #5
/*  4160*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4169*/     0, /*End of Scope*/
/*  4170*/    0, /*End of Scope*/
/*  4171*/   /*Scope*/ 40, /*->4212*/
/*  4172*/    OPC_CheckChild1TypeI64,
/*  4173*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4174*/    OPC_Scope, 17, /*->4193*/ // 2 children in Scope
/*  4176*/     OPC_CheckChild2TypeI32,
/*  4177*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4178*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4179*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4181*/     OPC_EmitMergeInputChains1_0,
/*  4182*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4184*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4193*/    /*Scope*/ 17, /*->4211*/
/*  4194*/     OPC_CheckChild2TypeI64,
/*  4195*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4196*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4197*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4199*/     OPC_EmitMergeInputChains1_0,
/*  4200*/     OPC_EmitInteger32, 0,  // 0 #5
/*  4202*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4211*/    0, /*End of Scope*/
/*  4212*/   0, /*End of Scope*/
/*  4213*/  0, /*End of Scope*/
/*  4214*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4564
/*  4218*/  OPC_Scope, 118, /*->4338*/ // 6 children in Scope
/*  4220*/   OPC_MoveChild0,
/*  4221*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4224*/   OPC_Scope, 55, /*->4281*/ // 2 children in Scope
/*  4226*/    OPC_CheckChild0Integer, 34|128,78|128,1/*26402*/, 
/*  4230*/    OPC_RecordChild1, // #0 = $x
/*  4231*/    OPC_Scope, 11, /*->4244*/ // 4 children in Scope
/*  4233*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4235*/     OPC_MoveParent,
/*  4236*/     OPC_CheckChild1Integer, 2, 
/*  4238*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4244*/    /*Scope*/ 11, /*->4256*/
/*  4245*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4247*/     OPC_MoveParent,
/*  4248*/     OPC_CheckChild1Integer, 2, 
/*  4250*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4256*/    /*Scope*/ 11, /*->4268*/
/*  4257*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4259*/     OPC_MoveParent,
/*  4260*/     OPC_CheckChild1Integer, 2, 
/*  4262*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4268*/    /*Scope*/ 11, /*->4280*/
/*  4269*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4271*/     OPC_MoveParent,
/*  4272*/     OPC_CheckChild1Integer, 2, 
/*  4274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4280*/    0, /*End of Scope*/
/*  4281*/   /*Scope*/ 55, /*->4337*/
/*  4282*/    OPC_CheckChild0Integer, 32|128,78|128,1/*26400*/, 
/*  4286*/    OPC_RecordChild1, // #0 = $x
/*  4287*/    OPC_Scope, 11, /*->4300*/ // 4 children in Scope
/*  4289*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4291*/     OPC_MoveParent,
/*  4292*/     OPC_CheckChild1Integer, 2, 
/*  4294*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4300*/    /*Scope*/ 11, /*->4312*/
/*  4301*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4303*/     OPC_MoveParent,
/*  4304*/     OPC_CheckChild1Integer, 2, 
/*  4306*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4312*/    /*Scope*/ 11, /*->4324*/
/*  4313*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4315*/     OPC_MoveParent,
/*  4316*/     OPC_CheckChild1Integer, 2, 
/*  4318*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4324*/    /*Scope*/ 11, /*->4336*/
/*  4325*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4327*/     OPC_MoveParent,
/*  4328*/     OPC_CheckChild1Integer, 2, 
/*  4330*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4336*/    0, /*End of Scope*/
/*  4337*/   0, /*End of Scope*/
/*  4338*/  /*Scope*/ 29, /*->4368*/
/*  4339*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4342*/   OPC_MoveChild0,
/*  4343*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4346*/   OPC_RecordChild0, // #0 = $vec
/*  4347*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  4349*/   OPC_RecordChild1, // #1 = $idx
/*  4350*/   OPC_MoveChild1,
/*  4351*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4354*/   OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/*  4356*/   OPC_CheckTypeI32,
/*  4357*/   OPC_MoveParent,
/*  4358*/   OPC_MoveParent,
/*  4359*/   OPC_CheckTypeI32,
/*  4360*/   OPC_EmitConvertToTarget1, // #2
/*  4361*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4368*/  /*Scope*/ 30, /*->4399*/
/*  4369*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4373*/   OPC_MoveChild0,
/*  4374*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4377*/   OPC_RecordChild0, // #0 = $vec
/*  4378*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  4380*/   OPC_RecordChild1, // #1 = $idx
/*  4381*/   OPC_MoveChild1,
/*  4382*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4385*/   OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/*  4387*/   OPC_CheckTypeI32,
/*  4388*/   OPC_MoveParent,
/*  4389*/   OPC_MoveParent,
/*  4390*/   OPC_CheckTypeI32,
/*  4391*/   OPC_EmitConvertToTarget1, // #2
/*  4392*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4399*/  /*Scope*/ 73, /*->4473*/
/*  4400*/   OPC_RecordChild0, // #0 = $lhs
/*  4401*/   OPC_Scope, 21, /*->4424*/ // 2 children in Scope
/*  4403*/    OPC_RecordChild1, // #1 = $rhs
/*  4404*/    OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->4414
/*  4407*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4414*/    /*SwitchType*/ 7, /*MVT::i64*/8, // ->4423
/*  4416*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4423*/    0, // EndSwitchType
/*  4424*/   /*Scope*/ 47, /*->4472*/
/*  4425*/    OPC_MoveChild1,
/*  4426*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4429*/    OPC_RecordChild0, // #1 = $rhs
/*  4430*/    OPC_MoveChild1,
/*  4431*/    OPC_CheckImmAllOnesV,
/*  4432*/    OPC_MoveParent,
/*  4433*/    OPC_MoveParent,
/*  4434*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4444
/*  4437*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4444*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4453
/*  4446*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4453*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4462
/*  4455*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4462*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4471
/*  4464*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4471*/    0, // EndSwitchType
/*  4472*/   0, /*End of Scope*/
/*  4473*/  /*Scope*/ 48, /*->4522*/
/*  4474*/   OPC_MoveChild0,
/*  4475*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4478*/   OPC_RecordChild0, // #0 = $rhs
/*  4479*/   OPC_MoveChild1,
/*  4480*/   OPC_CheckImmAllOnesV,
/*  4481*/   OPC_MoveParent,
/*  4482*/   OPC_MoveParent,
/*  4483*/   OPC_RecordChild1, // #1 = $lhs
/*  4484*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4494
/*  4487*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4494*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4503
/*  4496*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4503*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4512
/*  4505*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4512*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4521
/*  4514*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4521*/   0, // EndSwitchType
/*  4522*/  /*Scope*/ 40, /*->4563*/
/*  4523*/   OPC_RecordChild0, // #0 = $lhs
/*  4524*/   OPC_RecordChild1, // #1 = $rhs
/*  4525*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4535
/*  4528*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4535*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4544
/*  4537*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4544*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4553
/*  4546*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4553*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4562
/*  4555*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4562*/   0, // EndSwitchType
/*  4563*/  0, /*End of Scope*/
/*  4564*/ /*SwitchOpcode*/ 125|128,11/*1533*/, TARGET_VAL(ISD::SETCC),// ->6101
/*  4568*/  OPC_Scope, 126|128,1/*254*/, /*->4825*/ // 2 children in Scope
/*  4571*/   OPC_MoveChild0,
/*  4572*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4575*/   OPC_Scope, 123, /*->4700*/ // 2 children in Scope
/*  4577*/    OPC_CheckChild0Integer, 34|128,78|128,1/*26402*/, 
/*  4581*/    OPC_RecordChild1, // #0 = $x
/*  4582*/    OPC_Scope, 28, /*->4612*/ // 4 children in Scope
/*  4584*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4586*/     OPC_MoveParent,
/*  4587*/     OPC_CheckTypeI32,
/*  4588*/     OPC_Scope, 10, /*->4600*/ // 2 children in Scope
/*  4590*/      OPC_CheckChild1Integer, 0, 
/*  4592*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4594*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4600*/     /*Scope*/ 10, /*->4611*/
/*  4601*/      OPC_CheckChild1Integer, 2, 
/*  4603*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4605*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4611*/     0, /*End of Scope*/
/*  4612*/    /*Scope*/ 28, /*->4641*/
/*  4613*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4615*/     OPC_MoveParent,
/*  4616*/     OPC_CheckTypeI32,
/*  4617*/     OPC_Scope, 10, /*->4629*/ // 2 children in Scope
/*  4619*/      OPC_CheckChild1Integer, 0, 
/*  4621*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4623*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4629*/     /*Scope*/ 10, /*->4640*/
/*  4630*/      OPC_CheckChild1Integer, 2, 
/*  4632*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4634*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4640*/     0, /*End of Scope*/
/*  4641*/    /*Scope*/ 28, /*->4670*/
/*  4642*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4644*/     OPC_MoveParent,
/*  4645*/     OPC_CheckTypeI32,
/*  4646*/     OPC_Scope, 10, /*->4658*/ // 2 children in Scope
/*  4648*/      OPC_CheckChild1Integer, 0, 
/*  4650*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4652*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4658*/     /*Scope*/ 10, /*->4669*/
/*  4659*/      OPC_CheckChild1Integer, 2, 
/*  4661*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4663*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4669*/     0, /*End of Scope*/
/*  4670*/    /*Scope*/ 28, /*->4699*/
/*  4671*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4673*/     OPC_MoveParent,
/*  4674*/     OPC_CheckTypeI32,
/*  4675*/     OPC_Scope, 10, /*->4687*/ // 2 children in Scope
/*  4677*/      OPC_CheckChild1Integer, 0, 
/*  4679*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4681*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4687*/     /*Scope*/ 10, /*->4698*/
/*  4688*/      OPC_CheckChild1Integer, 2, 
/*  4690*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4692*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4698*/     0, /*End of Scope*/
/*  4699*/    0, /*End of Scope*/
/*  4700*/   /*Scope*/ 123, /*->4824*/
/*  4701*/    OPC_CheckChild0Integer, 32|128,78|128,1/*26400*/, 
/*  4705*/    OPC_RecordChild1, // #0 = $x
/*  4706*/    OPC_Scope, 28, /*->4736*/ // 4 children in Scope
/*  4708*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4710*/     OPC_MoveParent,
/*  4711*/     OPC_CheckTypeI32,
/*  4712*/     OPC_Scope, 10, /*->4724*/ // 2 children in Scope
/*  4714*/      OPC_CheckChild1Integer, 0, 
/*  4716*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4718*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4724*/     /*Scope*/ 10, /*->4735*/
/*  4725*/      OPC_CheckChild1Integer, 2, 
/*  4727*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4729*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4735*/     0, /*End of Scope*/
/*  4736*/    /*Scope*/ 28, /*->4765*/
/*  4737*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4739*/     OPC_MoveParent,
/*  4740*/     OPC_CheckTypeI32,
/*  4741*/     OPC_Scope, 10, /*->4753*/ // 2 children in Scope
/*  4743*/      OPC_CheckChild1Integer, 0, 
/*  4745*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4747*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4753*/     /*Scope*/ 10, /*->4764*/
/*  4754*/      OPC_CheckChild1Integer, 2, 
/*  4756*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4758*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4764*/     0, /*End of Scope*/
/*  4765*/    /*Scope*/ 28, /*->4794*/
/*  4766*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4768*/     OPC_MoveParent,
/*  4769*/     OPC_CheckTypeI32,
/*  4770*/     OPC_Scope, 10, /*->4782*/ // 2 children in Scope
/*  4772*/      OPC_CheckChild1Integer, 0, 
/*  4774*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4776*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4782*/     /*Scope*/ 10, /*->4793*/
/*  4783*/      OPC_CheckChild1Integer, 2, 
/*  4785*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4787*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4793*/     0, /*End of Scope*/
/*  4794*/    /*Scope*/ 28, /*->4823*/
/*  4795*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4797*/     OPC_MoveParent,
/*  4798*/     OPC_CheckTypeI32,
/*  4799*/     OPC_Scope, 10, /*->4811*/ // 2 children in Scope
/*  4801*/      OPC_CheckChild1Integer, 0, 
/*  4803*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4805*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4811*/     /*Scope*/ 10, /*->4822*/
/*  4812*/      OPC_CheckChild1Integer, 2, 
/*  4814*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4816*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4822*/     0, /*End of Scope*/
/*  4823*/    0, /*End of Scope*/
/*  4824*/   0, /*End of Scope*/
/*  4825*/  /*Scope*/ 121|128,9/*1273*/, /*->6100*/
/*  4827*/   OPC_RecordChild0, // #0 = $src
/*  4828*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, /*MVT::i32*/7, // ->5324
/*  4832*/    OPC_Scope, 118, /*->4952*/ // 4 children in Scope
/*  4834*/     OPC_CheckChild0TypeI32,
/*  4835*/     OPC_Scope, 10, /*->4847*/ // 2 children in Scope
/*  4837*/      OPC_CheckChild1Integer, 0, 
/*  4839*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4841*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4847*/     /*Scope*/ 103, /*->4951*/
/*  4848*/      OPC_RecordChild1, // #1 = $rhs
/*  4849*/      OPC_Scope, 9, /*->4860*/ // 10 children in Scope
/*  4851*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4853*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4860*/      /*Scope*/ 9, /*->4870*/
/*  4861*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4863*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4870*/      /*Scope*/ 9, /*->4880*/
/*  4871*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4873*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4880*/      /*Scope*/ 9, /*->4890*/
/*  4881*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4883*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4890*/      /*Scope*/ 9, /*->4900*/
/*  4891*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4893*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4900*/      /*Scope*/ 9, /*->4910*/
/*  4901*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4903*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4910*/      /*Scope*/ 9, /*->4920*/
/*  4911*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4913*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4920*/      /*Scope*/ 9, /*->4930*/
/*  4921*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4923*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4930*/      /*Scope*/ 9, /*->4940*/
/*  4931*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4933*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4940*/      /*Scope*/ 9, /*->4950*/
/*  4941*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4943*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4950*/      0, /*End of Scope*/
/*  4951*/     0, /*End of Scope*/
/*  4952*/    /*Scope*/ 118, /*->5071*/
/*  4953*/     OPC_CheckChild0TypeI64,
/*  4954*/     OPC_Scope, 10, /*->4966*/ // 2 children in Scope
/*  4956*/      OPC_CheckChild1Integer, 0, 
/*  4958*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4960*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4966*/     /*Scope*/ 103, /*->5070*/
/*  4967*/      OPC_RecordChild1, // #1 = $rhs
/*  4968*/      OPC_Scope, 9, /*->4979*/ // 10 children in Scope
/*  4970*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4972*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4979*/      /*Scope*/ 9, /*->4989*/
/*  4980*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4982*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4989*/      /*Scope*/ 9, /*->4999*/
/*  4990*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4992*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4999*/      /*Scope*/ 9, /*->5009*/
/*  5000*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  5002*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5009*/      /*Scope*/ 9, /*->5019*/
/*  5010*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  5012*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5019*/      /*Scope*/ 9, /*->5029*/
/*  5020*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5022*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5029*/      /*Scope*/ 9, /*->5039*/
/*  5030*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  5032*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5039*/      /*Scope*/ 9, /*->5049*/
/*  5040*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  5042*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5049*/      /*Scope*/ 9, /*->5059*/
/*  5050*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  5052*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5059*/      /*Scope*/ 9, /*->5069*/
/*  5060*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5062*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  5069*/      0, /*End of Scope*/
/*  5070*/     0, /*End of Scope*/
/*  5071*/    /*Scope*/ 125, /*->5197*/
/*  5072*/     OPC_CheckChild0Type, /*MVT::f32*/12, 
/*  5074*/     OPC_RecordChild1, // #1 = $rhs
/*  5075*/     OPC_Scope, 9, /*->5086*/ // 12 children in Scope
/*  5077*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5079*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5086*/     /*Scope*/ 9, /*->5096*/
/*  5087*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5089*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5096*/     /*Scope*/ 9, /*->5106*/
/*  5097*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5099*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5106*/     /*Scope*/ 9, /*->5116*/
/*  5107*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5109*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5116*/     /*Scope*/ 9, /*->5126*/
/*  5117*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5119*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5126*/     /*Scope*/ 9, /*->5136*/
/*  5127*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5129*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  5136*/     /*Scope*/ 9, /*->5146*/
/*  5137*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5139*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5146*/     /*Scope*/ 9, /*->5156*/
/*  5147*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5149*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5156*/     /*Scope*/ 9, /*->5166*/
/*  5157*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5159*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5166*/     /*Scope*/ 9, /*->5176*/
/*  5167*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5169*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5176*/     /*Scope*/ 9, /*->5186*/
/*  5177*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5179*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5186*/     /*Scope*/ 9, /*->5196*/
/*  5187*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5189*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5196*/     0, /*End of Scope*/
/*  5197*/    /*Scope*/ 125, /*->5323*/
/*  5198*/     OPC_CheckChild0Type, /*MVT::f64*/13, 
/*  5200*/     OPC_RecordChild1, // #1 = $rhs
/*  5201*/     OPC_Scope, 9, /*->5212*/ // 12 children in Scope
/*  5203*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5205*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5212*/     /*Scope*/ 9, /*->5222*/
/*  5213*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5215*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5222*/     /*Scope*/ 9, /*->5232*/
/*  5223*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5225*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5232*/     /*Scope*/ 9, /*->5242*/
/*  5233*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5235*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5242*/     /*Scope*/ 9, /*->5252*/
/*  5243*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5245*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5252*/     /*Scope*/ 9, /*->5262*/
/*  5253*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5255*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5262*/     /*Scope*/ 9, /*->5272*/
/*  5263*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5265*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5272*/     /*Scope*/ 9, /*->5282*/
/*  5273*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5275*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5282*/     /*Scope*/ 9, /*->5292*/
/*  5283*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5285*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5292*/     /*Scope*/ 9, /*->5302*/
/*  5293*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5295*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5302*/     /*Scope*/ 9, /*->5312*/
/*  5303*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5305*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5312*/     /*Scope*/ 9, /*->5322*/
/*  5313*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5315*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5322*/     0, /*End of Scope*/
/*  5323*/    0, /*End of Scope*/
/*  5324*/   /*SwitchType*/ 115, /*MVT::v16i8*/39, // ->5441
/*  5326*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  5328*/    OPC_RecordChild1, // #1 = $rhs
/*  5329*/    OPC_Scope, 10, /*->5341*/ // 10 children in Scope
/*  5331*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5333*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5334*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5341*/    /*Scope*/ 10, /*->5352*/
/*  5342*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5344*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5345*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5352*/    /*Scope*/ 10, /*->5363*/
/*  5353*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5355*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5356*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5363*/    /*Scope*/ 10, /*->5374*/
/*  5364*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5366*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5367*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5374*/    /*Scope*/ 10, /*->5385*/
/*  5375*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5377*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5378*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5385*/    /*Scope*/ 10, /*->5396*/
/*  5386*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5388*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5389*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5396*/    /*Scope*/ 10, /*->5407*/
/*  5397*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5399*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5400*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5407*/    /*Scope*/ 10, /*->5418*/
/*  5408*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5410*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5411*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5418*/    /*Scope*/ 10, /*->5429*/
/*  5419*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5421*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5422*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5429*/    /*Scope*/ 10, /*->5440*/
/*  5430*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5432*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5433*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5440*/    0, /*End of Scope*/
/*  5441*/   /*SwitchType*/ 62|128,1/*190*/, /*MVT::v8i16*/50, // ->5634
/*  5444*/    OPC_Scope, 115, /*->5561*/ // 2 children in Scope
/*  5446*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  5448*/     OPC_RecordChild1, // #1 = $rhs
/*  5449*/     OPC_Scope, 10, /*->5461*/ // 10 children in Scope
/*  5451*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5453*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5454*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5461*/     /*Scope*/ 10, /*->5472*/
/*  5462*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5464*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5465*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5472*/     /*Scope*/ 10, /*->5483*/
/*  5473*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5475*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5476*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5483*/     /*Scope*/ 10, /*->5494*/
/*  5484*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5486*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5487*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5494*/     /*Scope*/ 10, /*->5505*/
/*  5495*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5497*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5498*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5505*/     /*Scope*/ 10, /*->5516*/
/*  5506*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5508*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5509*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5516*/     /*Scope*/ 10, /*->5527*/
/*  5517*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5519*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5520*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5527*/     /*Scope*/ 10, /*->5538*/
/*  5528*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5530*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5531*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5538*/     /*Scope*/ 10, /*->5549*/
/*  5539*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5541*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5542*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5549*/     /*Scope*/ 10, /*->5560*/
/*  5550*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5552*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5553*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5560*/     0, /*End of Scope*/
/*  5561*/    /*Scope*/ 71, /*->5633*/
/*  5562*/     OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/*  5564*/     OPC_RecordChild1, // #1 = $rhs
/*  5565*/     OPC_Scope, 10, /*->5577*/ // 6 children in Scope
/*  5567*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5569*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5570*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5577*/     /*Scope*/ 10, /*->5588*/
/*  5578*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5580*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5581*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5588*/     /*Scope*/ 10, /*->5599*/
/*  5589*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5591*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5592*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5599*/     /*Scope*/ 10, /*->5610*/
/*  5600*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5602*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5603*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5610*/     /*Scope*/ 10, /*->5621*/
/*  5611*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5613*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5614*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5621*/     /*Scope*/ 10, /*->5632*/
/*  5622*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5624*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5625*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5632*/     0, /*End of Scope*/
/*  5633*/    0, /*End of Scope*/
/*  5634*/   /*SwitchType*/ 123|128,1/*251*/, /*MVT::v4i32*/60, // ->5888
/*  5637*/    OPC_Scope, 115, /*->5754*/ // 2 children in Scope
/*  5639*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  5641*/     OPC_RecordChild1, // #1 = $rhs
/*  5642*/     OPC_Scope, 10, /*->5654*/ // 10 children in Scope
/*  5644*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5646*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5647*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5654*/     /*Scope*/ 10, /*->5665*/
/*  5655*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5657*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5658*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5665*/     /*Scope*/ 10, /*->5676*/
/*  5666*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5668*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5669*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5676*/     /*Scope*/ 10, /*->5687*/
/*  5677*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5679*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5680*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5687*/     /*Scope*/ 10, /*->5698*/
/*  5688*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5690*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5691*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5698*/     /*Scope*/ 10, /*->5709*/
/*  5699*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5701*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5702*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5709*/     /*Scope*/ 10, /*->5720*/
/*  5710*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5712*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5713*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5720*/     /*Scope*/ 10, /*->5731*/
/*  5721*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5723*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5724*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5731*/     /*Scope*/ 10, /*->5742*/
/*  5732*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5734*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5735*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5742*/     /*Scope*/ 10, /*->5753*/
/*  5743*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5745*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5746*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5753*/     0, /*End of Scope*/
/*  5754*/    /*Scope*/ 3|128,1/*131*/, /*->5887*/
/*  5756*/     OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/*  5758*/     OPC_RecordChild1, // #1 = $rhs
/*  5759*/     OPC_Scope, 10, /*->5771*/ // 12 children in Scope
/*  5761*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5763*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5771*/     /*Scope*/ 10, /*->5782*/
/*  5772*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5774*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5775*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5782*/     /*Scope*/ 10, /*->5793*/
/*  5783*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5785*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5786*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5793*/     /*Scope*/ 10, /*->5804*/
/*  5794*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5796*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5804*/     /*Scope*/ 10, /*->5815*/
/*  5805*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5807*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5815*/     /*Scope*/ 10, /*->5826*/
/*  5816*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5818*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5819*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5826*/     /*Scope*/ 9, /*->5836*/
/*  5827*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5829*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5836*/     /*Scope*/ 9, /*->5846*/
/*  5837*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5839*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5846*/     /*Scope*/ 9, /*->5856*/
/*  5847*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5849*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5856*/     /*Scope*/ 9, /*->5866*/
/*  5857*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5859*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5866*/     /*Scope*/ 9, /*->5876*/
/*  5867*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5869*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5876*/     /*Scope*/ 9, /*->5886*/
/*  5877*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5879*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5886*/     0, /*End of Scope*/
/*  5887*/    0, /*End of Scope*/
/*  5888*/   /*SwitchType*/ 80|128,1/*208*/, /*MVT::v2i64*/78, // ->6099
/*  5891*/    OPC_Scope, 71, /*->5964*/ // 2 children in Scope
/*  5893*/     OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  5895*/     OPC_RecordChild1, // #1 = $rhs
/*  5896*/     OPC_Scope, 10, /*->5908*/ // 6 children in Scope
/*  5898*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5900*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5901*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5908*/     /*Scope*/ 10, /*->5919*/
/*  5909*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5911*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5919*/     /*Scope*/ 10, /*->5930*/
/*  5920*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5922*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5923*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5930*/     /*Scope*/ 10, /*->5941*/
/*  5931*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5933*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5934*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5941*/     /*Scope*/ 10, /*->5952*/
/*  5942*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5944*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5945*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5952*/     /*Scope*/ 10, /*->5963*/
/*  5953*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5955*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5956*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5963*/     0, /*End of Scope*/
/*  5964*/    /*Scope*/ 4|128,1/*132*/, /*->6098*/
/*  5966*/     OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  5969*/     OPC_RecordChild1, // #1 = $rhs
/*  5970*/     OPC_Scope, 10, /*->5982*/ // 12 children in Scope
/*  5972*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5974*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5975*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5982*/     /*Scope*/ 10, /*->5993*/
/*  5983*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5985*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5986*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5993*/     /*Scope*/ 10, /*->6004*/
/*  5994*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5996*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5997*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6004*/     /*Scope*/ 10, /*->6015*/
/*  6005*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  6007*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  6008*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6015*/     /*Scope*/ 10, /*->6026*/
/*  6016*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  6018*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  6019*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6026*/     /*Scope*/ 10, /*->6037*/
/*  6027*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  6029*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  6030*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  6037*/     /*Scope*/ 9, /*->6047*/
/*  6038*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  6040*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6047*/     /*Scope*/ 9, /*->6057*/
/*  6048*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  6050*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6057*/     /*Scope*/ 9, /*->6067*/
/*  6058*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  6060*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6067*/     /*Scope*/ 9, /*->6077*/
/*  6068*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  6070*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6077*/     /*Scope*/ 9, /*->6087*/
/*  6078*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  6080*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6087*/     /*Scope*/ 9, /*->6097*/
/*  6088*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  6090*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  6097*/     0, /*End of Scope*/
/*  6098*/    0, /*End of Scope*/
/*  6099*/   0, // EndSwitchType
/*  6100*/  0, /*End of Scope*/
/*  6101*/ /*SwitchOpcode*/ 59|128,11/*1467*/, TARGET_VAL(ISD::LOAD),// ->7572
/*  6105*/  OPC_RecordMemRef,
/*  6106*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  6107*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  6108*/  OPC_Scope, 89|128,5/*729*/, /*->6840*/ // 2 children in Scope
/*  6111*/   OPC_CheckChild1TypeI32,
/*  6112*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6114*/   OPC_Scope, 37, /*->6153*/ // 16 children in Scope
/*  6116*/    OPC_CheckPredicate6,  // Predicate_load
/*  6117*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6135
/*  6120*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6121*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6123*/     OPC_EmitMergeInputChains1_0,
/*  6124*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6126*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6135*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6152
/*  6137*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6138*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6140*/     OPC_EmitMergeInputChains1_0,
/*  6141*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6143*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6152*/    0, // EndSwitchType
/*  6153*/   /*Scope*/ 97, /*->6251*/
/*  6154*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  6156*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6195
/*  6159*/     OPC_Scope, 16, /*->6177*/ // 2 children in Scope
/*  6161*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6162*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6163*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6165*/      OPC_EmitMergeInputChains1_0,
/*  6166*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6168*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6177*/     /*Scope*/ 16, /*->6194*/
/*  6178*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6179*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6180*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6182*/      OPC_EmitMergeInputChains1_0,
/*  6183*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6185*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6194*/     0, /*End of Scope*/
/*  6195*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6250
/*  6197*/     OPC_Scope, 16, /*->6215*/ // 3 children in Scope
/*  6199*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6200*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6201*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6203*/      OPC_EmitMergeInputChains1_0,
/*  6204*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6206*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6215*/     /*Scope*/ 16, /*->6232*/
/*  6216*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6217*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6218*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6220*/      OPC_EmitMergeInputChains1_0,
/*  6221*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6223*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6232*/     /*Scope*/ 16, /*->6249*/
/*  6233*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6234*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6235*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6237*/      OPC_EmitMergeInputChains1_0,
/*  6238*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6240*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6249*/     0, /*End of Scope*/
/*  6250*/    0, // EndSwitchType
/*  6251*/   /*Scope*/ 97, /*->6349*/
/*  6252*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  6254*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6293
/*  6257*/     OPC_Scope, 16, /*->6275*/ // 2 children in Scope
/*  6259*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6260*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6261*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6263*/      OPC_EmitMergeInputChains1_0,
/*  6264*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6266*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6275*/     /*Scope*/ 16, /*->6292*/
/*  6276*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6277*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6278*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6280*/      OPC_EmitMergeInputChains1_0,
/*  6281*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6283*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6292*/     0, /*End of Scope*/
/*  6293*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6348
/*  6295*/     OPC_Scope, 16, /*->6313*/ // 3 children in Scope
/*  6297*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6298*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6299*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6301*/      OPC_EmitMergeInputChains1_0,
/*  6302*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6304*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6313*/     /*Scope*/ 16, /*->6330*/
/*  6314*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6315*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6316*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6318*/      OPC_EmitMergeInputChains1_0,
/*  6319*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6330*/     /*Scope*/ 16, /*->6347*/
/*  6331*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6332*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6333*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6335*/      OPC_EmitMergeInputChains1_0,
/*  6336*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6338*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6347*/     0, /*End of Scope*/
/*  6348*/    0, // EndSwitchType
/*  6349*/   /*Scope*/ 97, /*->6447*/
/*  6350*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6352*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6391
/*  6355*/     OPC_Scope, 16, /*->6373*/ // 2 children in Scope
/*  6357*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6358*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6359*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6361*/      OPC_EmitMergeInputChains1_0,
/*  6362*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6364*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6373*/     /*Scope*/ 16, /*->6390*/
/*  6374*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6375*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6378*/      OPC_EmitMergeInputChains1_0,
/*  6379*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6390*/     0, /*End of Scope*/
/*  6391*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6446
/*  6393*/     OPC_Scope, 16, /*->6411*/ // 3 children in Scope
/*  6395*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6396*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6397*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6399*/      OPC_EmitMergeInputChains1_0,
/*  6400*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6402*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6411*/     /*Scope*/ 16, /*->6428*/
/*  6412*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6413*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6414*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6416*/      OPC_EmitMergeInputChains1_0,
/*  6417*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6419*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6428*/     /*Scope*/ 16, /*->6445*/
/*  6429*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6430*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6431*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6433*/      OPC_EmitMergeInputChains1_0,
/*  6434*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6436*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6445*/     0, /*End of Scope*/
/*  6446*/    0, // EndSwitchType
/*  6447*/   /*Scope*/ 105, /*->6553*/
/*  6448*/    OPC_CheckPredicate6,  // Predicate_load
/*  6449*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6467
/*  6452*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6453*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6455*/     OPC_EmitMergeInputChains1_0,
/*  6456*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6458*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6467*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->6484
/*  6469*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6470*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6472*/     OPC_EmitMergeInputChains1_0,
/*  6473*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6475*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6484*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->6501
/*  6486*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6487*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6489*/     OPC_EmitMergeInputChains1_0,
/*  6490*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6492*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6501*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->6518
/*  6503*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6504*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6506*/     OPC_EmitMergeInputChains1_0,
/*  6507*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6509*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6518*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->6535
/*  6520*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6521*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6523*/     OPC_EmitMergeInputChains1_0,
/*  6524*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6526*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6535*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->6552
/*  6537*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6538*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6540*/     OPC_EmitMergeInputChains1_0,
/*  6541*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6543*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6552*/    0, // EndSwitchType
/*  6553*/   /*Scope*/ 21, /*->6575*/
/*  6554*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  6556*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6558*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6560*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6561*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6563*/    OPC_EmitMergeInputChains1_0,
/*  6564*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6566*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6575*/   /*Scope*/ 21, /*->6597*/
/*  6576*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  6578*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6580*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6582*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6583*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6585*/    OPC_EmitMergeInputChains1_0,
/*  6586*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6588*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6597*/   /*Scope*/ 21, /*->6619*/
/*  6598*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6600*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6602*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6604*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6605*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6607*/    OPC_EmitMergeInputChains1_0,
/*  6608*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6610*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6619*/   /*Scope*/ 21, /*->6641*/
/*  6620*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  6622*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6624*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6626*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6627*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6629*/    OPC_EmitMergeInputChains1_0,
/*  6630*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6632*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6641*/   /*Scope*/ 21, /*->6663*/
/*  6642*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  6644*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6646*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6648*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6649*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6651*/    OPC_EmitMergeInputChains1_0,
/*  6652*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6654*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6663*/   /*Scope*/ 21, /*->6685*/
/*  6664*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6666*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6668*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6670*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6671*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6673*/    OPC_EmitMergeInputChains1_0,
/*  6674*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6676*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6685*/   /*Scope*/ 21, /*->6707*/
/*  6686*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  6688*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6690*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6692*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6693*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6695*/    OPC_EmitMergeInputChains1_0,
/*  6696*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6698*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6707*/   /*Scope*/ 21, /*->6729*/
/*  6708*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  6710*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6712*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6714*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6715*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6717*/    OPC_EmitMergeInputChains1_0,
/*  6718*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6720*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6729*/   /*Scope*/ 21, /*->6751*/
/*  6730*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6732*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6734*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6736*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6737*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6739*/    OPC_EmitMergeInputChains1_0,
/*  6740*/    OPC_EmitInteger32, 0,  // 0 #4
/*  6742*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6751*/   /*Scope*/ 56, /*->6808*/
/*  6752*/    OPC_CheckPredicate6,  // Predicate_load
/*  6753*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->6771
/*  6756*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6757*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6759*/     OPC_EmitMergeInputChains1_0,
/*  6760*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6771*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->6790
/*  6774*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6775*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6777*/     OPC_EmitMergeInputChains1_0,
/*  6778*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6790*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->6807
/*  6792*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6793*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6795*/     OPC_EmitMergeInputChains1_0,
/*  6796*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6798*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8f16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6807*/    0, // EndSwitchType
/*  6808*/   /*Scope*/ 30, /*->6839*/
/*  6809*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6811*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  6814*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6815*/    OPC_EmitMergeInputChains1_0,
/*  6816*/    OPC_EmitInteger32, 0,  // 0 #2
/*  6818*/    OPC_EmitInteger32, 0,  // 0 #3
/*  6820*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6829*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  6836*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6839*/   0, /*End of Scope*/
/*  6840*/  /*Scope*/ 89|128,5/*729*/, /*->7571*/
/*  6842*/   OPC_CheckChild1TypeI64,
/*  6843*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6845*/   OPC_Scope, 37, /*->6884*/ // 16 children in Scope
/*  6847*/    OPC_CheckPredicate6,  // Predicate_load
/*  6848*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6866
/*  6851*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6852*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6854*/     OPC_EmitMergeInputChains1_0,
/*  6855*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6857*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6866*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6883
/*  6868*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6869*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6871*/     OPC_EmitMergeInputChains1_0,
/*  6872*/     OPC_EmitInteger32, 0,  // 0 #4
/*  6874*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6883*/    0, // EndSwitchType
/*  6884*/   /*Scope*/ 97, /*->6982*/
/*  6885*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  6887*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6926
/*  6890*/     OPC_Scope, 16, /*->6908*/ // 2 children in Scope
/*  6892*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6893*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6894*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6896*/      OPC_EmitMergeInputChains1_0,
/*  6897*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6899*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6908*/     /*Scope*/ 16, /*->6925*/
/*  6909*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6910*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6911*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6913*/      OPC_EmitMergeInputChains1_0,
/*  6914*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6916*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6925*/     0, /*End of Scope*/
/*  6926*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6981
/*  6928*/     OPC_Scope, 16, /*->6946*/ // 3 children in Scope
/*  6930*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6931*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6932*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6934*/      OPC_EmitMergeInputChains1_0,
/*  6935*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6937*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6946*/     /*Scope*/ 16, /*->6963*/
/*  6947*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6948*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6949*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6951*/      OPC_EmitMergeInputChains1_0,
/*  6952*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6954*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6963*/     /*Scope*/ 16, /*->6980*/
/*  6964*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6965*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6966*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6968*/      OPC_EmitMergeInputChains1_0,
/*  6969*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6971*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6980*/     0, /*End of Scope*/
/*  6981*/    0, // EndSwitchType
/*  6982*/   /*Scope*/ 97, /*->7080*/
/*  6983*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  6985*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->7024
/*  6988*/     OPC_Scope, 16, /*->7006*/ // 2 children in Scope
/*  6990*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6991*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6992*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6994*/      OPC_EmitMergeInputChains1_0,
/*  6995*/      OPC_EmitInteger32, 0,  // 0 #4
/*  6997*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7006*/     /*Scope*/ 16, /*->7023*/
/*  7007*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  7008*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7009*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7011*/      OPC_EmitMergeInputChains1_0,
/*  7012*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7014*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7023*/     0, /*End of Scope*/
/*  7024*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->7079
/*  7026*/     OPC_Scope, 16, /*->7044*/ // 3 children in Scope
/*  7028*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  7029*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7030*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7032*/      OPC_EmitMergeInputChains1_0,
/*  7033*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7035*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7044*/     /*Scope*/ 16, /*->7061*/
/*  7045*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  7046*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7047*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7049*/      OPC_EmitMergeInputChains1_0,
/*  7050*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7052*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7061*/     /*Scope*/ 16, /*->7078*/
/*  7062*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  7063*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7064*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7066*/      OPC_EmitMergeInputChains1_0,
/*  7067*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7069*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7078*/     0, /*End of Scope*/
/*  7079*/    0, // EndSwitchType
/*  7080*/   /*Scope*/ 97, /*->7178*/
/*  7081*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7083*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->7122
/*  7086*/     OPC_Scope, 16, /*->7104*/ // 2 children in Scope
/*  7088*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  7089*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7090*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7092*/      OPC_EmitMergeInputChains1_0,
/*  7093*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7095*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7104*/     /*Scope*/ 16, /*->7121*/
/*  7105*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  7106*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7107*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7109*/      OPC_EmitMergeInputChains1_0,
/*  7110*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7112*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7121*/     0, /*End of Scope*/
/*  7122*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->7177
/*  7124*/     OPC_Scope, 16, /*->7142*/ // 3 children in Scope
/*  7126*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  7127*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7128*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7130*/      OPC_EmitMergeInputChains1_0,
/*  7131*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7133*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7142*/     /*Scope*/ 16, /*->7159*/
/*  7143*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  7144*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7145*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7147*/      OPC_EmitMergeInputChains1_0,
/*  7148*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7150*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7159*/     /*Scope*/ 16, /*->7176*/
/*  7160*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  7161*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7162*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7164*/      OPC_EmitMergeInputChains1_0,
/*  7165*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7167*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7176*/     0, /*End of Scope*/
/*  7177*/    0, // EndSwitchType
/*  7178*/   /*Scope*/ 105, /*->7284*/
/*  7179*/    OPC_CheckPredicate6,  // Predicate_load
/*  7180*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->7198
/*  7183*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7184*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7186*/     OPC_EmitMergeInputChains1_0,
/*  7187*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7189*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7198*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->7215
/*  7200*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7201*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7203*/     OPC_EmitMergeInputChains1_0,
/*  7204*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7206*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7215*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->7232
/*  7217*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7218*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7220*/     OPC_EmitMergeInputChains1_0,
/*  7221*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7223*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7232*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->7249
/*  7234*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7235*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7237*/     OPC_EmitMergeInputChains1_0,
/*  7238*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7240*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7249*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->7266
/*  7251*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7252*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7254*/     OPC_EmitMergeInputChains1_0,
/*  7255*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7257*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7266*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->7283
/*  7268*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7269*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7271*/     OPC_EmitMergeInputChains1_0,
/*  7272*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7274*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7283*/    0, // EndSwitchType
/*  7284*/   /*Scope*/ 21, /*->7306*/
/*  7285*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  7287*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7289*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7291*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7292*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7294*/    OPC_EmitMergeInputChains1_0,
/*  7295*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7297*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7306*/   /*Scope*/ 21, /*->7328*/
/*  7307*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  7309*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7311*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7313*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7314*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7316*/    OPC_EmitMergeInputChains1_0,
/*  7317*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7319*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7328*/   /*Scope*/ 21, /*->7350*/
/*  7329*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7331*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7333*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7335*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7336*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7338*/    OPC_EmitMergeInputChains1_0,
/*  7339*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7341*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7350*/   /*Scope*/ 21, /*->7372*/
/*  7351*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  7353*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7355*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7357*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7358*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7360*/    OPC_EmitMergeInputChains1_0,
/*  7361*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7363*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7372*/   /*Scope*/ 21, /*->7394*/
/*  7373*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  7375*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7377*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7379*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7380*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7382*/    OPC_EmitMergeInputChains1_0,
/*  7383*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7385*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7394*/   /*Scope*/ 21, /*->7416*/
/*  7395*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7397*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7399*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7401*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7402*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7404*/    OPC_EmitMergeInputChains1_0,
/*  7405*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7407*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7416*/   /*Scope*/ 21, /*->7438*/
/*  7417*/    OPC_CheckPredicate, 17, // Predicate_sextload
/*  7419*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7421*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7423*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7424*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7426*/    OPC_EmitMergeInputChains1_0,
/*  7427*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7429*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7438*/   /*Scope*/ 21, /*->7460*/
/*  7439*/    OPC_CheckPredicate, 18, // Predicate_zextload
/*  7441*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7443*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7445*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7446*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7448*/    OPC_EmitMergeInputChains1_0,
/*  7449*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7451*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7460*/   /*Scope*/ 21, /*->7482*/
/*  7461*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7463*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7465*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7467*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7468*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7470*/    OPC_EmitMergeInputChains1_0,
/*  7471*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7473*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7482*/   /*Scope*/ 56, /*->7539*/
/*  7483*/    OPC_CheckPredicate6,  // Predicate_load
/*  7484*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->7502
/*  7487*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7488*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7490*/     OPC_EmitMergeInputChains1_0,
/*  7491*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7493*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7502*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->7521
/*  7505*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7506*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7508*/     OPC_EmitMergeInputChains1_0,
/*  7509*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7511*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7521*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->7538
/*  7523*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7524*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7526*/     OPC_EmitMergeInputChains1_0,
/*  7527*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7529*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8f16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7538*/    0, // EndSwitchType
/*  7539*/   /*Scope*/ 30, /*->7570*/
/*  7540*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7542*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  7545*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7546*/    OPC_EmitMergeInputChains1_0,
/*  7547*/    OPC_EmitInteger32, 0,  // 0 #2
/*  7549*/    OPC_EmitInteger64, 0,  // 0 #3
/*  7551*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7560*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  7567*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7570*/   0, /*End of Scope*/
/*  7571*/  0, /*End of Scope*/
/*  7572*/ /*SwitchOpcode*/ 41|128,1/*169*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7745
/*  7576*/  OPC_RecordMemRef,
/*  7577*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7578*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7579*/  OPC_Scope, 81, /*->7662*/ // 2 children in Scope
/*  7581*/   OPC_CheckChild1TypeI32,
/*  7582*/   OPC_SwitchType /*2 cases */, 58, /*MVT::i32*/7, // ->7643
/*  7585*/    OPC_Scope, 16, /*->7603*/ // 2 children in Scope
/*  7587*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7588*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7589*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7591*/     OPC_EmitMergeInputChains1_0,
/*  7592*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7594*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7603*/    /*Scope*/ 38, /*->7642*/
/*  7604*/     OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  7606*/     OPC_Scope, 16, /*->7624*/ // 2 children in Scope
/*  7608*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  7609*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7610*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7612*/      OPC_EmitMergeInputChains1_0,
/*  7613*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7615*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7624*/     /*Scope*/ 16, /*->7641*/
/*  7625*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  7626*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7627*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7629*/      OPC_EmitMergeInputChains1_0,
/*  7630*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7632*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7641*/     0, /*End of Scope*/
/*  7642*/    0, /*End of Scope*/
/*  7643*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7661
/*  7645*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7646*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7647*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7649*/    OPC_EmitMergeInputChains1_0,
/*  7650*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7652*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7661*/   0, // EndSwitchType
/*  7662*/  /*Scope*/ 81, /*->7744*/
/*  7663*/   OPC_CheckChild1TypeI64,
/*  7664*/   OPC_SwitchType /*2 cases */, 58, /*MVT::i32*/7, // ->7725
/*  7667*/    OPC_Scope, 16, /*->7685*/ // 2 children in Scope
/*  7669*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7670*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7671*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7673*/     OPC_EmitMergeInputChains1_0,
/*  7674*/     OPC_EmitInteger32, 0,  // 0 #4
/*  7676*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7685*/    /*Scope*/ 38, /*->7724*/
/*  7686*/     OPC_CheckPredicate, 13, // Predicate_atomic_load_zext
/*  7688*/     OPC_Scope, 16, /*->7706*/ // 2 children in Scope
/*  7690*/      OPC_CheckPredicate1,  // Predicate_atomic_load_zext_8
/*  7691*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7692*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7694*/      OPC_EmitMergeInputChains1_0,
/*  7695*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7697*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>> - Complexity = 13
                // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7706*/     /*Scope*/ 16, /*->7723*/
/*  7707*/      OPC_CheckPredicate2,  // Predicate_atomic_load_zext_16
/*  7708*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7709*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7711*/      OPC_EmitMergeInputChains1_0,
/*  7712*/      OPC_EmitInteger32, 0,  // 0 #4
/*  7714*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>> - Complexity = 13
                // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7723*/     0, /*End of Scope*/
/*  7724*/    0, /*End of Scope*/
/*  7725*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7743
/*  7727*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7728*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7729*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7731*/    OPC_EmitMergeInputChains1_0,
/*  7732*/    OPC_EmitInteger32, 0,  // 0 #4
/*  7734*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7743*/   0, // EndSwitchType
/*  7744*/  0, /*End of Scope*/
/*  7745*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7990
/*  7749*/  OPC_RecordMemRef,
/*  7750*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7751*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7752*/  OPC_Scope, 117, /*->7871*/ // 2 children in Scope
/*  7754*/   OPC_CheckChild1TypeI32,
/*  7755*/   OPC_RecordChild2, // #2 = $val
/*  7756*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7851
/*  7759*/    OPC_Scope, 17, /*->7778*/ // 5 children in Scope
/*  7761*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7762*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7763*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7765*/     OPC_EmitMergeInputChains1_0,
/*  7766*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7768*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7778*/    /*Scope*/ 17, /*->7796*/
/*  7779*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7780*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7781*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7783*/     OPC_EmitMergeInputChains1_0,
/*  7784*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7786*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7796*/    /*Scope*/ 17, /*->7814*/
/*  7797*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7798*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7799*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7801*/     OPC_EmitMergeInputChains1_0,
/*  7802*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7804*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7814*/    /*Scope*/ 17, /*->7832*/
/*  7815*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7816*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7817*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7819*/     OPC_EmitMergeInputChains1_0,
/*  7820*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7822*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7832*/    /*Scope*/ 17, /*->7850*/
/*  7833*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7834*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7835*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7837*/     OPC_EmitMergeInputChains1_0,
/*  7838*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7840*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7850*/    0, /*End of Scope*/
/*  7851*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7870
/*  7853*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7854*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7855*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7857*/    OPC_EmitMergeInputChains1_0,
/*  7858*/    OPC_EmitInteger32, 0,  // 0 #5
/*  7860*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7870*/   0, // EndSwitchType
/*  7871*/  /*Scope*/ 117, /*->7989*/
/*  7872*/   OPC_CheckChild1TypeI64,
/*  7873*/   OPC_RecordChild2, // #2 = $val
/*  7874*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7969
/*  7877*/    OPC_Scope, 17, /*->7896*/ // 5 children in Scope
/*  7879*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7880*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7881*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7883*/     OPC_EmitMergeInputChains1_0,
/*  7884*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7886*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7896*/    /*Scope*/ 17, /*->7914*/
/*  7897*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7898*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7899*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7901*/     OPC_EmitMergeInputChains1_0,
/*  7902*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7904*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7914*/    /*Scope*/ 17, /*->7932*/
/*  7915*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7916*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7917*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7919*/     OPC_EmitMergeInputChains1_0,
/*  7920*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7922*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7932*/    /*Scope*/ 17, /*->7950*/
/*  7933*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7934*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7935*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7937*/     OPC_EmitMergeInputChains1_0,
/*  7938*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7940*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7950*/    /*Scope*/ 17, /*->7968*/
/*  7951*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7952*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7953*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7955*/     OPC_EmitMergeInputChains1_0,
/*  7956*/     OPC_EmitInteger32, 0,  // 0 #5
/*  7958*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7968*/    0, /*End of Scope*/
/*  7969*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7988
/*  7971*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7972*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7973*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7975*/    OPC_EmitMergeInputChains1_0,
/*  7976*/    OPC_EmitInteger32, 0,  // 0 #5
/*  7978*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7988*/   0, // EndSwitchType
/*  7989*/  0, /*End of Scope*/
/*  7990*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->8235
/*  7994*/  OPC_RecordMemRef,
/*  7995*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7996*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7997*/  OPC_Scope, 117, /*->8116*/ // 2 children in Scope
/*  7999*/   OPC_CheckChild1TypeI32,
/*  8000*/   OPC_RecordChild2, // #2 = $val
/*  8001*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8096
/*  8004*/    OPC_Scope, 17, /*->8023*/ // 5 children in Scope
/*  8006*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  8007*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8008*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8010*/     OPC_EmitMergeInputChains1_0,
/*  8011*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8013*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8023*/    /*Scope*/ 17, /*->8041*/
/*  8024*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8025*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8026*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8028*/     OPC_EmitMergeInputChains1_0,
/*  8029*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8031*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8041*/    /*Scope*/ 17, /*->8059*/
/*  8042*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8043*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8044*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8046*/     OPC_EmitMergeInputChains1_0,
/*  8047*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8049*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8059*/    /*Scope*/ 17, /*->8077*/
/*  8060*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8061*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8062*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8064*/     OPC_EmitMergeInputChains1_0,
/*  8065*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8067*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8077*/    /*Scope*/ 17, /*->8095*/
/*  8078*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8079*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8080*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8082*/     OPC_EmitMergeInputChains1_0,
/*  8083*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8085*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8095*/    0, /*End of Scope*/
/*  8096*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8115
/*  8098*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  8099*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8100*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8102*/    OPC_EmitMergeInputChains1_0,
/*  8103*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8105*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8115*/   0, // EndSwitchType
/*  8116*/  /*Scope*/ 117, /*->8234*/
/*  8117*/   OPC_CheckChild1TypeI64,
/*  8118*/   OPC_RecordChild2, // #2 = $val
/*  8119*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8214
/*  8122*/    OPC_Scope, 17, /*->8141*/ // 5 children in Scope
/*  8124*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  8125*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8126*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8128*/     OPC_EmitMergeInputChains1_0,
/*  8129*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8131*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8141*/    /*Scope*/ 17, /*->8159*/
/*  8142*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8143*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8144*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8146*/     OPC_EmitMergeInputChains1_0,
/*  8147*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8149*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8159*/    /*Scope*/ 17, /*->8177*/
/*  8160*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8161*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8162*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8164*/     OPC_EmitMergeInputChains1_0,
/*  8165*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8167*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8177*/    /*Scope*/ 17, /*->8195*/
/*  8178*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8179*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8180*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8182*/     OPC_EmitMergeInputChains1_0,
/*  8183*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8185*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8195*/    /*Scope*/ 17, /*->8213*/
/*  8196*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8197*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8198*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8200*/     OPC_EmitMergeInputChains1_0,
/*  8201*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8203*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8213*/    0, /*End of Scope*/
/*  8214*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8233
/*  8216*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  8217*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8218*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8220*/    OPC_EmitMergeInputChains1_0,
/*  8221*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8223*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8233*/   0, // EndSwitchType
/*  8234*/  0, /*End of Scope*/
/*  8235*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8480
/*  8239*/  OPC_RecordMemRef,
/*  8240*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8241*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8242*/  OPC_Scope, 117, /*->8361*/ // 2 children in Scope
/*  8244*/   OPC_CheckChild1TypeI32,
/*  8245*/   OPC_RecordChild2, // #2 = $val
/*  8246*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8341
/*  8249*/    OPC_Scope, 17, /*->8268*/ // 5 children in Scope
/*  8251*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8252*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8253*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8255*/     OPC_EmitMergeInputChains1_0,
/*  8256*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8258*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8268*/    /*Scope*/ 17, /*->8286*/
/*  8269*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8270*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8271*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8273*/     OPC_EmitMergeInputChains1_0,
/*  8274*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8276*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8286*/    /*Scope*/ 17, /*->8304*/
/*  8287*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8288*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8289*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8291*/     OPC_EmitMergeInputChains1_0,
/*  8292*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8294*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8304*/    /*Scope*/ 17, /*->8322*/
/*  8305*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8306*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8307*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8309*/     OPC_EmitMergeInputChains1_0,
/*  8310*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8312*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8322*/    /*Scope*/ 17, /*->8340*/
/*  8323*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8324*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8325*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8327*/     OPC_EmitMergeInputChains1_0,
/*  8328*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8330*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8340*/    0, /*End of Scope*/
/*  8341*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8360
/*  8343*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8344*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8345*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8347*/    OPC_EmitMergeInputChains1_0,
/*  8348*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8350*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8360*/   0, // EndSwitchType
/*  8361*/  /*Scope*/ 117, /*->8479*/
/*  8362*/   OPC_CheckChild1TypeI64,
/*  8363*/   OPC_RecordChild2, // #2 = $val
/*  8364*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8459
/*  8367*/    OPC_Scope, 17, /*->8386*/ // 5 children in Scope
/*  8369*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8370*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8371*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8373*/     OPC_EmitMergeInputChains1_0,
/*  8374*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8376*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8386*/    /*Scope*/ 17, /*->8404*/
/*  8387*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8388*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8389*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8391*/     OPC_EmitMergeInputChains1_0,
/*  8392*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8394*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8404*/    /*Scope*/ 17, /*->8422*/
/*  8405*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8406*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8407*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8409*/     OPC_EmitMergeInputChains1_0,
/*  8410*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8412*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8422*/    /*Scope*/ 17, /*->8440*/
/*  8423*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8424*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8425*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8427*/     OPC_EmitMergeInputChains1_0,
/*  8428*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8430*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8440*/    /*Scope*/ 17, /*->8458*/
/*  8441*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8442*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8443*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8445*/     OPC_EmitMergeInputChains1_0,
/*  8446*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8448*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8458*/    0, /*End of Scope*/
/*  8459*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8478
/*  8461*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8462*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8463*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8465*/    OPC_EmitMergeInputChains1_0,
/*  8466*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8468*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8478*/   0, // EndSwitchType
/*  8479*/  0, /*End of Scope*/
/*  8480*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8725
/*  8484*/  OPC_RecordMemRef,
/*  8485*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8486*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8487*/  OPC_Scope, 117, /*->8606*/ // 2 children in Scope
/*  8489*/   OPC_CheckChild1TypeI32,
/*  8490*/   OPC_RecordChild2, // #2 = $val
/*  8491*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8586
/*  8494*/    OPC_Scope, 17, /*->8513*/ // 5 children in Scope
/*  8496*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8497*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8498*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8500*/     OPC_EmitMergeInputChains1_0,
/*  8501*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8503*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8513*/    /*Scope*/ 17, /*->8531*/
/*  8514*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8515*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8516*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8518*/     OPC_EmitMergeInputChains1_0,
/*  8519*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8521*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8531*/    /*Scope*/ 17, /*->8549*/
/*  8532*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8533*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8534*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8536*/     OPC_EmitMergeInputChains1_0,
/*  8537*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8539*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8549*/    /*Scope*/ 17, /*->8567*/
/*  8550*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8551*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8552*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8554*/     OPC_EmitMergeInputChains1_0,
/*  8555*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8557*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8567*/    /*Scope*/ 17, /*->8585*/
/*  8568*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8569*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8570*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8572*/     OPC_EmitMergeInputChains1_0,
/*  8573*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8575*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8585*/    0, /*End of Scope*/
/*  8586*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8605
/*  8588*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8589*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8590*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8592*/    OPC_EmitMergeInputChains1_0,
/*  8593*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8595*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8605*/   0, // EndSwitchType
/*  8606*/  /*Scope*/ 117, /*->8724*/
/*  8607*/   OPC_CheckChild1TypeI64,
/*  8608*/   OPC_RecordChild2, // #2 = $val
/*  8609*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8704
/*  8612*/    OPC_Scope, 17, /*->8631*/ // 5 children in Scope
/*  8614*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8615*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8616*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8618*/     OPC_EmitMergeInputChains1_0,
/*  8619*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8621*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8631*/    /*Scope*/ 17, /*->8649*/
/*  8632*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8633*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8634*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8636*/     OPC_EmitMergeInputChains1_0,
/*  8637*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8639*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8649*/    /*Scope*/ 17, /*->8667*/
/*  8650*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8651*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8652*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8654*/     OPC_EmitMergeInputChains1_0,
/*  8655*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8657*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8667*/    /*Scope*/ 17, /*->8685*/
/*  8668*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8669*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8670*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8672*/     OPC_EmitMergeInputChains1_0,
/*  8673*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8675*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8685*/    /*Scope*/ 17, /*->8703*/
/*  8686*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8687*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8688*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8690*/     OPC_EmitMergeInputChains1_0,
/*  8691*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8693*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8703*/    0, /*End of Scope*/
/*  8704*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8723
/*  8706*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8707*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8708*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8710*/    OPC_EmitMergeInputChains1_0,
/*  8711*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8713*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8723*/   0, // EndSwitchType
/*  8724*/  0, /*End of Scope*/
/*  8725*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8970
/*  8729*/  OPC_RecordMemRef,
/*  8730*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8731*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8732*/  OPC_Scope, 117, /*->8851*/ // 2 children in Scope
/*  8734*/   OPC_CheckChild1TypeI32,
/*  8735*/   OPC_RecordChild2, // #2 = $val
/*  8736*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8831
/*  8739*/    OPC_Scope, 17, /*->8758*/ // 5 children in Scope
/*  8741*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8742*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8743*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8745*/     OPC_EmitMergeInputChains1_0,
/*  8746*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8748*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8758*/    /*Scope*/ 17, /*->8776*/
/*  8759*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8760*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8761*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8763*/     OPC_EmitMergeInputChains1_0,
/*  8764*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8766*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8776*/    /*Scope*/ 17, /*->8794*/
/*  8777*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8778*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8779*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8781*/     OPC_EmitMergeInputChains1_0,
/*  8782*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8784*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8794*/    /*Scope*/ 17, /*->8812*/
/*  8795*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8796*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8797*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8799*/     OPC_EmitMergeInputChains1_0,
/*  8800*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8802*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8812*/    /*Scope*/ 17, /*->8830*/
/*  8813*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8814*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8815*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8817*/     OPC_EmitMergeInputChains1_0,
/*  8818*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8820*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8830*/    0, /*End of Scope*/
/*  8831*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8850
/*  8833*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8834*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8835*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8837*/    OPC_EmitMergeInputChains1_0,
/*  8838*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8840*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8850*/   0, // EndSwitchType
/*  8851*/  /*Scope*/ 117, /*->8969*/
/*  8852*/   OPC_CheckChild1TypeI64,
/*  8853*/   OPC_RecordChild2, // #2 = $val
/*  8854*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8949
/*  8857*/    OPC_Scope, 17, /*->8876*/ // 5 children in Scope
/*  8859*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8860*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8861*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8863*/     OPC_EmitMergeInputChains1_0,
/*  8864*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8866*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8876*/    /*Scope*/ 17, /*->8894*/
/*  8877*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8878*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8879*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8881*/     OPC_EmitMergeInputChains1_0,
/*  8882*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8884*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8894*/    /*Scope*/ 17, /*->8912*/
/*  8895*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8896*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8897*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8899*/     OPC_EmitMergeInputChains1_0,
/*  8900*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8902*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8912*/    /*Scope*/ 17, /*->8930*/
/*  8913*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8914*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8915*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8917*/     OPC_EmitMergeInputChains1_0,
/*  8918*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8920*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8930*/    /*Scope*/ 17, /*->8948*/
/*  8931*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8932*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8933*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8935*/     OPC_EmitMergeInputChains1_0,
/*  8936*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8938*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8948*/    0, /*End of Scope*/
/*  8949*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8968
/*  8951*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8952*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8953*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8955*/    OPC_EmitMergeInputChains1_0,
/*  8956*/    OPC_EmitInteger32, 0,  // 0 #5
/*  8958*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8968*/   0, // EndSwitchType
/*  8969*/  0, /*End of Scope*/
/*  8970*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->9215
/*  8974*/  OPC_RecordMemRef,
/*  8975*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8976*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8977*/  OPC_Scope, 117, /*->9096*/ // 2 children in Scope
/*  8979*/   OPC_CheckChild1TypeI32,
/*  8980*/   OPC_RecordChild2, // #2 = $val
/*  8981*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->9076
/*  8984*/    OPC_Scope, 17, /*->9003*/ // 5 children in Scope
/*  8986*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8987*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8988*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8990*/     OPC_EmitMergeInputChains1_0,
/*  8991*/     OPC_EmitInteger32, 0,  // 0 #5
/*  8993*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9003*/    /*Scope*/ 17, /*->9021*/
/*  9004*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9005*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9006*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9008*/     OPC_EmitMergeInputChains1_0,
/*  9009*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9011*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9021*/    /*Scope*/ 17, /*->9039*/
/*  9022*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9023*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9024*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9026*/     OPC_EmitMergeInputChains1_0,
/*  9027*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9029*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9039*/    /*Scope*/ 17, /*->9057*/
/*  9040*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9041*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9042*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9044*/     OPC_EmitMergeInputChains1_0,
/*  9045*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9047*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9057*/    /*Scope*/ 17, /*->9075*/
/*  9058*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9059*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9060*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9062*/     OPC_EmitMergeInputChains1_0,
/*  9063*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9065*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  9075*/    0, /*End of Scope*/
/*  9076*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->9095
/*  9078*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  9079*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9080*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  9082*/    OPC_EmitMergeInputChains1_0,
/*  9083*/    OPC_EmitInteger32, 0,  // 0 #5
/*  9085*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  9095*/   0, // EndSwitchType
/*  9096*/  /*Scope*/ 117, /*->9214*/
/*  9097*/   OPC_CheckChild1TypeI64,
/*  9098*/   OPC_RecordChild2, // #2 = $val
/*  9099*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->9194
/*  9102*/    OPC_Scope, 17, /*->9121*/ // 5 children in Scope
/*  9104*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  9105*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9106*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9108*/     OPC_EmitMergeInputChains1_0,
/*  9109*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9111*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9121*/    /*Scope*/ 17, /*->9139*/
/*  9122*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9123*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9124*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9126*/     OPC_EmitMergeInputChains1_0,
/*  9127*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9129*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9139*/    /*Scope*/ 17, /*->9157*/
/*  9140*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9141*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9142*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9144*/     OPC_EmitMergeInputChains1_0,
/*  9145*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9147*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9157*/    /*Scope*/ 17, /*->9175*/
/*  9158*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9159*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9160*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9162*/     OPC_EmitMergeInputChains1_0,
/*  9163*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9175*/    /*Scope*/ 17, /*->9193*/
/*  9176*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9177*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9178*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9180*/     OPC_EmitMergeInputChains1_0,
/*  9181*/     OPC_EmitInteger32, 0,  // 0 #5
/*  9183*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9193*/    0, /*End of Scope*/
/*  9194*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->9213
/*  9196*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  9197*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9198*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9200*/    OPC_EmitMergeInputChains1_0,
/*  9201*/    OPC_EmitInteger32, 0,  // 0 #5
/*  9203*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9213*/   0, // EndSwitchType
/*  9214*/  0, /*End of Scope*/
/*  9215*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9474
/*  9219*/  OPC_RecordMemRef,
/*  9220*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9221*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9222*/  OPC_Scope, 124, /*->9348*/ // 2 children in Scope
/*  9224*/   OPC_CheckChild1TypeI32,
/*  9225*/   OPC_RecordChild2, // #2 = $exp
/*  9226*/   OPC_RecordChild3, // #3 = $new
/*  9227*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9327
/*  9230*/    OPC_Scope, 18, /*->9250*/ // 5 children in Scope
/*  9232*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9233*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9234*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9236*/     OPC_EmitMergeInputChains1_0,
/*  9237*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9239*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9250*/    /*Scope*/ 18, /*->9269*/
/*  9251*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9252*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9253*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9255*/     OPC_EmitMergeInputChains1_0,
/*  9256*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9258*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9269*/    /*Scope*/ 18, /*->9288*/
/*  9270*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9271*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9272*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9274*/     OPC_EmitMergeInputChains1_0,
/*  9275*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9277*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9288*/    /*Scope*/ 18, /*->9307*/
/*  9289*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9290*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9291*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9293*/     OPC_EmitMergeInputChains1_0,
/*  9294*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9296*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9307*/    /*Scope*/ 18, /*->9326*/
/*  9308*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9309*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9310*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9312*/     OPC_EmitMergeInputChains1_0,
/*  9313*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9315*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9326*/    0, /*End of Scope*/
/*  9327*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9347
/*  9329*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9330*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9331*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9333*/    OPC_EmitMergeInputChains1_0,
/*  9334*/    OPC_EmitInteger32, 0,  // 0 #6
/*  9336*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9347*/   0, // EndSwitchType
/*  9348*/  /*Scope*/ 124, /*->9473*/
/*  9349*/   OPC_CheckChild1TypeI64,
/*  9350*/   OPC_RecordChild2, // #2 = $exp
/*  9351*/   OPC_RecordChild3, // #3 = $new
/*  9352*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9452
/*  9355*/    OPC_Scope, 18, /*->9375*/ // 5 children in Scope
/*  9357*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9358*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9359*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9361*/     OPC_EmitMergeInputChains1_0,
/*  9362*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9364*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9375*/    /*Scope*/ 18, /*->9394*/
/*  9376*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9377*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9378*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9380*/     OPC_EmitMergeInputChains1_0,
/*  9381*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9383*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9394*/    /*Scope*/ 18, /*->9413*/
/*  9395*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9396*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9397*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9399*/     OPC_EmitMergeInputChains1_0,
/*  9400*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9413*/    /*Scope*/ 18, /*->9432*/
/*  9414*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9415*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9416*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9418*/     OPC_EmitMergeInputChains1_0,
/*  9419*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9421*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9432*/    /*Scope*/ 18, /*->9451*/
/*  9433*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9434*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9435*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9437*/     OPC_EmitMergeInputChains1_0,
/*  9438*/     OPC_EmitInteger32, 0,  // 0 #6
/*  9440*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9451*/    0, /*End of Scope*/
/*  9452*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9472
/*  9454*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9455*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9456*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9458*/    OPC_EmitMergeInputChains1_0,
/*  9459*/    OPC_EmitInteger32, 0,  // 0 #6
/*  9461*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9472*/   0, // EndSwitchType
/*  9473*/  0, /*End of Scope*/
/*  9474*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9566
/*  9477*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9478*/  OPC_Scope, 69, /*->9549*/ // 2 children in Scope
/*  9480*/   OPC_MoveChild1,
/*  9481*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9506
/*  9485*/    OPC_RecordChild0, // #1 = $cond
/*  9486*/    OPC_MoveChild0,
/*  9487*/    OPC_CheckPredicate, 25, // Predicate_bool_node
/*  9489*/    OPC_MoveParent,
/*  9490*/    OPC_CheckChild1Integer, 2, 
/*  9492*/    OPC_CheckTypeI32,
/*  9493*/    OPC_MoveSibling2,
/*  9494*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9497*/    OPC_RecordNode, // #2 = $dst
/*  9498*/    OPC_MoveParent,
/*  9499*/    OPC_EmitMergeInputChains1_0,
/*  9500*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9506*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9548
/*  9509*/    OPC_RecordChild0, // #1 = $cond
/*  9510*/    OPC_CheckChild0TypeI32,
/*  9511*/    OPC_CheckChild1Integer, 0, 
/*  9513*/    OPC_CheckTypeI32,
/*  9514*/    OPC_Scope, 15, /*->9531*/ // 2 children in Scope
/*  9516*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9518*/     OPC_MoveSibling2,
/*  9519*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9522*/     OPC_RecordNode, // #2 = $dst
/*  9523*/     OPC_MoveParent,
/*  9524*/     OPC_EmitMergeInputChains1_0,
/*  9525*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9531*/    /*Scope*/ 15, /*->9547*/
/*  9532*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9534*/     OPC_MoveSibling2,
/*  9535*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9538*/     OPC_RecordNode, // #2 = $dst
/*  9539*/     OPC_MoveParent,
/*  9540*/     OPC_EmitMergeInputChains1_0,
/*  9541*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9547*/    0, /*End of Scope*/
/*  9548*/   0, // EndSwitchOpcode
/*  9549*/  /*Scope*/ 15, /*->9565*/
/*  9550*/   OPC_RecordChild1, // #1 = $cond
/*  9551*/   OPC_CheckChild1TypeI32,
/*  9552*/   OPC_RecordChild2, // #2 = $dst
/*  9553*/   OPC_MoveChild2,
/*  9554*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9557*/   OPC_MoveParent,
/*  9558*/   OPC_EmitMergeInputChains1_0,
/*  9559*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9565*/  0, /*End of Scope*/
/*  9566*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9628
/*  9569*/  OPC_RecordChild0, // #0 = $lhs
/*  9570*/  OPC_Scope, 31, /*->9603*/ // 2 children in Scope
/*  9572*/   OPC_MoveChild1,
/*  9573*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9588
/*  9576*/    OPC_CheckAndImm, 31, 
/*  9578*/    OPC_RecordChild0, // #1 = $rhs
/*  9579*/    OPC_MoveParent,
/*  9580*/    OPC_CheckTypeI32,
/*  9581*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9588*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9602
/*  9590*/    OPC_CheckAndImm, 63, 
/*  9592*/    OPC_RecordChild0, // #1 = $rhs
/*  9593*/    OPC_MoveParent,
/*  9594*/    OPC_CheckTypeI64,
/*  9595*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9602*/   0, // EndSwitchType
/*  9603*/  /*Scope*/ 23, /*->9627*/
/*  9604*/   OPC_RecordChild1, // #1 = $rhs
/*  9605*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9616
/*  9608*/    OPC_CheckChild1TypeI32,
/*  9609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9616*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9626
/*  9618*/    OPC_CheckChild1TypeI64,
/*  9619*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9626*/   0, // EndSwitchType
/*  9627*/  0, /*End of Scope*/
/*  9628*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9690
/*  9631*/  OPC_RecordChild0, // #0 = $lhs
/*  9632*/  OPC_Scope, 31, /*->9665*/ // 2 children in Scope
/*  9634*/   OPC_MoveChild1,
/*  9635*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9650
/*  9638*/    OPC_CheckAndImm, 31, 
/*  9640*/    OPC_RecordChild0, // #1 = $rhs
/*  9641*/    OPC_MoveParent,
/*  9642*/    OPC_CheckTypeI32,
/*  9643*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9650*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9664
/*  9652*/    OPC_CheckAndImm, 63, 
/*  9654*/    OPC_RecordChild0, // #1 = $rhs
/*  9655*/    OPC_MoveParent,
/*  9656*/    OPC_CheckTypeI64,
/*  9657*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9664*/   0, // EndSwitchType
/*  9665*/  /*Scope*/ 23, /*->9689*/
/*  9666*/   OPC_RecordChild1, // #1 = $rhs
/*  9667*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9678
/*  9670*/    OPC_CheckChild1TypeI32,
/*  9671*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9678*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9688
/*  9680*/    OPC_CheckChild1TypeI64,
/*  9681*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9688*/   0, // EndSwitchType
/*  9689*/  0, /*End of Scope*/
/*  9690*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9752
/*  9693*/  OPC_RecordChild0, // #0 = $lhs
/*  9694*/  OPC_Scope, 31, /*->9727*/ // 2 children in Scope
/*  9696*/   OPC_MoveChild1,
/*  9697*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9712
/*  9700*/    OPC_CheckAndImm, 31, 
/*  9702*/    OPC_RecordChild0, // #1 = $rhs
/*  9703*/    OPC_MoveParent,
/*  9704*/    OPC_CheckTypeI32,
/*  9705*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9712*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9726
/*  9714*/    OPC_CheckAndImm, 63, 
/*  9716*/    OPC_RecordChild0, // #1 = $rhs
/*  9717*/    OPC_MoveParent,
/*  9718*/    OPC_CheckTypeI64,
/*  9719*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9726*/   0, // EndSwitchType
/*  9727*/  /*Scope*/ 23, /*->9751*/
/*  9728*/   OPC_RecordChild1, // #1 = $rhs
/*  9729*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9740
/*  9732*/    OPC_CheckChild1TypeI32,
/*  9733*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9740*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9750
/*  9742*/    OPC_CheckChild1TypeI64,
/*  9743*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9750*/   0, // EndSwitchType
/*  9751*/  0, /*End of Scope*/
/*  9752*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9814
/*  9755*/  OPC_RecordChild0, // #0 = $lhs
/*  9756*/  OPC_Scope, 31, /*->9789*/ // 2 children in Scope
/*  9758*/   OPC_MoveChild1,
/*  9759*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9774
/*  9762*/    OPC_CheckAndImm, 31, 
/*  9764*/    OPC_RecordChild0, // #1 = $rhs
/*  9765*/    OPC_MoveParent,
/*  9766*/    OPC_CheckTypeI32,
/*  9767*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9774*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9788
/*  9776*/    OPC_CheckAndImm, 63, 
/*  9778*/    OPC_RecordChild0, // #1 = $rhs
/*  9779*/    OPC_MoveParent,
/*  9780*/    OPC_CheckTypeI64,
/*  9781*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9788*/   0, // EndSwitchType
/*  9789*/  /*Scope*/ 23, /*->9813*/
/*  9790*/   OPC_RecordChild1, // #1 = $rhs
/*  9791*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9802
/*  9794*/    OPC_CheckChild1TypeI32,
/*  9795*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9802*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9812
/*  9804*/    OPC_CheckChild1TypeI64,
/*  9805*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9812*/   0, // EndSwitchType
/*  9813*/  0, /*End of Scope*/
/*  9814*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9876
/*  9817*/  OPC_RecordChild0, // #0 = $lhs
/*  9818*/  OPC_Scope, 31, /*->9851*/ // 2 children in Scope
/*  9820*/   OPC_MoveChild1,
/*  9821*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9836
/*  9824*/    OPC_CheckAndImm, 31, 
/*  9826*/    OPC_RecordChild0, // #1 = $rhs
/*  9827*/    OPC_MoveParent,
/*  9828*/    OPC_CheckTypeI32,
/*  9829*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9836*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9850
/*  9838*/    OPC_CheckAndImm, 63, 
/*  9840*/    OPC_RecordChild0, // #1 = $rhs
/*  9841*/    OPC_MoveParent,
/*  9842*/    OPC_CheckTypeI64,
/*  9843*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9850*/   0, // EndSwitchType
/*  9851*/  /*Scope*/ 23, /*->9875*/
/*  9852*/   OPC_RecordChild1, // #1 = $rhs
/*  9853*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9864
/*  9856*/    OPC_CheckChild1TypeI32,
/*  9857*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9864*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9874
/*  9866*/    OPC_CheckChild1TypeI64,
/*  9867*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9874*/   0, // EndSwitchType
/*  9875*/  0, /*End of Scope*/
/*  9876*/ /*SwitchOpcode*/ 48|128,4/*560*/, TARGET_VAL(ISD::SELECT),// ->10440
/*  9880*/  OPC_Scope, 11|128,1/*139*/, /*->10022*/ // 8 children in Scope
/*  9883*/   OPC_MoveChild0,
/*  9884*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9887*/   OPC_RecordChild0, // #0 = $cond
/*  9888*/   OPC_CheckChild0TypeI32,
/*  9889*/   OPC_CheckChild1Integer, 0, 
/*  9891*/   OPC_CheckTypeI32,
/*  9892*/   OPC_Scope, 63, /*->9957*/ // 2 children in Scope
/*  9894*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9896*/    OPC_MoveParent,
/*  9897*/    OPC_RecordChild1, // #1 = $lhs
/*  9898*/    OPC_RecordChild2, // #2 = $rhs
/*  9899*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9910
/*  9902*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9910*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9920
/*  9912*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9920*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9932
/*  9923*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9932*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->9944
/*  9935*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9944*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->9956
/*  9947*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9956*/    0, // EndSwitchType
/*  9957*/   /*Scope*/ 63, /*->10021*/
/*  9958*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9960*/    OPC_MoveParent,
/*  9961*/    OPC_RecordChild1, // #1 = $lhs
/*  9962*/    OPC_RecordChild2, // #2 = $rhs
/*  9963*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9974
/*  9966*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9974*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9984
/*  9976*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9984*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9996
/*  9987*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9996*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->10008
/*  9999*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10008*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->10020
/* 10011*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10020*/    0, // EndSwitchType
/* 10021*/   0, /*End of Scope*/
/* 10022*/  /*Scope*/ 65, /*->10088*/
/* 10023*/   OPC_RecordChild0, // #0 = $cond
/* 10024*/   OPC_CheckChild0TypeI32,
/* 10025*/   OPC_RecordChild1, // #1 = $lhs
/* 10026*/   OPC_RecordChild2, // #2 = $rhs
/* 10027*/   OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->10038
/* 10030*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10038*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->10048
/* 10040*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10048*/   /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->10061
/* 10051*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10061*/   /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->10074
/* 10064*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10065*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10074*/   /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->10087
/* 10077*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10078*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10087*/   0, // EndSwitchType
/* 10088*/  /*Scope*/ 67, /*->10156*/
/* 10089*/   OPC_MoveChild0,
/* 10090*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10093*/   OPC_RecordChild0, // #0 = $cond
/* 10094*/   OPC_CheckChild0TypeI32,
/* 10095*/   OPC_CheckChild1Integer, 0, 
/* 10097*/   OPC_CheckTypeI32,
/* 10098*/   OPC_Scope, 27, /*->10127*/ // 2 children in Scope
/* 10100*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10102*/    OPC_MoveParent,
/* 10103*/    OPC_RecordChild1, // #1 = $lhs
/* 10104*/    OPC_RecordChild2, // #2 = $rhs
/* 10105*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->10116
/* 10108*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10116*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->10126
/* 10118*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10126*/    0, // EndSwitchType
/* 10127*/   /*Scope*/ 27, /*->10155*/
/* 10128*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10130*/    OPC_MoveParent,
/* 10131*/    OPC_RecordChild1, // #1 = $lhs
/* 10132*/    OPC_RecordChild2, // #2 = $rhs
/* 10133*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->10144
/* 10136*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10144*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->10154
/* 10146*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/* 10154*/    0, // EndSwitchType
/* 10155*/   0, /*End of Scope*/
/* 10156*/  /*Scope*/ 26, /*->10183*/
/* 10157*/   OPC_RecordChild0, // #0 = $cond
/* 10158*/   OPC_CheckChild0TypeI32,
/* 10159*/   OPC_RecordChild1, // #1 = $lhs
/* 10160*/   OPC_RecordChild2, // #2 = $rhs
/* 10161*/   OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->10172
/* 10164*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10172*/   /*SwitchType*/ 8, /*MVT::f64*/13, // ->10182
/* 10174*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10182*/   0, // EndSwitchType
/* 10183*/  /*Scope*/ 107, /*->10291*/
/* 10184*/   OPC_MoveChild0,
/* 10185*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10188*/   OPC_RecordChild0, // #0 = $cond
/* 10189*/   OPC_CheckChild0TypeI32,
/* 10190*/   OPC_CheckChild1Integer, 0, 
/* 10192*/   OPC_CheckTypeI32,
/* 10193*/   OPC_Scope, 47, /*->10242*/ // 2 children in Scope
/* 10195*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10197*/    OPC_MoveParent,
/* 10198*/    OPC_RecordChild1, // #1 = $lhs
/* 10199*/    OPC_RecordChild2, // #2 = $rhs
/* 10200*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10211
/* 10203*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10211*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10221
/* 10213*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10221*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10231
/* 10223*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10231*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10241
/* 10233*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10241*/    0, // EndSwitchType
/* 10242*/   /*Scope*/ 47, /*->10290*/
/* 10243*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10245*/    OPC_MoveParent,
/* 10246*/    OPC_RecordChild1, // #1 = $lhs
/* 10247*/    OPC_RecordChild2, // #2 = $rhs
/* 10248*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10259
/* 10251*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10259*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10269
/* 10261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10269*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10279
/* 10271*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10279*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10289
/* 10281*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10289*/    0, // EndSwitchType
/* 10290*/   0, /*End of Scope*/
/* 10291*/  /*Scope*/ 46, /*->10338*/
/* 10292*/   OPC_RecordChild0, // #0 = $cond
/* 10293*/   OPC_CheckChild0TypeI32,
/* 10294*/   OPC_RecordChild1, // #1 = $lhs
/* 10295*/   OPC_RecordChild2, // #2 = $rhs
/* 10296*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10307
/* 10299*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10307*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10317
/* 10309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10317*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10327
/* 10319*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10327*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10337
/* 10329*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10337*/   0, // EndSwitchType
/* 10338*/  /*Scope*/ 71, /*->10410*/
/* 10339*/   OPC_MoveChild0,
/* 10340*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10343*/   OPC_RecordChild0, // #0 = $cond
/* 10344*/   OPC_CheckChild0TypeI32,
/* 10345*/   OPC_CheckChild1Integer, 0, 
/* 10347*/   OPC_CheckTypeI32,
/* 10348*/   OPC_Scope, 29, /*->10379*/ // 2 children in Scope
/* 10350*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10352*/    OPC_MoveParent,
/* 10353*/    OPC_RecordChild1, // #1 = $lhs
/* 10354*/    OPC_RecordChild2, // #2 = $rhs
/* 10355*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10366
/* 10358*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10366*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10378
/* 10369*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10378*/    0, // EndSwitchType
/* 10379*/   /*Scope*/ 29, /*->10409*/
/* 10380*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10382*/    OPC_MoveParent,
/* 10383*/    OPC_RecordChild1, // #1 = $lhs
/* 10384*/    OPC_RecordChild2, // #2 = $rhs
/* 10385*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10396
/* 10388*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10396*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10408
/* 10399*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10408*/    0, // EndSwitchType
/* 10409*/   0, /*End of Scope*/
/* 10410*/  /*Scope*/ 28, /*->10439*/
/* 10411*/   OPC_RecordChild0, // #0 = $cond
/* 10412*/   OPC_CheckChild0TypeI32,
/* 10413*/   OPC_RecordChild1, // #1 = $lhs
/* 10414*/   OPC_RecordChild2, // #2 = $rhs
/* 10415*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10426
/* 10418*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10426*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10438
/* 10429*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10438*/   0, // EndSwitchType
/* 10439*/  0, /*End of Scope*/
/* 10440*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10573
/* 10444*/  OPC_Scope, 57, /*->10503*/ // 2 children in Scope
/* 10446*/   OPC_MoveChild0,
/* 10447*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10450*/   OPC_RecordChild0, // #0 = $vec
/* 10451*/   OPC_Scope, 24, /*->10477*/ // 2 children in Scope
/* 10453*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 10455*/    OPC_RecordChild1, // #1 = $idx
/* 10456*/    OPC_MoveChild1,
/* 10457*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10460*/    OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/* 10462*/    OPC_CheckTypeI32,
/* 10463*/    OPC_MoveParent,
/* 10464*/    OPC_MoveSibling1,
/* 10465*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10467*/    OPC_MoveParent,
/* 10468*/    OPC_CheckTypeI32,
/* 10469*/    OPC_EmitConvertToTarget1, // #2
/* 10470*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10477*/   /*Scope*/ 24, /*->10502*/
/* 10478*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 10480*/    OPC_RecordChild1, // #1 = $idx
/* 10481*/    OPC_MoveChild1,
/* 10482*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10485*/    OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 10487*/    OPC_CheckTypeI32,
/* 10488*/    OPC_MoveParent,
/* 10489*/    OPC_MoveSibling1,
/* 10490*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10492*/    OPC_MoveParent,
/* 10493*/    OPC_CheckTypeI32,
/* 10494*/    OPC_EmitConvertToTarget1, // #2
/* 10495*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10502*/   0, /*End of Scope*/
/* 10503*/  /*Scope*/ 68, /*->10572*/
/* 10504*/   OPC_RecordChild0, // #0 = $src
/* 10505*/   OPC_MoveChild1,
/* 10506*/   OPC_Scope, 25, /*->10533*/ // 3 children in Scope
/* 10508*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10510*/    OPC_MoveParent,
/* 10511*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10522
/* 10514*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10516*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10522*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10532
/* 10524*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10526*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10532*/    0, // EndSwitchType
/* 10533*/   /*Scope*/ 25, /*->10559*/
/* 10534*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10536*/    OPC_MoveParent,
/* 10537*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10548
/* 10540*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10542*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10548*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10558
/* 10550*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10552*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10558*/    0, // EndSwitchType
/* 10559*/   /*Scope*/ 11, /*->10571*/
/* 10560*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 10562*/    OPC_MoveParent,
/* 10563*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10565*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10571*/   0, /*End of Scope*/
/* 10572*/  0, /*End of Scope*/
/* 10573*/ /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10751
/* 10577*/  OPC_RecordMemRef,
/* 10578*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10579*/  OPC_MoveChild1,
/* 10580*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10583*/  OPC_RecordChild0, // #1 = $addr
/* 10584*/  OPC_MoveChild0,
/* 10585*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10588*/  OPC_MoveParent,
/* 10589*/  OPC_MoveParent,
/* 10590*/  OPC_SwitchType /*14 cases */, 8, /*MVT::i32*/7, // ->10601
/* 10593*/   OPC_EmitMergeInputChains1_0,
/* 10594*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10601*/  /*SwitchType*/ 8, /*MVT::i64*/8, // ->10611
/* 10603*/   OPC_EmitMergeInputChains1_0,
/* 10604*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10611*/  /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->10624
/* 10614*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10615*/   OPC_EmitMergeInputChains1_0,
/* 10616*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10624*/  /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->10637
/* 10627*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10628*/   OPC_EmitMergeInputChains1_0,
/* 10629*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10637*/  /*SwitchType*/ 11, /*MVT::exnref*/101|128,1/*229*/, // ->10651
/* 10640*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10642*/   OPC_EmitMergeInputChains1_0,
/* 10643*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10651*/  /*SwitchType*/ 8, /*MVT::f32*/12, // ->10661
/* 10653*/   OPC_EmitMergeInputChains1_0,
/* 10654*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10661*/  /*SwitchType*/ 8, /*MVT::f64*/13, // ->10671
/* 10663*/   OPC_EmitMergeInputChains1_0,
/* 10664*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10671*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->10682
/* 10673*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10674*/   OPC_EmitMergeInputChains1_0,
/* 10675*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10682*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->10693
/* 10684*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10685*/   OPC_EmitMergeInputChains1_0,
/* 10686*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10693*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->10704
/* 10695*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10696*/   OPC_EmitMergeInputChains1_0,
/* 10697*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10704*/  /*SwitchType*/ 9, /*MVT::v8i16*/50, // ->10715
/* 10706*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10707*/   OPC_EmitMergeInputChains1_0,
/* 10708*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10715*/  /*SwitchType*/ 9, /*MVT::v8f16*/92, // ->10726
/* 10717*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10718*/   OPC_EmitMergeInputChains1_0,
/* 10719*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10726*/  /*SwitchType*/ 9, /*MVT::v4f32*/111, // ->10737
/* 10728*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10729*/   OPC_EmitMergeInputChains1_0,
/* 10730*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10737*/  /*SwitchType*/ 10, /*MVT::v2f64*/1|128,1/*129*/, // ->10750
/* 10740*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10741*/   OPC_EmitMergeInputChains1_0,
/* 10742*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10750*/  0, // EndSwitchType
/* 10751*/ /*SwitchOpcode*/ 70|128,2/*326*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->11081
/* 10755*/  OPC_RecordMemRef,
/* 10756*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10757*/  OPC_RecordChild1, // #1 = $src
/* 10758*/  OPC_Scope, 20, /*->10780*/ // 14 children in Scope
/* 10760*/   OPC_CheckChild1TypeI32,
/* 10761*/   OPC_MoveChild2,
/* 10762*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10765*/   OPC_RecordChild0, // #2 = $addr
/* 10766*/   OPC_MoveChild0,
/* 10767*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10770*/   OPC_MoveParent,
/* 10771*/   OPC_MoveParent,
/* 10772*/   OPC_EmitMergeInputChains1_0,
/* 10773*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10780*/  /*Scope*/ 20, /*->10801*/
/* 10781*/   OPC_CheckChild1TypeI64,
/* 10782*/   OPC_MoveChild2,
/* 10783*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10786*/   OPC_RecordChild0, // #2 = $addr
/* 10787*/   OPC_MoveChild0,
/* 10788*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10791*/   OPC_MoveParent,
/* 10792*/   OPC_MoveParent,
/* 10793*/   OPC_EmitMergeInputChains1_0,
/* 10794*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10801*/  /*Scope*/ 21, /*->10823*/
/* 10802*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 10804*/   OPC_MoveChild2,
/* 10805*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10808*/   OPC_RecordChild0, // #2 = $addr
/* 10809*/   OPC_MoveChild0,
/* 10810*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10813*/   OPC_MoveParent,
/* 10814*/   OPC_MoveParent,
/* 10815*/   OPC_EmitMergeInputChains1_0,
/* 10816*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10823*/  /*Scope*/ 21, /*->10845*/
/* 10824*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 10826*/   OPC_MoveChild2,
/* 10827*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10830*/   OPC_RecordChild0, // #2 = $addr
/* 10831*/   OPC_MoveChild0,
/* 10832*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10835*/   OPC_MoveParent,
/* 10836*/   OPC_MoveParent,
/* 10837*/   OPC_EmitMergeInputChains1_0,
/* 10838*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10845*/  /*Scope*/ 22, /*->10868*/
/* 10846*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 10848*/   OPC_MoveChild2,
/* 10849*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10852*/   OPC_RecordChild0, // #2 = $addr
/* 10853*/   OPC_MoveChild0,
/* 10854*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10857*/   OPC_MoveParent,
/* 10858*/   OPC_MoveParent,
/* 10859*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10860*/   OPC_EmitMergeInputChains1_0,
/* 10861*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10868*/  /*Scope*/ 22, /*->10891*/
/* 10869*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 10871*/   OPC_MoveChild2,
/* 10872*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10875*/   OPC_RecordChild0, // #2 = $addr
/* 10876*/   OPC_MoveChild0,
/* 10877*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10880*/   OPC_MoveParent,
/* 10881*/   OPC_MoveParent,
/* 10882*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10883*/   OPC_EmitMergeInputChains1_0,
/* 10884*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10891*/  /*Scope*/ 23, /*->10915*/
/* 10892*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 10895*/   OPC_MoveChild2,
/* 10896*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10899*/   OPC_RecordChild0, // #2 = $addr
/* 10900*/   OPC_MoveChild0,
/* 10901*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10904*/   OPC_MoveParent,
/* 10905*/   OPC_MoveParent,
/* 10906*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10907*/   OPC_EmitMergeInputChains1_0,
/* 10908*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10915*/  /*Scope*/ 22, /*->10938*/
/* 10916*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 10918*/   OPC_MoveChild2,
/* 10919*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10922*/   OPC_RecordChild0, // #2 = $addr
/* 10923*/   OPC_MoveChild0,
/* 10924*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10927*/   OPC_MoveParent,
/* 10928*/   OPC_MoveParent,
/* 10929*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10930*/   OPC_EmitMergeInputChains1_0,
/* 10931*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10938*/  /*Scope*/ 22, /*->10961*/
/* 10939*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 10941*/   OPC_MoveChild2,
/* 10942*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10945*/   OPC_RecordChild0, // #2 = $addr
/* 10946*/   OPC_MoveChild0,
/* 10947*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10950*/   OPC_MoveParent,
/* 10951*/   OPC_MoveParent,
/* 10952*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10953*/   OPC_EmitMergeInputChains1_0,
/* 10954*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10961*/  /*Scope*/ 22, /*->10984*/
/* 10962*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 10964*/   OPC_MoveChild2,
/* 10965*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10968*/   OPC_RecordChild0, // #2 = $addr
/* 10969*/   OPC_MoveChild0,
/* 10970*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10973*/   OPC_MoveParent,
/* 10974*/   OPC_MoveParent,
/* 10975*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10976*/   OPC_EmitMergeInputChains1_0,
/* 10977*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10984*/  /*Scope*/ 22, /*->11007*/
/* 10985*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 10987*/   OPC_MoveChild2,
/* 10988*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10991*/   OPC_RecordChild0, // #2 = $addr
/* 10992*/   OPC_MoveChild0,
/* 10993*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10996*/   OPC_MoveParent,
/* 10997*/   OPC_MoveParent,
/* 10998*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10999*/   OPC_EmitMergeInputChains1_0,
/* 11000*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 11007*/  /*Scope*/ 23, /*->11031*/
/* 11008*/   OPC_CheckChild1Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11011*/   OPC_MoveChild2,
/* 11012*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11015*/   OPC_RecordChild0, // #2 = $addr
/* 11016*/   OPC_MoveChild0,
/* 11017*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11020*/   OPC_MoveParent,
/* 11021*/   OPC_MoveParent,
/* 11022*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11023*/   OPC_EmitMergeInputChains1_0,
/* 11024*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 11031*/  /*Scope*/ 23, /*->11055*/
/* 11032*/   OPC_CheckChild1Type, /*MVT::externref*/100|128,1/*228*/, 
/* 11035*/   OPC_MoveChild2,
/* 11036*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11039*/   OPC_RecordChild0, // #2 = $addr
/* 11040*/   OPC_MoveChild0,
/* 11041*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11044*/   OPC_MoveParent,
/* 11045*/   OPC_MoveParent,
/* 11046*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11047*/   OPC_EmitMergeInputChains1_0,
/* 11048*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 11055*/  /*Scope*/ 24, /*->11080*/
/* 11056*/   OPC_CheckChild1Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 11059*/   OPC_MoveChild2,
/* 11060*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11063*/   OPC_RecordChild0, // #2 = $addr
/* 11064*/   OPC_MoveChild0,
/* 11065*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11068*/   OPC_MoveParent,
/* 11069*/   OPC_MoveParent,
/* 11070*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11072*/   OPC_EmitMergeInputChains1_0,
/* 11073*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 11080*/  0, /*End of Scope*/
/* 11081*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->11105
/* 11084*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 11085*/  OPC_RecordChild1, // #1 = $amt
/* 11086*/  OPC_MoveChild1,
/* 11087*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11090*/  OPC_MoveSibling2,
/* 11091*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11094*/  OPC_RecordNode, // #2 = $amt2
/* 11095*/  OPC_MoveParent,
/* 11096*/  OPC_EmitMergeInputChains1_0,
/* 11097*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 11105*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->11130
/* 11108*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 11109*/  OPC_CaptureGlueInput,
/* 11110*/  OPC_RecordChild1, // #1 = $amt
/* 11111*/  OPC_MoveChild1,
/* 11112*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11115*/  OPC_MoveSibling2,
/* 11116*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 11119*/  OPC_RecordNode, // #2 = $amt2
/* 11120*/  OPC_MoveParent,
/* 11121*/  OPC_EmitMergeInputChains1_0,
/* 11122*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 11130*/ /*SwitchOpcode*/ 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11193
/* 11133*/  OPC_RecordMemRef,
/* 11134*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 11135*/  OPC_MoveChild1,
/* 11136*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11139*/  OPC_RecordChild0, // #1 = $table
/* 11140*/  OPC_MoveChild0,
/* 11141*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11144*/  OPC_MoveParent,
/* 11145*/  OPC_MoveParent,
/* 11146*/  OPC_RecordChild2, // #2 = $idx
/* 11147*/  OPC_CheckChild2TypeI32,
/* 11148*/  OPC_SwitchType /*3 cases */, 11, /*MVT::funcref*/99|128,1/*227*/, // ->11163
/* 11152*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11153*/   OPC_EmitMergeInputChains1_0,
/* 11154*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11163*/  /*SwitchType*/ 11, /*MVT::externref*/100|128,1/*228*/, // ->11177
/* 11166*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11167*/   OPC_EmitMergeInputChains1_0,
/* 11168*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11177*/  /*SwitchType*/ 12, /*MVT::exnref*/101|128,1/*229*/, // ->11192
/* 11180*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11182*/   OPC_EmitMergeInputChains1_0,
/* 11183*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11192*/  0, // EndSwitchType
/* 11193*/ /*SwitchOpcode*/ 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11283
/* 11196*/  OPC_RecordMemRef,
/* 11197*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11198*/  OPC_Scope, 59, /*->11259*/ // 2 children in Scope
/* 11200*/   OPC_MoveChild1,
/* 11201*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11204*/   OPC_RecordChild0, // #1 = $table
/* 11205*/   OPC_MoveChild0,
/* 11206*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11209*/   OPC_MoveParent,
/* 11210*/   OPC_MoveParent,
/* 11211*/   OPC_RecordChild2, // #2 = $idx
/* 11212*/   OPC_CheckChild2TypeI32,
/* 11213*/   OPC_RecordChild3, // #3 = $src
/* 11214*/   OPC_Scope, 13, /*->11229*/ // 3 children in Scope
/* 11216*/    OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11219*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11220*/    OPC_EmitMergeInputChains1_0,
/* 11221*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11229*/   /*Scope*/ 13, /*->11243*/
/* 11230*/    OPC_CheckChild3Type, /*MVT::externref*/100|128,1/*228*/, 
/* 11233*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11234*/    OPC_EmitMergeInputChains1_0,
/* 11235*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11243*/   /*Scope*/ 14, /*->11258*/
/* 11244*/    OPC_CheckChild3Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 11247*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11249*/    OPC_EmitMergeInputChains1_0,
/* 11250*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11258*/   0, /*End of Scope*/
/* 11259*/  /*Scope*/ 22, /*->11282*/
/* 11260*/   OPC_RecordChild1, // #1 = $table
/* 11261*/   OPC_MoveChild1,
/* 11262*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11265*/   OPC_MoveParent,
/* 11266*/   OPC_RecordChild2, // #2 = $idx
/* 11267*/   OPC_CheckChild2TypeI32,
/* 11268*/   OPC_RecordChild3, // #3 = $r
/* 11269*/   OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11272*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11273*/   OPC_EmitMergeInputChains1_0,
/* 11274*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11282*/  0, /*End of Scope*/
/* 11283*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMCPY),// ->11343
/* 11286*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 11287*/  OPC_RecordChild1, // #1 = $src_idx
/* 11288*/  OPC_MoveChild1,
/* 11289*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11292*/  OPC_CheckTypeI32,
/* 11293*/  OPC_MoveSibling2,
/* 11294*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11297*/  OPC_RecordNode, // #2 = $dst_idx
/* 11298*/  OPC_CheckTypeI32,
/* 11299*/  OPC_MoveParent,
/* 11300*/  OPC_RecordChild3, // #3 = $dst
/* 11301*/  OPC_Scope, 19, /*->11322*/ // 2 children in Scope
/* 11303*/   OPC_CheckChild3TypeI32,
/* 11304*/   OPC_RecordChild4, // #4 = $src
/* 11305*/   OPC_CheckChild4TypeI32,
/* 11306*/   OPC_RecordChild5, // #5 = $len
/* 11307*/   OPC_CheckChild5TypeI32,
/* 11308*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 11310*/   OPC_EmitMergeInputChains1_0,
/* 11311*/   OPC_EmitConvertToTarget1, // #6
/* 11312*/   OPC_EmitConvertToTarget2, // #7
/* 11313*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 11322*/  /*Scope*/ 19, /*->11342*/
/* 11323*/   OPC_CheckChild3TypeI64,
/* 11324*/   OPC_RecordChild4, // #4 = $src
/* 11325*/   OPC_CheckChild4TypeI64,
/* 11326*/   OPC_RecordChild5, // #5 = $len
/* 11327*/   OPC_CheckChild5TypeI64,
/* 11328*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 11330*/   OPC_EmitMergeInputChains1_0,
/* 11331*/   OPC_EmitConvertToTarget1, // #6
/* 11332*/   OPC_EmitConvertToTarget2, // #7
/* 11333*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 11342*/  0, /*End of Scope*/
/* 11343*/ /*SwitchOpcode*/ 119|128,9/*1271*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12618
/* 11347*/  OPC_Scope, 49, /*->11398*/ // 39 children in Scope
/* 11349*/   OPC_CheckChild0Integer, 46|128,79|128,1/*26542*/, 
/* 11353*/   OPC_RecordChild1, // #0 = $src
/* 11354*/   OPC_Scope, 20, /*->11376*/ // 2 children in Scope
/* 11356*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11358*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11367
/* 11361*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13271:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11367*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11375
/* 11369*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13271:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11375*/    0, // EndSwitchType
/* 11376*/   /*Scope*/ 20, /*->11397*/
/* 11377*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11379*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11388
/* 11382*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13271:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11388*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11396
/* 11390*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13271:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11396*/    0, // EndSwitchType
/* 11397*/   0, /*End of Scope*/
/* 11398*/  /*Scope*/ 49, /*->11448*/
/* 11399*/   OPC_CheckChild0Integer, 48|128,79|128,1/*26544*/, 
/* 11403*/   OPC_RecordChild1, // #0 = $src
/* 11404*/   OPC_Scope, 20, /*->11426*/ // 2 children in Scope
/* 11406*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11408*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11417
/* 11411*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13272:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11417*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11425
/* 11419*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13272:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11425*/    0, // EndSwitchType
/* 11426*/   /*Scope*/ 20, /*->11447*/
/* 11427*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11429*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11438
/* 11432*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 13272:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11438*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11446
/* 11440*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 13272:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11446*/    0, // EndSwitchType
/* 11447*/   0, /*End of Scope*/
/* 11448*/  /*Scope*/ 43, /*->11492*/
/* 11449*/   OPC_CheckChild0Integer, 34|128,78|128,1/*26402*/, 
/* 11453*/   OPC_RecordChild1, // #0 = $vec
/* 11454*/   OPC_Scope, 8, /*->11464*/ // 4 children in Scope
/* 11456*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11458*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11464*/   /*Scope*/ 8, /*->11473*/
/* 11465*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11467*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11473*/   /*Scope*/ 8, /*->11482*/
/* 11474*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11476*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11482*/   /*Scope*/ 8, /*->11491*/
/* 11483*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11485*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13201:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11491*/   0, /*End of Scope*/
/* 11492*/  /*Scope*/ 47, /*->11540*/
/* 11493*/   OPC_CheckChild0Integer, 32|128,78|128,1/*26400*/, 
/* 11497*/   OPC_RecordChild1, // #0 = $vec
/* 11498*/   OPC_Scope, 9, /*->11509*/ // 4 children in Scope
/* 11500*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11502*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11503*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11509*/   /*Scope*/ 9, /*->11519*/
/* 11510*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11512*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11513*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11519*/   /*Scope*/ 9, /*->11529*/
/* 11520*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11522*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11523*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11529*/   /*Scope*/ 9, /*->11539*/
/* 11530*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11532*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11533*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13200:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11539*/   0, /*End of Scope*/
/* 11540*/  /*Scope*/ 47, /*->11588*/
/* 11541*/   OPC_CheckChild0Integer, 38|128,78|128,1/*26406*/, 
/* 11545*/   OPC_RecordChild1, // #0 = $vec
/* 11546*/   OPC_Scope, 9, /*->11557*/ // 4 children in Scope
/* 11548*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11550*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11551*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13203:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11557*/   /*Scope*/ 9, /*->11567*/
/* 11558*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11560*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13203:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11567*/   /*Scope*/ 9, /*->11577*/
/* 11568*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11570*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11571*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13203:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11577*/   /*Scope*/ 9, /*->11587*/
/* 11578*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11580*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11581*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 13203:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11587*/   0, /*End of Scope*/
/* 11588*/  /*Scope*/ 11, /*->11600*/
/* 11589*/   OPC_CheckChild0Integer, 92|128,78|128,1/*26460*/, 
/* 11593*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11594*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 13230:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11600*/  /*Scope*/ 12, /*->11613*/
/* 11601*/   OPC_CheckChild0Integer, 86|128,78|128,1/*26454*/, 
/* 11605*/   OPC_RecordChild1, // #0 = $ref
/* 11606*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11607*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13227:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11613*/  /*Scope*/ 11, /*->11625*/
/* 11614*/   OPC_CheckChild0Integer, 90|128,78|128,1/*26458*/, 
/* 11618*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11619*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 13229:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11625*/  /*Scope*/ 12, /*->11638*/
/* 11626*/   OPC_CheckChild0Integer, 84|128,78|128,1/*26452*/, 
/* 11630*/   OPC_RecordChild1, // #0 = $ref
/* 11631*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11632*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13226:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11638*/  /*Scope*/ 11, /*->11650*/
/* 11639*/   OPC_CheckChild0Integer, 88|128,78|128,1/*26456*/, 
/* 11643*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11644*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 13228:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11650*/  /*Scope*/ 12, /*->11663*/
/* 11651*/   OPC_CheckChild0Integer, 82|128,78|128,1/*26450*/, 
/* 11655*/   OPC_RecordChild1, // #0 = $ref
/* 11656*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11657*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 13225:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11663*/  /*Scope*/ 23, /*->11687*/
/* 11664*/   OPC_CheckChild0Integer, 50|128,78|128,1/*26418*/, 
/* 11668*/   OPC_RecordChild1, // #0 = $vec
/* 11669*/   OPC_RecordChild2, // #1 = $idx
/* 11670*/   OPC_MoveChild2,
/* 11671*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11674*/   OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 11676*/   OPC_MoveParent,
/* 11677*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 11679*/   OPC_EmitConvertToTarget1, // #2
/* 11680*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 13209:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11687*/  /*Scope*/ 13, /*->11701*/
/* 11688*/   OPC_CheckChild0Integer, 4|128,79|128,1/*26500*/, 
/* 11692*/   OPC_RecordChild1, // #0 = $src
/* 11693*/   OPC_RecordChild2, // #1 = $mask
/* 11694*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13250:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11701*/  /*Scope*/ 120, /*->11822*/
/* 11702*/   OPC_CheckChild0Integer, 40|128,78|128,1/*26408*/, 
/* 11706*/   OPC_RecordChild1, // #0 = $v1
/* 11707*/   OPC_SwitchType /*6 cases */, 16, /*MVT::v16i8*/39, // ->11726
/* 11710*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11712*/    OPC_RecordChild2, // #1 = $v2
/* 11713*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11715*/    OPC_RecordChild3, // #2 = $c
/* 11716*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11718*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13204:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11726*/   /*SwitchType*/ 16, /*MVT::v8i16*/50, // ->11744
/* 11728*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11730*/    OPC_RecordChild2, // #1 = $v2
/* 11731*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11733*/    OPC_RecordChild3, // #2 = $c
/* 11734*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11736*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13204:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11744*/   /*SwitchType*/ 16, /*MVT::v4i32*/60, // ->11762
/* 11746*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11748*/    OPC_RecordChild2, // #1 = $v2
/* 11749*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11751*/    OPC_RecordChild3, // #2 = $c
/* 11752*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11754*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13204:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11762*/   /*SwitchType*/ 16, /*MVT::v2i64*/78, // ->11780
/* 11764*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11766*/    OPC_RecordChild2, // #1 = $v2
/* 11767*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11769*/    OPC_RecordChild3, // #2 = $c
/* 11770*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11772*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 13204:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11780*/   /*SwitchType*/ 16, /*MVT::v4f32*/111, // ->11798
/* 11782*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 11784*/    OPC_RecordChild2, // #1 = $v2
/* 11785*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 11787*/    OPC_RecordChild3, // #2 = $c
/* 11788*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 11790*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13204:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11798*/   /*SwitchType*/ 20, /*MVT::v2f64*/1|128,1/*129*/, // ->11821
/* 11801*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11804*/    OPC_RecordChild2, // #1 = $v2
/* 11805*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11808*/    OPC_RecordChild3, // #2 = $c
/* 11809*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11812*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13204:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11821*/   0, // EndSwitchType
/* 11822*/  /*Scope*/ 37, /*->11860*/
/* 11823*/   OPC_CheckChild0Integer, 36|128,78|128,1/*26404*/, 
/* 11827*/   OPC_RecordChild1, // #0 = $lhs
/* 11828*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11844
/* 11831*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11833*/    OPC_RecordChild2, // #1 = $rhs
/* 11834*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11836*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11837*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13202:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11844*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11859
/* 11846*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11848*/    OPC_RecordChild2, // #1 = $rhs
/* 11849*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11851*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11852*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13202:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11859*/   0, // EndSwitchType
/* 11860*/  /*Scope*/ 14, /*->11875*/
/* 11861*/   OPC_CheckChild0Integer, 44|128,78|128,1/*26412*/, 
/* 11865*/   OPC_RecordChild1, // #0 = $lhs
/* 11866*/   OPC_RecordChild2, // #1 = $rhs
/* 11867*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11868*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13206:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11875*/  /*Scope*/ 37, /*->11913*/
/* 11876*/   OPC_CheckChild0Integer, 72|128,78|128,1/*26440*/, 
/* 11880*/   OPC_RecordChild1, // #0 = $low
/* 11881*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11897
/* 11884*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11886*/    OPC_RecordChild2, // #1 = $high
/* 11887*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11889*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11890*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13220:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11897*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11912
/* 11899*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11901*/    OPC_RecordChild2, // #1 = $high
/* 11902*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11904*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11905*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13220:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11912*/   0, // EndSwitchType
/* 11913*/  /*Scope*/ 37, /*->11951*/
/* 11914*/   OPC_CheckChild0Integer, 74|128,78|128,1/*26442*/, 
/* 11918*/   OPC_RecordChild1, // #0 = $low
/* 11919*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11935
/* 11922*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11924*/    OPC_RecordChild2, // #1 = $high
/* 11925*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11927*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11928*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13221:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11935*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11950
/* 11937*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11939*/    OPC_RecordChild2, // #1 = $high
/* 11940*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11942*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11943*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13221:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11950*/   0, // EndSwitchType
/* 11951*/  /*Scope*/ 29, /*->11981*/
/* 11952*/   OPC_CheckChild0Integer, 46|128,78|128,1/*26414*/, 
/* 11956*/   OPC_RecordChild1, // #0 = $vec
/* 11957*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11969
/* 11960*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11962*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11963*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13207:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11969*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11980
/* 11971*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11973*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11974*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13207:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11980*/   0, // EndSwitchType
/* 11981*/  /*Scope*/ 29, /*->12011*/
/* 11982*/   OPC_CheckChild0Integer, 48|128,78|128,1/*26416*/, 
/* 11986*/   OPC_RecordChild1, // #0 = $vec
/* 11987*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11999
/* 11990*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11992*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11993*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13208:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11999*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->12010
/* 12001*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 12003*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12004*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13208:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 12010*/   0, // EndSwitchType
/* 12011*/  /*Scope*/ 14, /*->12026*/
/* 12012*/   OPC_CheckChild0Integer, 80|128,78|128,1/*26448*/, 
/* 12016*/   OPC_RecordChild1, // #0 = $lhs
/* 12017*/   OPC_RecordChild2, // #1 = $rhs
/* 12018*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12019*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13224:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12026*/  /*Scope*/ 14, /*->12041*/
/* 12027*/   OPC_CheckChild0Integer, 112|128,78|128,1/*26480*/, 
/* 12031*/   OPC_RecordChild1, // #0 = $src
/* 12032*/   OPC_RecordChild2, // #1 = $mask
/* 12033*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12034*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13240:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 12041*/  /*Scope*/ 12, /*->12054*/
/* 12042*/   OPC_CheckChild0Integer, 114|128,78|128,1/*26482*/, 
/* 12046*/   OPC_RecordChild1, // #0 = $vec
/* 12047*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12048*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13241:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 12054*/  /*Scope*/ 12, /*->12067*/
/* 12055*/   OPC_CheckChild0Integer, 118|128,78|128,1/*26486*/, 
/* 12059*/   OPC_RecordChild1, // #0 = $vec
/* 12060*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12061*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13243:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 12067*/  /*Scope*/ 12, /*->12080*/
/* 12068*/   OPC_CheckChild0Integer, 116|128,78|128,1/*26484*/, 
/* 12072*/   OPC_RecordChild1, // #0 = $vec
/* 12073*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12074*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13242:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 12080*/  /*Scope*/ 12, /*->12093*/
/* 12081*/   OPC_CheckChild0Integer, 120|128,78|128,1/*26488*/, 
/* 12085*/   OPC_RecordChild1, // #0 = $vec
/* 12086*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12087*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13244:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 12093*/  /*Scope*/ 83, /*->12177*/
/* 12094*/   OPC_CheckChild0Integer, 100|128,78|128,1/*26468*/, 
/* 12098*/   OPC_RecordChild1, // #0 = $a
/* 12099*/   OPC_SwitchType /*4 cases */, 17, /*MVT::v16i8*/39, // ->12119
/* 12102*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 12104*/    OPC_RecordChild2, // #1 = $b
/* 12105*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 12107*/    OPC_RecordChild3, // #2 = $c
/* 12108*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 12110*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12111*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 13234:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 12119*/   /*SwitchType*/ 17, /*MVT::v8i16*/50, // ->12138
/* 12121*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 12123*/    OPC_RecordChild2, // #1 = $b
/* 12124*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 12126*/    OPC_RecordChild3, // #2 = $c
/* 12127*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 12129*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12130*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13234:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 12138*/   /*SwitchType*/ 17, /*MVT::v4i32*/60, // ->12157
/* 12140*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 12142*/    OPC_RecordChild2, // #1 = $b
/* 12143*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 12145*/    OPC_RecordChild3, // #2 = $c
/* 12146*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 12148*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12149*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13234:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 12157*/   /*SwitchType*/ 17, /*MVT::v2i64*/78, // ->12176
/* 12159*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 12161*/    OPC_RecordChild2, // #1 = $b
/* 12162*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12164*/    OPC_RecordChild3, // #2 = $c
/* 12165*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 12167*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12168*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 13234:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12176*/   0, // EndSwitchType
/* 12177*/  /*Scope*/ 14, /*->12192*/
/* 12178*/   OPC_CheckChild0Integer, 110|128,78|128,1/*26478*/, 
/* 12182*/   OPC_RecordChild1, // #0 = $lhs
/* 12183*/   OPC_RecordChild2, // #1 = $rhs
/* 12184*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12185*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13239:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12192*/  /*Scope*/ 14, /*->12207*/
/* 12193*/   OPC_CheckChild0Integer, 98|128,78|128,1/*26466*/, 
/* 12197*/   OPC_RecordChild1, // #0 = $lhs
/* 12198*/   OPC_RecordChild2, // #1 = $rhs
/* 12199*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12200*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 13233:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12207*/  /*Scope*/ 16, /*->12224*/
/* 12208*/   OPC_CheckChild0Integer, 96|128,78|128,1/*26464*/, 
/* 12212*/   OPC_RecordChild1, // #0 = $lhs
/* 12213*/   OPC_RecordChild2, // #1 = $rhs
/* 12214*/   OPC_RecordChild3, // #2 = $acc
/* 12215*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12216*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 13232:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12224*/  /*Scope*/ 25, /*->12250*/
/* 12225*/   OPC_CheckChild0Integer, 122|128,78|128,1/*26490*/, 
/* 12229*/   OPC_RecordChild1, // #0 = $vec
/* 12230*/   OPC_RecordChild2, // #1 = $idx
/* 12231*/   OPC_MoveChild2,
/* 12232*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12235*/   OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 12237*/   OPC_MoveParent,
/* 12238*/   OPC_RecordChild3, // #2 = $x
/* 12239*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 12241*/   OPC_EmitConvertToTarget1, // #3
/* 12242*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 /*MVT::v8f16*/92, 3/*#Ops*/, 0, 3, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13245:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx, F32:{ *:[f32] }:$x) - Complexity = 12
             // Dst: (REPLACE_LANE_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 12250*/  /*Scope*/ 13, /*->12264*/
/* 12251*/   OPC_CheckChild0Integer, 0|128,79|128,1/*26496*/, 
/* 12255*/   OPC_RecordChild1, // #0 = $x
/* 12256*/   OPC_CheckPatternPredicate, 16, // (Subtarget->hasFP16())
/* 12258*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13248:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12264*/  /*Scope*/ 53, /*->12318*/
/* 12265*/   OPC_CheckChild0Integer, 78|128,78|128,1/*26446*/, 
/* 12269*/   OPC_RecordChild1, // #0 = $lhs
/* 12270*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12285
/* 12273*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12275*/    OPC_RecordChild2, // #1 = $rhs
/* 12276*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12278*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13223:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12285*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12303
/* 12288*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12291*/    OPC_RecordChild2, // #1 = $rhs
/* 12292*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12295*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13223:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12303*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12317
/* 12305*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12307*/    OPC_RecordChild2, // #1 = $rhs
/* 12308*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12310*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13223:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12317*/   0, // EndSwitchType
/* 12318*/  /*Scope*/ 53, /*->12372*/
/* 12319*/   OPC_CheckChild0Integer, 76|128,78|128,1/*26444*/, 
/* 12323*/   OPC_RecordChild1, // #0 = $lhs
/* 12324*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12339
/* 12327*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12329*/    OPC_RecordChild2, // #1 = $rhs
/* 12330*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12332*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13222:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12339*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12357
/* 12342*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12345*/    OPC_RecordChild2, // #1 = $rhs
/* 12346*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12349*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13222:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12357*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12371
/* 12359*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12361*/    OPC_RecordChild2, // #1 = $rhs
/* 12362*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12364*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13222:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12371*/   0, // EndSwitchType
/* 12372*/  /*Scope*/ 71, /*->12444*/
/* 12373*/   OPC_CheckChild0Integer, 102|128,78|128,1/*26470*/, 
/* 12377*/   OPC_RecordChild1, // #0 = $a
/* 12378*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12399
/* 12381*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12383*/    OPC_RecordChild2, // #1 = $b
/* 12384*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12386*/    OPC_RecordChild3, // #2 = $c
/* 12387*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12389*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12391*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13235:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12399*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12424
/* 12402*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12405*/    OPC_RecordChild2, // #1 = $b
/* 12406*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12409*/    OPC_RecordChild3, // #2 = $c
/* 12410*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12413*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12415*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13235:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12424*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12443
/* 12426*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12428*/    OPC_RecordChild2, // #1 = $b
/* 12429*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12431*/    OPC_RecordChild3, // #2 = $c
/* 12432*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12434*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12435*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13235:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12443*/   0, // EndSwitchType
/* 12444*/  /*Scope*/ 71, /*->12516*/
/* 12445*/   OPC_CheckChild0Integer, 108|128,78|128,1/*26476*/, 
/* 12449*/   OPC_RecordChild1, // #0 = $a
/* 12450*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12471
/* 12453*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12455*/    OPC_RecordChild2, // #1 = $b
/* 12456*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12458*/    OPC_RecordChild3, // #2 = $c
/* 12459*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12461*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12463*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13238:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12471*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12496
/* 12474*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12477*/    OPC_RecordChild2, // #1 = $b
/* 12478*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12481*/    OPC_RecordChild3, // #2 = $c
/* 12482*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12485*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12487*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13238:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12496*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12515
/* 12498*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12500*/    OPC_RecordChild2, // #1 = $b
/* 12501*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12503*/    OPC_RecordChild3, // #2 = $c
/* 12504*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12506*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12507*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 13238:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12515*/   0, // EndSwitchType
/* 12516*/  /*Scope*/ 41, /*->12558*/
/* 12517*/   OPC_CheckChild0Integer, 106|128,78|128,1/*26474*/, 
/* 12521*/   OPC_RecordChild1, // #0 = $lhs
/* 12522*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12538
/* 12525*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12527*/    OPC_RecordChild2, // #1 = $rhs
/* 12528*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12530*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12531*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13237:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12538*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12557
/* 12541*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12544*/    OPC_RecordChild2, // #1 = $rhs
/* 12545*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12548*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12549*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13237:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12557*/   0, // EndSwitchType
/* 12558*/  /*Scope*/ 41, /*->12600*/
/* 12559*/   OPC_CheckChild0Integer, 104|128,78|128,1/*26472*/, 
/* 12563*/   OPC_RecordChild1, // #0 = $lhs
/* 12564*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12580
/* 12567*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12569*/    OPC_RecordChild2, // #1 = $rhs
/* 12570*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12572*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12573*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13236:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12580*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12599
/* 12583*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12586*/    OPC_RecordChild2, // #1 = $rhs
/* 12587*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12590*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12591*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 13236:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12599*/   0, // EndSwitchType
/* 12600*/  /*Scope*/ 16, /*->12617*/
/* 12601*/   OPC_CheckChild0Integer, 94|128,78|128,1/*26462*/, 
/* 12605*/   OPC_RecordChild1, // #0 = $lhs
/* 12606*/   OPC_RecordChild2, // #1 = $rhs
/* 12607*/   OPC_RecordChild3, // #2 = $acc
/* 12608*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12609*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 13231:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12617*/  0, /*End of Scope*/
/* 12618*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12754
/* 12622*/  OPC_RecordChild0, // #0 = $vec
/* 12623*/  OPC_Scope, 20, /*->12645*/ // 6 children in Scope
/* 12625*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 12627*/   OPC_RecordChild1, // #1 = $idx
/* 12628*/   OPC_MoveChild1,
/* 12629*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12632*/   OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/* 12634*/   OPC_CheckTypeI32,
/* 12635*/   OPC_MoveParent,
/* 12636*/   OPC_CheckTypeI32,
/* 12637*/   OPC_EmitConvertToTarget1, // #2
/* 12638*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12645*/  /*Scope*/ 20, /*->12666*/
/* 12646*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 12648*/   OPC_RecordChild1, // #1 = $idx
/* 12649*/   OPC_MoveChild1,
/* 12650*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12653*/   OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 12655*/   OPC_CheckTypeI32,
/* 12656*/   OPC_MoveParent,
/* 12657*/   OPC_CheckTypeI32,
/* 12658*/   OPC_EmitConvertToTarget1, // #2
/* 12659*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12666*/  /*Scope*/ 20, /*->12687*/
/* 12667*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 12669*/   OPC_RecordChild1, // #1 = $idx
/* 12670*/   OPC_MoveChild1,
/* 12671*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12674*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12676*/   OPC_CheckTypeI32,
/* 12677*/   OPC_MoveParent,
/* 12678*/   OPC_CheckTypeI32,
/* 12679*/   OPC_EmitConvertToTarget1, // #2
/* 12680*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12687*/  /*Scope*/ 20, /*->12708*/
/* 12688*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 12690*/   OPC_RecordChild1, // #1 = $idx
/* 12691*/   OPC_MoveChild1,
/* 12692*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12695*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12697*/   OPC_CheckTypeI32,
/* 12698*/   OPC_MoveParent,
/* 12699*/   OPC_CheckTypeI64,
/* 12700*/   OPC_EmitConvertToTarget1, // #2
/* 12701*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12708*/  /*Scope*/ 21, /*->12730*/
/* 12709*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 12711*/   OPC_RecordChild1, // #1 = $idx
/* 12712*/   OPC_MoveChild1,
/* 12713*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12716*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12718*/   OPC_CheckTypeI32,
/* 12719*/   OPC_MoveParent,
/* 12720*/   OPC_CheckType, /*MVT::f32*/12, 
/* 12722*/   OPC_EmitConvertToTarget1, // #2
/* 12723*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12730*/  /*Scope*/ 22, /*->12753*/
/* 12731*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12734*/   OPC_RecordChild1, // #1 = $idx
/* 12735*/   OPC_MoveChild1,
/* 12736*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12739*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12741*/   OPC_CheckTypeI32,
/* 12742*/   OPC_MoveParent,
/* 12743*/   OPC_CheckType, /*MVT::f64*/13, 
/* 12745*/   OPC_EmitConvertToTarget1, // #2
/* 12746*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12753*/  0, /*End of Scope*/
/* 12754*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12886
/* 12758*/  OPC_RecordChild0, // #0 = $argno
/* 12759*/  OPC_MoveChild0,
/* 12760*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12763*/  OPC_MoveParent,
/* 12764*/  OPC_SwitchType /*14 cases */, 6, /*MVT::i32*/7, // ->12773
/* 12767*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12773*/  /*SwitchType*/ 6, /*MVT::i64*/8, // ->12781
/* 12775*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12781*/  /*SwitchType*/ 7, /*MVT::funcref*/99|128,1/*227*/, // ->12791
/* 12784*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12791*/  /*SwitchType*/ 7, /*MVT::externref*/100|128,1/*228*/, // ->12801
/* 12794*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12801*/  /*SwitchType*/ 7, /*MVT::exnref*/101|128,1/*229*/, // ->12811
/* 12804*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12811*/  /*SwitchType*/ 6, /*MVT::f32*/12, // ->12819
/* 12813*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12819*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->12827
/* 12821*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12827*/  /*SwitchType*/ 6, /*MVT::v16i8*/39, // ->12835
/* 12829*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12835*/  /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->12843
/* 12837*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12843*/  /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->12851
/* 12845*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12851*/  /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->12859
/* 12853*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12859*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->12867
/* 12861*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12867*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->12877
/* 12870*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12877*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->12885
/* 12879*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12885*/  0, // EndSwitchType
/* 12886*/ /*SwitchOpcode*/ 26|128,1/*154*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->13044
/* 12890*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12891*/  OPC_RecordChild1, // #1 = $local
/* 12892*/  OPC_MoveChild1,
/* 12893*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12896*/  OPC_MoveParent,
/* 12897*/  OPC_SwitchType /*14 cases */, 7, /*MVT::i32*/7, // ->12907
/* 12900*/   OPC_EmitMergeInputChains1_0,
/* 12901*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12907*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->12916
/* 12909*/   OPC_EmitMergeInputChains1_0,
/* 12910*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12916*/  /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->12928
/* 12919*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12920*/   OPC_EmitMergeInputChains1_0,
/* 12921*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12928*/  /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->12940
/* 12931*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12932*/   OPC_EmitMergeInputChains1_0,
/* 12933*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12940*/  /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->12953
/* 12943*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12945*/   OPC_EmitMergeInputChains1_0,
/* 12946*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12953*/  /*SwitchType*/ 7, /*MVT::f32*/12, // ->12962
/* 12955*/   OPC_EmitMergeInputChains1_0,
/* 12956*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12962*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->12971
/* 12964*/   OPC_EmitMergeInputChains1_0,
/* 12965*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12971*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->12981
/* 12973*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12974*/   OPC_EmitMergeInputChains1_0,
/* 12975*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12981*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->12991
/* 12983*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12984*/   OPC_EmitMergeInputChains1_0,
/* 12985*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12991*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13001
/* 12993*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12994*/   OPC_EmitMergeInputChains1_0,
/* 12995*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 13001*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13011
/* 13003*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13004*/   OPC_EmitMergeInputChains1_0,
/* 13005*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 13011*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->13021
/* 13013*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13014*/   OPC_EmitMergeInputChains1_0,
/* 13015*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 13021*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->13031
/* 13023*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13024*/   OPC_EmitMergeInputChains1_0,
/* 13025*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 13031*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->13043
/* 13034*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13035*/   OPC_EmitMergeInputChains1_0,
/* 13036*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 13043*/  0, // EndSwitchType
/* 13044*/ /*SwitchOpcode*/ 35|128,1/*163*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13211
/* 13048*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 13049*/  OPC_RecordChild1, // #1 = $local
/* 13050*/  OPC_MoveChild1,
/* 13051*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 13054*/  OPC_MoveParent,
/* 13055*/  OPC_RecordChild2, // #2 = $src
/* 13056*/  OPC_Scope, 8, /*->13066*/ // 14 children in Scope
/* 13058*/   OPC_CheckChild2TypeI32,
/* 13059*/   OPC_EmitMergeInputChains1_0,
/* 13060*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 13066*/  /*Scope*/ 8, /*->13075*/
/* 13067*/   OPC_CheckChild2TypeI64,
/* 13068*/   OPC_EmitMergeInputChains1_0,
/* 13069*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 13075*/  /*Scope*/ 9, /*->13085*/
/* 13076*/   OPC_CheckChild2Type, /*MVT::f32*/12, 
/* 13078*/   OPC_EmitMergeInputChains1_0,
/* 13079*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 13085*/  /*Scope*/ 9, /*->13095*/
/* 13086*/   OPC_CheckChild2Type, /*MVT::f64*/13, 
/* 13088*/   OPC_EmitMergeInputChains1_0,
/* 13089*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 13095*/  /*Scope*/ 10, /*->13106*/
/* 13096*/   OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 13098*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13099*/   OPC_EmitMergeInputChains1_0,
/* 13100*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 13106*/  /*Scope*/ 10, /*->13117*/
/* 13107*/   OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 13109*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13110*/   OPC_EmitMergeInputChains1_0,
/* 13111*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 13117*/  /*Scope*/ 11, /*->13129*/
/* 13118*/   OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 13121*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13122*/   OPC_EmitMergeInputChains1_0,
/* 13123*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 13129*/  /*Scope*/ 10, /*->13140*/
/* 13130*/   OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 13132*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13133*/   OPC_EmitMergeInputChains1_0,
/* 13134*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 13140*/  /*Scope*/ 10, /*->13151*/
/* 13141*/   OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 13143*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13144*/   OPC_EmitMergeInputChains1_0,
/* 13145*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 13151*/  /*Scope*/ 10, /*->13162*/
/* 13152*/   OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 13154*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13155*/   OPC_EmitMergeInputChains1_0,
/* 13156*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 13162*/  /*Scope*/ 10, /*->13173*/
/* 13163*/   OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 13165*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13166*/   OPC_EmitMergeInputChains1_0,
/* 13167*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13173*/  /*Scope*/ 11, /*->13185*/
/* 13174*/   OPC_CheckChild2Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 13177*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13178*/   OPC_EmitMergeInputChains1_0,
/* 13179*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13185*/  /*Scope*/ 11, /*->13197*/
/* 13186*/   OPC_CheckChild2Type, /*MVT::externref*/100|128,1/*228*/, 
/* 13189*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13190*/   OPC_EmitMergeInputChains1_0,
/* 13191*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13197*/  /*Scope*/ 12, /*->13210*/
/* 13198*/   OPC_CheckChild2Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 13201*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 13203*/   OPC_EmitMergeInputChains1_0,
/* 13204*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 13210*/  0, /*End of Scope*/
/* 13211*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13343
/* 13215*/  OPC_RecordChild0, // #0 = $addr
/* 13216*/  OPC_MoveChild0,
/* 13217*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13268
/* 13221*/   OPC_MoveParent,
/* 13222*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13245
/* 13225*/    OPC_Scope, 8, /*->13235*/ // 2 children in Scope
/* 13227*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13229*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13235*/    /*Scope*/ 8, /*->13244*/
/* 13236*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13238*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13244*/    0, /*End of Scope*/
/* 13245*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13267
/* 13247*/    OPC_Scope, 8, /*->13257*/ // 2 children in Scope
/* 13249*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13251*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13257*/    /*Scope*/ 8, /*->13266*/
/* 13258*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13260*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13266*/    0, /*End of Scope*/
/* 13267*/   0, // EndSwitchType
/* 13268*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13292
/* 13271*/   OPC_MoveParent,
/* 13272*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13282
/* 13275*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13276*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13282*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13291
/* 13284*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13291*/   0, // EndSwitchType
/* 13292*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13342
/* 13295*/   OPC_MoveParent,
/* 13296*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13319
/* 13299*/    OPC_Scope, 8, /*->13309*/ // 2 children in Scope
/* 13301*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13303*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13309*/    /*Scope*/ 8, /*->13318*/
/* 13310*/     OPC_CheckPatternPredicate, 17, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13312*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13318*/    0, /*End of Scope*/
/* 13319*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13341
/* 13321*/    OPC_Scope, 8, /*->13331*/ // 2 children in Scope
/* 13323*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13325*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13331*/    /*Scope*/ 8, /*->13340*/
/* 13332*/     OPC_CheckPatternPredicate, 18, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13334*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13340*/    0, /*End of Scope*/
/* 13341*/   0, // EndSwitchType
/* 13342*/  0, // EndSwitchOpcode
/* 13343*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13426
/* 13346*/  OPC_RecordChild0, // #0 = $addr
/* 13347*/  OPC_MoveChild0,
/* 13348*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13375
/* 13352*/   OPC_MoveParent,
/* 13353*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13364
/* 13356*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13358*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13364*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13374
/* 13366*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13368*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13374*/   0, // EndSwitchType
/* 13375*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13399
/* 13378*/   OPC_MoveParent,
/* 13379*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13389
/* 13382*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13383*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13389*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13398
/* 13391*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13392*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13398*/   0, // EndSwitchType
/* 13399*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13425
/* 13402*/   OPC_MoveParent,
/* 13403*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13414
/* 13406*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13408*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13414*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13424
/* 13416*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13418*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13424*/   0, // EndSwitchType
/* 13425*/  0, // EndSwitchOpcode
/* 13426*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMSET),// ->13476
/* 13429*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13430*/  OPC_RecordChild1, // #1 = $idx
/* 13431*/  OPC_MoveChild1,
/* 13432*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13435*/  OPC_CheckTypeI32,
/* 13436*/  OPC_MoveParent,
/* 13437*/  OPC_RecordChild2, // #2 = $dst
/* 13438*/  OPC_Scope, 17, /*->13457*/ // 2 children in Scope
/* 13440*/   OPC_CheckChild2TypeI32,
/* 13441*/   OPC_RecordChild3, // #3 = $value
/* 13442*/   OPC_CheckChild3TypeI32,
/* 13443*/   OPC_RecordChild4, // #4 = $size
/* 13444*/   OPC_CheckChild4TypeI32,
/* 13445*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 13447*/   OPC_EmitMergeInputChains1_0,
/* 13448*/   OPC_EmitConvertToTarget1, // #5
/* 13449*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (MEMSET_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13457*/  /*Scope*/ 17, /*->13475*/
/* 13458*/   OPC_CheckChild2TypeI64,
/* 13459*/   OPC_RecordChild3, // #3 = $value
/* 13460*/   OPC_CheckChild3TypeI32,
/* 13461*/   OPC_RecordChild4, // #4 = $size
/* 13462*/   OPC_CheckChild4TypeI64,
/* 13463*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemoryOpt())
/* 13465*/   OPC_EmitMergeInputChains1_0,
/* 13466*/   OPC_EmitConvertToTarget1, // #5
/* 13467*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (MEMSET_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13475*/  0, /*End of Scope*/
/* 13476*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13500
/* 13479*/  OPC_RecordNode, // #0 = $imm
/* 13480*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13490
/* 13483*/   OPC_EmitConvertToTarget0, // #1
/* 13484*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13490*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13499
/* 13492*/   OPC_EmitConvertToTarget0, // #1
/* 13493*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13499*/  0, // EndSwitchType
/* 13500*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13516
/* 13503*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13504*/  OPC_RecordChild1, // #1 = $dst
/* 13505*/  OPC_MoveChild1,
/* 13506*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13509*/  OPC_MoveParent,
/* 13510*/  OPC_EmitMergeInputChains1_0,
/* 13511*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13516*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13541
/* 13519*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13520*/  OPC_RecordChild1, // #1 = $index
/* 13521*/  OPC_Scope, 8, /*->13531*/ // 2 children in Scope
/* 13523*/   OPC_CheckChild1TypeI32,
/* 13524*/   OPC_EmitMergeInputChains1_0,
/* 13525*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13531*/  /*Scope*/ 8, /*->13540*/
/* 13532*/   OPC_CheckChild1TypeI64,
/* 13533*/   OPC_EmitMergeInputChains1_0,
/* 13534*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13540*/  0, /*End of Scope*/
/* 13541*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13551
/* 13544*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13545*/  OPC_EmitMergeInputChains1_0,
/* 13546*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13551*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13560
/* 13554*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13555*/  OPC_EmitMergeInputChains1_0,
/* 13556*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13560*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13569
/* 13563*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13564*/  OPC_EmitMergeInputChains1_0,
/* 13565*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13569*/ /*SwitchOpcode*/ 15, TARGET_VAL(ISD::CLEANUPRET),// ->13587
/* 13572*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13573*/  OPC_RecordChild1, // #1 = $ehpad
/* 13574*/  OPC_MoveChild1,
/* 13575*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13578*/  OPC_MoveParent,
/* 13579*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13581*/  OPC_EmitMergeInputChains1_0,
/* 13582*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                1/*#Ops*/, 1, 
            // Src: (cleanupret (bb:{ *:[Other] }):$ehpad) - Complexity = 3
            // Dst: (CLEANUPRET (bb:{ *:[Other] }):$ehpad)
/* 13587*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13611
/* 13590*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13591*/  OPC_RecordChild1, // #1 = $dst
/* 13592*/  OPC_MoveChild1,
/* 13593*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13596*/  OPC_MoveSibling2,
/* 13597*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13600*/  OPC_RecordNode, // #2 = $from
/* 13601*/  OPC_MoveParent,
/* 13602*/  OPC_CheckPatternPredicate, 19, // (Subtarget->hasExceptionHandling())
/* 13604*/  OPC_EmitMergeInputChains1_0,
/* 13605*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13611*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13676
/* 13614*/  OPC_RecordChild0, // #0 = $lhs
/* 13615*/  OPC_RecordChild1, // #1 = $rhs
/* 13616*/  OPC_SwitchType /*6 cases */, 7, /*MVT::i32*/7, // ->13626
/* 13619*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13626*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13635
/* 13628*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13635*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13645
/* 13637*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13638*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13645*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13655
/* 13647*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13648*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13655*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13665
/* 13657*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13658*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13665*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13675
/* 13667*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13668*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13675*/  0, // EndSwitchType
/* 13676*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13792
/* 13679*/  OPC_Scope, 22, /*->13703*/ // 3 children in Scope
/* 13681*/   OPC_RecordChild0, // #0 = $lhs
/* 13682*/   OPC_RecordChild1, // #1 = $rhs
/* 13683*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13693
/* 13686*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13693*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13702
/* 13695*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13702*/   0, // EndSwitchType
/* 13703*/  /*Scope*/ 42, /*->13746*/
/* 13704*/   OPC_MoveChild0,
/* 13705*/   OPC_CheckImmAllZerosV,
/* 13706*/   OPC_MoveParent,
/* 13707*/   OPC_RecordChild1, // #0 = $v
/* 13708*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->13718
/* 13711*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13712*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13718*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->13727
/* 13720*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13721*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13727*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->13736
/* 13729*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13730*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13736*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->13745
/* 13738*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13739*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13745*/   0, // EndSwitchType
/* 13746*/  /*Scope*/ 44, /*->13791*/
/* 13747*/   OPC_RecordChild0, // #0 = $lhs
/* 13748*/   OPC_RecordChild1, // #1 = $rhs
/* 13749*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->13760
/* 13752*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13753*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13760*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13770
/* 13762*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13763*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13770*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13780
/* 13772*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13773*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13780*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13790
/* 13782*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13783*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13790*/   0, // EndSwitchType
/* 13791*/  0, /*End of Scope*/
/* 13792*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->14137
/* 13796*/  OPC_Scope, 22, /*->13820*/ // 3 children in Scope
/* 13798*/   OPC_RecordChild0, // #0 = $lhs
/* 13799*/   OPC_RecordChild1, // #1 = $rhs
/* 13800*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13810
/* 13803*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13810*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13819
/* 13812*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13819*/   0, // EndSwitchType
/* 13820*/  /*Scope*/ 23|128,2/*279*/, /*->14101*/
/* 13822*/   OPC_MoveChild0,
/* 13823*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13893
/* 13827*/    OPC_RecordChild0, // #0 = $lhs
/* 13828*/    OPC_Scope, 20, /*->13850*/ // 3 children in Scope
/* 13830*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13832*/     OPC_MoveSibling1,
/* 13833*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13836*/     OPC_RecordChild0, // #1 = $rhs
/* 13837*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13839*/     OPC_MoveParent,
/* 13840*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13842*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13843*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13850*/    /*Scope*/ 20, /*->13871*/
/* 13851*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13853*/     OPC_MoveSibling1,
/* 13854*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13857*/     OPC_RecordChild0, // #1 = $rhs
/* 13858*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13860*/     OPC_MoveParent,
/* 13861*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13863*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13864*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13871*/    /*Scope*/ 20, /*->13892*/
/* 13872*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13874*/     OPC_MoveSibling1,
/* 13875*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13878*/     OPC_RecordChild0, // #1 = $rhs
/* 13879*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13881*/     OPC_MoveParent,
/* 13882*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13884*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13885*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13892*/    0, /*End of Scope*/
/* 13893*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13962
/* 13896*/    OPC_RecordChild0, // #0 = $lhs
/* 13897*/    OPC_Scope, 20, /*->13919*/ // 3 children in Scope
/* 13899*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13901*/     OPC_MoveSibling1,
/* 13902*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13905*/     OPC_RecordChild0, // #1 = $rhs
/* 13906*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13908*/     OPC_MoveParent,
/* 13909*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13911*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13912*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13919*/    /*Scope*/ 20, /*->13940*/
/* 13920*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13922*/     OPC_MoveSibling1,
/* 13923*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13926*/     OPC_RecordChild0, // #1 = $rhs
/* 13927*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13929*/     OPC_MoveParent,
/* 13930*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13932*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13933*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13940*/    /*Scope*/ 20, /*->13961*/
/* 13941*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13943*/     OPC_MoveSibling1,
/* 13944*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13947*/     OPC_RecordChild0, // #1 = $rhs
/* 13948*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13950*/     OPC_MoveParent,
/* 13951*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13953*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13954*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13961*/    0, /*End of Scope*/
/* 13962*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->14031
/* 13965*/    OPC_RecordChild0, // #0 = $lhs
/* 13966*/    OPC_Scope, 20, /*->13988*/ // 3 children in Scope
/* 13968*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13970*/     OPC_MoveSibling1,
/* 13971*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13974*/     OPC_RecordChild0, // #1 = $rhs
/* 13975*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13977*/     OPC_MoveParent,
/* 13978*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13980*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13981*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13988*/    /*Scope*/ 20, /*->14009*/
/* 13989*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13991*/     OPC_MoveSibling1,
/* 13992*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13995*/     OPC_RecordChild0, // #1 = $rhs
/* 13996*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13998*/     OPC_MoveParent,
/* 13999*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14001*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14002*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14009*/    /*Scope*/ 20, /*->14030*/
/* 14010*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 14012*/     OPC_MoveSibling1,
/* 14013*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 14016*/     OPC_RecordChild0, // #1 = $rhs
/* 14017*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 14019*/     OPC_MoveParent,
/* 14020*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14022*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14023*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14030*/    0, /*End of Scope*/
/* 14031*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->14100
/* 14034*/    OPC_RecordChild0, // #0 = $lhs
/* 14035*/    OPC_Scope, 20, /*->14057*/ // 3 children in Scope
/* 14037*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 14039*/     OPC_MoveSibling1,
/* 14040*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14043*/     OPC_RecordChild0, // #1 = $rhs
/* 14044*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 14046*/     OPC_MoveParent,
/* 14047*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14049*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14050*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 14057*/    /*Scope*/ 20, /*->14078*/
/* 14058*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 14060*/     OPC_MoveSibling1,
/* 14061*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14064*/     OPC_RecordChild0, // #1 = $rhs
/* 14065*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 14067*/     OPC_MoveParent,
/* 14068*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14070*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14071*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14078*/    /*Scope*/ 20, /*->14099*/
/* 14079*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 14081*/     OPC_MoveSibling1,
/* 14082*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 14085*/     OPC_RecordChild0, // #1 = $rhs
/* 14086*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 14088*/     OPC_MoveParent,
/* 14089*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14091*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14092*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14099*/    0, /*End of Scope*/
/* 14100*/   0, // EndSwitchOpcode
/* 14101*/  /*Scope*/ 34, /*->14136*/
/* 14102*/   OPC_RecordChild0, // #0 = $lhs
/* 14103*/   OPC_RecordChild1, // #1 = $rhs
/* 14104*/   OPC_SwitchType /*3 cases */, 8, /*MVT::v8i16*/50, // ->14115
/* 14107*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14108*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 14115*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14125
/* 14117*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14118*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 14125*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14135
/* 14127*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 14128*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 14135*/   0, // EndSwitchType
/* 14136*/  0, /*End of Scope*/
/* 14137*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->14162
/* 14140*/  OPC_RecordChild0, // #0 = $lhs
/* 14141*/  OPC_RecordChild1, // #1 = $rhs
/* 14142*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14152
/* 14145*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14152*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14161
/* 14154*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14161*/  0, // EndSwitchType
/* 14162*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14187
/* 14165*/  OPC_RecordChild0, // #0 = $lhs
/* 14166*/  OPC_RecordChild1, // #1 = $rhs
/* 14167*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14177
/* 14170*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14177*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14186
/* 14179*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14186*/  0, // EndSwitchType
/* 14187*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14212
/* 14190*/  OPC_RecordChild0, // #0 = $lhs
/* 14191*/  OPC_RecordChild1, // #1 = $rhs
/* 14192*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14202
/* 14195*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14202*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14211
/* 14204*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14211*/  0, // EndSwitchType
/* 14212*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14237
/* 14215*/  OPC_RecordChild0, // #0 = $lhs
/* 14216*/  OPC_RecordChild1, // #1 = $rhs
/* 14217*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14227
/* 14220*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14227*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14236
/* 14229*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14236*/  0, // EndSwitchType
/* 14237*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->15065
/* 14241*/  OPC_Scope, 22, /*->14265*/ // 3 children in Scope
/* 14243*/   OPC_RecordChild0, // #0 = $lhs
/* 14244*/   OPC_RecordChild1, // #1 = $rhs
/* 14245*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14255
/* 14248*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14255*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14264
/* 14257*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14264*/   0, // EndSwitchType
/* 14265*/  /*Scope*/ 116|128,5/*756*/, /*->15023*/
/* 14267*/   OPC_MoveChild0,
/* 14268*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14271*/   OPC_Scope, 4|128,1/*132*/, /*->14406*/ // 9 children in Scope
/* 14274*/    OPC_RecordChild0, // #0 = $c
/* 14275*/    OPC_RecordChild1, // #1 = $v1
/* 14276*/    OPC_MoveSibling1,
/* 14277*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14280*/    OPC_Scope, 54, /*->14336*/ // 4 children in Scope
/* 14282*/     OPC_MoveChild0,
/* 14283*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14286*/     OPC_CheckChild0Same, 0,
/* 14288*/     OPC_MoveChild1,
/* 14289*/     OPC_CheckImmAllOnesV,
/* 14290*/     OPC_MoveParent,
/* 14291*/     OPC_MoveParent,
/* 14292*/     OPC_RecordChild1, // #2 = $v2
/* 14293*/     OPC_MoveParent,
/* 14294*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14305
/* 14297*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14305*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14315
/* 14307*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14315*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14325
/* 14317*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14325*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14335
/* 14327*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14335*/     0, // EndSwitchType
/* 14336*/    /*Scope*/ 22, /*->14359*/
/* 14337*/     OPC_RecordChild0, // #2 = $v2
/* 14338*/     OPC_MoveChild1,
/* 14339*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14342*/     OPC_CheckChild0Same, 0,
/* 14344*/     OPC_MoveChild1,
/* 14345*/     OPC_CheckImmAllOnesV,
/* 14346*/     OPC_MoveParent,
/* 14347*/     OPC_MoveParent,
/* 14348*/     OPC_MoveParent,
/* 14349*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14351*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14359*/    /*Scope*/ 22, /*->14382*/
/* 14360*/     OPC_MoveChild0,
/* 14361*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14364*/     OPC_CheckChild0Same, 1,
/* 14366*/     OPC_MoveChild1,
/* 14367*/     OPC_CheckImmAllOnesV,
/* 14368*/     OPC_MoveParent,
/* 14369*/     OPC_MoveParent,
/* 14370*/     OPC_RecordChild1, // #2 = $v2
/* 14371*/     OPC_MoveParent,
/* 14372*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14374*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14382*/    /*Scope*/ 22, /*->14405*/
/* 14383*/     OPC_RecordChild0, // #2 = $v2
/* 14384*/     OPC_MoveChild1,
/* 14385*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14388*/     OPC_CheckChild0Same, 1,
/* 14390*/     OPC_MoveChild1,
/* 14391*/     OPC_CheckImmAllOnesV,
/* 14392*/     OPC_MoveParent,
/* 14393*/     OPC_MoveParent,
/* 14394*/     OPC_MoveParent,
/* 14395*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14397*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14405*/    0, /*End of Scope*/
/* 14406*/   /*Scope*/ 46, /*->14453*/
/* 14407*/    OPC_MoveChild0,
/* 14408*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14411*/    OPC_RecordChild0, // #0 = $c
/* 14412*/    OPC_MoveChild1,
/* 14413*/    OPC_CheckImmAllOnesV,
/* 14414*/    OPC_MoveParent,
/* 14415*/    OPC_MoveParent,
/* 14416*/    OPC_RecordChild1, // #1 = $v2
/* 14417*/    OPC_MoveSibling1,
/* 14418*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14421*/    OPC_Scope, 14, /*->14437*/ // 2 children in Scope
/* 14423*/     OPC_CheckChild0Same, 0,
/* 14425*/     OPC_RecordChild1, // #2 = $v1
/* 14426*/     OPC_MoveParent,
/* 14427*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14429*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14437*/    /*Scope*/ 14, /*->14452*/
/* 14438*/     OPC_RecordChild0, // #2 = $v1
/* 14439*/     OPC_CheckChild1Same, 0,
/* 14441*/     OPC_MoveParent,
/* 14442*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14444*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14452*/    0, /*End of Scope*/
/* 14453*/   /*Scope*/ 126, /*->14580*/
/* 14454*/    OPC_RecordChild0, // #0 = $v2
/* 14455*/    OPC_Scope, 45, /*->14502*/ // 2 children in Scope
/* 14457*/     OPC_MoveChild1,
/* 14458*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14461*/     OPC_RecordChild0, // #1 = $c
/* 14462*/     OPC_MoveChild1,
/* 14463*/     OPC_CheckImmAllOnesV,
/* 14464*/     OPC_MoveParent,
/* 14465*/     OPC_MoveParent,
/* 14466*/     OPC_MoveSibling1,
/* 14467*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14470*/     OPC_Scope, 14, /*->14486*/ // 2 children in Scope
/* 14472*/      OPC_CheckChild0Same, 1,
/* 14474*/      OPC_RecordChild1, // #2 = $v1
/* 14475*/      OPC_MoveParent,
/* 14476*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14478*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14486*/     /*Scope*/ 14, /*->14501*/
/* 14487*/      OPC_RecordChild0, // #2 = $v1
/* 14488*/      OPC_CheckChild1Same, 1,
/* 14490*/      OPC_MoveParent,
/* 14491*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14493*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14501*/     0, /*End of Scope*/
/* 14502*/    /*Scope*/ 76, /*->14579*/
/* 14503*/     OPC_RecordChild1, // #1 = $v1
/* 14504*/     OPC_MoveSibling1,
/* 14505*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14508*/     OPC_Scope, 22, /*->14532*/ // 3 children in Scope
/* 14510*/      OPC_RecordChild0, // #2 = $v2
/* 14511*/      OPC_MoveChild1,
/* 14512*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14515*/      OPC_CheckChild0Same, 0,
/* 14517*/      OPC_MoveChild1,
/* 14518*/      OPC_CheckImmAllOnesV,
/* 14519*/      OPC_MoveParent,
/* 14520*/      OPC_MoveParent,
/* 14521*/      OPC_MoveParent,
/* 14522*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14532*/     /*Scope*/ 22, /*->14555*/
/* 14533*/      OPC_MoveChild0,
/* 14534*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14537*/      OPC_CheckChild0Same, 1,
/* 14539*/      OPC_MoveChild1,
/* 14540*/      OPC_CheckImmAllOnesV,
/* 14541*/      OPC_MoveParent,
/* 14542*/      OPC_MoveParent,
/* 14543*/      OPC_RecordChild1, // #2 = $v2
/* 14544*/      OPC_MoveParent,
/* 14545*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14547*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14555*/     /*Scope*/ 22, /*->14578*/
/* 14556*/      OPC_RecordChild0, // #2 = $v2
/* 14557*/      OPC_MoveChild1,
/* 14558*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14561*/      OPC_CheckChild0Same, 1,
/* 14563*/      OPC_MoveChild1,
/* 14564*/      OPC_CheckImmAllOnesV,
/* 14565*/      OPC_MoveParent,
/* 14566*/      OPC_MoveParent,
/* 14567*/      OPC_MoveParent,
/* 14568*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14570*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14578*/     0, /*End of Scope*/
/* 14579*/    0, /*End of Scope*/
/* 14580*/   /*Scope*/ 46, /*->14627*/
/* 14581*/    OPC_MoveChild0,
/* 14582*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14585*/    OPC_RecordChild0, // #0 = $c
/* 14586*/    OPC_MoveChild1,
/* 14587*/    OPC_CheckImmAllOnesV,
/* 14588*/    OPC_MoveParent,
/* 14589*/    OPC_MoveParent,
/* 14590*/    OPC_RecordChild1, // #1 = $v2
/* 14591*/    OPC_MoveSibling1,
/* 14592*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14595*/    OPC_Scope, 14, /*->14611*/ // 2 children in Scope
/* 14597*/     OPC_CheckChild0Same, 0,
/* 14599*/     OPC_RecordChild1, // #2 = $v1
/* 14600*/     OPC_MoveParent,
/* 14601*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14603*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14611*/    /*Scope*/ 14, /*->14626*/
/* 14612*/     OPC_RecordChild0, // #2 = $v1
/* 14613*/     OPC_CheckChild1Same, 0,
/* 14615*/     OPC_MoveParent,
/* 14616*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14618*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14626*/    0, /*End of Scope*/
/* 14627*/   /*Scope*/ 126, /*->14754*/
/* 14628*/    OPC_RecordChild0, // #0 = $v2
/* 14629*/    OPC_Scope, 45, /*->14676*/ // 2 children in Scope
/* 14631*/     OPC_MoveChild1,
/* 14632*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14635*/     OPC_RecordChild0, // #1 = $c
/* 14636*/     OPC_MoveChild1,
/* 14637*/     OPC_CheckImmAllOnesV,
/* 14638*/     OPC_MoveParent,
/* 14639*/     OPC_MoveParent,
/* 14640*/     OPC_MoveSibling1,
/* 14641*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14644*/     OPC_Scope, 14, /*->14660*/ // 2 children in Scope
/* 14646*/      OPC_CheckChild0Same, 1,
/* 14648*/      OPC_RecordChild1, // #2 = $v1
/* 14649*/      OPC_MoveParent,
/* 14650*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14652*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14660*/     /*Scope*/ 14, /*->14675*/
/* 14661*/      OPC_RecordChild0, // #2 = $v1
/* 14662*/      OPC_CheckChild1Same, 1,
/* 14664*/      OPC_MoveParent,
/* 14665*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14667*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14675*/     0, /*End of Scope*/
/* 14676*/    /*Scope*/ 76, /*->14753*/
/* 14677*/     OPC_RecordChild1, // #1 = $v1
/* 14678*/     OPC_MoveSibling1,
/* 14679*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14682*/     OPC_Scope, 22, /*->14706*/ // 3 children in Scope
/* 14684*/      OPC_RecordChild0, // #2 = $v2
/* 14685*/      OPC_MoveChild1,
/* 14686*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14689*/      OPC_CheckChild0Same, 0,
/* 14691*/      OPC_MoveChild1,
/* 14692*/      OPC_CheckImmAllOnesV,
/* 14693*/      OPC_MoveParent,
/* 14694*/      OPC_MoveParent,
/* 14695*/      OPC_MoveParent,
/* 14696*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14698*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14706*/     /*Scope*/ 22, /*->14729*/
/* 14707*/      OPC_MoveChild0,
/* 14708*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14711*/      OPC_CheckChild0Same, 1,
/* 14713*/      OPC_MoveChild1,
/* 14714*/      OPC_CheckImmAllOnesV,
/* 14715*/      OPC_MoveParent,
/* 14716*/      OPC_MoveParent,
/* 14717*/      OPC_RecordChild1, // #2 = $v2
/* 14718*/      OPC_MoveParent,
/* 14719*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14721*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14729*/     /*Scope*/ 22, /*->14752*/
/* 14730*/      OPC_RecordChild0, // #2 = $v2
/* 14731*/      OPC_MoveChild1,
/* 14732*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14735*/      OPC_CheckChild0Same, 1,
/* 14737*/      OPC_MoveChild1,
/* 14738*/      OPC_CheckImmAllOnesV,
/* 14739*/      OPC_MoveParent,
/* 14740*/      OPC_MoveParent,
/* 14741*/      OPC_MoveParent,
/* 14742*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14744*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14752*/     0, /*End of Scope*/
/* 14753*/    0, /*End of Scope*/
/* 14754*/   /*Scope*/ 46, /*->14801*/
/* 14755*/    OPC_MoveChild0,
/* 14756*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14759*/    OPC_RecordChild0, // #0 = $c
/* 14760*/    OPC_MoveChild1,
/* 14761*/    OPC_CheckImmAllOnesV,
/* 14762*/    OPC_MoveParent,
/* 14763*/    OPC_MoveParent,
/* 14764*/    OPC_RecordChild1, // #1 = $v2
/* 14765*/    OPC_MoveSibling1,
/* 14766*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14769*/    OPC_Scope, 14, /*->14785*/ // 2 children in Scope
/* 14771*/     OPC_CheckChild0Same, 0,
/* 14773*/     OPC_RecordChild1, // #2 = $v1
/* 14774*/     OPC_MoveParent,
/* 14775*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14777*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14785*/    /*Scope*/ 14, /*->14800*/
/* 14786*/     OPC_RecordChild0, // #2 = $v1
/* 14787*/     OPC_CheckChild1Same, 0,
/* 14789*/     OPC_MoveParent,
/* 14790*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14792*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14800*/    0, /*End of Scope*/
/* 14801*/   /*Scope*/ 126, /*->14928*/
/* 14802*/    OPC_RecordChild0, // #0 = $v2
/* 14803*/    OPC_Scope, 45, /*->14850*/ // 2 children in Scope
/* 14805*/     OPC_MoveChild1,
/* 14806*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14809*/     OPC_RecordChild0, // #1 = $c
/* 14810*/     OPC_MoveChild1,
/* 14811*/     OPC_CheckImmAllOnesV,
/* 14812*/     OPC_MoveParent,
/* 14813*/     OPC_MoveParent,
/* 14814*/     OPC_MoveSibling1,
/* 14815*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14818*/     OPC_Scope, 14, /*->14834*/ // 2 children in Scope
/* 14820*/      OPC_CheckChild0Same, 1,
/* 14822*/      OPC_RecordChild1, // #2 = $v1
/* 14823*/      OPC_MoveParent,
/* 14824*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14826*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14834*/     /*Scope*/ 14, /*->14849*/
/* 14835*/      OPC_RecordChild0, // #2 = $v1
/* 14836*/      OPC_CheckChild1Same, 1,
/* 14838*/      OPC_MoveParent,
/* 14839*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14841*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14849*/     0, /*End of Scope*/
/* 14850*/    /*Scope*/ 76, /*->14927*/
/* 14851*/     OPC_RecordChild1, // #1 = $v1
/* 14852*/     OPC_MoveSibling1,
/* 14853*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14856*/     OPC_Scope, 22, /*->14880*/ // 3 children in Scope
/* 14858*/      OPC_RecordChild0, // #2 = $v2
/* 14859*/      OPC_MoveChild1,
/* 14860*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14863*/      OPC_CheckChild0Same, 0,
/* 14865*/      OPC_MoveChild1,
/* 14866*/      OPC_CheckImmAllOnesV,
/* 14867*/      OPC_MoveParent,
/* 14868*/      OPC_MoveParent,
/* 14869*/      OPC_MoveParent,
/* 14870*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14872*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14880*/     /*Scope*/ 22, /*->14903*/
/* 14881*/      OPC_MoveChild0,
/* 14882*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14885*/      OPC_CheckChild0Same, 1,
/* 14887*/      OPC_MoveChild1,
/* 14888*/      OPC_CheckImmAllOnesV,
/* 14889*/      OPC_MoveParent,
/* 14890*/      OPC_MoveParent,
/* 14891*/      OPC_RecordChild1, // #2 = $v2
/* 14892*/      OPC_MoveParent,
/* 14893*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14895*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14903*/     /*Scope*/ 22, /*->14926*/
/* 14904*/      OPC_RecordChild0, // #2 = $v2
/* 14905*/      OPC_MoveChild1,
/* 14906*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14909*/      OPC_CheckChild0Same, 1,
/* 14911*/      OPC_MoveChild1,
/* 14912*/      OPC_CheckImmAllOnesV,
/* 14913*/      OPC_MoveParent,
/* 14914*/      OPC_MoveParent,
/* 14915*/      OPC_MoveParent,
/* 14916*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14918*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14926*/     0, /*End of Scope*/
/* 14927*/    0, /*End of Scope*/
/* 14928*/   /*Scope*/ 46, /*->14975*/
/* 14929*/    OPC_MoveChild0,
/* 14930*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14933*/    OPC_RecordChild0, // #0 = $c
/* 14934*/    OPC_MoveChild1,
/* 14935*/    OPC_CheckImmAllOnesV,
/* 14936*/    OPC_MoveParent,
/* 14937*/    OPC_MoveParent,
/* 14938*/    OPC_RecordChild1, // #1 = $v2
/* 14939*/    OPC_MoveSibling1,
/* 14940*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14943*/    OPC_Scope, 14, /*->14959*/ // 2 children in Scope
/* 14945*/     OPC_CheckChild0Same, 0,
/* 14947*/     OPC_RecordChild1, // #2 = $v1
/* 14948*/     OPC_MoveParent,
/* 14949*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14951*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14959*/    /*Scope*/ 14, /*->14974*/
/* 14960*/     OPC_RecordChild0, // #2 = $v1
/* 14961*/     OPC_CheckChild1Same, 0,
/* 14963*/     OPC_MoveParent,
/* 14964*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14966*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14974*/    0, /*End of Scope*/
/* 14975*/   /*Scope*/ 46, /*->15022*/
/* 14976*/    OPC_RecordChild0, // #0 = $v2
/* 14977*/    OPC_MoveChild1,
/* 14978*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14981*/    OPC_RecordChild0, // #1 = $c
/* 14982*/    OPC_MoveChild1,
/* 14983*/    OPC_CheckImmAllOnesV,
/* 14984*/    OPC_MoveParent,
/* 14985*/    OPC_MoveParent,
/* 14986*/    OPC_MoveSibling1,
/* 14987*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14990*/    OPC_Scope, 14, /*->15006*/ // 2 children in Scope
/* 14992*/     OPC_CheckChild0Same, 1,
/* 14994*/     OPC_RecordChild1, // #2 = $v1
/* 14995*/     OPC_MoveParent,
/* 14996*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14998*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15006*/    /*Scope*/ 14, /*->15021*/
/* 15007*/     OPC_RecordChild0, // #2 = $v1
/* 15008*/     OPC_CheckChild1Same, 1,
/* 15010*/     OPC_MoveParent,
/* 15011*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15013*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15021*/    0, /*End of Scope*/
/* 15022*/   0, /*End of Scope*/
/* 15023*/  /*Scope*/ 40, /*->15064*/
/* 15024*/   OPC_RecordChild0, // #0 = $lhs
/* 15025*/   OPC_RecordChild1, // #1 = $rhs
/* 15026*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->15036
/* 15029*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 15036*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->15045
/* 15038*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 15045*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->15054
/* 15047*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 15054*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->15063
/* 15056*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 15063*/   0, // EndSwitchType
/* 15064*/  0, /*End of Scope*/
/* 15065*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16598
/* 15069*/  OPC_Scope, 22, /*->15093*/ // 17 children in Scope
/* 15071*/   OPC_RecordChild0, // #0 = $lhs
/* 15072*/   OPC_RecordChild1, // #1 = $rhs
/* 15073*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->15083
/* 15076*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 15083*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->15092
/* 15085*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 15092*/   0, // EndSwitchType
/* 15093*/  /*Scope*/ 121, /*->15215*/
/* 15094*/   OPC_MoveChild0,
/* 15095*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15098*/   OPC_MoveChild0,
/* 15099*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15102*/   OPC_RecordChild0, // #0 = $v1
/* 15103*/   OPC_Scope, 71, /*->15176*/ // 2 children in Scope
/* 15105*/    OPC_RecordChild1, // #1 = $v2
/* 15106*/    OPC_MoveSibling1,
/* 15107*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15110*/    OPC_RecordChild0, // #2 = $c
/* 15111*/    OPC_MoveChild1,
/* 15112*/    OPC_CheckImmAllOnesV,
/* 15113*/    OPC_MoveParent,
/* 15114*/    OPC_MoveParent,
/* 15115*/    OPC_MoveParent,
/* 15116*/    OPC_Scope, 44, /*->15162*/ // 2 children in Scope
/* 15118*/     OPC_CheckChild1Same, 1,
/* 15120*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15131
/* 15123*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15131*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15141
/* 15133*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15141*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15151
/* 15143*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15151*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15161
/* 15153*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15161*/     0, // EndSwitchType
/* 15162*/    /*Scope*/ 12, /*->15175*/
/* 15163*/     OPC_CheckChild1Same, 0,
/* 15165*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15167*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15175*/    0, /*End of Scope*/
/* 15176*/   /*Scope*/ 37, /*->15214*/
/* 15177*/    OPC_MoveChild1,
/* 15178*/    OPC_CheckImmAllOnesV,
/* 15179*/    OPC_MoveParent,
/* 15180*/    OPC_MoveSibling1,
/* 15181*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15184*/    OPC_RecordChild0, // #1 = $v1
/* 15185*/    OPC_RecordChild1, // #2 = $v2
/* 15186*/    OPC_MoveParent,
/* 15187*/    OPC_MoveParent,
/* 15188*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15190*/    OPC_Scope, 10, /*->15202*/ // 2 children in Scope
/* 15192*/     OPC_CheckChild1Same, 2,
/* 15194*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15202*/    /*Scope*/ 10, /*->15213*/
/* 15203*/     OPC_CheckChild1Same, 1,
/* 15205*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15213*/    0, /*End of Scope*/
/* 15214*/   0, /*End of Scope*/
/* 15215*/  /*Scope*/ 102, /*->15318*/
/* 15216*/   OPC_RecordChild0, // #0 = $v2
/* 15217*/   OPC_MoveChild1,
/* 15218*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15221*/   OPC_MoveChild0,
/* 15222*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15225*/   OPC_Scope, 23, /*->15250*/ // 3 children in Scope
/* 15227*/    OPC_RecordChild0, // #1 = $v1
/* 15228*/    OPC_CheckChild1Same, 0,
/* 15230*/    OPC_MoveSibling1,
/* 15231*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15234*/    OPC_RecordChild0, // #2 = $c
/* 15235*/    OPC_MoveChild1,
/* 15236*/    OPC_CheckImmAllOnesV,
/* 15237*/    OPC_MoveParent,
/* 15238*/    OPC_MoveParent,
/* 15239*/    OPC_MoveParent,
/* 15240*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15242*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15250*/   /*Scope*/ 23, /*->15274*/
/* 15251*/    OPC_CheckChild0Same, 0,
/* 15253*/    OPC_RecordChild1, // #1 = $v1
/* 15254*/    OPC_MoveSibling1,
/* 15255*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15258*/    OPC_RecordChild0, // #2 = $c
/* 15259*/    OPC_MoveChild1,
/* 15260*/    OPC_CheckImmAllOnesV,
/* 15261*/    OPC_MoveParent,
/* 15262*/    OPC_MoveParent,
/* 15263*/    OPC_MoveParent,
/* 15264*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15266*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15274*/   /*Scope*/ 42, /*->15317*/
/* 15275*/    OPC_RecordChild0, // #1 = $c
/* 15276*/    OPC_MoveChild1,
/* 15277*/    OPC_CheckImmAllOnesV,
/* 15278*/    OPC_MoveParent,
/* 15279*/    OPC_MoveSibling1,
/* 15280*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15283*/    OPC_Scope, 15, /*->15300*/ // 2 children in Scope
/* 15285*/     OPC_RecordChild0, // #2 = $v1
/* 15286*/     OPC_CheckChild1Same, 0,
/* 15288*/     OPC_MoveParent,
/* 15289*/     OPC_MoveParent,
/* 15290*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15292*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15300*/    /*Scope*/ 15, /*->15316*/
/* 15301*/     OPC_CheckChild0Same, 0,
/* 15303*/     OPC_RecordChild1, // #2 = $v1
/* 15304*/     OPC_MoveParent,
/* 15305*/     OPC_MoveParent,
/* 15306*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15308*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15316*/    0, /*End of Scope*/
/* 15317*/   0, /*End of Scope*/
/* 15318*/  /*Scope*/ 73, /*->15392*/
/* 15319*/   OPC_MoveChild0,
/* 15320*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15323*/   OPC_MoveChild0,
/* 15324*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15327*/   OPC_RecordChild0, // #0 = $v2
/* 15328*/   OPC_Scope, 23, /*->15353*/ // 2 children in Scope
/* 15330*/    OPC_RecordChild1, // #1 = $v1
/* 15331*/    OPC_MoveSibling1,
/* 15332*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15335*/    OPC_RecordChild0, // #2 = $c
/* 15336*/    OPC_MoveChild1,
/* 15337*/    OPC_CheckImmAllOnesV,
/* 15338*/    OPC_MoveParent,
/* 15339*/    OPC_MoveParent,
/* 15340*/    OPC_MoveParent,
/* 15341*/    OPC_CheckChild1Same, 0,
/* 15343*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15353*/   /*Scope*/ 37, /*->15391*/
/* 15354*/    OPC_MoveChild1,
/* 15355*/    OPC_CheckImmAllOnesV,
/* 15356*/    OPC_MoveParent,
/* 15357*/    OPC_MoveSibling1,
/* 15358*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15361*/    OPC_RecordChild0, // #1 = $v1
/* 15362*/    OPC_RecordChild1, // #2 = $v2
/* 15363*/    OPC_MoveParent,
/* 15364*/    OPC_MoveParent,
/* 15365*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15367*/    OPC_Scope, 10, /*->15379*/ // 2 children in Scope
/* 15369*/     OPC_CheckChild1Same, 2,
/* 15371*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15379*/    /*Scope*/ 10, /*->15390*/
/* 15380*/     OPC_CheckChild1Same, 1,
/* 15382*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15390*/    0, /*End of Scope*/
/* 15391*/   0, /*End of Scope*/
/* 15392*/  /*Scope*/ 102, /*->15495*/
/* 15393*/   OPC_RecordChild0, // #0 = $v2
/* 15394*/   OPC_MoveChild1,
/* 15395*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15398*/   OPC_MoveChild0,
/* 15399*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15402*/   OPC_Scope, 23, /*->15427*/ // 3 children in Scope
/* 15404*/    OPC_RecordChild0, // #1 = $v1
/* 15405*/    OPC_CheckChild1Same, 0,
/* 15407*/    OPC_MoveSibling1,
/* 15408*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15411*/    OPC_RecordChild0, // #2 = $c
/* 15412*/    OPC_MoveChild1,
/* 15413*/    OPC_CheckImmAllOnesV,
/* 15414*/    OPC_MoveParent,
/* 15415*/    OPC_MoveParent,
/* 15416*/    OPC_MoveParent,
/* 15417*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15419*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15427*/   /*Scope*/ 23, /*->15451*/
/* 15428*/    OPC_CheckChild0Same, 0,
/* 15430*/    OPC_RecordChild1, // #1 = $v1
/* 15431*/    OPC_MoveSibling1,
/* 15432*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15435*/    OPC_RecordChild0, // #2 = $c
/* 15436*/    OPC_MoveChild1,
/* 15437*/    OPC_CheckImmAllOnesV,
/* 15438*/    OPC_MoveParent,
/* 15439*/    OPC_MoveParent,
/* 15440*/    OPC_MoveParent,
/* 15441*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15443*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15451*/   /*Scope*/ 42, /*->15494*/
/* 15452*/    OPC_RecordChild0, // #1 = $c
/* 15453*/    OPC_MoveChild1,
/* 15454*/    OPC_CheckImmAllOnesV,
/* 15455*/    OPC_MoveParent,
/* 15456*/    OPC_MoveSibling1,
/* 15457*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15460*/    OPC_Scope, 15, /*->15477*/ // 2 children in Scope
/* 15462*/     OPC_RecordChild0, // #2 = $v1
/* 15463*/     OPC_CheckChild1Same, 0,
/* 15465*/     OPC_MoveParent,
/* 15466*/     OPC_MoveParent,
/* 15467*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15469*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15477*/    /*Scope*/ 15, /*->15493*/
/* 15478*/     OPC_CheckChild0Same, 0,
/* 15480*/     OPC_RecordChild1, // #2 = $v1
/* 15481*/     OPC_MoveParent,
/* 15482*/     OPC_MoveParent,
/* 15483*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15485*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15493*/    0, /*End of Scope*/
/* 15494*/   0, /*End of Scope*/
/* 15495*/  /*Scope*/ 73, /*->15569*/
/* 15496*/   OPC_MoveChild0,
/* 15497*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15500*/   OPC_MoveChild0,
/* 15501*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15504*/   OPC_RecordChild0, // #0 = $v2
/* 15505*/   OPC_Scope, 23, /*->15530*/ // 2 children in Scope
/* 15507*/    OPC_RecordChild1, // #1 = $v1
/* 15508*/    OPC_MoveSibling1,
/* 15509*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15512*/    OPC_RecordChild0, // #2 = $c
/* 15513*/    OPC_MoveChild1,
/* 15514*/    OPC_CheckImmAllOnesV,
/* 15515*/    OPC_MoveParent,
/* 15516*/    OPC_MoveParent,
/* 15517*/    OPC_MoveParent,
/* 15518*/    OPC_CheckChild1Same, 0,
/* 15520*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15522*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15530*/   /*Scope*/ 37, /*->15568*/
/* 15531*/    OPC_MoveChild1,
/* 15532*/    OPC_CheckImmAllOnesV,
/* 15533*/    OPC_MoveParent,
/* 15534*/    OPC_MoveSibling1,
/* 15535*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15538*/    OPC_RecordChild0, // #1 = $v1
/* 15539*/    OPC_RecordChild1, // #2 = $v2
/* 15540*/    OPC_MoveParent,
/* 15541*/    OPC_MoveParent,
/* 15542*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15544*/    OPC_Scope, 10, /*->15556*/ // 2 children in Scope
/* 15546*/     OPC_CheckChild1Same, 2,
/* 15548*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15556*/    /*Scope*/ 10, /*->15567*/
/* 15557*/     OPC_CheckChild1Same, 1,
/* 15559*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15567*/    0, /*End of Scope*/
/* 15568*/   0, /*End of Scope*/
/* 15569*/  /*Scope*/ 102, /*->15672*/
/* 15570*/   OPC_RecordChild0, // #0 = $v2
/* 15571*/   OPC_MoveChild1,
/* 15572*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15575*/   OPC_MoveChild0,
/* 15576*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15579*/   OPC_Scope, 23, /*->15604*/ // 3 children in Scope
/* 15581*/    OPC_RecordChild0, // #1 = $v1
/* 15582*/    OPC_CheckChild1Same, 0,
/* 15584*/    OPC_MoveSibling1,
/* 15585*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15588*/    OPC_RecordChild0, // #2 = $c
/* 15589*/    OPC_MoveChild1,
/* 15590*/    OPC_CheckImmAllOnesV,
/* 15591*/    OPC_MoveParent,
/* 15592*/    OPC_MoveParent,
/* 15593*/    OPC_MoveParent,
/* 15594*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15596*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15604*/   /*Scope*/ 23, /*->15628*/
/* 15605*/    OPC_CheckChild0Same, 0,
/* 15607*/    OPC_RecordChild1, // #1 = $v1
/* 15608*/    OPC_MoveSibling1,
/* 15609*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15612*/    OPC_RecordChild0, // #2 = $c
/* 15613*/    OPC_MoveChild1,
/* 15614*/    OPC_CheckImmAllOnesV,
/* 15615*/    OPC_MoveParent,
/* 15616*/    OPC_MoveParent,
/* 15617*/    OPC_MoveParent,
/* 15618*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15620*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15628*/   /*Scope*/ 42, /*->15671*/
/* 15629*/    OPC_RecordChild0, // #1 = $c
/* 15630*/    OPC_MoveChild1,
/* 15631*/    OPC_CheckImmAllOnesV,
/* 15632*/    OPC_MoveParent,
/* 15633*/    OPC_MoveSibling1,
/* 15634*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15637*/    OPC_Scope, 15, /*->15654*/ // 2 children in Scope
/* 15639*/     OPC_RecordChild0, // #2 = $v1
/* 15640*/     OPC_CheckChild1Same, 0,
/* 15642*/     OPC_MoveParent,
/* 15643*/     OPC_MoveParent,
/* 15644*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15646*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15654*/    /*Scope*/ 15, /*->15670*/
/* 15655*/     OPC_CheckChild0Same, 0,
/* 15657*/     OPC_RecordChild1, // #2 = $v1
/* 15658*/     OPC_MoveParent,
/* 15659*/     OPC_MoveParent,
/* 15660*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15662*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15670*/    0, /*End of Scope*/
/* 15671*/   0, /*End of Scope*/
/* 15672*/  /*Scope*/ 73, /*->15746*/
/* 15673*/   OPC_MoveChild0,
/* 15674*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15677*/   OPC_MoveChild0,
/* 15678*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15681*/   OPC_RecordChild0, // #0 = $v2
/* 15682*/   OPC_Scope, 23, /*->15707*/ // 2 children in Scope
/* 15684*/    OPC_RecordChild1, // #1 = $v1
/* 15685*/    OPC_MoveSibling1,
/* 15686*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15689*/    OPC_RecordChild0, // #2 = $c
/* 15690*/    OPC_MoveChild1,
/* 15691*/    OPC_CheckImmAllOnesV,
/* 15692*/    OPC_MoveParent,
/* 15693*/    OPC_MoveParent,
/* 15694*/    OPC_MoveParent,
/* 15695*/    OPC_CheckChild1Same, 0,
/* 15697*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15699*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15707*/   /*Scope*/ 37, /*->15745*/
/* 15708*/    OPC_MoveChild1,
/* 15709*/    OPC_CheckImmAllOnesV,
/* 15710*/    OPC_MoveParent,
/* 15711*/    OPC_MoveSibling1,
/* 15712*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15715*/    OPC_RecordChild0, // #1 = $v1
/* 15716*/    OPC_RecordChild1, // #2 = $v2
/* 15717*/    OPC_MoveParent,
/* 15718*/    OPC_MoveParent,
/* 15719*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15721*/    OPC_Scope, 10, /*->15733*/ // 2 children in Scope
/* 15723*/     OPC_CheckChild1Same, 2,
/* 15725*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15733*/    /*Scope*/ 10, /*->15744*/
/* 15734*/     OPC_CheckChild1Same, 1,
/* 15736*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15744*/    0, /*End of Scope*/
/* 15745*/   0, /*End of Scope*/
/* 15746*/  /*Scope*/ 102, /*->15849*/
/* 15747*/   OPC_RecordChild0, // #0 = $v2
/* 15748*/   OPC_MoveChild1,
/* 15749*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15752*/   OPC_MoveChild0,
/* 15753*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15756*/   OPC_Scope, 23, /*->15781*/ // 3 children in Scope
/* 15758*/    OPC_RecordChild0, // #1 = $v1
/* 15759*/    OPC_CheckChild1Same, 0,
/* 15761*/    OPC_MoveSibling1,
/* 15762*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15765*/    OPC_RecordChild0, // #2 = $c
/* 15766*/    OPC_MoveChild1,
/* 15767*/    OPC_CheckImmAllOnesV,
/* 15768*/    OPC_MoveParent,
/* 15769*/    OPC_MoveParent,
/* 15770*/    OPC_MoveParent,
/* 15771*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15773*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15781*/   /*Scope*/ 23, /*->15805*/
/* 15782*/    OPC_CheckChild0Same, 0,
/* 15784*/    OPC_RecordChild1, // #1 = $v1
/* 15785*/    OPC_MoveSibling1,
/* 15786*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15789*/    OPC_RecordChild0, // #2 = $c
/* 15790*/    OPC_MoveChild1,
/* 15791*/    OPC_CheckImmAllOnesV,
/* 15792*/    OPC_MoveParent,
/* 15793*/    OPC_MoveParent,
/* 15794*/    OPC_MoveParent,
/* 15795*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15797*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15805*/   /*Scope*/ 42, /*->15848*/
/* 15806*/    OPC_RecordChild0, // #1 = $c
/* 15807*/    OPC_MoveChild1,
/* 15808*/    OPC_CheckImmAllOnesV,
/* 15809*/    OPC_MoveParent,
/* 15810*/    OPC_MoveSibling1,
/* 15811*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15814*/    OPC_Scope, 15, /*->15831*/ // 2 children in Scope
/* 15816*/     OPC_RecordChild0, // #2 = $v1
/* 15817*/     OPC_CheckChild1Same, 0,
/* 15819*/     OPC_MoveParent,
/* 15820*/     OPC_MoveParent,
/* 15821*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15823*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15831*/    /*Scope*/ 15, /*->15847*/
/* 15832*/     OPC_CheckChild0Same, 0,
/* 15834*/     OPC_RecordChild1, // #2 = $v1
/* 15835*/     OPC_MoveParent,
/* 15836*/     OPC_MoveParent,
/* 15837*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15839*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15847*/    0, /*End of Scope*/
/* 15848*/   0, /*End of Scope*/
/* 15849*/  /*Scope*/ 112, /*->15962*/
/* 15850*/   OPC_MoveChild0,
/* 15851*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15854*/   OPC_Scope, 69, /*->15925*/ // 2 children in Scope
/* 15856*/    OPC_MoveChild0,
/* 15857*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15860*/    OPC_RecordChild0, // #0 = $v1
/* 15861*/    OPC_RecordChild1, // #1 = $v2
/* 15862*/    OPC_MoveParent,
/* 15863*/    OPC_RecordChild1, // #2 = $c
/* 15864*/    OPC_MoveParent,
/* 15865*/    OPC_Scope, 44, /*->15911*/ // 2 children in Scope
/* 15867*/     OPC_CheckChild1Same, 1,
/* 15869*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15880
/* 15872*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15880*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15890
/* 15882*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15890*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15900
/* 15892*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15900*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15910
/* 15902*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15910*/     0, // EndSwitchType
/* 15911*/    /*Scope*/ 12, /*->15924*/
/* 15912*/     OPC_CheckChild1Same, 0,
/* 15914*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15916*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15924*/    0, /*End of Scope*/
/* 15925*/   /*Scope*/ 35, /*->15961*/
/* 15926*/    OPC_RecordChild0, // #0 = $c
/* 15927*/    OPC_MoveChild1,
/* 15928*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15931*/    OPC_RecordChild0, // #1 = $v1
/* 15932*/    OPC_RecordChild1, // #2 = $v2
/* 15933*/    OPC_MoveParent,
/* 15934*/    OPC_MoveParent,
/* 15935*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15937*/    OPC_Scope, 10, /*->15949*/ // 2 children in Scope
/* 15939*/     OPC_CheckChild1Same, 2,
/* 15941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15949*/    /*Scope*/ 10, /*->15960*/
/* 15950*/     OPC_CheckChild1Same, 1,
/* 15952*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15960*/    0, /*End of Scope*/
/* 15961*/   0, /*End of Scope*/
/* 15962*/  /*Scope*/ 88, /*->16051*/
/* 15963*/   OPC_RecordChild0, // #0 = $v2
/* 15964*/   OPC_MoveChild1,
/* 15965*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15968*/   OPC_Scope, 40, /*->16010*/ // 2 children in Scope
/* 15970*/    OPC_MoveChild0,
/* 15971*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15974*/    OPC_Scope, 16, /*->15992*/ // 2 children in Scope
/* 15976*/     OPC_RecordChild0, // #1 = $v1
/* 15977*/     OPC_CheckChild1Same, 0,
/* 15979*/     OPC_MoveParent,
/* 15980*/     OPC_RecordChild1, // #2 = $c
/* 15981*/     OPC_MoveParent,
/* 15982*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15984*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15992*/    /*Scope*/ 16, /*->16009*/
/* 15993*/     OPC_CheckChild0Same, 0,
/* 15995*/     OPC_RecordChild1, // #1 = $v1
/* 15996*/     OPC_MoveParent,
/* 15997*/     OPC_RecordChild1, // #2 = $c
/* 15998*/     OPC_MoveParent,
/* 15999*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 16001*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16009*/    0, /*End of Scope*/
/* 16010*/   /*Scope*/ 39, /*->16050*/
/* 16011*/    OPC_RecordChild0, // #1 = $c
/* 16012*/    OPC_MoveChild1,
/* 16013*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16016*/    OPC_Scope, 15, /*->16033*/ // 2 children in Scope
/* 16018*/     OPC_RecordChild0, // #2 = $v1
/* 16019*/     OPC_CheckChild1Same, 0,
/* 16021*/     OPC_MoveParent,
/* 16022*/     OPC_MoveParent,
/* 16023*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 16025*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16033*/    /*Scope*/ 15, /*->16049*/
/* 16034*/     OPC_CheckChild0Same, 0,
/* 16036*/     OPC_RecordChild1, // #2 = $v1
/* 16037*/     OPC_MoveParent,
/* 16038*/     OPC_MoveParent,
/* 16039*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 16041*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 16049*/    0, /*End of Scope*/
/* 16050*/   0, /*End of Scope*/
/* 16051*/  /*Scope*/ 64, /*->16116*/
/* 16052*/   OPC_MoveChild0,
/* 16053*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16056*/   OPC_Scope, 21, /*->16079*/ // 2 children in Scope
/* 16058*/    OPC_MoveChild0,
/* 16059*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16062*/    OPC_RecordChild0, // #0 = $v2
/* 16063*/    OPC_RecordChild1, // #1 = $v1
/* 16064*/    OPC_MoveParent,
/* 16065*/    OPC_RecordChild1, // #2 = $c
/* 16066*/    OPC_MoveParent,
/* 16067*/    OPC_CheckChild1Same, 0,
/* 16069*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16071*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16079*/   /*Scope*/ 35, /*->16115*/
/* 16080*/    OPC_RecordChild0, // #0 = $c
/* 16081*/    OPC_MoveChild1,
/* 16082*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16085*/    OPC_RecordChild0, // #1 = $v1
/* 16086*/    OPC_RecordChild1, // #2 = $v2
/* 16087*/    OPC_MoveParent,
/* 16088*/    OPC_MoveParent,
/* 16089*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16091*/    OPC_Scope, 10, /*->16103*/ // 2 children in Scope
/* 16093*/     OPC_CheckChild1Same, 2,
/* 16095*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16103*/    /*Scope*/ 10, /*->16114*/
/* 16104*/     OPC_CheckChild1Same, 1,
/* 16106*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16114*/    0, /*End of Scope*/
/* 16115*/   0, /*End of Scope*/
/* 16116*/  /*Scope*/ 88, /*->16205*/
/* 16117*/   OPC_RecordChild0, // #0 = $v2
/* 16118*/   OPC_MoveChild1,
/* 16119*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16122*/   OPC_Scope, 40, /*->16164*/ // 2 children in Scope
/* 16124*/    OPC_MoveChild0,
/* 16125*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16128*/    OPC_Scope, 16, /*->16146*/ // 2 children in Scope
/* 16130*/     OPC_RecordChild0, // #1 = $v1
/* 16131*/     OPC_CheckChild1Same, 0,
/* 16133*/     OPC_MoveParent,
/* 16134*/     OPC_RecordChild1, // #2 = $c
/* 16135*/     OPC_MoveParent,
/* 16136*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16138*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16146*/    /*Scope*/ 16, /*->16163*/
/* 16147*/     OPC_CheckChild0Same, 0,
/* 16149*/     OPC_RecordChild1, // #1 = $v1
/* 16150*/     OPC_MoveParent,
/* 16151*/     OPC_RecordChild1, // #2 = $c
/* 16152*/     OPC_MoveParent,
/* 16153*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16155*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16163*/    0, /*End of Scope*/
/* 16164*/   /*Scope*/ 39, /*->16204*/
/* 16165*/    OPC_RecordChild0, // #1 = $c
/* 16166*/    OPC_MoveChild1,
/* 16167*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16170*/    OPC_Scope, 15, /*->16187*/ // 2 children in Scope
/* 16172*/     OPC_RecordChild0, // #2 = $v1
/* 16173*/     OPC_CheckChild1Same, 0,
/* 16175*/     OPC_MoveParent,
/* 16176*/     OPC_MoveParent,
/* 16177*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16179*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16187*/    /*Scope*/ 15, /*->16203*/
/* 16188*/     OPC_CheckChild0Same, 0,
/* 16190*/     OPC_RecordChild1, // #2 = $v1
/* 16191*/     OPC_MoveParent,
/* 16192*/     OPC_MoveParent,
/* 16193*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16195*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16203*/    0, /*End of Scope*/
/* 16204*/   0, /*End of Scope*/
/* 16205*/  /*Scope*/ 64, /*->16270*/
/* 16206*/   OPC_MoveChild0,
/* 16207*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16210*/   OPC_Scope, 21, /*->16233*/ // 2 children in Scope
/* 16212*/    OPC_MoveChild0,
/* 16213*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16216*/    OPC_RecordChild0, // #0 = $v2
/* 16217*/    OPC_RecordChild1, // #1 = $v1
/* 16218*/    OPC_MoveParent,
/* 16219*/    OPC_RecordChild1, // #2 = $c
/* 16220*/    OPC_MoveParent,
/* 16221*/    OPC_CheckChild1Same, 0,
/* 16223*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16225*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16233*/   /*Scope*/ 35, /*->16269*/
/* 16234*/    OPC_RecordChild0, // #0 = $c
/* 16235*/    OPC_MoveChild1,
/* 16236*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16239*/    OPC_RecordChild0, // #1 = $v1
/* 16240*/    OPC_RecordChild1, // #2 = $v2
/* 16241*/    OPC_MoveParent,
/* 16242*/    OPC_MoveParent,
/* 16243*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16245*/    OPC_Scope, 10, /*->16257*/ // 2 children in Scope
/* 16247*/     OPC_CheckChild1Same, 2,
/* 16249*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16257*/    /*Scope*/ 10, /*->16268*/
/* 16258*/     OPC_CheckChild1Same, 1,
/* 16260*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16268*/    0, /*End of Scope*/
/* 16269*/   0, /*End of Scope*/
/* 16270*/  /*Scope*/ 88, /*->16359*/
/* 16271*/   OPC_RecordChild0, // #0 = $v2
/* 16272*/   OPC_MoveChild1,
/* 16273*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16276*/   OPC_Scope, 40, /*->16318*/ // 2 children in Scope
/* 16278*/    OPC_MoveChild0,
/* 16279*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16282*/    OPC_Scope, 16, /*->16300*/ // 2 children in Scope
/* 16284*/     OPC_RecordChild0, // #1 = $v1
/* 16285*/     OPC_CheckChild1Same, 0,
/* 16287*/     OPC_MoveParent,
/* 16288*/     OPC_RecordChild1, // #2 = $c
/* 16289*/     OPC_MoveParent,
/* 16290*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16292*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16300*/    /*Scope*/ 16, /*->16317*/
/* 16301*/     OPC_CheckChild0Same, 0,
/* 16303*/     OPC_RecordChild1, // #1 = $v1
/* 16304*/     OPC_MoveParent,
/* 16305*/     OPC_RecordChild1, // #2 = $c
/* 16306*/     OPC_MoveParent,
/* 16307*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16309*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16317*/    0, /*End of Scope*/
/* 16318*/   /*Scope*/ 39, /*->16358*/
/* 16319*/    OPC_RecordChild0, // #1 = $c
/* 16320*/    OPC_MoveChild1,
/* 16321*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16324*/    OPC_Scope, 15, /*->16341*/ // 2 children in Scope
/* 16326*/     OPC_RecordChild0, // #2 = $v1
/* 16327*/     OPC_CheckChild1Same, 0,
/* 16329*/     OPC_MoveParent,
/* 16330*/     OPC_MoveParent,
/* 16331*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16333*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16341*/    /*Scope*/ 15, /*->16357*/
/* 16342*/     OPC_CheckChild0Same, 0,
/* 16344*/     OPC_RecordChild1, // #2 = $v1
/* 16345*/     OPC_MoveParent,
/* 16346*/     OPC_MoveParent,
/* 16347*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16349*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16357*/    0, /*End of Scope*/
/* 16358*/   0, /*End of Scope*/
/* 16359*/  /*Scope*/ 64, /*->16424*/
/* 16360*/   OPC_MoveChild0,
/* 16361*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16364*/   OPC_Scope, 21, /*->16387*/ // 2 children in Scope
/* 16366*/    OPC_MoveChild0,
/* 16367*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16370*/    OPC_RecordChild0, // #0 = $v2
/* 16371*/    OPC_RecordChild1, // #1 = $v1
/* 16372*/    OPC_MoveParent,
/* 16373*/    OPC_RecordChild1, // #2 = $c
/* 16374*/    OPC_MoveParent,
/* 16375*/    OPC_CheckChild1Same, 0,
/* 16377*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16379*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16387*/   /*Scope*/ 35, /*->16423*/
/* 16388*/    OPC_RecordChild0, // #0 = $c
/* 16389*/    OPC_MoveChild1,
/* 16390*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16393*/    OPC_RecordChild0, // #1 = $v1
/* 16394*/    OPC_RecordChild1, // #2 = $v2
/* 16395*/    OPC_MoveParent,
/* 16396*/    OPC_MoveParent,
/* 16397*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16399*/    OPC_Scope, 10, /*->16411*/ // 2 children in Scope
/* 16401*/     OPC_CheckChild1Same, 2,
/* 16403*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16411*/    /*Scope*/ 10, /*->16422*/
/* 16412*/     OPC_CheckChild1Same, 1,
/* 16414*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16422*/    0, /*End of Scope*/
/* 16423*/   0, /*End of Scope*/
/* 16424*/  /*Scope*/ 43|128,1/*171*/, /*->16597*/
/* 16426*/   OPC_RecordChild0, // #0 = $v2
/* 16427*/   OPC_Scope, 127, /*->16556*/ // 2 children in Scope
/* 16429*/    OPC_MoveChild1,
/* 16430*/    OPC_Scope, 86, /*->16518*/ // 2 children in Scope
/* 16432*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16435*/     OPC_Scope, 40, /*->16477*/ // 2 children in Scope
/* 16437*/      OPC_MoveChild0,
/* 16438*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16441*/      OPC_Scope, 16, /*->16459*/ // 2 children in Scope
/* 16443*/       OPC_RecordChild0, // #1 = $v1
/* 16444*/       OPC_CheckChild1Same, 0,
/* 16446*/       OPC_MoveParent,
/* 16447*/       OPC_RecordChild1, // #2 = $c
/* 16448*/       OPC_MoveParent,
/* 16449*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16451*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16459*/      /*Scope*/ 16, /*->16476*/
/* 16460*/       OPC_CheckChild0Same, 0,
/* 16462*/       OPC_RecordChild1, // #1 = $v1
/* 16463*/       OPC_MoveParent,
/* 16464*/       OPC_RecordChild1, // #2 = $c
/* 16465*/       OPC_MoveParent,
/* 16466*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16468*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16476*/      0, /*End of Scope*/
/* 16477*/     /*Scope*/ 39, /*->16517*/
/* 16478*/      OPC_RecordChild0, // #1 = $c
/* 16479*/      OPC_MoveChild1,
/* 16480*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16483*/      OPC_Scope, 15, /*->16500*/ // 2 children in Scope
/* 16485*/       OPC_RecordChild0, // #2 = $v1
/* 16486*/       OPC_CheckChild1Same, 0,
/* 16488*/       OPC_MoveParent,
/* 16489*/       OPC_MoveParent,
/* 16490*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16492*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16500*/      /*Scope*/ 15, /*->16516*/
/* 16501*/       OPC_CheckChild0Same, 0,
/* 16503*/       OPC_RecordChild1, // #2 = $v1
/* 16504*/       OPC_MoveParent,
/* 16505*/       OPC_MoveParent,
/* 16506*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16508*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16516*/      0, /*End of Scope*/
/* 16517*/     0, /*End of Scope*/
/* 16518*/    /*Scope*/ 36, /*->16555*/
/* 16519*/     OPC_CheckImmAllOnesV,
/* 16520*/     OPC_MoveParent,
/* 16521*/     OPC_SwitchType /*4 cases */, 6, /*MVT::v16i8*/39, // ->16530
/* 16524*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16530*/     /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->16538
/* 16532*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16538*/     /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->16546
/* 16540*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16546*/     /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->16554
/* 16548*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16554*/     0, // EndSwitchType
/* 16555*/    0, /*End of Scope*/
/* 16556*/   /*Scope*/ 39, /*->16596*/
/* 16557*/    OPC_RecordChild1, // #1 = $rhs
/* 16558*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->16568
/* 16561*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16568*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->16577
/* 16570*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16577*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->16586
/* 16579*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16586*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->16595
/* 16588*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16595*/    0, // EndSwitchType
/* 16596*/   0, /*End of Scope*/
/* 16597*/  0, /*End of Scope*/
/* 16598*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16622
/* 16601*/  OPC_RecordChild0, // #0 = $src
/* 16602*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16612
/* 16605*/   OPC_CheckChild0TypeI32,
/* 16606*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16612*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16621
/* 16614*/   OPC_CheckChild0TypeI64,
/* 16615*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16621*/  0, // EndSwitchType
/* 16622*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16646
/* 16625*/  OPC_RecordChild0, // #0 = $src
/* 16626*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16636
/* 16629*/   OPC_CheckChild0TypeI32,
/* 16630*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16636*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16645
/* 16638*/   OPC_CheckChild0TypeI64,
/* 16639*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16645*/  0, // EndSwitchType
/* 16646*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16681
/* 16649*/  OPC_RecordChild0, // #0 = $src
/* 16650*/  OPC_SwitchType /*3 cases */, 7, /*MVT::i32*/7, // ->16660
/* 16653*/   OPC_CheckChild0TypeI32,
/* 16654*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16660*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16669
/* 16662*/   OPC_CheckChild0TypeI64,
/* 16663*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16669*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->16680
/* 16671*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 16673*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16674*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16680*/  0, // EndSwitchType
/* 16681*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_ADD128),// ->16706
/* 16684*/  OPC_RecordChild0, // #0 = $a
/* 16685*/  OPC_CheckChild0TypeI64,
/* 16686*/  OPC_RecordChild1, // #1 = $b
/* 16687*/  OPC_CheckChild1TypeI64,
/* 16688*/  OPC_RecordChild2, // #2 = $c
/* 16689*/  OPC_CheckChild2TypeI64,
/* 16690*/  OPC_RecordChild3, // #3 = $d
/* 16691*/  OPC_CheckChild3TypeI64,
/* 16692*/  OPC_CheckTypeI64,
/* 16693*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16696*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_ADD128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_add128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_ADD128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16706*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_SUB128),// ->16731
/* 16709*/  OPC_RecordChild0, // #0 = $a
/* 16710*/  OPC_CheckChild0TypeI64,
/* 16711*/  OPC_RecordChild1, // #1 = $b
/* 16712*/  OPC_CheckChild1TypeI64,
/* 16713*/  OPC_RecordChild2, // #2 = $c
/* 16714*/  OPC_CheckChild2TypeI64,
/* 16715*/  OPC_RecordChild3, // #3 = $d
/* 16716*/  OPC_CheckChild3TypeI64,
/* 16717*/  OPC_CheckTypeI64,
/* 16718*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16721*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_SUB128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_sub128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_SUB128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16731*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_S),// ->16750
/* 16734*/  OPC_RecordChild0, // #0 = $x
/* 16735*/  OPC_CheckChild0TypeI64,
/* 16736*/  OPC_RecordChild1, // #1 = $y
/* 16737*/  OPC_CheckChild1TypeI64,
/* 16738*/  OPC_CheckTypeI64,
/* 16739*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16742*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_S),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_s:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_S:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16750*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_U),// ->16769
/* 16753*/  OPC_RecordChild0, // #0 = $x
/* 16754*/  OPC_CheckChild0TypeI64,
/* 16755*/  OPC_RecordChild1, // #1 = $y
/* 16756*/  OPC_CheckChild1TypeI64,
/* 16757*/  OPC_CheckTypeI64,
/* 16758*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16761*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_U),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_u:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_U:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16769*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16779
/* 16772*/  OPC_RecordChild0, // #0 = $src
/* 16773*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                /*MVT::i32*/7, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16779*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16789
/* 16782*/  OPC_RecordChild0, // #0 = $src
/* 16783*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                /*MVT::i64*/8, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16789*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16913
/* 16792*/  OPC_RecordChild0, // #0 = $src
/* 16793*/  OPC_Scope, 48, /*->16843*/ // 4 children in Scope
/* 16795*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16797*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16820
/* 16800*/    OPC_Scope, 8, /*->16810*/ // 2 children in Scope
/* 16802*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16804*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16810*/    /*Scope*/ 8, /*->16819*/
/* 16811*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16813*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16819*/    0, /*End of Scope*/
/* 16820*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16842
/* 16822*/    OPC_Scope, 8, /*->16832*/ // 2 children in Scope
/* 16824*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16826*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16832*/    /*Scope*/ 8, /*->16841*/
/* 16833*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16835*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16841*/    0, /*End of Scope*/
/* 16842*/   0, // EndSwitchType
/* 16843*/  /*Scope*/ 48, /*->16892*/
/* 16844*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16846*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16869
/* 16849*/    OPC_Scope, 8, /*->16859*/ // 2 children in Scope
/* 16851*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16853*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16859*/    /*Scope*/ 8, /*->16868*/
/* 16860*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16862*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16868*/    0, /*End of Scope*/
/* 16869*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16891
/* 16871*/    OPC_Scope, 8, /*->16881*/ // 2 children in Scope
/* 16873*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16875*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16881*/    /*Scope*/ 8, /*->16890*/
/* 16882*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16884*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16890*/    0, /*End of Scope*/
/* 16891*/   0, // EndSwitchType
/* 16892*/  /*Scope*/ 9, /*->16902*/
/* 16893*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16895*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16896*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16902*/  /*Scope*/ 9, /*->16912*/
/* 16903*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16905*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16906*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16912*/  0, /*End of Scope*/
/* 16913*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->17037
/* 16916*/  OPC_RecordChild0, // #0 = $src
/* 16917*/  OPC_Scope, 48, /*->16967*/ // 4 children in Scope
/* 16919*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16921*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16944
/* 16924*/    OPC_Scope, 8, /*->16934*/ // 2 children in Scope
/* 16926*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16928*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16934*/    /*Scope*/ 8, /*->16943*/
/* 16935*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16937*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16943*/    0, /*End of Scope*/
/* 16944*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16966
/* 16946*/    OPC_Scope, 8, /*->16956*/ // 2 children in Scope
/* 16948*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16950*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16956*/    /*Scope*/ 8, /*->16965*/
/* 16957*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16959*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16965*/    0, /*End of Scope*/
/* 16966*/   0, // EndSwitchType
/* 16967*/  /*Scope*/ 48, /*->17016*/
/* 16968*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16970*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16993
/* 16973*/    OPC_Scope, 8, /*->16983*/ // 2 children in Scope
/* 16975*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16977*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16983*/    /*Scope*/ 8, /*->16992*/
/* 16984*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16986*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16992*/    0, /*End of Scope*/
/* 16993*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->17015
/* 16995*/    OPC_Scope, 8, /*->17005*/ // 2 children in Scope
/* 16997*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16999*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17005*/    /*Scope*/ 8, /*->17014*/
/* 17006*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 17008*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17014*/    0, /*End of Scope*/
/* 17015*/   0, // EndSwitchType
/* 17016*/  /*Scope*/ 9, /*->17026*/
/* 17017*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 17019*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17020*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 17026*/  /*Scope*/ 9, /*->17036*/
/* 17027*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 17029*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17030*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 17036*/  0, /*End of Scope*/
/* 17037*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->17127
/* 17040*/  OPC_RecordChild0, // #0 = $src
/* 17041*/  OPC_Scope, 27, /*->17070*/ // 3 children in Scope
/* 17043*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17045*/   OPC_MoveChild1,
/* 17046*/   OPC_Scope, 10, /*->17058*/ // 2 children in Scope
/* 17048*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17050*/    OPC_MoveParent,
/* 17051*/    OPC_CheckTypeI32,
/* 17052*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17058*/   /*Scope*/ 10, /*->17069*/
/* 17059*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17061*/    OPC_MoveParent,
/* 17062*/    OPC_CheckTypeI64,
/* 17063*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17069*/   0, /*End of Scope*/
/* 17070*/  /*Scope*/ 27, /*->17098*/
/* 17071*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17073*/   OPC_MoveChild1,
/* 17074*/   OPC_Scope, 10, /*->17086*/ // 2 children in Scope
/* 17076*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17078*/    OPC_MoveParent,
/* 17079*/    OPC_CheckTypeI32,
/* 17080*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17086*/   /*Scope*/ 10, /*->17097*/
/* 17087*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17089*/    OPC_MoveParent,
/* 17090*/    OPC_CheckTypeI64,
/* 17091*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17097*/   0, /*End of Scope*/
/* 17098*/  /*Scope*/ 27, /*->17126*/
/* 17099*/   OPC_MoveChild1,
/* 17100*/   OPC_Scope, 11, /*->17113*/ // 2 children in Scope
/* 17102*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17104*/    OPC_MoveParent,
/* 17105*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 17107*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17113*/   /*Scope*/ 11, /*->17125*/
/* 17114*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 17116*/    OPC_MoveParent,
/* 17117*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 17119*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 17125*/   0, /*End of Scope*/
/* 17126*/  0, /*End of Scope*/
/* 17127*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->17217
/* 17130*/  OPC_RecordChild0, // #0 = $src
/* 17131*/  OPC_Scope, 27, /*->17160*/ // 3 children in Scope
/* 17133*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17135*/   OPC_MoveChild1,
/* 17136*/   OPC_Scope, 10, /*->17148*/ // 2 children in Scope
/* 17138*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17140*/    OPC_MoveParent,
/* 17141*/    OPC_CheckTypeI32,
/* 17142*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17148*/   /*Scope*/ 10, /*->17159*/
/* 17149*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17151*/    OPC_MoveParent,
/* 17152*/    OPC_CheckTypeI64,
/* 17153*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 17159*/   0, /*End of Scope*/
/* 17160*/  /*Scope*/ 27, /*->17188*/
/* 17161*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17163*/   OPC_MoveChild1,
/* 17164*/   OPC_Scope, 10, /*->17176*/ // 2 children in Scope
/* 17166*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17168*/    OPC_MoveParent,
/* 17169*/    OPC_CheckTypeI32,
/* 17170*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17176*/   /*Scope*/ 10, /*->17187*/
/* 17177*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17179*/    OPC_MoveParent,
/* 17180*/    OPC_CheckTypeI64,
/* 17181*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17187*/   0, /*End of Scope*/
/* 17188*/  /*Scope*/ 27, /*->17216*/
/* 17189*/   OPC_MoveChild1,
/* 17190*/   OPC_Scope, 11, /*->17203*/ // 2 children in Scope
/* 17192*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17194*/    OPC_MoveParent,
/* 17195*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 17197*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17203*/   /*Scope*/ 11, /*->17215*/
/* 17204*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 17206*/    OPC_MoveParent,
/* 17207*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 17209*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 17215*/   0, /*End of Scope*/
/* 17216*/  0, /*End of Scope*/
/* 17217*/ /*SwitchOpcode*/ 39|128,2/*295*/, TARGET_VAL(ISD::BITCAST),// ->17516
/* 17221*/  OPC_RecordChild0, // #0 = $src
/* 17222*/  OPC_Scope, 9, /*->17233*/ // 11 children in Scope
/* 17224*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17226*/   OPC_CheckTypeI32,
/* 17227*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17233*/  /*Scope*/ 9, /*->17243*/
/* 17234*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17236*/   OPC_CheckTypeI64,
/* 17237*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17243*/  /*Scope*/ 9, /*->17253*/
/* 17244*/   OPC_CheckChild0TypeI32,
/* 17245*/   OPC_CheckType, /*MVT::f32*/12, 
/* 17247*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17253*/  /*Scope*/ 9, /*->17263*/
/* 17254*/   OPC_CheckChild0TypeI64,
/* 17255*/   OPC_CheckType, /*MVT::f64*/13, 
/* 17257*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17263*/  /*Scope*/ 35, /*->17299*/
/* 17264*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 17266*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17272
/* 17269*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17272*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17277
/* 17274*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17277*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17282
/* 17279*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17282*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17287
/* 17284*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17287*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17293
/* 17290*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17293*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17298
/* 17295*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17298*/   0, // EndSwitchType
/* 17299*/  /*Scope*/ 35, /*->17335*/
/* 17300*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 17302*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17308
/* 17305*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17308*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17313
/* 17310*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17313*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17318
/* 17315*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17318*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17323
/* 17320*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17323*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17329
/* 17326*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17329*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17334
/* 17331*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17334*/   0, // EndSwitchType
/* 17335*/  /*Scope*/ 35, /*->17371*/
/* 17336*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 17338*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17344
/* 17341*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17344*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17349
/* 17346*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17349*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17354
/* 17351*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17354*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17359
/* 17356*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17359*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17365
/* 17362*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17365*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17370
/* 17367*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17370*/   0, // EndSwitchType
/* 17371*/  /*Scope*/ 35, /*->17407*/
/* 17372*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 17374*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17380
/* 17377*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17380*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17385
/* 17382*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17385*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17390
/* 17387*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17390*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17395
/* 17392*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17395*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17401
/* 17398*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17401*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17406
/* 17403*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17406*/   0, // EndSwitchType
/* 17407*/  /*Scope*/ 35, /*->17443*/
/* 17408*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 17411*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17417
/* 17414*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17417*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17422
/* 17419*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17422*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17427
/* 17424*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17427*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17432
/* 17429*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17432*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17437
/* 17434*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17437*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17442
/* 17439*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17442*/   0, // EndSwitchType
/* 17443*/  /*Scope*/ 35, /*->17479*/
/* 17444*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 17446*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17452
/* 17449*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17452*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17457
/* 17454*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17457*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17462
/* 17459*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17462*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17467
/* 17464*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17467*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17472
/* 17469*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17472*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17478
/* 17475*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17478*/   0, // EndSwitchType
/* 17479*/  /*Scope*/ 35, /*->17515*/
/* 17480*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 17482*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v8i16*/50, // ->17488
/* 17485*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17488*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17493
/* 17490*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17493*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17498
/* 17495*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17498*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17503
/* 17500*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17503*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17509
/* 17506*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17509*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17514
/* 17511*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17514*/   0, // EndSwitchType
/* 17515*/  0, /*End of Scope*/
/* 17516*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17540
/* 17519*/  OPC_RecordNode, // #0 = $imm
/* 17520*/  OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17530
/* 17523*/   OPC_EmitConvertToTarget0, // #1
/* 17524*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17530*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17539
/* 17532*/   OPC_EmitConvertToTarget0, // #1
/* 17533*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17539*/  0, // EndSwitchType
/* 17540*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17606
/* 17543*/  OPC_RecordChild0, // #0 = $src
/* 17544*/  OPC_Scope, 19, /*->17565*/ // 4 children in Scope
/* 17546*/   OPC_CheckChild0TypeI32,
/* 17547*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17556
/* 17550*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17556*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17564
/* 17558*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17564*/   0, // EndSwitchType
/* 17565*/  /*Scope*/ 19, /*->17585*/
/* 17566*/   OPC_CheckChild0TypeI64,
/* 17567*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17576
/* 17570*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17576*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17584
/* 17578*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17584*/   0, // EndSwitchType
/* 17585*/  /*Scope*/ 9, /*->17595*/
/* 17586*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17588*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17589*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17595*/  /*Scope*/ 9, /*->17605*/
/* 17596*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17598*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17599*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17605*/  0, /*End of Scope*/
/* 17606*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17672
/* 17609*/  OPC_RecordChild0, // #0 = $src
/* 17610*/  OPC_Scope, 19, /*->17631*/ // 4 children in Scope
/* 17612*/   OPC_CheckChild0TypeI32,
/* 17613*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17622
/* 17616*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17622*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17630
/* 17624*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17630*/   0, // EndSwitchType
/* 17631*/  /*Scope*/ 19, /*->17651*/
/* 17632*/   OPC_CheckChild0TypeI64,
/* 17633*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17642
/* 17636*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17642*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17650
/* 17644*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17650*/   0, // EndSwitchType
/* 17651*/  /*Scope*/ 9, /*->17661*/
/* 17652*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17654*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17655*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17661*/  /*Scope*/ 9, /*->17671*/
/* 17662*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17664*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17665*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17671*/  0, /*End of Scope*/
/* 17672*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17682
/* 17675*/  OPC_RecordChild0, // #0 = $src
/* 17676*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                /*MVT::f64*/13, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17682*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17692
/* 17685*/  OPC_RecordChild0, // #0 = $src
/* 17686*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                /*MVT::f32*/12, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17692*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FADD),// ->17749
/* 17695*/  OPC_RecordChild0, // #0 = $lhs
/* 17696*/  OPC_RecordChild1, // #1 = $rhs
/* 17697*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17707
/* 17700*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17707*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17716
/* 17709*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17716*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17726
/* 17718*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17719*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17726*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17738
/* 17729*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17730*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17738*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17748
/* 17740*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17741*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17748*/  0, // EndSwitchType
/* 17749*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FSUB),// ->17806
/* 17752*/  OPC_RecordChild0, // #0 = $lhs
/* 17753*/  OPC_RecordChild1, // #1 = $rhs
/* 17754*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17764
/* 17757*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17764*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17773
/* 17766*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17773*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17783
/* 17775*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17776*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17783*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17795
/* 17786*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17787*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17795*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17805
/* 17797*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17798*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17805*/  0, // EndSwitchType
/* 17806*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMUL),// ->17863
/* 17809*/  OPC_RecordChild0, // #0 = $lhs
/* 17810*/  OPC_RecordChild1, // #1 = $rhs
/* 17811*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17821
/* 17814*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17821*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17830
/* 17823*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17830*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17840
/* 17832*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17833*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17840*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17852
/* 17843*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17844*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17852*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17862
/* 17854*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17855*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17862*/  0, // EndSwitchType
/* 17863*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FDIV),// ->17920
/* 17866*/  OPC_RecordChild0, // #0 = $lhs
/* 17867*/  OPC_RecordChild1, // #1 = $rhs
/* 17868*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17878
/* 17871*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17878*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17887
/* 17880*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17887*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17897
/* 17889*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17890*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17897*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17909
/* 17900*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17901*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17909*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17919
/* 17911*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17912*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17919*/  0, // EndSwitchType
/* 17920*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSQRT),// ->17971
/* 17923*/  OPC_RecordChild0, // #0 = $src
/* 17924*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17933
/* 17927*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17933*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17941
/* 17935*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17941*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17950
/* 17943*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17944*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17950*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17961
/* 17953*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17954*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17961*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17970
/* 17963*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17964*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17970*/  0, // EndSwitchType
/* 17971*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FABS),// ->18022
/* 17974*/  OPC_RecordChild0, // #0 = $src
/* 17975*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17984
/* 17978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17984*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17992
/* 17986*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17992*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18001
/* 17994*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17995*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18001*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18012
/* 18004*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18012*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18021
/* 18014*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18015*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18021*/  0, // EndSwitchType
/* 18022*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEG),// ->18073
/* 18025*/  OPC_RecordChild0, // #0 = $src
/* 18026*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18035
/* 18029*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18035*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18043
/* 18037*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18043*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18052
/* 18045*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18046*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18052*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18063
/* 18055*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18056*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18063*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18072
/* 18065*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18066*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18072*/  0, // EndSwitchType
/* 18073*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->18138
/* 18076*/  OPC_RecordChild0, // #0 = $lhs
/* 18077*/  OPC_RecordChild1, // #1 = $rhs
/* 18078*/  OPC_Scope, 28, /*->18108*/ // 2 children in Scope
/* 18080*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 18082*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->18092
/* 18085*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18092*/   /*SwitchType*/ 13, /*MVT::f64*/13, // ->18107
/* 18094*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  /*MVT::f64*/13, 1/*#Ops*/, 1,  // Results = #2
/* 18100*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 18107*/   0, // EndSwitchType
/* 18108*/  /*Scope*/ 28, /*->18137*/
/* 18109*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 18111*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f64*/13, // ->18121
/* 18114*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18121*/   /*SwitchType*/ 13, /*MVT::f32*/12, // ->18136
/* 18123*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  /*MVT::f32*/12, 1/*#Ops*/, 1,  // Results = #2
/* 18129*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 18136*/   0, // EndSwitchType
/* 18137*/  0, /*End of Scope*/
/* 18138*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMINIMUM),// ->18195
/* 18141*/  OPC_RecordChild0, // #0 = $lhs
/* 18142*/  OPC_RecordChild1, // #1 = $rhs
/* 18143*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->18153
/* 18146*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18153*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->18162
/* 18155*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18162*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->18172
/* 18164*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18165*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18172*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18184
/* 18175*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18176*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18184*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18194
/* 18186*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18187*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18194*/  0, // EndSwitchType
/* 18195*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMAXIMUM),// ->18252
/* 18198*/  OPC_RecordChild0, // #0 = $lhs
/* 18199*/  OPC_RecordChild1, // #1 = $rhs
/* 18200*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->18210
/* 18203*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18210*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->18219
/* 18212*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18219*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->18229
/* 18221*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18222*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18229*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18241
/* 18232*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18233*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18241*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18251
/* 18243*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18244*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18251*/  0, // EndSwitchType
/* 18252*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FCEIL),// ->18303
/* 18255*/  OPC_RecordChild0, // #0 = $src
/* 18256*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18265
/* 18259*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18265*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18273
/* 18267*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18273*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18282
/* 18275*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18276*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18282*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18293
/* 18285*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18286*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18293*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18302
/* 18295*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18296*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18302*/  0, // EndSwitchType
/* 18303*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FFLOOR),// ->18354
/* 18306*/  OPC_RecordChild0, // #0 = $src
/* 18307*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18316
/* 18310*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18316*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18324
/* 18318*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18324*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18333
/* 18326*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18327*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18333*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18344
/* 18336*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18337*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18344*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18353
/* 18346*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18347*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18353*/  0, // EndSwitchType
/* 18354*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FTRUNC),// ->18405
/* 18357*/  OPC_RecordChild0, // #0 = $src
/* 18358*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18367
/* 18361*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18367*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18375
/* 18369*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18375*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18384
/* 18377*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18378*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18384*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18395
/* 18387*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18388*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18395*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18404
/* 18397*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18398*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18404*/  0, // EndSwitchType
/* 18405*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEARBYINT),// ->18456
/* 18408*/  OPC_RecordChild0, // #0 = $src
/* 18409*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18418
/* 18412*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18418*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18426
/* 18420*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18426*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18435
/* 18428*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18435*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18446
/* 18438*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18439*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18446*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18455
/* 18448*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18449*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18455*/  0, // EndSwitchType
/* 18456*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FRINT),// ->18504
/* 18459*/  OPC_RecordChild0, // #0 = $src
/* 18460*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18469
/* 18463*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18469*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18477
/* 18471*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18477*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18485
/* 18479*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18485*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18495
/* 18488*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18495*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18503
/* 18497*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18503*/  0, // EndSwitchType
/* 18504*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FROUNDEVEN),// ->18552
/* 18507*/  OPC_RecordChild0, // #0 = $src
/* 18508*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18517
/* 18511*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18517*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18525
/* 18519*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18525*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18533
/* 18527*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18533*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18543
/* 18536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18543*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18551
/* 18545*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18551*/  0, // EndSwitchType
/* 18552*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18962
/* 18556*/  OPC_RecordChild0, // #0 = $i0
/* 18557*/  OPC_MoveChild0,
/* 18558*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18892
/* 18563*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, /*MVT::i32*/7, // ->18870
/* 18567*/    OPC_Scope, 51|128,1/*179*/, /*->18749*/ // 3 children in Scope
/* 18570*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18572*/     OPC_MoveSibling1,
/* 18573*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18576*/     OPC_RecordNode, // #1 = $i1
/* 18577*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18579*/     OPC_CheckTypeI32,
/* 18580*/     OPC_MoveSibling2,
/* 18581*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18584*/     OPC_RecordNode, // #2 = $i2
/* 18585*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18587*/     OPC_CheckTypeI32,
/* 18588*/     OPC_MoveSibling3,
/* 18589*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18592*/     OPC_RecordNode, // #3 = $i3
/* 18593*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18595*/     OPC_CheckTypeI32,
/* 18596*/     OPC_MoveSibling4,
/* 18597*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18600*/     OPC_RecordNode, // #4 = $i4
/* 18601*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18603*/     OPC_CheckTypeI32,
/* 18604*/     OPC_MoveSibling5,
/* 18605*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18608*/     OPC_RecordNode, // #5 = $i5
/* 18609*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18611*/     OPC_CheckTypeI32,
/* 18612*/     OPC_MoveSibling6,
/* 18613*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18616*/     OPC_RecordNode, // #6 = $i6
/* 18617*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18619*/     OPC_CheckTypeI32,
/* 18620*/     OPC_MoveSibling7,
/* 18621*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18624*/     OPC_RecordNode, // #7 = $i7
/* 18625*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18627*/     OPC_CheckTypeI32,
/* 18628*/     OPC_MoveSibling, 8,
/* 18630*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18633*/     OPC_RecordNode, // #8 = $i8
/* 18634*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18636*/     OPC_CheckTypeI32,
/* 18637*/     OPC_MoveSibling, 9,
/* 18639*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18642*/     OPC_RecordNode, // #9 = $i9
/* 18643*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18645*/     OPC_CheckTypeI32,
/* 18646*/     OPC_MoveSibling, 10,
/* 18648*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18651*/     OPC_RecordNode, // #10 = $iA
/* 18652*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18654*/     OPC_CheckTypeI32,
/* 18655*/     OPC_MoveSibling, 11,
/* 18657*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18660*/     OPC_RecordNode, // #11 = $iB
/* 18661*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18663*/     OPC_CheckTypeI32,
/* 18664*/     OPC_MoveSibling, 12,
/* 18666*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18669*/     OPC_RecordNode, // #12 = $iC
/* 18670*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18672*/     OPC_CheckTypeI32,
/* 18673*/     OPC_MoveSibling, 13,
/* 18675*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18678*/     OPC_RecordNode, // #13 = $iD
/* 18679*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18681*/     OPC_CheckTypeI32,
/* 18682*/     OPC_MoveSibling, 14,
/* 18684*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18687*/     OPC_RecordNode, // #14 = $iE
/* 18688*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18690*/     OPC_CheckTypeI32,
/* 18691*/     OPC_MoveSibling, 15,
/* 18693*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18696*/     OPC_RecordNode, // #15 = $iF
/* 18697*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18699*/     OPC_CheckTypeI32,
/* 18700*/     OPC_MoveParent,
/* 18701*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 18703*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18704*/     OPC_EmitConvertToTarget0, // #16
/* 18705*/     OPC_EmitConvertToTarget1, // #17
/* 18706*/     OPC_EmitConvertToTarget2, // #18
/* 18707*/     OPC_EmitConvertToTarget3, // #19
/* 18708*/     OPC_EmitConvertToTarget4, // #20
/* 18709*/     OPC_EmitConvertToTarget5, // #21
/* 18710*/     OPC_EmitConvertToTarget6, // #22
/* 18711*/     OPC_EmitConvertToTarget7, // #23
/* 18712*/     OPC_EmitConvertToTarget, 8, // #24
/* 18714*/     OPC_EmitConvertToTarget, 9, // #25
/* 18716*/     OPC_EmitConvertToTarget, 10, // #26
/* 18718*/     OPC_EmitConvertToTarget, 11, // #27
/* 18720*/     OPC_EmitConvertToTarget, 12, // #28
/* 18722*/     OPC_EmitConvertToTarget, 13, // #29
/* 18724*/     OPC_EmitConvertToTarget, 14, // #30
/* 18726*/     OPC_EmitConvertToTarget, 15, // #31
/* 18728*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   /*MVT::v16i8*/39, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18749*/    /*Scope*/ 83, /*->18833*/
/* 18750*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18752*/     OPC_MoveSibling1,
/* 18753*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18756*/     OPC_RecordNode, // #1 = $i1
/* 18757*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18759*/     OPC_CheckTypeI32,
/* 18760*/     OPC_MoveSibling2,
/* 18761*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18764*/     OPC_RecordNode, // #2 = $i2
/* 18765*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18767*/     OPC_CheckTypeI32,
/* 18768*/     OPC_MoveSibling3,
/* 18769*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18772*/     OPC_RecordNode, // #3 = $i3
/* 18773*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18775*/     OPC_CheckTypeI32,
/* 18776*/     OPC_MoveSibling4,
/* 18777*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18780*/     OPC_RecordNode, // #4 = $i4
/* 18781*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18783*/     OPC_CheckTypeI32,
/* 18784*/     OPC_MoveSibling5,
/* 18785*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18788*/     OPC_RecordNode, // #5 = $i5
/* 18789*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18791*/     OPC_CheckTypeI32,
/* 18792*/     OPC_MoveSibling6,
/* 18793*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18796*/     OPC_RecordNode, // #6 = $i6
/* 18797*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18799*/     OPC_CheckTypeI32,
/* 18800*/     OPC_MoveSibling7,
/* 18801*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18804*/     OPC_RecordNode, // #7 = $i7
/* 18805*/     OPC_CheckPredicate, 19, // Predicate_ImmI16
/* 18807*/     OPC_CheckTypeI32,
/* 18808*/     OPC_MoveParent,
/* 18809*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 18811*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18812*/     OPC_EmitConvertToTarget0, // #8
/* 18813*/     OPC_EmitConvertToTarget1, // #9
/* 18814*/     OPC_EmitConvertToTarget2, // #10
/* 18815*/     OPC_EmitConvertToTarget3, // #11
/* 18816*/     OPC_EmitConvertToTarget4, // #12
/* 18817*/     OPC_EmitConvertToTarget5, // #13
/* 18818*/     OPC_EmitConvertToTarget6, // #14
/* 18819*/     OPC_EmitConvertToTarget7, // #15
/* 18820*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   /*MVT::v8i16*/50, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18833*/    /*Scope*/ 35, /*->18869*/
/* 18834*/     OPC_MoveSibling1,
/* 18835*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18838*/     OPC_RecordNode, // #1 = $i1
/* 18839*/     OPC_CheckTypeI32,
/* 18840*/     OPC_MoveSibling2,
/* 18841*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18844*/     OPC_RecordNode, // #2 = $i2
/* 18845*/     OPC_CheckTypeI32,
/* 18846*/     OPC_MoveSibling3,
/* 18847*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18850*/     OPC_RecordNode, // #3 = $i3
/* 18851*/     OPC_CheckTypeI32,
/* 18852*/     OPC_MoveParent,
/* 18853*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 18855*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18856*/     OPC_EmitConvertToTarget0, // #4
/* 18857*/     OPC_EmitConvertToTarget1, // #5
/* 18858*/     OPC_EmitConvertToTarget2, // #6
/* 18859*/     OPC_EmitConvertToTarget3, // #7
/* 18860*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   /*MVT::v4i32*/60, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18869*/    0, /*End of Scope*/
/* 18870*/   /*SwitchType*/ 19, /*MVT::i64*/8, // ->18891
/* 18872*/    OPC_MoveSibling1,
/* 18873*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18876*/    OPC_RecordNode, // #1 = $i1
/* 18877*/    OPC_CheckTypeI64,
/* 18878*/    OPC_MoveParent,
/* 18879*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 18881*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18882*/    OPC_EmitConvertToTarget0, // #2
/* 18883*/    OPC_EmitConvertToTarget1, // #3
/* 18884*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18891*/   0, // EndSwitchType
/* 18892*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18961
/* 18895*/   OPC_SwitchType /*2 cases */, 38, /*MVT::f32*/12, // ->18936
/* 18898*/    OPC_MoveSibling1,
/* 18899*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18902*/    OPC_RecordNode, // #1 = $i1
/* 18903*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18905*/    OPC_MoveSibling2,
/* 18906*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18909*/    OPC_RecordNode, // #2 = $i2
/* 18910*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18912*/    OPC_MoveSibling3,
/* 18913*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18916*/    OPC_RecordNode, // #3 = $i3
/* 18917*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18919*/    OPC_MoveParent,
/* 18920*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 18922*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18923*/    OPC_EmitConvertToTarget0, // #4
/* 18924*/    OPC_EmitConvertToTarget1, // #5
/* 18925*/    OPC_EmitConvertToTarget2, // #6
/* 18926*/    OPC_EmitConvertToTarget3, // #7
/* 18927*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  /*MVT::v4f32*/111, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18936*/   /*SwitchType*/ 22, /*MVT::f64*/13, // ->18960
/* 18938*/    OPC_MoveSibling1,
/* 18939*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18942*/    OPC_RecordNode, // #1 = $i1
/* 18943*/    OPC_CheckType, /*MVT::f64*/13, 
/* 18945*/    OPC_MoveParent,
/* 18946*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 18949*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18950*/    OPC_EmitConvertToTarget0, // #2
/* 18951*/    OPC_EmitConvertToTarget1, // #3
/* 18952*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18960*/   0, // EndSwitchType
/* 18961*/  0, // EndSwitchOpcode
/* 18962*/ /*SwitchOpcode*/ 92|128,18/*2396*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->21362
/* 18966*/  OPC_RecordChild0, // #0 = $x
/* 18967*/  OPC_Scope, 83|128,2/*339*/, /*->19309*/ // 7 children in Scope
/* 18970*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 18972*/   OPC_RecordChild1, // #1 = $y
/* 18973*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 18975*/   OPC_RecordChild2, // #2 = $m0
/* 18976*/   OPC_MoveChild2,
/* 18977*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19151
/* 18982*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18983*/    OPC_CheckTypeI32,
/* 18984*/    OPC_MoveSibling3,
/* 18985*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18988*/    OPC_RecordNode, // #3 = $m1
/* 18989*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18990*/    OPC_CheckTypeI32,
/* 18991*/    OPC_MoveSibling4,
/* 18992*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18995*/    OPC_RecordNode, // #4 = $m2
/* 18996*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18997*/    OPC_CheckTypeI32,
/* 18998*/    OPC_MoveSibling5,
/* 18999*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19002*/    OPC_RecordNode, // #5 = $m3
/* 19003*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19004*/    OPC_CheckTypeI32,
/* 19005*/    OPC_MoveSibling6,
/* 19006*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19009*/    OPC_RecordNode, // #6 = $m4
/* 19010*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19011*/    OPC_CheckTypeI32,
/* 19012*/    OPC_MoveSibling7,
/* 19013*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19016*/    OPC_RecordNode, // #7 = $m5
/* 19017*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19018*/    OPC_CheckTypeI32,
/* 19019*/    OPC_MoveSibling, 8,
/* 19021*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19024*/    OPC_RecordNode, // #8 = $m6
/* 19025*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19026*/    OPC_CheckTypeI32,
/* 19027*/    OPC_MoveSibling, 9,
/* 19029*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19032*/    OPC_RecordNode, // #9 = $m7
/* 19033*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19034*/    OPC_CheckTypeI32,
/* 19035*/    OPC_MoveSibling, 10,
/* 19037*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19040*/    OPC_RecordNode, // #10 = $m8
/* 19041*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19042*/    OPC_CheckTypeI32,
/* 19043*/    OPC_MoveSibling, 11,
/* 19045*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19048*/    OPC_RecordNode, // #11 = $m9
/* 19049*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19050*/    OPC_CheckTypeI32,
/* 19051*/    OPC_MoveSibling, 12,
/* 19053*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19056*/    OPC_RecordNode, // #12 = $mA
/* 19057*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19058*/    OPC_CheckTypeI32,
/* 19059*/    OPC_MoveSibling, 13,
/* 19061*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19064*/    OPC_RecordNode, // #13 = $mB
/* 19065*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19066*/    OPC_CheckTypeI32,
/* 19067*/    OPC_MoveSibling, 14,
/* 19069*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19072*/    OPC_RecordNode, // #14 = $mC
/* 19073*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19074*/    OPC_CheckTypeI32,
/* 19075*/    OPC_MoveSibling, 15,
/* 19077*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19080*/    OPC_RecordNode, // #15 = $mD
/* 19081*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19082*/    OPC_CheckTypeI32,
/* 19083*/    OPC_MoveSibling, 16,
/* 19085*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19088*/    OPC_RecordNode, // #16 = $mE
/* 19089*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19090*/    OPC_CheckTypeI32,
/* 19091*/    OPC_MoveSibling, 17,
/* 19093*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19096*/    OPC_RecordNode, // #17 = $mF
/* 19097*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19098*/    OPC_CheckTypeI32,
/* 19099*/    OPC_MoveParent,
/* 19100*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19102*/    OPC_EmitConvertToTarget2, // #18
/* 19103*/    OPC_EmitConvertToTarget3, // #19
/* 19104*/    OPC_EmitConvertToTarget4, // #20
/* 19105*/    OPC_EmitConvertToTarget5, // #21
/* 19106*/    OPC_EmitConvertToTarget6, // #22
/* 19107*/    OPC_EmitConvertToTarget7, // #23
/* 19108*/    OPC_EmitConvertToTarget, 8, // #24
/* 19110*/    OPC_EmitConvertToTarget, 9, // #25
/* 19112*/    OPC_EmitConvertToTarget, 10, // #26
/* 19114*/    OPC_EmitConvertToTarget, 11, // #27
/* 19116*/    OPC_EmitConvertToTarget, 12, // #28
/* 19118*/    OPC_EmitConvertToTarget, 13, // #29
/* 19120*/    OPC_EmitConvertToTarget, 14, // #30
/* 19122*/    OPC_EmitConvertToTarget, 15, // #31
/* 19124*/    OPC_EmitConvertToTarget, 16, // #32
/* 19126*/    OPC_EmitConvertToTarget, 17, // #33
/* 19128*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19151*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19308
/* 19155*/    OPC_CheckTypeI32,
/* 19156*/    OPC_MoveSibling3,
/* 19157*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19160*/    OPC_RecordNode, // #3 = $m1
/* 19161*/    OPC_CheckTypeI32,
/* 19162*/    OPC_MoveSibling4,
/* 19163*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19166*/    OPC_RecordNode, // #4 = $m2
/* 19167*/    OPC_CheckTypeI32,
/* 19168*/    OPC_MoveSibling5,
/* 19169*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19172*/    OPC_RecordNode, // #5 = $m3
/* 19173*/    OPC_CheckTypeI32,
/* 19174*/    OPC_MoveSibling6,
/* 19175*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19178*/    OPC_RecordNode, // #6 = $m4
/* 19179*/    OPC_CheckTypeI32,
/* 19180*/    OPC_MoveSibling7,
/* 19181*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19184*/    OPC_RecordNode, // #7 = $m5
/* 19185*/    OPC_CheckTypeI32,
/* 19186*/    OPC_MoveSibling, 8,
/* 19188*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19191*/    OPC_RecordNode, // #8 = $m6
/* 19192*/    OPC_CheckTypeI32,
/* 19193*/    OPC_MoveSibling, 9,
/* 19195*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19198*/    OPC_RecordNode, // #9 = $m7
/* 19199*/    OPC_CheckTypeI32,
/* 19200*/    OPC_MoveSibling, 10,
/* 19202*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19205*/    OPC_RecordNode, // #10 = $m8
/* 19206*/    OPC_CheckTypeI32,
/* 19207*/    OPC_MoveSibling, 11,
/* 19209*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19212*/    OPC_RecordNode, // #11 = $m9
/* 19213*/    OPC_CheckTypeI32,
/* 19214*/    OPC_MoveSibling, 12,
/* 19216*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19219*/    OPC_RecordNode, // #12 = $mA
/* 19220*/    OPC_CheckTypeI32,
/* 19221*/    OPC_MoveSibling, 13,
/* 19223*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19226*/    OPC_RecordNode, // #13 = $mB
/* 19227*/    OPC_CheckTypeI32,
/* 19228*/    OPC_MoveSibling, 14,
/* 19230*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19233*/    OPC_RecordNode, // #14 = $mC
/* 19234*/    OPC_CheckTypeI32,
/* 19235*/    OPC_MoveSibling, 15,
/* 19237*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19240*/    OPC_RecordNode, // #15 = $mD
/* 19241*/    OPC_CheckTypeI32,
/* 19242*/    OPC_MoveSibling, 16,
/* 19244*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19247*/    OPC_RecordNode, // #16 = $mE
/* 19248*/    OPC_CheckTypeI32,
/* 19249*/    OPC_MoveSibling, 17,
/* 19251*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19254*/    OPC_RecordNode, // #17 = $mF
/* 19255*/    OPC_CheckTypeI32,
/* 19256*/    OPC_MoveParent,
/* 19257*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19259*/    OPC_EmitConvertToTarget2, // #18
/* 19260*/    OPC_EmitConvertToTarget3, // #19
/* 19261*/    OPC_EmitConvertToTarget4, // #20
/* 19262*/    OPC_EmitConvertToTarget5, // #21
/* 19263*/    OPC_EmitConvertToTarget6, // #22
/* 19264*/    OPC_EmitConvertToTarget7, // #23
/* 19265*/    OPC_EmitConvertToTarget, 8, // #24
/* 19267*/    OPC_EmitConvertToTarget, 9, // #25
/* 19269*/    OPC_EmitConvertToTarget, 10, // #26
/* 19271*/    OPC_EmitConvertToTarget, 11, // #27
/* 19273*/    OPC_EmitConvertToTarget, 12, // #28
/* 19275*/    OPC_EmitConvertToTarget, 13, // #29
/* 19277*/    OPC_EmitConvertToTarget, 14, // #30
/* 19279*/    OPC_EmitConvertToTarget, 15, // #31
/* 19281*/    OPC_EmitConvertToTarget, 16, // #32
/* 19283*/    OPC_EmitConvertToTarget, 17, // #33
/* 19285*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19308*/   0, // EndSwitchOpcode
/* 19309*/  /*Scope*/ 83|128,2/*339*/, /*->19650*/
/* 19311*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 19313*/   OPC_RecordChild1, // #1 = $y
/* 19314*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 19316*/   OPC_RecordChild2, // #2 = $m0
/* 19317*/   OPC_MoveChild2,
/* 19318*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19492
/* 19323*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19324*/    OPC_CheckTypeI32,
/* 19325*/    OPC_MoveSibling3,
/* 19326*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19329*/    OPC_RecordNode, // #3 = $m1
/* 19330*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19331*/    OPC_CheckTypeI32,
/* 19332*/    OPC_MoveSibling4,
/* 19333*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19336*/    OPC_RecordNode, // #4 = $m2
/* 19337*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19338*/    OPC_CheckTypeI32,
/* 19339*/    OPC_MoveSibling5,
/* 19340*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19343*/    OPC_RecordNode, // #5 = $m3
/* 19344*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19345*/    OPC_CheckTypeI32,
/* 19346*/    OPC_MoveSibling6,
/* 19347*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19350*/    OPC_RecordNode, // #6 = $m4
/* 19351*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19352*/    OPC_CheckTypeI32,
/* 19353*/    OPC_MoveSibling7,
/* 19354*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19357*/    OPC_RecordNode, // #7 = $m5
/* 19358*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19359*/    OPC_CheckTypeI32,
/* 19360*/    OPC_MoveSibling, 8,
/* 19362*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19365*/    OPC_RecordNode, // #8 = $m6
/* 19366*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19367*/    OPC_CheckTypeI32,
/* 19368*/    OPC_MoveSibling, 9,
/* 19370*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19373*/    OPC_RecordNode, // #9 = $m7
/* 19374*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19375*/    OPC_CheckTypeI32,
/* 19376*/    OPC_MoveSibling, 10,
/* 19378*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19381*/    OPC_RecordNode, // #10 = $m8
/* 19382*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19383*/    OPC_CheckTypeI32,
/* 19384*/    OPC_MoveSibling, 11,
/* 19386*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19389*/    OPC_RecordNode, // #11 = $m9
/* 19390*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19391*/    OPC_CheckTypeI32,
/* 19392*/    OPC_MoveSibling, 12,
/* 19394*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19397*/    OPC_RecordNode, // #12 = $mA
/* 19398*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19399*/    OPC_CheckTypeI32,
/* 19400*/    OPC_MoveSibling, 13,
/* 19402*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19405*/    OPC_RecordNode, // #13 = $mB
/* 19406*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19407*/    OPC_CheckTypeI32,
/* 19408*/    OPC_MoveSibling, 14,
/* 19410*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19413*/    OPC_RecordNode, // #14 = $mC
/* 19414*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19415*/    OPC_CheckTypeI32,
/* 19416*/    OPC_MoveSibling, 15,
/* 19418*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19421*/    OPC_RecordNode, // #15 = $mD
/* 19422*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19423*/    OPC_CheckTypeI32,
/* 19424*/    OPC_MoveSibling, 16,
/* 19426*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19429*/    OPC_RecordNode, // #16 = $mE
/* 19430*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19431*/    OPC_CheckTypeI32,
/* 19432*/    OPC_MoveSibling, 17,
/* 19434*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19437*/    OPC_RecordNode, // #17 = $mF
/* 19438*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19439*/    OPC_CheckTypeI32,
/* 19440*/    OPC_MoveParent,
/* 19441*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19443*/    OPC_EmitConvertToTarget2, // #18
/* 19444*/    OPC_EmitConvertToTarget3, // #19
/* 19445*/    OPC_EmitConvertToTarget4, // #20
/* 19446*/    OPC_EmitConvertToTarget5, // #21
/* 19447*/    OPC_EmitConvertToTarget6, // #22
/* 19448*/    OPC_EmitConvertToTarget7, // #23
/* 19449*/    OPC_EmitConvertToTarget, 8, // #24
/* 19451*/    OPC_EmitConvertToTarget, 9, // #25
/* 19453*/    OPC_EmitConvertToTarget, 10, // #26
/* 19455*/    OPC_EmitConvertToTarget, 11, // #27
/* 19457*/    OPC_EmitConvertToTarget, 12, // #28
/* 19459*/    OPC_EmitConvertToTarget, 13, // #29
/* 19461*/    OPC_EmitConvertToTarget, 14, // #30
/* 19463*/    OPC_EmitConvertToTarget, 15, // #31
/* 19465*/    OPC_EmitConvertToTarget, 16, // #32
/* 19467*/    OPC_EmitConvertToTarget, 17, // #33
/* 19469*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19492*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19649
/* 19496*/    OPC_CheckTypeI32,
/* 19497*/    OPC_MoveSibling3,
/* 19498*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19501*/    OPC_RecordNode, // #3 = $m1
/* 19502*/    OPC_CheckTypeI32,
/* 19503*/    OPC_MoveSibling4,
/* 19504*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19507*/    OPC_RecordNode, // #4 = $m2
/* 19508*/    OPC_CheckTypeI32,
/* 19509*/    OPC_MoveSibling5,
/* 19510*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19513*/    OPC_RecordNode, // #5 = $m3
/* 19514*/    OPC_CheckTypeI32,
/* 19515*/    OPC_MoveSibling6,
/* 19516*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19519*/    OPC_RecordNode, // #6 = $m4
/* 19520*/    OPC_CheckTypeI32,
/* 19521*/    OPC_MoveSibling7,
/* 19522*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19525*/    OPC_RecordNode, // #7 = $m5
/* 19526*/    OPC_CheckTypeI32,
/* 19527*/    OPC_MoveSibling, 8,
/* 19529*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19532*/    OPC_RecordNode, // #8 = $m6
/* 19533*/    OPC_CheckTypeI32,
/* 19534*/    OPC_MoveSibling, 9,
/* 19536*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19539*/    OPC_RecordNode, // #9 = $m7
/* 19540*/    OPC_CheckTypeI32,
/* 19541*/    OPC_MoveSibling, 10,
/* 19543*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19546*/    OPC_RecordNode, // #10 = $m8
/* 19547*/    OPC_CheckTypeI32,
/* 19548*/    OPC_MoveSibling, 11,
/* 19550*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19553*/    OPC_RecordNode, // #11 = $m9
/* 19554*/    OPC_CheckTypeI32,
/* 19555*/    OPC_MoveSibling, 12,
/* 19557*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19560*/    OPC_RecordNode, // #12 = $mA
/* 19561*/    OPC_CheckTypeI32,
/* 19562*/    OPC_MoveSibling, 13,
/* 19564*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19567*/    OPC_RecordNode, // #13 = $mB
/* 19568*/    OPC_CheckTypeI32,
/* 19569*/    OPC_MoveSibling, 14,
/* 19571*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19574*/    OPC_RecordNode, // #14 = $mC
/* 19575*/    OPC_CheckTypeI32,
/* 19576*/    OPC_MoveSibling, 15,
/* 19578*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19581*/    OPC_RecordNode, // #15 = $mD
/* 19582*/    OPC_CheckTypeI32,
/* 19583*/    OPC_MoveSibling, 16,
/* 19585*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19588*/    OPC_RecordNode, // #16 = $mE
/* 19589*/    OPC_CheckTypeI32,
/* 19590*/    OPC_MoveSibling, 17,
/* 19592*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19595*/    OPC_RecordNode, // #17 = $mF
/* 19596*/    OPC_CheckTypeI32,
/* 19597*/    OPC_MoveParent,
/* 19598*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19600*/    OPC_EmitConvertToTarget2, // #18
/* 19601*/    OPC_EmitConvertToTarget3, // #19
/* 19602*/    OPC_EmitConvertToTarget4, // #20
/* 19603*/    OPC_EmitConvertToTarget5, // #21
/* 19604*/    OPC_EmitConvertToTarget6, // #22
/* 19605*/    OPC_EmitConvertToTarget7, // #23
/* 19606*/    OPC_EmitConvertToTarget, 8, // #24
/* 19608*/    OPC_EmitConvertToTarget, 9, // #25
/* 19610*/    OPC_EmitConvertToTarget, 10, // #26
/* 19612*/    OPC_EmitConvertToTarget, 11, // #27
/* 19614*/    OPC_EmitConvertToTarget, 12, // #28
/* 19616*/    OPC_EmitConvertToTarget, 13, // #29
/* 19618*/    OPC_EmitConvertToTarget, 14, // #30
/* 19620*/    OPC_EmitConvertToTarget, 15, // #31
/* 19622*/    OPC_EmitConvertToTarget, 16, // #32
/* 19624*/    OPC_EmitConvertToTarget, 17, // #33
/* 19626*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19649*/   0, // EndSwitchOpcode
/* 19650*/  /*Scope*/ 83|128,2/*339*/, /*->19991*/
/* 19652*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 19654*/   OPC_RecordChild1, // #1 = $y
/* 19655*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 19657*/   OPC_RecordChild2, // #2 = $m0
/* 19658*/   OPC_MoveChild2,
/* 19659*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19833
/* 19664*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19665*/    OPC_CheckTypeI32,
/* 19666*/    OPC_MoveSibling3,
/* 19667*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19670*/    OPC_RecordNode, // #3 = $m1
/* 19671*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19672*/    OPC_CheckTypeI32,
/* 19673*/    OPC_MoveSibling4,
/* 19674*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19677*/    OPC_RecordNode, // #4 = $m2
/* 19678*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19679*/    OPC_CheckTypeI32,
/* 19680*/    OPC_MoveSibling5,
/* 19681*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19684*/    OPC_RecordNode, // #5 = $m3
/* 19685*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19686*/    OPC_CheckTypeI32,
/* 19687*/    OPC_MoveSibling6,
/* 19688*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19691*/    OPC_RecordNode, // #6 = $m4
/* 19692*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19693*/    OPC_CheckTypeI32,
/* 19694*/    OPC_MoveSibling7,
/* 19695*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19698*/    OPC_RecordNode, // #7 = $m5
/* 19699*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19700*/    OPC_CheckTypeI32,
/* 19701*/    OPC_MoveSibling, 8,
/* 19703*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19706*/    OPC_RecordNode, // #8 = $m6
/* 19707*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19708*/    OPC_CheckTypeI32,
/* 19709*/    OPC_MoveSibling, 9,
/* 19711*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19714*/    OPC_RecordNode, // #9 = $m7
/* 19715*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19716*/    OPC_CheckTypeI32,
/* 19717*/    OPC_MoveSibling, 10,
/* 19719*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19722*/    OPC_RecordNode, // #10 = $m8
/* 19723*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19724*/    OPC_CheckTypeI32,
/* 19725*/    OPC_MoveSibling, 11,
/* 19727*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19730*/    OPC_RecordNode, // #11 = $m9
/* 19731*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19732*/    OPC_CheckTypeI32,
/* 19733*/    OPC_MoveSibling, 12,
/* 19735*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19738*/    OPC_RecordNode, // #12 = $mA
/* 19739*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19740*/    OPC_CheckTypeI32,
/* 19741*/    OPC_MoveSibling, 13,
/* 19743*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19746*/    OPC_RecordNode, // #13 = $mB
/* 19747*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19748*/    OPC_CheckTypeI32,
/* 19749*/    OPC_MoveSibling, 14,
/* 19751*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19754*/    OPC_RecordNode, // #14 = $mC
/* 19755*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19756*/    OPC_CheckTypeI32,
/* 19757*/    OPC_MoveSibling, 15,
/* 19759*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19762*/    OPC_RecordNode, // #15 = $mD
/* 19763*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19764*/    OPC_CheckTypeI32,
/* 19765*/    OPC_MoveSibling, 16,
/* 19767*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19770*/    OPC_RecordNode, // #16 = $mE
/* 19771*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19772*/    OPC_CheckTypeI32,
/* 19773*/    OPC_MoveSibling, 17,
/* 19775*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19778*/    OPC_RecordNode, // #17 = $mF
/* 19779*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19780*/    OPC_CheckTypeI32,
/* 19781*/    OPC_MoveParent,
/* 19782*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19784*/    OPC_EmitConvertToTarget2, // #18
/* 19785*/    OPC_EmitConvertToTarget3, // #19
/* 19786*/    OPC_EmitConvertToTarget4, // #20
/* 19787*/    OPC_EmitConvertToTarget5, // #21
/* 19788*/    OPC_EmitConvertToTarget6, // #22
/* 19789*/    OPC_EmitConvertToTarget7, // #23
/* 19790*/    OPC_EmitConvertToTarget, 8, // #24
/* 19792*/    OPC_EmitConvertToTarget, 9, // #25
/* 19794*/    OPC_EmitConvertToTarget, 10, // #26
/* 19796*/    OPC_EmitConvertToTarget, 11, // #27
/* 19798*/    OPC_EmitConvertToTarget, 12, // #28
/* 19800*/    OPC_EmitConvertToTarget, 13, // #29
/* 19802*/    OPC_EmitConvertToTarget, 14, // #30
/* 19804*/    OPC_EmitConvertToTarget, 15, // #31
/* 19806*/    OPC_EmitConvertToTarget, 16, // #32
/* 19808*/    OPC_EmitConvertToTarget, 17, // #33
/* 19810*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19833*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19990
/* 19837*/    OPC_CheckTypeI32,
/* 19838*/    OPC_MoveSibling3,
/* 19839*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19842*/    OPC_RecordNode, // #3 = $m1
/* 19843*/    OPC_CheckTypeI32,
/* 19844*/    OPC_MoveSibling4,
/* 19845*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19848*/    OPC_RecordNode, // #4 = $m2
/* 19849*/    OPC_CheckTypeI32,
/* 19850*/    OPC_MoveSibling5,
/* 19851*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19854*/    OPC_RecordNode, // #5 = $m3
/* 19855*/    OPC_CheckTypeI32,
/* 19856*/    OPC_MoveSibling6,
/* 19857*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19860*/    OPC_RecordNode, // #6 = $m4
/* 19861*/    OPC_CheckTypeI32,
/* 19862*/    OPC_MoveSibling7,
/* 19863*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19866*/    OPC_RecordNode, // #7 = $m5
/* 19867*/    OPC_CheckTypeI32,
/* 19868*/    OPC_MoveSibling, 8,
/* 19870*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19873*/    OPC_RecordNode, // #8 = $m6
/* 19874*/    OPC_CheckTypeI32,
/* 19875*/    OPC_MoveSibling, 9,
/* 19877*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19880*/    OPC_RecordNode, // #9 = $m7
/* 19881*/    OPC_CheckTypeI32,
/* 19882*/    OPC_MoveSibling, 10,
/* 19884*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19887*/    OPC_RecordNode, // #10 = $m8
/* 19888*/    OPC_CheckTypeI32,
/* 19889*/    OPC_MoveSibling, 11,
/* 19891*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19894*/    OPC_RecordNode, // #11 = $m9
/* 19895*/    OPC_CheckTypeI32,
/* 19896*/    OPC_MoveSibling, 12,
/* 19898*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19901*/    OPC_RecordNode, // #12 = $mA
/* 19902*/    OPC_CheckTypeI32,
/* 19903*/    OPC_MoveSibling, 13,
/* 19905*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19908*/    OPC_RecordNode, // #13 = $mB
/* 19909*/    OPC_CheckTypeI32,
/* 19910*/    OPC_MoveSibling, 14,
/* 19912*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19915*/    OPC_RecordNode, // #14 = $mC
/* 19916*/    OPC_CheckTypeI32,
/* 19917*/    OPC_MoveSibling, 15,
/* 19919*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19922*/    OPC_RecordNode, // #15 = $mD
/* 19923*/    OPC_CheckTypeI32,
/* 19924*/    OPC_MoveSibling, 16,
/* 19926*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19929*/    OPC_RecordNode, // #16 = $mE
/* 19930*/    OPC_CheckTypeI32,
/* 19931*/    OPC_MoveSibling, 17,
/* 19933*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19936*/    OPC_RecordNode, // #17 = $mF
/* 19937*/    OPC_CheckTypeI32,
/* 19938*/    OPC_MoveParent,
/* 19939*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19941*/    OPC_EmitConvertToTarget2, // #18
/* 19942*/    OPC_EmitConvertToTarget3, // #19
/* 19943*/    OPC_EmitConvertToTarget4, // #20
/* 19944*/    OPC_EmitConvertToTarget5, // #21
/* 19945*/    OPC_EmitConvertToTarget6, // #22
/* 19946*/    OPC_EmitConvertToTarget7, // #23
/* 19947*/    OPC_EmitConvertToTarget, 8, // #24
/* 19949*/    OPC_EmitConvertToTarget, 9, // #25
/* 19951*/    OPC_EmitConvertToTarget, 10, // #26
/* 19953*/    OPC_EmitConvertToTarget, 11, // #27
/* 19955*/    OPC_EmitConvertToTarget, 12, // #28
/* 19957*/    OPC_EmitConvertToTarget, 13, // #29
/* 19959*/    OPC_EmitConvertToTarget, 14, // #30
/* 19961*/    OPC_EmitConvertToTarget, 15, // #31
/* 19963*/    OPC_EmitConvertToTarget, 16, // #32
/* 19965*/    OPC_EmitConvertToTarget, 17, // #33
/* 19967*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19990*/   0, // EndSwitchOpcode
/* 19991*/  /*Scope*/ 83|128,2/*339*/, /*->20332*/
/* 19993*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 19995*/   OPC_RecordChild1, // #1 = $y
/* 19996*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 19998*/   OPC_RecordChild2, // #2 = $m0
/* 19999*/   OPC_MoveChild2,
/* 20000*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20174
/* 20005*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20006*/    OPC_CheckTypeI32,
/* 20007*/    OPC_MoveSibling3,
/* 20008*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20011*/    OPC_RecordNode, // #3 = $m1
/* 20012*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20013*/    OPC_CheckTypeI32,
/* 20014*/    OPC_MoveSibling4,
/* 20015*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20018*/    OPC_RecordNode, // #4 = $m2
/* 20019*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20020*/    OPC_CheckTypeI32,
/* 20021*/    OPC_MoveSibling5,
/* 20022*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20025*/    OPC_RecordNode, // #5 = $m3
/* 20026*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20027*/    OPC_CheckTypeI32,
/* 20028*/    OPC_MoveSibling6,
/* 20029*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20032*/    OPC_RecordNode, // #6 = $m4
/* 20033*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20034*/    OPC_CheckTypeI32,
/* 20035*/    OPC_MoveSibling7,
/* 20036*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20039*/    OPC_RecordNode, // #7 = $m5
/* 20040*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20041*/    OPC_CheckTypeI32,
/* 20042*/    OPC_MoveSibling, 8,
/* 20044*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20047*/    OPC_RecordNode, // #8 = $m6
/* 20048*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20049*/    OPC_CheckTypeI32,
/* 20050*/    OPC_MoveSibling, 9,
/* 20052*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20055*/    OPC_RecordNode, // #9 = $m7
/* 20056*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20057*/    OPC_CheckTypeI32,
/* 20058*/    OPC_MoveSibling, 10,
/* 20060*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20063*/    OPC_RecordNode, // #10 = $m8
/* 20064*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20065*/    OPC_CheckTypeI32,
/* 20066*/    OPC_MoveSibling, 11,
/* 20068*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20071*/    OPC_RecordNode, // #11 = $m9
/* 20072*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20073*/    OPC_CheckTypeI32,
/* 20074*/    OPC_MoveSibling, 12,
/* 20076*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20079*/    OPC_RecordNode, // #12 = $mA
/* 20080*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20081*/    OPC_CheckTypeI32,
/* 20082*/    OPC_MoveSibling, 13,
/* 20084*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20087*/    OPC_RecordNode, // #13 = $mB
/* 20088*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20089*/    OPC_CheckTypeI32,
/* 20090*/    OPC_MoveSibling, 14,
/* 20092*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20095*/    OPC_RecordNode, // #14 = $mC
/* 20096*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20097*/    OPC_CheckTypeI32,
/* 20098*/    OPC_MoveSibling, 15,
/* 20100*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20103*/    OPC_RecordNode, // #15 = $mD
/* 20104*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20105*/    OPC_CheckTypeI32,
/* 20106*/    OPC_MoveSibling, 16,
/* 20108*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20111*/    OPC_RecordNode, // #16 = $mE
/* 20112*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20113*/    OPC_CheckTypeI32,
/* 20114*/    OPC_MoveSibling, 17,
/* 20116*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20119*/    OPC_RecordNode, // #17 = $mF
/* 20120*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20121*/    OPC_CheckTypeI32,
/* 20122*/    OPC_MoveParent,
/* 20123*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20125*/    OPC_EmitConvertToTarget2, // #18
/* 20126*/    OPC_EmitConvertToTarget3, // #19
/* 20127*/    OPC_EmitConvertToTarget4, // #20
/* 20128*/    OPC_EmitConvertToTarget5, // #21
/* 20129*/    OPC_EmitConvertToTarget6, // #22
/* 20130*/    OPC_EmitConvertToTarget7, // #23
/* 20131*/    OPC_EmitConvertToTarget, 8, // #24
/* 20133*/    OPC_EmitConvertToTarget, 9, // #25
/* 20135*/    OPC_EmitConvertToTarget, 10, // #26
/* 20137*/    OPC_EmitConvertToTarget, 11, // #27
/* 20139*/    OPC_EmitConvertToTarget, 12, // #28
/* 20141*/    OPC_EmitConvertToTarget, 13, // #29
/* 20143*/    OPC_EmitConvertToTarget, 14, // #30
/* 20145*/    OPC_EmitConvertToTarget, 15, // #31
/* 20147*/    OPC_EmitConvertToTarget, 16, // #32
/* 20149*/    OPC_EmitConvertToTarget, 17, // #33
/* 20151*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20174*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20331
/* 20178*/    OPC_CheckTypeI32,
/* 20179*/    OPC_MoveSibling3,
/* 20180*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20183*/    OPC_RecordNode, // #3 = $m1
/* 20184*/    OPC_CheckTypeI32,
/* 20185*/    OPC_MoveSibling4,
/* 20186*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20189*/    OPC_RecordNode, // #4 = $m2
/* 20190*/    OPC_CheckTypeI32,
/* 20191*/    OPC_MoveSibling5,
/* 20192*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20195*/    OPC_RecordNode, // #5 = $m3
/* 20196*/    OPC_CheckTypeI32,
/* 20197*/    OPC_MoveSibling6,
/* 20198*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20201*/    OPC_RecordNode, // #6 = $m4
/* 20202*/    OPC_CheckTypeI32,
/* 20203*/    OPC_MoveSibling7,
/* 20204*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20207*/    OPC_RecordNode, // #7 = $m5
/* 20208*/    OPC_CheckTypeI32,
/* 20209*/    OPC_MoveSibling, 8,
/* 20211*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20214*/    OPC_RecordNode, // #8 = $m6
/* 20215*/    OPC_CheckTypeI32,
/* 20216*/    OPC_MoveSibling, 9,
/* 20218*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20221*/    OPC_RecordNode, // #9 = $m7
/* 20222*/    OPC_CheckTypeI32,
/* 20223*/    OPC_MoveSibling, 10,
/* 20225*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20228*/    OPC_RecordNode, // #10 = $m8
/* 20229*/    OPC_CheckTypeI32,
/* 20230*/    OPC_MoveSibling, 11,
/* 20232*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20235*/    OPC_RecordNode, // #11 = $m9
/* 20236*/    OPC_CheckTypeI32,
/* 20237*/    OPC_MoveSibling, 12,
/* 20239*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20242*/    OPC_RecordNode, // #12 = $mA
/* 20243*/    OPC_CheckTypeI32,
/* 20244*/    OPC_MoveSibling, 13,
/* 20246*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20249*/    OPC_RecordNode, // #13 = $mB
/* 20250*/    OPC_CheckTypeI32,
/* 20251*/    OPC_MoveSibling, 14,
/* 20253*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20256*/    OPC_RecordNode, // #14 = $mC
/* 20257*/    OPC_CheckTypeI32,
/* 20258*/    OPC_MoveSibling, 15,
/* 20260*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20263*/    OPC_RecordNode, // #15 = $mD
/* 20264*/    OPC_CheckTypeI32,
/* 20265*/    OPC_MoveSibling, 16,
/* 20267*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20270*/    OPC_RecordNode, // #16 = $mE
/* 20271*/    OPC_CheckTypeI32,
/* 20272*/    OPC_MoveSibling, 17,
/* 20274*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20277*/    OPC_RecordNode, // #17 = $mF
/* 20278*/    OPC_CheckTypeI32,
/* 20279*/    OPC_MoveParent,
/* 20280*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20282*/    OPC_EmitConvertToTarget2, // #18
/* 20283*/    OPC_EmitConvertToTarget3, // #19
/* 20284*/    OPC_EmitConvertToTarget4, // #20
/* 20285*/    OPC_EmitConvertToTarget5, // #21
/* 20286*/    OPC_EmitConvertToTarget6, // #22
/* 20287*/    OPC_EmitConvertToTarget7, // #23
/* 20288*/    OPC_EmitConvertToTarget, 8, // #24
/* 20290*/    OPC_EmitConvertToTarget, 9, // #25
/* 20292*/    OPC_EmitConvertToTarget, 10, // #26
/* 20294*/    OPC_EmitConvertToTarget, 11, // #27
/* 20296*/    OPC_EmitConvertToTarget, 12, // #28
/* 20298*/    OPC_EmitConvertToTarget, 13, // #29
/* 20300*/    OPC_EmitConvertToTarget, 14, // #30
/* 20302*/    OPC_EmitConvertToTarget, 15, // #31
/* 20304*/    OPC_EmitConvertToTarget, 16, // #32
/* 20306*/    OPC_EmitConvertToTarget, 17, // #33
/* 20308*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20331*/   0, // EndSwitchOpcode
/* 20332*/  /*Scope*/ 83|128,2/*339*/, /*->20673*/
/* 20334*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 20336*/   OPC_RecordChild1, // #1 = $y
/* 20337*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 20339*/   OPC_RecordChild2, // #2 = $m0
/* 20340*/   OPC_MoveChild2,
/* 20341*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20515
/* 20346*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20347*/    OPC_CheckTypeI32,
/* 20348*/    OPC_MoveSibling3,
/* 20349*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20352*/    OPC_RecordNode, // #3 = $m1
/* 20353*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20354*/    OPC_CheckTypeI32,
/* 20355*/    OPC_MoveSibling4,
/* 20356*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20359*/    OPC_RecordNode, // #4 = $m2
/* 20360*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20361*/    OPC_CheckTypeI32,
/* 20362*/    OPC_MoveSibling5,
/* 20363*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20366*/    OPC_RecordNode, // #5 = $m3
/* 20367*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20368*/    OPC_CheckTypeI32,
/* 20369*/    OPC_MoveSibling6,
/* 20370*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20373*/    OPC_RecordNode, // #6 = $m4
/* 20374*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20375*/    OPC_CheckTypeI32,
/* 20376*/    OPC_MoveSibling7,
/* 20377*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20380*/    OPC_RecordNode, // #7 = $m5
/* 20381*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20382*/    OPC_CheckTypeI32,
/* 20383*/    OPC_MoveSibling, 8,
/* 20385*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20388*/    OPC_RecordNode, // #8 = $m6
/* 20389*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20390*/    OPC_CheckTypeI32,
/* 20391*/    OPC_MoveSibling, 9,
/* 20393*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20396*/    OPC_RecordNode, // #9 = $m7
/* 20397*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20398*/    OPC_CheckTypeI32,
/* 20399*/    OPC_MoveSibling, 10,
/* 20401*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20404*/    OPC_RecordNode, // #10 = $m8
/* 20405*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20406*/    OPC_CheckTypeI32,
/* 20407*/    OPC_MoveSibling, 11,
/* 20409*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20412*/    OPC_RecordNode, // #11 = $m9
/* 20413*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20414*/    OPC_CheckTypeI32,
/* 20415*/    OPC_MoveSibling, 12,
/* 20417*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20420*/    OPC_RecordNode, // #12 = $mA
/* 20421*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20422*/    OPC_CheckTypeI32,
/* 20423*/    OPC_MoveSibling, 13,
/* 20425*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20428*/    OPC_RecordNode, // #13 = $mB
/* 20429*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20430*/    OPC_CheckTypeI32,
/* 20431*/    OPC_MoveSibling, 14,
/* 20433*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20436*/    OPC_RecordNode, // #14 = $mC
/* 20437*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20438*/    OPC_CheckTypeI32,
/* 20439*/    OPC_MoveSibling, 15,
/* 20441*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20444*/    OPC_RecordNode, // #15 = $mD
/* 20445*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20446*/    OPC_CheckTypeI32,
/* 20447*/    OPC_MoveSibling, 16,
/* 20449*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20452*/    OPC_RecordNode, // #16 = $mE
/* 20453*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20454*/    OPC_CheckTypeI32,
/* 20455*/    OPC_MoveSibling, 17,
/* 20457*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20460*/    OPC_RecordNode, // #17 = $mF
/* 20461*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20462*/    OPC_CheckTypeI32,
/* 20463*/    OPC_MoveParent,
/* 20464*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20466*/    OPC_EmitConvertToTarget2, // #18
/* 20467*/    OPC_EmitConvertToTarget3, // #19
/* 20468*/    OPC_EmitConvertToTarget4, // #20
/* 20469*/    OPC_EmitConvertToTarget5, // #21
/* 20470*/    OPC_EmitConvertToTarget6, // #22
/* 20471*/    OPC_EmitConvertToTarget7, // #23
/* 20472*/    OPC_EmitConvertToTarget, 8, // #24
/* 20474*/    OPC_EmitConvertToTarget, 9, // #25
/* 20476*/    OPC_EmitConvertToTarget, 10, // #26
/* 20478*/    OPC_EmitConvertToTarget, 11, // #27
/* 20480*/    OPC_EmitConvertToTarget, 12, // #28
/* 20482*/    OPC_EmitConvertToTarget, 13, // #29
/* 20484*/    OPC_EmitConvertToTarget, 14, // #30
/* 20486*/    OPC_EmitConvertToTarget, 15, // #31
/* 20488*/    OPC_EmitConvertToTarget, 16, // #32
/* 20490*/    OPC_EmitConvertToTarget, 17, // #33
/* 20492*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20515*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20672
/* 20519*/    OPC_CheckTypeI32,
/* 20520*/    OPC_MoveSibling3,
/* 20521*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20524*/    OPC_RecordNode, // #3 = $m1
/* 20525*/    OPC_CheckTypeI32,
/* 20526*/    OPC_MoveSibling4,
/* 20527*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20530*/    OPC_RecordNode, // #4 = $m2
/* 20531*/    OPC_CheckTypeI32,
/* 20532*/    OPC_MoveSibling5,
/* 20533*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20536*/    OPC_RecordNode, // #5 = $m3
/* 20537*/    OPC_CheckTypeI32,
/* 20538*/    OPC_MoveSibling6,
/* 20539*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20542*/    OPC_RecordNode, // #6 = $m4
/* 20543*/    OPC_CheckTypeI32,
/* 20544*/    OPC_MoveSibling7,
/* 20545*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20548*/    OPC_RecordNode, // #7 = $m5
/* 20549*/    OPC_CheckTypeI32,
/* 20550*/    OPC_MoveSibling, 8,
/* 20552*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20555*/    OPC_RecordNode, // #8 = $m6
/* 20556*/    OPC_CheckTypeI32,
/* 20557*/    OPC_MoveSibling, 9,
/* 20559*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20562*/    OPC_RecordNode, // #9 = $m7
/* 20563*/    OPC_CheckTypeI32,
/* 20564*/    OPC_MoveSibling, 10,
/* 20566*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20569*/    OPC_RecordNode, // #10 = $m8
/* 20570*/    OPC_CheckTypeI32,
/* 20571*/    OPC_MoveSibling, 11,
/* 20573*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20576*/    OPC_RecordNode, // #11 = $m9
/* 20577*/    OPC_CheckTypeI32,
/* 20578*/    OPC_MoveSibling, 12,
/* 20580*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20583*/    OPC_RecordNode, // #12 = $mA
/* 20584*/    OPC_CheckTypeI32,
/* 20585*/    OPC_MoveSibling, 13,
/* 20587*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20590*/    OPC_RecordNode, // #13 = $mB
/* 20591*/    OPC_CheckTypeI32,
/* 20592*/    OPC_MoveSibling, 14,
/* 20594*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20597*/    OPC_RecordNode, // #14 = $mC
/* 20598*/    OPC_CheckTypeI32,
/* 20599*/    OPC_MoveSibling, 15,
/* 20601*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20604*/    OPC_RecordNode, // #15 = $mD
/* 20605*/    OPC_CheckTypeI32,
/* 20606*/    OPC_MoveSibling, 16,
/* 20608*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20611*/    OPC_RecordNode, // #16 = $mE
/* 20612*/    OPC_CheckTypeI32,
/* 20613*/    OPC_MoveSibling, 17,
/* 20615*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20618*/    OPC_RecordNode, // #17 = $mF
/* 20619*/    OPC_CheckTypeI32,
/* 20620*/    OPC_MoveParent,
/* 20621*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20623*/    OPC_EmitConvertToTarget2, // #18
/* 20624*/    OPC_EmitConvertToTarget3, // #19
/* 20625*/    OPC_EmitConvertToTarget4, // #20
/* 20626*/    OPC_EmitConvertToTarget5, // #21
/* 20627*/    OPC_EmitConvertToTarget6, // #22
/* 20628*/    OPC_EmitConvertToTarget7, // #23
/* 20629*/    OPC_EmitConvertToTarget, 8, // #24
/* 20631*/    OPC_EmitConvertToTarget, 9, // #25
/* 20633*/    OPC_EmitConvertToTarget, 10, // #26
/* 20635*/    OPC_EmitConvertToTarget, 11, // #27
/* 20637*/    OPC_EmitConvertToTarget, 12, // #28
/* 20639*/    OPC_EmitConvertToTarget, 13, // #29
/* 20641*/    OPC_EmitConvertToTarget, 14, // #30
/* 20643*/    OPC_EmitConvertToTarget, 15, // #31
/* 20645*/    OPC_EmitConvertToTarget, 16, // #32
/* 20647*/    OPC_EmitConvertToTarget, 17, // #33
/* 20649*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20672*/   0, // EndSwitchOpcode
/* 20673*/  /*Scope*/ 89|128,2/*345*/, /*->21020*/
/* 20675*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20678*/   OPC_RecordChild1, // #1 = $y
/* 20679*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20682*/   OPC_RecordChild2, // #2 = $m0
/* 20683*/   OPC_MoveChild2,
/* 20684*/   OPC_SwitchOpcode /*2 cases */, 43|128,1/*171*/, TARGET_VAL(ISD::Constant),// ->20860
/* 20689*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20690*/    OPC_CheckTypeI32,
/* 20691*/    OPC_MoveSibling3,
/* 20692*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20695*/    OPC_RecordNode, // #3 = $m1
/* 20696*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20697*/    OPC_CheckTypeI32,
/* 20698*/    OPC_MoveSibling4,
/* 20699*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20702*/    OPC_RecordNode, // #4 = $m2
/* 20703*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20704*/    OPC_CheckTypeI32,
/* 20705*/    OPC_MoveSibling5,
/* 20706*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20709*/    OPC_RecordNode, // #5 = $m3
/* 20710*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20711*/    OPC_CheckTypeI32,
/* 20712*/    OPC_MoveSibling6,
/* 20713*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20716*/    OPC_RecordNode, // #6 = $m4
/* 20717*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20718*/    OPC_CheckTypeI32,
/* 20719*/    OPC_MoveSibling7,
/* 20720*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20723*/    OPC_RecordNode, // #7 = $m5
/* 20724*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20725*/    OPC_CheckTypeI32,
/* 20726*/    OPC_MoveSibling, 8,
/* 20728*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20731*/    OPC_RecordNode, // #8 = $m6
/* 20732*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20733*/    OPC_CheckTypeI32,
/* 20734*/    OPC_MoveSibling, 9,
/* 20736*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20739*/    OPC_RecordNode, // #9 = $m7
/* 20740*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20741*/    OPC_CheckTypeI32,
/* 20742*/    OPC_MoveSibling, 10,
/* 20744*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20747*/    OPC_RecordNode, // #10 = $m8
/* 20748*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20749*/    OPC_CheckTypeI32,
/* 20750*/    OPC_MoveSibling, 11,
/* 20752*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20755*/    OPC_RecordNode, // #11 = $m9
/* 20756*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20757*/    OPC_CheckTypeI32,
/* 20758*/    OPC_MoveSibling, 12,
/* 20760*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20763*/    OPC_RecordNode, // #12 = $mA
/* 20764*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20765*/    OPC_CheckTypeI32,
/* 20766*/    OPC_MoveSibling, 13,
/* 20768*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20771*/    OPC_RecordNode, // #13 = $mB
/* 20772*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20773*/    OPC_CheckTypeI32,
/* 20774*/    OPC_MoveSibling, 14,
/* 20776*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20779*/    OPC_RecordNode, // #14 = $mC
/* 20780*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20781*/    OPC_CheckTypeI32,
/* 20782*/    OPC_MoveSibling, 15,
/* 20784*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20787*/    OPC_RecordNode, // #15 = $mD
/* 20788*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20789*/    OPC_CheckTypeI32,
/* 20790*/    OPC_MoveSibling, 16,
/* 20792*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20795*/    OPC_RecordNode, // #16 = $mE
/* 20796*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20797*/    OPC_CheckTypeI32,
/* 20798*/    OPC_MoveSibling, 17,
/* 20800*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20803*/    OPC_RecordNode, // #17 = $mF
/* 20804*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20805*/    OPC_CheckTypeI32,
/* 20806*/    OPC_MoveParent,
/* 20807*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20810*/    OPC_EmitConvertToTarget2, // #18
/* 20811*/    OPC_EmitConvertToTarget3, // #19
/* 20812*/    OPC_EmitConvertToTarget4, // #20
/* 20813*/    OPC_EmitConvertToTarget5, // #21
/* 20814*/    OPC_EmitConvertToTarget6, // #22
/* 20815*/    OPC_EmitConvertToTarget7, // #23
/* 20816*/    OPC_EmitConvertToTarget, 8, // #24
/* 20818*/    OPC_EmitConvertToTarget, 9, // #25
/* 20820*/    OPC_EmitConvertToTarget, 10, // #26
/* 20822*/    OPC_EmitConvertToTarget, 11, // #27
/* 20824*/    OPC_EmitConvertToTarget, 12, // #28
/* 20826*/    OPC_EmitConvertToTarget, 13, // #29
/* 20828*/    OPC_EmitConvertToTarget, 14, // #30
/* 20830*/    OPC_EmitConvertToTarget, 15, // #31
/* 20832*/    OPC_EmitConvertToTarget, 16, // #32
/* 20834*/    OPC_EmitConvertToTarget, 17, // #33
/* 20836*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20860*/   /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::TargetConstant),// ->21019
/* 20864*/    OPC_CheckTypeI32,
/* 20865*/    OPC_MoveSibling3,
/* 20866*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20869*/    OPC_RecordNode, // #3 = $m1
/* 20870*/    OPC_CheckTypeI32,
/* 20871*/    OPC_MoveSibling4,
/* 20872*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20875*/    OPC_RecordNode, // #4 = $m2
/* 20876*/    OPC_CheckTypeI32,
/* 20877*/    OPC_MoveSibling5,
/* 20878*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20881*/    OPC_RecordNode, // #5 = $m3
/* 20882*/    OPC_CheckTypeI32,
/* 20883*/    OPC_MoveSibling6,
/* 20884*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20887*/    OPC_RecordNode, // #6 = $m4
/* 20888*/    OPC_CheckTypeI32,
/* 20889*/    OPC_MoveSibling7,
/* 20890*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20893*/    OPC_RecordNode, // #7 = $m5
/* 20894*/    OPC_CheckTypeI32,
/* 20895*/    OPC_MoveSibling, 8,
/* 20897*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20900*/    OPC_RecordNode, // #8 = $m6
/* 20901*/    OPC_CheckTypeI32,
/* 20902*/    OPC_MoveSibling, 9,
/* 20904*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20907*/    OPC_RecordNode, // #9 = $m7
/* 20908*/    OPC_CheckTypeI32,
/* 20909*/    OPC_MoveSibling, 10,
/* 20911*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20914*/    OPC_RecordNode, // #10 = $m8
/* 20915*/    OPC_CheckTypeI32,
/* 20916*/    OPC_MoveSibling, 11,
/* 20918*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20921*/    OPC_RecordNode, // #11 = $m9
/* 20922*/    OPC_CheckTypeI32,
/* 20923*/    OPC_MoveSibling, 12,
/* 20925*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20928*/    OPC_RecordNode, // #12 = $mA
/* 20929*/    OPC_CheckTypeI32,
/* 20930*/    OPC_MoveSibling, 13,
/* 20932*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20935*/    OPC_RecordNode, // #13 = $mB
/* 20936*/    OPC_CheckTypeI32,
/* 20937*/    OPC_MoveSibling, 14,
/* 20939*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20942*/    OPC_RecordNode, // #14 = $mC
/* 20943*/    OPC_CheckTypeI32,
/* 20944*/    OPC_MoveSibling, 15,
/* 20946*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20949*/    OPC_RecordNode, // #15 = $mD
/* 20950*/    OPC_CheckTypeI32,
/* 20951*/    OPC_MoveSibling, 16,
/* 20953*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20956*/    OPC_RecordNode, // #16 = $mE
/* 20957*/    OPC_CheckTypeI32,
/* 20958*/    OPC_MoveSibling, 17,
/* 20960*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20963*/    OPC_RecordNode, // #17 = $mF
/* 20964*/    OPC_CheckTypeI32,
/* 20965*/    OPC_MoveParent,
/* 20966*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20969*/    OPC_EmitConvertToTarget2, // #18
/* 20970*/    OPC_EmitConvertToTarget3, // #19
/* 20971*/    OPC_EmitConvertToTarget4, // #20
/* 20972*/    OPC_EmitConvertToTarget5, // #21
/* 20973*/    OPC_EmitConvertToTarget6, // #22
/* 20974*/    OPC_EmitConvertToTarget7, // #23
/* 20975*/    OPC_EmitConvertToTarget, 8, // #24
/* 20977*/    OPC_EmitConvertToTarget, 9, // #25
/* 20979*/    OPC_EmitConvertToTarget, 10, // #26
/* 20981*/    OPC_EmitConvertToTarget, 11, // #27
/* 20983*/    OPC_EmitConvertToTarget, 12, // #28
/* 20985*/    OPC_EmitConvertToTarget, 13, // #29
/* 20987*/    OPC_EmitConvertToTarget, 14, // #30
/* 20989*/    OPC_EmitConvertToTarget, 15, // #31
/* 20991*/    OPC_EmitConvertToTarget, 16, // #32
/* 20993*/    OPC_EmitConvertToTarget, 17, // #33
/* 20995*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21019*/   0, // EndSwitchOpcode
/* 21020*/  /*Scope*/ 83|128,2/*339*/, /*->21361*/
/* 21022*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 21024*/   OPC_RecordChild1, // #1 = $y
/* 21025*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 21027*/   OPC_RecordChild2, // #2 = $m0
/* 21028*/   OPC_MoveChild2,
/* 21029*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->21203
/* 21034*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21035*/    OPC_CheckTypeI32,
/* 21036*/    OPC_MoveSibling3,
/* 21037*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21040*/    OPC_RecordNode, // #3 = $m1
/* 21041*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21042*/    OPC_CheckTypeI32,
/* 21043*/    OPC_MoveSibling4,
/* 21044*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21047*/    OPC_RecordNode, // #4 = $m2
/* 21048*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21049*/    OPC_CheckTypeI32,
/* 21050*/    OPC_MoveSibling5,
/* 21051*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21054*/    OPC_RecordNode, // #5 = $m3
/* 21055*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21056*/    OPC_CheckTypeI32,
/* 21057*/    OPC_MoveSibling6,
/* 21058*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21061*/    OPC_RecordNode, // #6 = $m4
/* 21062*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21063*/    OPC_CheckTypeI32,
/* 21064*/    OPC_MoveSibling7,
/* 21065*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21068*/    OPC_RecordNode, // #7 = $m5
/* 21069*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21070*/    OPC_CheckTypeI32,
/* 21071*/    OPC_MoveSibling, 8,
/* 21073*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21076*/    OPC_RecordNode, // #8 = $m6
/* 21077*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21078*/    OPC_CheckTypeI32,
/* 21079*/    OPC_MoveSibling, 9,
/* 21081*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21084*/    OPC_RecordNode, // #9 = $m7
/* 21085*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21086*/    OPC_CheckTypeI32,
/* 21087*/    OPC_MoveSibling, 10,
/* 21089*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21092*/    OPC_RecordNode, // #10 = $m8
/* 21093*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21094*/    OPC_CheckTypeI32,
/* 21095*/    OPC_MoveSibling, 11,
/* 21097*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21100*/    OPC_RecordNode, // #11 = $m9
/* 21101*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21102*/    OPC_CheckTypeI32,
/* 21103*/    OPC_MoveSibling, 12,
/* 21105*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21108*/    OPC_RecordNode, // #12 = $mA
/* 21109*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21110*/    OPC_CheckTypeI32,
/* 21111*/    OPC_MoveSibling, 13,
/* 21113*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21116*/    OPC_RecordNode, // #13 = $mB
/* 21117*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21118*/    OPC_CheckTypeI32,
/* 21119*/    OPC_MoveSibling, 14,
/* 21121*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21124*/    OPC_RecordNode, // #14 = $mC
/* 21125*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21126*/    OPC_CheckTypeI32,
/* 21127*/    OPC_MoveSibling, 15,
/* 21129*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21132*/    OPC_RecordNode, // #15 = $mD
/* 21133*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21134*/    OPC_CheckTypeI32,
/* 21135*/    OPC_MoveSibling, 16,
/* 21137*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21140*/    OPC_RecordNode, // #16 = $mE
/* 21141*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21142*/    OPC_CheckTypeI32,
/* 21143*/    OPC_MoveSibling, 17,
/* 21145*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21148*/    OPC_RecordNode, // #17 = $mF
/* 21149*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 21150*/    OPC_CheckTypeI32,
/* 21151*/    OPC_MoveParent,
/* 21152*/    OPC_CheckType, /*MVT::v8f16*/92, 
/* 21154*/    OPC_EmitConvertToTarget2, // #18
/* 21155*/    OPC_EmitConvertToTarget3, // #19
/* 21156*/    OPC_EmitConvertToTarget4, // #20
/* 21157*/    OPC_EmitConvertToTarget5, // #21
/* 21158*/    OPC_EmitConvertToTarget6, // #22
/* 21159*/    OPC_EmitConvertToTarget7, // #23
/* 21160*/    OPC_EmitConvertToTarget, 8, // #24
/* 21162*/    OPC_EmitConvertToTarget, 9, // #25
/* 21164*/    OPC_EmitConvertToTarget, 10, // #26
/* 21166*/    OPC_EmitConvertToTarget, 11, // #27
/* 21168*/    OPC_EmitConvertToTarget, 12, // #28
/* 21170*/    OPC_EmitConvertToTarget, 13, // #29
/* 21172*/    OPC_EmitConvertToTarget, 14, // #30
/* 21174*/    OPC_EmitConvertToTarget, 15, // #31
/* 21176*/    OPC_EmitConvertToTarget, 16, // #32
/* 21178*/    OPC_EmitConvertToTarget, 17, // #33
/* 21180*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8f16*/92, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8f16] } V128:{ *:[v8f16] }:$x, V128:{ *:[v8f16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8f16] } ?:{ *:[v8f16] }:$x, ?:{ *:[v8f16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21203*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->21360
/* 21207*/    OPC_CheckTypeI32,
/* 21208*/    OPC_MoveSibling3,
/* 21209*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21212*/    OPC_RecordNode, // #3 = $m1
/* 21213*/    OPC_CheckTypeI32,
/* 21214*/    OPC_MoveSibling4,
/* 21215*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21218*/    OPC_RecordNode, // #4 = $m2
/* 21219*/    OPC_CheckTypeI32,
/* 21220*/    OPC_MoveSibling5,
/* 21221*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21224*/    OPC_RecordNode, // #5 = $m3
/* 21225*/    OPC_CheckTypeI32,
/* 21226*/    OPC_MoveSibling6,
/* 21227*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21230*/    OPC_RecordNode, // #6 = $m4
/* 21231*/    OPC_CheckTypeI32,
/* 21232*/    OPC_MoveSibling7,
/* 21233*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21236*/    OPC_RecordNode, // #7 = $m5
/* 21237*/    OPC_CheckTypeI32,
/* 21238*/    OPC_MoveSibling, 8,
/* 21240*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21243*/    OPC_RecordNode, // #8 = $m6
/* 21244*/    OPC_CheckTypeI32,
/* 21245*/    OPC_MoveSibling, 9,
/* 21247*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21250*/    OPC_RecordNode, // #9 = $m7
/* 21251*/    OPC_CheckTypeI32,
/* 21252*/    OPC_MoveSibling, 10,
/* 21254*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21257*/    OPC_RecordNode, // #10 = $m8
/* 21258*/    OPC_CheckTypeI32,
/* 21259*/    OPC_MoveSibling, 11,
/* 21261*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21264*/    OPC_RecordNode, // #11 = $m9
/* 21265*/    OPC_CheckTypeI32,
/* 21266*/    OPC_MoveSibling, 12,
/* 21268*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21271*/    OPC_RecordNode, // #12 = $mA
/* 21272*/    OPC_CheckTypeI32,
/* 21273*/    OPC_MoveSibling, 13,
/* 21275*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21278*/    OPC_RecordNode, // #13 = $mB
/* 21279*/    OPC_CheckTypeI32,
/* 21280*/    OPC_MoveSibling, 14,
/* 21282*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21285*/    OPC_RecordNode, // #14 = $mC
/* 21286*/    OPC_CheckTypeI32,
/* 21287*/    OPC_MoveSibling, 15,
/* 21289*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21292*/    OPC_RecordNode, // #15 = $mD
/* 21293*/    OPC_CheckTypeI32,
/* 21294*/    OPC_MoveSibling, 16,
/* 21296*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21299*/    OPC_RecordNode, // #16 = $mE
/* 21300*/    OPC_CheckTypeI32,
/* 21301*/    OPC_MoveSibling, 17,
/* 21303*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 21306*/    OPC_RecordNode, // #17 = $mF
/* 21307*/    OPC_CheckTypeI32,
/* 21308*/    OPC_MoveParent,
/* 21309*/    OPC_CheckType, /*MVT::v8f16*/92, 
/* 21311*/    OPC_EmitConvertToTarget2, // #18
/* 21312*/    OPC_EmitConvertToTarget3, // #19
/* 21313*/    OPC_EmitConvertToTarget4, // #20
/* 21314*/    OPC_EmitConvertToTarget5, // #21
/* 21315*/    OPC_EmitConvertToTarget6, // #22
/* 21316*/    OPC_EmitConvertToTarget7, // #23
/* 21317*/    OPC_EmitConvertToTarget, 8, // #24
/* 21319*/    OPC_EmitConvertToTarget, 9, // #25
/* 21321*/    OPC_EmitConvertToTarget, 10, // #26
/* 21323*/    OPC_EmitConvertToTarget, 11, // #27
/* 21325*/    OPC_EmitConvertToTarget, 12, // #28
/* 21327*/    OPC_EmitConvertToTarget, 13, // #29
/* 21329*/    OPC_EmitConvertToTarget, 14, // #30
/* 21331*/    OPC_EmitConvertToTarget, 15, // #31
/* 21333*/    OPC_EmitConvertToTarget, 16, // #32
/* 21335*/    OPC_EmitConvertToTarget, 17, // #33
/* 21337*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8f16*/92, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8f16] } V128:{ *:[v8f16] }:$x, V128:{ *:[v8f16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8f16] } ?:{ *:[v8f16] }:$x, ?:{ *:[v8f16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 21360*/   0, // EndSwitchOpcode
/* 21361*/  0, /*End of Scope*/
/* 21362*/ /*SwitchOpcode*/ 73|128,8/*1097*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->22463
/* 21366*/  OPC_Scope, 6|128,1/*134*/, /*->21503*/ // 2 children in Scope
/* 21369*/   OPC_MoveChild0,
/* 21370*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21373*/   OPC_CheckChild0Integer, 0, 
/* 21375*/   OPC_Scope, 62, /*->21439*/ // 2 children in Scope
/* 21377*/    OPC_CheckChild0TypeI32,
/* 21378*/    OPC_MoveSibling1,
/* 21379*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21382*/    OPC_RecordMemRef,
/* 21383*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21384*/    OPC_CheckFoldableChainNode,
/* 21385*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21386*/    OPC_CheckTypeI32,
/* 21387*/    OPC_Scope, 24, /*->21413*/ // 2 children in Scope
/* 21389*/     OPC_CheckChild1TypeI32,
/* 21390*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21392*/     OPC_CheckPredicate6,  // Predicate_load
/* 21393*/     OPC_MoveParent,
/* 21394*/     OPC_CheckChild2Integer, 0, 
/* 21396*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 21398*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21399*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21401*/     OPC_EmitMergeInputChains1_0,
/* 21402*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21404*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21413*/    /*Scope*/ 24, /*->21438*/
/* 21414*/     OPC_CheckChild1TypeI64,
/* 21415*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21417*/     OPC_CheckPredicate6,  // Predicate_load
/* 21418*/     OPC_MoveParent,
/* 21419*/     OPC_CheckChild2Integer, 0, 
/* 21421*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 21423*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21424*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21426*/     OPC_EmitMergeInputChains1_0,
/* 21427*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21429*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21438*/    0, /*End of Scope*/
/* 21439*/   /*Scope*/ 62, /*->21502*/
/* 21440*/    OPC_CheckChild0TypeI64,
/* 21441*/    OPC_MoveSibling1,
/* 21442*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21445*/    OPC_RecordMemRef,
/* 21446*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 21447*/    OPC_CheckFoldableChainNode,
/* 21448*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 21449*/    OPC_CheckTypeI64,
/* 21450*/    OPC_Scope, 24, /*->21476*/ // 2 children in Scope
/* 21452*/     OPC_CheckChild1TypeI32,
/* 21453*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21455*/     OPC_CheckPredicate6,  // Predicate_load
/* 21456*/     OPC_MoveParent,
/* 21457*/     OPC_CheckChild2Integer, 0, 
/* 21459*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 21461*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21462*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 21464*/     OPC_EmitMergeInputChains1_0,
/* 21465*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21467*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 21476*/    /*Scope*/ 24, /*->21501*/
/* 21477*/     OPC_CheckChild1TypeI64,
/* 21478*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21480*/     OPC_CheckPredicate6,  // Predicate_load
/* 21481*/     OPC_MoveParent,
/* 21482*/     OPC_CheckChild2Integer, 0, 
/* 21484*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 21486*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21487*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 21489*/     OPC_EmitMergeInputChains1_0,
/* 21490*/     OPC_EmitInteger32, 0,  // 0 #4
/* 21492*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 21501*/    0, /*End of Scope*/
/* 21502*/   0, /*End of Scope*/
/* 21503*/  /*Scope*/ 61|128,7/*957*/, /*->22462*/
/* 21505*/   OPC_RecordChild0, // #0 = $vec
/* 21506*/   OPC_Scope, 32|128,3/*416*/, /*->21925*/ // 4 children in Scope
/* 21509*/    OPC_MoveChild1,
/* 21510*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21513*/    OPC_RecordMemRef,
/* 21514*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21515*/    OPC_CheckFoldableChainNode,
/* 21516*/    OPC_RecordChild1, // #2 = $addr
/* 21517*/    OPC_Scope, 73|128,1/*201*/, /*->21721*/ // 2 children in Scope
/* 21520*/     OPC_CheckChild1TypeI32,
/* 21521*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21523*/     OPC_Scope, 67, /*->21592*/ // 2 children in Scope
/* 21525*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21527*/      OPC_CheckTypeI32,
/* 21528*/      OPC_Scope, 30, /*->21560*/ // 2 children in Scope
/* 21530*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21531*/       OPC_MoveSibling2,
/* 21532*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21535*/       OPC_RecordNode, // #3 = $idx
/* 21536*/       OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/* 21538*/       OPC_CheckTypeI32,
/* 21539*/       OPC_MoveParent,
/* 21540*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21542*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21543*/       OPC_EmitMergeInputChains1_1,
/* 21544*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21546*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21548*/       OPC_EmitConvertToTarget3, // #6
/* 21549*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21560*/      /*Scope*/ 30, /*->21591*/
/* 21561*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21562*/       OPC_MoveSibling2,
/* 21563*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21566*/       OPC_RecordNode, // #3 = $idx
/* 21567*/       OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 21569*/       OPC_CheckTypeI32,
/* 21570*/       OPC_MoveParent,
/* 21571*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21573*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21574*/       OPC_EmitMergeInputChains1_1,
/* 21575*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21577*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21579*/       OPC_EmitConvertToTarget3, // #6
/* 21580*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21591*/      0, /*End of Scope*/
/* 21592*/     /*Scope*/ 127, /*->21720*/
/* 21593*/      OPC_CheckPredicate6,  // Predicate_load
/* 21594*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21626
/* 21597*/       OPC_MoveSibling2,
/* 21598*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21601*/       OPC_RecordNode, // #3 = $idx
/* 21602*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21604*/       OPC_CheckTypeI32,
/* 21605*/       OPC_MoveParent,
/* 21606*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21608*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21609*/       OPC_EmitMergeInputChains1_1,
/* 21610*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21612*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21614*/       OPC_EmitConvertToTarget3, // #6
/* 21615*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21626*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21657
/* 21628*/       OPC_MoveSibling2,
/* 21629*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21632*/       OPC_RecordNode, // #3 = $idx
/* 21633*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21635*/       OPC_CheckTypeI32,
/* 21636*/       OPC_MoveParent,
/* 21637*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21639*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21640*/       OPC_EmitMergeInputChains1_1,
/* 21641*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21643*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21645*/       OPC_EmitConvertToTarget3, // #6
/* 21646*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21657*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21688
/* 21659*/       OPC_MoveSibling2,
/* 21660*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21663*/       OPC_RecordNode, // #3 = $idx
/* 21664*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21666*/       OPC_CheckTypeI32,
/* 21667*/       OPC_MoveParent,
/* 21668*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21670*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21671*/       OPC_EmitMergeInputChains1_1,
/* 21672*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21674*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21676*/       OPC_EmitConvertToTarget3, // #6
/* 21677*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21688*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21719
/* 21690*/       OPC_MoveSibling2,
/* 21691*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21694*/       OPC_RecordNode, // #3 = $idx
/* 21695*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21697*/       OPC_CheckTypeI32,
/* 21698*/       OPC_MoveParent,
/* 21699*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21701*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21702*/       OPC_EmitMergeInputChains1_1,
/* 21703*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21705*/       OPC_EmitInteger32, 0,  // 0 #5
/* 21707*/       OPC_EmitConvertToTarget3, // #6
/* 21708*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21719*/      0, // EndSwitchType
/* 21720*/     0, /*End of Scope*/
/* 21721*/    /*Scope*/ 73|128,1/*201*/, /*->21924*/
/* 21723*/     OPC_CheckChild1TypeI64,
/* 21724*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21726*/     OPC_Scope, 67, /*->21795*/ // 2 children in Scope
/* 21728*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21730*/      OPC_CheckTypeI32,
/* 21731*/      OPC_Scope, 30, /*->21763*/ // 2 children in Scope
/* 21733*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21734*/       OPC_MoveSibling2,
/* 21735*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21738*/       OPC_RecordNode, // #3 = $idx
/* 21739*/       OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/* 21741*/       OPC_CheckTypeI32,
/* 21742*/       OPC_MoveParent,
/* 21743*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21745*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21746*/       OPC_EmitMergeInputChains1_1,
/* 21747*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21749*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21751*/       OPC_EmitConvertToTarget3, // #6
/* 21752*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21763*/      /*Scope*/ 30, /*->21794*/
/* 21764*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21765*/       OPC_MoveSibling2,
/* 21766*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21769*/       OPC_RecordNode, // #3 = $idx
/* 21770*/       OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 21772*/       OPC_CheckTypeI32,
/* 21773*/       OPC_MoveParent,
/* 21774*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21776*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21777*/       OPC_EmitMergeInputChains1_1,
/* 21778*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21780*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21782*/       OPC_EmitConvertToTarget3, // #6
/* 21783*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21794*/      0, /*End of Scope*/
/* 21795*/     /*Scope*/ 127, /*->21923*/
/* 21796*/      OPC_CheckPredicate6,  // Predicate_load
/* 21797*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21829
/* 21800*/       OPC_MoveSibling2,
/* 21801*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21804*/       OPC_RecordNode, // #3 = $idx
/* 21805*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21807*/       OPC_CheckTypeI32,
/* 21808*/       OPC_MoveParent,
/* 21809*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21811*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21812*/       OPC_EmitMergeInputChains1_1,
/* 21813*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21815*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21817*/       OPC_EmitConvertToTarget3, // #6
/* 21818*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21829*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21860
/* 21831*/       OPC_MoveSibling2,
/* 21832*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21835*/       OPC_RecordNode, // #3 = $idx
/* 21836*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21838*/       OPC_CheckTypeI32,
/* 21839*/       OPC_MoveParent,
/* 21840*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21842*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21843*/       OPC_EmitMergeInputChains1_1,
/* 21844*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21846*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21848*/       OPC_EmitConvertToTarget3, // #6
/* 21849*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21860*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21891
/* 21862*/       OPC_MoveSibling2,
/* 21863*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21866*/       OPC_RecordNode, // #3 = $idx
/* 21867*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21869*/       OPC_CheckTypeI32,
/* 21870*/       OPC_MoveParent,
/* 21871*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21873*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21874*/       OPC_EmitMergeInputChains1_1,
/* 21875*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21877*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21879*/       OPC_EmitConvertToTarget3, // #6
/* 21880*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21891*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21922
/* 21893*/       OPC_MoveSibling2,
/* 21894*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21897*/       OPC_RecordNode, // #3 = $idx
/* 21898*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21900*/       OPC_CheckTypeI32,
/* 21901*/       OPC_MoveParent,
/* 21902*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21904*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21905*/       OPC_EmitMergeInputChains1_1,
/* 21906*/       OPC_EmitInteger32, 0,  // 0 #4
/* 21908*/       OPC_EmitInteger64, 0,  // 0 #5
/* 21910*/       OPC_EmitConvertToTarget3, // #6
/* 21911*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21922*/      0, // EndSwitchType
/* 21923*/     0, /*End of Scope*/
/* 21924*/    0, /*End of Scope*/
/* 21925*/   /*Scope*/ 24|128,1/*152*/, /*->22079*/
/* 21927*/    OPC_RecordChild1, // #1 = $x
/* 21928*/    OPC_Scope, 104, /*->22034*/ // 2 children in Scope
/* 21930*/     OPC_CheckChild1TypeI32,
/* 21931*/     OPC_Scope, 56, /*->21989*/ // 2 children in Scope
/* 21933*/      OPC_RecordChild2, // #2 = $idx
/* 21934*/      OPC_MoveChild2,
/* 21935*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21938*/      OPC_CheckTypeI32,
/* 21939*/      OPC_Scope, 15, /*->21956*/ // 3 children in Scope
/* 21941*/       OPC_CheckPredicate, 20, // Predicate_LaneIdx16
/* 21943*/       OPC_MoveParent,
/* 21944*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21946*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21947*/       OPC_EmitConvertToTarget2, // #3
/* 21948*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21956*/      /*Scope*/ 15, /*->21972*/
/* 21957*/       OPC_CheckPredicate, 14, // Predicate_LaneIdx8
/* 21959*/       OPC_MoveParent,
/* 21960*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21962*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21963*/       OPC_EmitConvertToTarget2, // #3
/* 21964*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21972*/      /*Scope*/ 15, /*->21988*/
/* 21973*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21975*/       OPC_MoveParent,
/* 21976*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21978*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21979*/       OPC_EmitConvertToTarget2, // #3
/* 21980*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21988*/      0, /*End of Scope*/
/* 21989*/     /*Scope*/ 43, /*->22033*/
/* 21990*/      OPC_MoveChild2,
/* 21991*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21994*/      OPC_MoveParent,
/* 21995*/      OPC_SwitchType /*3 cases */, 10, /*MVT::v16i8*/39, // ->22008
/* 21998*/       OPC_EmitInteger32, 0,  // 0 #2
/* 22000*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22008*/      /*SwitchType*/ 10, /*MVT::v8i16*/50, // ->22020
/* 22010*/       OPC_EmitInteger32, 0,  // 0 #2
/* 22012*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22020*/      /*SwitchType*/ 10, /*MVT::v4i32*/60, // ->22032
/* 22022*/       OPC_EmitInteger32, 0,  // 0 #2
/* 22024*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 22032*/      0, // EndSwitchType
/* 22033*/     0, /*End of Scope*/
/* 22034*/    /*Scope*/ 43, /*->22078*/
/* 22035*/     OPC_CheckChild1TypeI64,
/* 22036*/     OPC_Scope, 21, /*->22059*/ // 2 children in Scope
/* 22038*/      OPC_RecordChild2, // #2 = $idx
/* 22039*/      OPC_MoveChild2,
/* 22040*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22043*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22045*/      OPC_CheckTypeI32,
/* 22046*/      OPC_MoveParent,
/* 22047*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22049*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22050*/      OPC_EmitConvertToTarget2, // #3
/* 22051*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 22059*/     /*Scope*/ 17, /*->22077*/
/* 22060*/      OPC_MoveChild2,
/* 22061*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22064*/      OPC_MoveParent,
/* 22065*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22067*/      OPC_EmitInteger32, 0,  // 0 #2
/* 22069*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 22077*/     0, /*End of Scope*/
/* 22078*/    0, /*End of Scope*/
/* 22079*/   /*Scope*/ 26|128,2/*282*/, /*->22363*/
/* 22081*/    OPC_MoveChild1,
/* 22082*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22085*/    OPC_RecordMemRef,
/* 22086*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 22087*/    OPC_CheckFoldableChainNode,
/* 22088*/    OPC_RecordChild1, // #2 = $addr
/* 22089*/    OPC_Scope, 6|128,1/*134*/, /*->22226*/ // 2 children in Scope
/* 22092*/     OPC_CheckChild1TypeI32,
/* 22093*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22095*/     OPC_CheckPredicate6,  // Predicate_load
/* 22096*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->22128
/* 22099*/      OPC_MoveSibling2,
/* 22100*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22103*/      OPC_RecordNode, // #3 = $idx
/* 22104*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22106*/      OPC_CheckTypeI32,
/* 22107*/      OPC_MoveParent,
/* 22108*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22110*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22111*/      OPC_EmitMergeInputChains1_1,
/* 22112*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22114*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22116*/      OPC_EmitConvertToTarget3, // #6
/* 22117*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22128*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->22159
/* 22130*/      OPC_MoveSibling2,
/* 22131*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22134*/      OPC_RecordNode, // #3 = $idx
/* 22135*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22137*/      OPC_CheckTypeI32,
/* 22138*/      OPC_MoveParent,
/* 22139*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22141*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22142*/      OPC_EmitMergeInputChains1_1,
/* 22143*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22145*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22147*/      OPC_EmitConvertToTarget3, // #6
/* 22148*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22159*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->22192
/* 22161*/      OPC_MoveSibling2,
/* 22162*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22165*/      OPC_RecordNode, // #3 = $idx
/* 22166*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22168*/      OPC_CheckTypeI32,
/* 22169*/      OPC_MoveParent,
/* 22170*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22173*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22174*/      OPC_EmitMergeInputChains1_1,
/* 22175*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22177*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22179*/      OPC_EmitConvertToTarget3, // #6
/* 22180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22192*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->22225
/* 22194*/      OPC_MoveSibling2,
/* 22195*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22198*/      OPC_RecordNode, // #3 = $idx
/* 22199*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22201*/      OPC_CheckTypeI32,
/* 22202*/      OPC_MoveParent,
/* 22203*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22206*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22207*/      OPC_EmitMergeInputChains1_1,
/* 22208*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22210*/      OPC_EmitInteger32, 0,  // 0 #5
/* 22212*/      OPC_EmitConvertToTarget3, // #6
/* 22213*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22225*/     0, // EndSwitchType
/* 22226*/    /*Scope*/ 6|128,1/*134*/, /*->22362*/
/* 22228*/     OPC_CheckChild1TypeI64,
/* 22229*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22231*/     OPC_CheckPredicate6,  // Predicate_load
/* 22232*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->22264
/* 22235*/      OPC_MoveSibling2,
/* 22236*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22239*/      OPC_RecordNode, // #3 = $idx
/* 22240*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22242*/      OPC_CheckTypeI32,
/* 22243*/      OPC_MoveParent,
/* 22244*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22246*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22247*/      OPC_EmitMergeInputChains1_1,
/* 22248*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22250*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22252*/      OPC_EmitConvertToTarget3, // #6
/* 22253*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22264*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->22295
/* 22266*/      OPC_MoveSibling2,
/* 22267*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22270*/      OPC_RecordNode, // #3 = $idx
/* 22271*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22273*/      OPC_CheckTypeI32,
/* 22274*/      OPC_MoveParent,
/* 22275*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22277*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22278*/      OPC_EmitMergeInputChains1_1,
/* 22279*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22281*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22283*/      OPC_EmitConvertToTarget3, // #6
/* 22284*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 22295*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->22328
/* 22297*/      OPC_MoveSibling2,
/* 22298*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22301*/      OPC_RecordNode, // #3 = $idx
/* 22302*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22304*/      OPC_CheckTypeI32,
/* 22305*/      OPC_MoveParent,
/* 22306*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22309*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22310*/      OPC_EmitMergeInputChains1_1,
/* 22311*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22313*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22315*/      OPC_EmitConvertToTarget3, // #6
/* 22316*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22328*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->22361
/* 22330*/      OPC_MoveSibling2,
/* 22331*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22334*/      OPC_RecordNode, // #3 = $idx
/* 22335*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22337*/      OPC_CheckTypeI32,
/* 22338*/      OPC_MoveParent,
/* 22339*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22342*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22343*/      OPC_EmitMergeInputChains1_1,
/* 22344*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22346*/      OPC_EmitInteger64, 0,  // 0 #5
/* 22348*/      OPC_EmitConvertToTarget3, // #6
/* 22349*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 22361*/     0, // EndSwitchType
/* 22362*/    0, /*End of Scope*/
/* 22363*/   /*Scope*/ 97, /*->22461*/
/* 22364*/    OPC_RecordChild1, // #1 = $x
/* 22365*/    OPC_Scope, 44, /*->22411*/ // 2 children in Scope
/* 22367*/     OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 22369*/     OPC_Scope, 21, /*->22392*/ // 2 children in Scope
/* 22371*/      OPC_RecordChild2, // #2 = $idx
/* 22372*/      OPC_MoveChild2,
/* 22373*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22376*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 22378*/      OPC_CheckTypeI32,
/* 22379*/      OPC_MoveParent,
/* 22380*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22382*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22383*/      OPC_EmitConvertToTarget2, // #3
/* 22384*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 22392*/     /*Scope*/ 17, /*->22410*/
/* 22393*/      OPC_MoveChild2,
/* 22394*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22397*/      OPC_MoveParent,
/* 22398*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 22400*/      OPC_EmitInteger32, 0,  // 0 #2
/* 22402*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 22410*/     0, /*End of Scope*/
/* 22411*/    /*Scope*/ 48, /*->22460*/
/* 22412*/     OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 22414*/     OPC_Scope, 23, /*->22439*/ // 2 children in Scope
/* 22416*/      OPC_RecordChild2, // #2 = $idx
/* 22417*/      OPC_MoveChild2,
/* 22418*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22421*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 22423*/      OPC_CheckTypeI32,
/* 22424*/      OPC_MoveParent,
/* 22425*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22428*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22429*/      OPC_EmitConvertToTarget2, // #3
/* 22430*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 22439*/     /*Scope*/ 19, /*->22459*/
/* 22440*/      OPC_MoveChild2,
/* 22441*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 22444*/      OPC_MoveParent,
/* 22445*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22448*/      OPC_EmitInteger32, 0,  // 0 #2
/* 22450*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 22459*/     0, /*End of Scope*/
/* 22460*/    0, /*End of Scope*/
/* 22461*/   0, /*End of Scope*/
/* 22462*/  0, /*End of Scope*/
/* 22463*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22691
/* 22467*/  OPC_Scope, 87, /*->22556*/ // 2 children in Scope
/* 22469*/   OPC_MoveChild0,
/* 22470*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22473*/   OPC_MoveChild0,
/* 22474*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->22515
/* 22478*/    OPC_RecordChild0, // #0 = $lhs
/* 22479*/    OPC_RecordChild1, // #1 = $rhs
/* 22480*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22482*/    OPC_MoveSibling1,
/* 22483*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 22486*/    OPC_CheckChild0Integer, 2, 
/* 22488*/    OPC_CheckChild0TypeI32,
/* 22489*/    OPC_MoveParent,
/* 22490*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22492*/    OPC_MoveParent,
/* 22493*/    OPC_CheckChild1Integer, 2, 
/* 22495*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22505
/* 22498*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22505*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22514
/* 22507*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22514*/    0, // EndSwitchType
/* 22515*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22555
/* 22518*/    OPC_CheckChild0Integer, 2, 
/* 22520*/    OPC_CheckChild0TypeI32,
/* 22521*/    OPC_MoveSibling1,
/* 22522*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22525*/    OPC_RecordChild0, // #0 = $lhs
/* 22526*/    OPC_RecordChild1, // #1 = $rhs
/* 22527*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22529*/    OPC_MoveParent,
/* 22530*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22532*/    OPC_MoveParent,
/* 22533*/    OPC_CheckChild1Integer, 2, 
/* 22535*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22545
/* 22538*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22545*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22554
/* 22547*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22554*/    0, // EndSwitchType
/* 22555*/   0, // EndSwitchOpcode
/* 22556*/  /*Scope*/ 4|128,1/*132*/, /*->22690*/
/* 22558*/   OPC_RecordChild0, // #0 = $lhs
/* 22559*/   OPC_Scope, 84, /*->22645*/ // 2 children in Scope
/* 22561*/    OPC_MoveChild1,
/* 22562*/    OPC_Scope, 24, /*->22588*/ // 5 children in Scope
/* 22564*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22567*/     OPC_MoveChild0,
/* 22568*/     OPC_CheckAndImm, 63, 
/* 22570*/     OPC_RecordChild0, // #1 = $rhs
/* 22571*/     OPC_MoveParent,
/* 22572*/     OPC_MoveParent,
/* 22573*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22575*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 22581*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22588*/    /*Scope*/ 13, /*->22602*/
/* 22589*/     OPC_CheckAndImm, 7, 
/* 22591*/     OPC_RecordChild0, // #1 = $rhs
/* 22592*/     OPC_MoveParent,
/* 22593*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 22595*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22602*/    /*Scope*/ 13, /*->22616*/
/* 22603*/     OPC_CheckAndImm, 15, 
/* 22605*/     OPC_RecordChild0, // #1 = $rhs
/* 22606*/     OPC_MoveParent,
/* 22607*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 22609*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22616*/    /*Scope*/ 13, /*->22630*/
/* 22617*/     OPC_CheckAndImm, 31, 
/* 22619*/     OPC_RecordChild0, // #1 = $rhs
/* 22620*/     OPC_MoveParent,
/* 22621*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22623*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22630*/    /*Scope*/ 13, /*->22644*/
/* 22631*/     OPC_CheckAndImm, 63, 
/* 22633*/     OPC_RecordChild0, // #1 = $rhs
/* 22634*/     OPC_MoveParent,
/* 22635*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22637*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22644*/    0, /*End of Scope*/
/* 22645*/   /*Scope*/ 43, /*->22689*/
/* 22646*/    OPC_RecordChild1, // #1 = $x
/* 22647*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->22658
/* 22650*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22651*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22658*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->22668
/* 22660*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22661*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22668*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->22678
/* 22670*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22671*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22678*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->22688
/* 22680*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22681*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22688*/    0, // EndSwitchType
/* 22689*/   0, /*End of Scope*/
/* 22690*/  0, /*End of Scope*/
/* 22691*/ /*SwitchOpcode*/ 22|128,4/*534*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->23229
/* 22695*/  OPC_Scope, 73|128,1/*201*/, /*->22899*/ // 4 children in Scope
/* 22698*/   OPC_MoveChild0,
/* 22699*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22702*/   OPC_RecordMemRef,
/* 22703*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22704*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22705*/   OPC_Scope, 95, /*->22802*/ // 2 children in Scope
/* 22707*/    OPC_CheckChild1TypeI32,
/* 22708*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22710*/    OPC_Scope, 45, /*->22757*/ // 2 children in Scope
/* 22712*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22714*/     OPC_CheckTypeI32,
/* 22715*/     OPC_Scope, 19, /*->22736*/ // 2 children in Scope
/* 22717*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22718*/      OPC_MoveParent,
/* 22719*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22721*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22722*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22724*/      OPC_EmitMergeInputChains1_0,
/* 22725*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22727*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22736*/     /*Scope*/ 19, /*->22756*/
/* 22737*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22738*/      OPC_MoveParent,
/* 22739*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22741*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22742*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22744*/      OPC_EmitMergeInputChains1_0,
/* 22745*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22747*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22756*/     0, /*End of Scope*/
/* 22757*/    /*Scope*/ 43, /*->22801*/
/* 22758*/     OPC_CheckPredicate6,  // Predicate_load
/* 22759*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22780
/* 22762*/      OPC_MoveParent,
/* 22763*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22765*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22766*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22768*/      OPC_EmitMergeInputChains1_0,
/* 22769*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22771*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22780*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22800
/* 22782*/      OPC_MoveParent,
/* 22783*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22785*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22786*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22788*/      OPC_EmitMergeInputChains1_0,
/* 22789*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22791*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22800*/     0, // EndSwitchType
/* 22801*/    0, /*End of Scope*/
/* 22802*/   /*Scope*/ 95, /*->22898*/
/* 22803*/    OPC_CheckChild1TypeI64,
/* 22804*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22806*/    OPC_Scope, 45, /*->22853*/ // 2 children in Scope
/* 22808*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22810*/     OPC_CheckTypeI32,
/* 22811*/     OPC_Scope, 19, /*->22832*/ // 2 children in Scope
/* 22813*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22814*/      OPC_MoveParent,
/* 22815*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22817*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22818*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22820*/      OPC_EmitMergeInputChains1_0,
/* 22821*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22823*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22832*/     /*Scope*/ 19, /*->22852*/
/* 22833*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22834*/      OPC_MoveParent,
/* 22835*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22837*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22838*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22840*/      OPC_EmitMergeInputChains1_0,
/* 22841*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22843*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22852*/     0, /*End of Scope*/
/* 22853*/    /*Scope*/ 43, /*->22897*/
/* 22854*/     OPC_CheckPredicate6,  // Predicate_load
/* 22855*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22876
/* 22858*/      OPC_MoveParent,
/* 22859*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22861*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22862*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22864*/      OPC_EmitMergeInputChains1_0,
/* 22865*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22867*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22876*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22896
/* 22878*/      OPC_MoveParent,
/* 22879*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22881*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22882*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22884*/      OPC_EmitMergeInputChains1_0,
/* 22885*/      OPC_EmitInteger32, 0,  // 0 #4
/* 22887*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22896*/     0, // EndSwitchType
/* 22897*/    0, /*End of Scope*/
/* 22898*/   0, /*End of Scope*/
/* 22899*/  /*Scope*/ 20|128,1/*148*/, /*->23049*/
/* 22901*/   OPC_RecordChild0, // #0 = $x
/* 22902*/   OPC_Scope, 102, /*->23006*/ // 3 children in Scope
/* 22904*/    OPC_MoveChild0,
/* 22905*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22908*/    OPC_SwitchType /*2 cases */, 80, /*MVT::i32*/7, // ->22991
/* 22911*/     OPC_MoveParent,
/* 22912*/     OPC_SwitchType /*3 cases */, 37, /*MVT::v16i8*/39, // ->22952
/* 22915*/      OPC_EmitConvertToTarget0, // #1
/* 22916*/      OPC_EmitConvertToTarget0, // #2
/* 22917*/      OPC_EmitConvertToTarget0, // #3
/* 22918*/      OPC_EmitConvertToTarget0, // #4
/* 22919*/      OPC_EmitConvertToTarget0, // #5
/* 22920*/      OPC_EmitConvertToTarget0, // #6
/* 22921*/      OPC_EmitConvertToTarget0, // #7
/* 22922*/      OPC_EmitConvertToTarget0, // #8
/* 22923*/      OPC_EmitConvertToTarget0, // #9
/* 22924*/      OPC_EmitConvertToTarget0, // #10
/* 22925*/      OPC_EmitConvertToTarget0, // #11
/* 22926*/      OPC_EmitConvertToTarget0, // #12
/* 22927*/      OPC_EmitConvertToTarget0, // #13
/* 22928*/      OPC_EmitConvertToTarget0, // #14
/* 22929*/      OPC_EmitConvertToTarget0, // #15
/* 22930*/      OPC_EmitConvertToTarget0, // #16
/* 22931*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    /*MVT::v16i8*/39, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22952*/     /*SwitchType*/ 21, /*MVT::v8i16*/50, // ->22975
/* 22954*/      OPC_EmitConvertToTarget0, // #1
/* 22955*/      OPC_EmitConvertToTarget0, // #2
/* 22956*/      OPC_EmitConvertToTarget0, // #3
/* 22957*/      OPC_EmitConvertToTarget0, // #4
/* 22958*/      OPC_EmitConvertToTarget0, // #5
/* 22959*/      OPC_EmitConvertToTarget0, // #6
/* 22960*/      OPC_EmitConvertToTarget0, // #7
/* 22961*/      OPC_EmitConvertToTarget0, // #8
/* 22962*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    /*MVT::v8i16*/50, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22975*/     /*SwitchType*/ 13, /*MVT::v4i32*/60, // ->22990
/* 22977*/      OPC_EmitConvertToTarget0, // #1
/* 22978*/      OPC_EmitConvertToTarget0, // #2
/* 22979*/      OPC_EmitConvertToTarget0, // #3
/* 22980*/      OPC_EmitConvertToTarget0, // #4
/* 22981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    /*MVT::v4i32*/60, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22990*/     0, // EndSwitchType
/* 22991*/    /*SwitchType*/ 12, /*MVT::i64*/8, // ->23005
/* 22993*/     OPC_MoveParent,
/* 22994*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22996*/     OPC_EmitConvertToTarget0, // #1
/* 22997*/     OPC_EmitConvertToTarget0, // #2
/* 22998*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 23005*/    0, // EndSwitchType
/* 23006*/   /*Scope*/ 30, /*->23037*/
/* 23007*/    OPC_CheckChild0TypeI32,
/* 23008*/    OPC_SwitchType /*3 cases */, 7, /*MVT::v16i8*/39, // ->23018
/* 23011*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23012*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 23018*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->23027
/* 23020*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23021*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 23027*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->23036
/* 23029*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23030*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 23036*/    0, // EndSwitchType
/* 23037*/   /*Scope*/ 10, /*->23048*/
/* 23038*/    OPC_CheckChild0TypeI64,
/* 23039*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23041*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23042*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 23048*/   0, /*End of Scope*/
/* 23049*/  /*Scope*/ 107, /*->23157*/
/* 23050*/   OPC_MoveChild0,
/* 23051*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23054*/   OPC_RecordMemRef,
/* 23055*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23056*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23057*/   OPC_Scope, 48, /*->23107*/ // 2 children in Scope
/* 23059*/    OPC_CheckChild1TypeI32,
/* 23060*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23062*/    OPC_CheckPredicate6,  // Predicate_load
/* 23063*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23084
/* 23066*/     OPC_MoveParent,
/* 23067*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23069*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23070*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23072*/     OPC_EmitMergeInputChains1_0,
/* 23073*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23075*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23084*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23106
/* 23086*/     OPC_MoveParent,
/* 23087*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23090*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23091*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23093*/     OPC_EmitMergeInputChains1_0,
/* 23094*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23096*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23106*/    0, // EndSwitchType
/* 23107*/   /*Scope*/ 48, /*->23156*/
/* 23108*/    OPC_CheckChild1TypeI64,
/* 23109*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23111*/    OPC_CheckPredicate6,  // Predicate_load
/* 23112*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23133
/* 23115*/     OPC_MoveParent,
/* 23116*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23118*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23119*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23121*/     OPC_EmitMergeInputChains1_0,
/* 23122*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23124*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23133*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23155
/* 23135*/     OPC_MoveParent,
/* 23136*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23139*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23140*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23142*/     OPC_EmitMergeInputChains1_0,
/* 23143*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23145*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23155*/    0, // EndSwitchType
/* 23156*/   0, /*End of Scope*/
/* 23157*/  /*Scope*/ 70, /*->23228*/
/* 23158*/   OPC_RecordChild0, // #0 = $x
/* 23159*/   OPC_Scope, 40, /*->23201*/ // 3 children in Scope
/* 23161*/    OPC_MoveChild0,
/* 23162*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 23165*/    OPC_SwitchType /*2 cases */, 16, /*MVT::f32*/12, // ->23184
/* 23168*/     OPC_MoveParent,
/* 23169*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23171*/     OPC_EmitConvertToTarget0, // #1
/* 23172*/     OPC_EmitConvertToTarget0, // #2
/* 23173*/     OPC_EmitConvertToTarget0, // #3
/* 23174*/     OPC_EmitConvertToTarget0, // #4
/* 23175*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   /*MVT::v4f32*/111, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 23184*/    /*SwitchType*/ 14, /*MVT::f64*/13, // ->23200
/* 23186*/     OPC_MoveParent,
/* 23187*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23190*/     OPC_EmitConvertToTarget0, // #1
/* 23191*/     OPC_EmitConvertToTarget0, // #2
/* 23192*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 23200*/    0, // EndSwitchType
/* 23201*/   /*Scope*/ 11, /*->23213*/
/* 23202*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 23204*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 23206*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23207*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 23213*/   /*Scope*/ 13, /*->23227*/
/* 23214*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 23216*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23219*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23220*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 23227*/   0, /*End of Scope*/
/* 23228*/  0, /*End of Scope*/
/* 23229*/ /*SwitchOpcode*/ 26|128,2/*282*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->23515
/* 23233*/  OPC_Scope, 103, /*->23338*/ // 4 children in Scope
/* 23235*/   OPC_MoveChild0,
/* 23236*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23239*/   OPC_RecordMemRef,
/* 23240*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23241*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23242*/   OPC_Scope, 46, /*->23290*/ // 2 children in Scope
/* 23244*/    OPC_CheckChild1TypeI32,
/* 23245*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23247*/    OPC_CheckPredicate6,  // Predicate_load
/* 23248*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->23269
/* 23251*/     OPC_MoveParent,
/* 23252*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 23254*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23255*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23257*/     OPC_EmitMergeInputChains1_0,
/* 23258*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23260*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23269*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->23289
/* 23271*/     OPC_MoveParent,
/* 23272*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 23274*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23275*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23277*/     OPC_EmitMergeInputChains1_0,
/* 23278*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23280*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23289*/    0, // EndSwitchType
/* 23290*/   /*Scope*/ 46, /*->23337*/
/* 23291*/    OPC_CheckChild1TypeI64,
/* 23292*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23294*/    OPC_CheckPredicate6,  // Predicate_load
/* 23295*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->23316
/* 23298*/     OPC_MoveParent,
/* 23299*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 23301*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23302*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23304*/     OPC_EmitMergeInputChains1_0,
/* 23305*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23307*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23316*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->23336
/* 23318*/     OPC_MoveParent,
/* 23319*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 23321*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23322*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23324*/     OPC_EmitMergeInputChains1_0,
/* 23325*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23327*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23336*/    0, // EndSwitchType
/* 23337*/   0, /*End of Scope*/
/* 23338*/  /*Scope*/ 41, /*->23380*/
/* 23339*/   OPC_RecordChild0, // #0 = $x
/* 23340*/   OPC_Scope, 27, /*->23369*/ // 2 children in Scope
/* 23342*/    OPC_CheckChild0TypeI32,
/* 23343*/    OPC_SwitchType /*3 cases */, 6, /*MVT::v16i8*/39, // ->23352
/* 23346*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 23352*/    /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->23360
/* 23354*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 23360*/    /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->23368
/* 23362*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 23368*/    0, // EndSwitchType
/* 23369*/   /*Scope*/ 9, /*->23379*/
/* 23370*/    OPC_CheckChild0TypeI64,
/* 23371*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23373*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 23379*/   0, /*End of Scope*/
/* 23380*/  /*Scope*/ 107, /*->23488*/
/* 23381*/   OPC_MoveChild0,
/* 23382*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 23385*/   OPC_RecordMemRef,
/* 23386*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 23387*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 23388*/   OPC_Scope, 48, /*->23438*/ // 2 children in Scope
/* 23390*/    OPC_CheckChild1TypeI32,
/* 23391*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23393*/    OPC_CheckPredicate6,  // Predicate_load
/* 23394*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23415
/* 23397*/     OPC_MoveParent,
/* 23398*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23400*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23401*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23403*/     OPC_EmitMergeInputChains1_0,
/* 23404*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23406*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23415*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23437
/* 23417*/     OPC_MoveParent,
/* 23418*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23421*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 23422*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 23424*/     OPC_EmitMergeInputChains1_0,
/* 23425*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23427*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 23437*/    0, // EndSwitchType
/* 23438*/   /*Scope*/ 48, /*->23487*/
/* 23439*/    OPC_CheckChild1TypeI64,
/* 23440*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 23442*/    OPC_CheckPredicate6,  // Predicate_load
/* 23443*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->23464
/* 23446*/     OPC_MoveParent,
/* 23447*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23449*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23450*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23452*/     OPC_EmitMergeInputChains1_0,
/* 23453*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23455*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23464*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->23486
/* 23466*/     OPC_MoveParent,
/* 23467*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23470*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 23471*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 23473*/     OPC_EmitMergeInputChains1_0,
/* 23474*/     OPC_EmitInteger32, 0,  // 0 #4
/* 23476*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 23486*/    0, // EndSwitchType
/* 23487*/   0, /*End of Scope*/
/* 23488*/  /*Scope*/ 25, /*->23514*/
/* 23489*/   OPC_RecordChild0, // #0 = $x
/* 23490*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->23501
/* 23493*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 23495*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 23501*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->23513
/* 23504*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 23506*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 23513*/   0, // EndSwitchType
/* 23514*/  0, /*End of Scope*/
/* 23515*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23651
/* 23519*/  OPC_RecordChild0, // #0 = $lhs
/* 23520*/  OPC_Scope, 84, /*->23606*/ // 2 children in Scope
/* 23522*/   OPC_MoveChild1,
/* 23523*/   OPC_Scope, 24, /*->23549*/ // 5 children in Scope
/* 23525*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23528*/    OPC_MoveChild0,
/* 23529*/    OPC_CheckAndImm, 63, 
/* 23531*/    OPC_RecordChild0, // #1 = $rhs
/* 23532*/    OPC_MoveParent,
/* 23533*/    OPC_MoveParent,
/* 23534*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23536*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23542*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23549*/   /*Scope*/ 13, /*->23563*/
/* 23550*/    OPC_CheckAndImm, 7, 
/* 23552*/    OPC_RecordChild0, // #1 = $rhs
/* 23553*/    OPC_MoveParent,
/* 23554*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23556*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23563*/   /*Scope*/ 13, /*->23577*/
/* 23564*/    OPC_CheckAndImm, 15, 
/* 23566*/    OPC_RecordChild0, // #1 = $rhs
/* 23567*/    OPC_MoveParent,
/* 23568*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23570*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23577*/   /*Scope*/ 13, /*->23591*/
/* 23578*/    OPC_CheckAndImm, 31, 
/* 23580*/    OPC_RecordChild0, // #1 = $rhs
/* 23581*/    OPC_MoveParent,
/* 23582*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23584*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23591*/   /*Scope*/ 13, /*->23605*/
/* 23592*/    OPC_CheckAndImm, 63, 
/* 23594*/    OPC_RecordChild0, // #1 = $rhs
/* 23595*/    OPC_MoveParent,
/* 23596*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23598*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23605*/   0, /*End of Scope*/
/* 23606*/  /*Scope*/ 43, /*->23650*/
/* 23607*/   OPC_RecordChild1, // #1 = $x
/* 23608*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23619
/* 23611*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23612*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23619*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23629
/* 23621*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23622*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23629*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23639
/* 23631*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23639*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23649
/* 23641*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23642*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23649*/   0, // EndSwitchType
/* 23650*/  0, /*End of Scope*/
/* 23651*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23787
/* 23655*/  OPC_RecordChild0, // #0 = $lhs
/* 23656*/  OPC_Scope, 84, /*->23742*/ // 2 children in Scope
/* 23658*/   OPC_MoveChild1,
/* 23659*/   OPC_Scope, 24, /*->23685*/ // 5 children in Scope
/* 23661*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23664*/    OPC_MoveChild0,
/* 23665*/    OPC_CheckAndImm, 63, 
/* 23667*/    OPC_RecordChild0, // #1 = $rhs
/* 23668*/    OPC_MoveParent,
/* 23669*/    OPC_MoveParent,
/* 23670*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23672*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23678*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23685*/   /*Scope*/ 13, /*->23699*/
/* 23686*/    OPC_CheckAndImm, 7, 
/* 23688*/    OPC_RecordChild0, // #1 = $rhs
/* 23689*/    OPC_MoveParent,
/* 23690*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23692*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23699*/   /*Scope*/ 13, /*->23713*/
/* 23700*/    OPC_CheckAndImm, 15, 
/* 23702*/    OPC_RecordChild0, // #1 = $rhs
/* 23703*/    OPC_MoveParent,
/* 23704*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23706*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23713*/   /*Scope*/ 13, /*->23727*/
/* 23714*/    OPC_CheckAndImm, 31, 
/* 23716*/    OPC_RecordChild0, // #1 = $rhs
/* 23717*/    OPC_MoveParent,
/* 23718*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23720*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23727*/   /*Scope*/ 13, /*->23741*/
/* 23728*/    OPC_CheckAndImm, 63, 
/* 23730*/    OPC_RecordChild0, // #1 = $rhs
/* 23731*/    OPC_MoveParent,
/* 23732*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23734*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23741*/   0, /*End of Scope*/
/* 23742*/  /*Scope*/ 43, /*->23786*/
/* 23743*/   OPC_RecordChild1, // #1 = $x
/* 23744*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23755
/* 23747*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23748*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23755*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23765
/* 23757*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23758*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23765*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23775
/* 23767*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23768*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23775*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23785
/* 23777*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23778*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23785*/   0, // EndSwitchType
/* 23786*/  0, /*End of Scope*/
/* 23787*/ /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::VSELECT),// ->24881
/* 23791*/  OPC_Scope, 13|128,1/*141*/, /*->23935*/ // 4 children in Scope
/* 23794*/   OPC_MoveChild0,
/* 23795*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23798*/   OPC_MoveChild0,
/* 23799*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23802*/   OPC_RecordChild0, // #0 = $rhs
/* 23803*/   OPC_SwitchType /*3 cases */, 41, /*MVT::v4f32*/111, // ->23847
/* 23806*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23808*/    OPC_MoveSibling1,
/* 23809*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23812*/    OPC_RecordChild0, // #1 = $lhs
/* 23813*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23815*/    OPC_MoveParent,
/* 23816*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23818*/    OPC_MoveParent,
/* 23819*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23821*/    OPC_Scope, 11, /*->23834*/ // 2 children in Scope
/* 23823*/     OPC_CheckChild1Same, 0,
/* 23825*/     OPC_CheckChild2Same, 1,
/* 23827*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23834*/    /*Scope*/ 11, /*->23846*/
/* 23835*/     OPC_CheckChild1Same, 1,
/* 23837*/     OPC_CheckChild2Same, 0,
/* 23839*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23846*/    0, /*End of Scope*/
/* 23847*/   /*SwitchType*/ 41, /*MVT::v2f64*/1|128,1/*129*/, // ->23891
/* 23850*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23852*/    OPC_MoveSibling1,
/* 23853*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23856*/    OPC_RecordChild0, // #1 = $lhs
/* 23857*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23859*/    OPC_MoveParent,
/* 23860*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23862*/    OPC_MoveParent,
/* 23863*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23865*/    OPC_Scope, 11, /*->23878*/ // 2 children in Scope
/* 23867*/     OPC_CheckChild1Same, 0,
/* 23869*/     OPC_CheckChild2Same, 1,
/* 23871*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23878*/    /*Scope*/ 11, /*->23890*/
/* 23879*/     OPC_CheckChild1Same, 1,
/* 23881*/     OPC_CheckChild2Same, 0,
/* 23883*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23890*/    0, /*End of Scope*/
/* 23891*/   /*SwitchType*/ 41, /*MVT::v8f16*/92, // ->23934
/* 23893*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23895*/    OPC_MoveSibling1,
/* 23896*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23899*/    OPC_RecordChild0, // #1 = $lhs
/* 23900*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23902*/    OPC_MoveParent,
/* 23903*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23905*/    OPC_MoveParent,
/* 23906*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23908*/    OPC_Scope, 11, /*->23921*/ // 2 children in Scope
/* 23910*/     OPC_CheckChild1Same, 0,
/* 23912*/     OPC_CheckChild2Same, 1,
/* 23914*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23921*/    /*Scope*/ 11, /*->23933*/
/* 23922*/     OPC_CheckChild1Same, 1,
/* 23924*/     OPC_CheckChild2Same, 0,
/* 23926*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23933*/    0, /*End of Scope*/
/* 23934*/   0, // EndSwitchType
/* 23935*/  /*Scope*/ 45, /*->23981*/
/* 23936*/   OPC_RecordChild0, // #0 = $c
/* 23937*/   OPC_RecordChild1, // #1 = $v1
/* 23938*/   OPC_RecordChild2, // #2 = $v2
/* 23939*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23950
/* 23942*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23950*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23960
/* 23952*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23960*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23970
/* 23962*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23970*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23980
/* 23972*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23980*/   0, // EndSwitchType
/* 23981*/  /*Scope*/ 101|128,6/*869*/, /*->24852*/
/* 23983*/   OPC_MoveChild0,
/* 23984*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23987*/   OPC_RecordChild0, // #0 = $rhs
/* 23988*/   OPC_Scope, 21|128,2/*277*/, /*->24268*/ // 3 children in Scope
/* 23991*/    OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 23993*/    OPC_RecordChild1, // #1 = $lhs
/* 23994*/    OPC_Scope, 33, /*->24029*/ // 8 children in Scope
/* 23996*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23998*/     OPC_MoveParent,
/* 23999*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24001*/     OPC_Scope, 12, /*->24015*/ // 2 children in Scope
/* 24003*/      OPC_CheckChild1Same, 0,
/* 24005*/      OPC_CheckChild2Same, 1,
/* 24007*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24008*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24015*/     /*Scope*/ 12, /*->24028*/
/* 24016*/      OPC_CheckChild1Same, 1,
/* 24018*/      OPC_CheckChild2Same, 0,
/* 24020*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24021*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24028*/     0, /*End of Scope*/
/* 24029*/    /*Scope*/ 33, /*->24063*/
/* 24030*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24032*/     OPC_MoveParent,
/* 24033*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24035*/     OPC_Scope, 12, /*->24049*/ // 2 children in Scope
/* 24037*/      OPC_CheckChild1Same, 0,
/* 24039*/      OPC_CheckChild2Same, 1,
/* 24041*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24042*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24049*/     /*Scope*/ 12, /*->24062*/
/* 24050*/      OPC_CheckChild1Same, 1,
/* 24052*/      OPC_CheckChild2Same, 0,
/* 24054*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24055*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24062*/     0, /*End of Scope*/
/* 24063*/    /*Scope*/ 33, /*->24097*/
/* 24064*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24066*/     OPC_MoveParent,
/* 24067*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24069*/     OPC_Scope, 12, /*->24083*/ // 2 children in Scope
/* 24071*/      OPC_CheckChild1Same, 1,
/* 24073*/      OPC_CheckChild2Same, 0,
/* 24075*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24076*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24083*/     /*Scope*/ 12, /*->24096*/
/* 24084*/      OPC_CheckChild1Same, 0,
/* 24086*/      OPC_CheckChild2Same, 1,
/* 24088*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24089*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24096*/     0, /*End of Scope*/
/* 24097*/    /*Scope*/ 33, /*->24131*/
/* 24098*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24100*/     OPC_MoveParent,
/* 24101*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24103*/     OPC_Scope, 12, /*->24117*/ // 2 children in Scope
/* 24105*/      OPC_CheckChild1Same, 1,
/* 24107*/      OPC_CheckChild2Same, 0,
/* 24109*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24110*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24117*/     /*Scope*/ 12, /*->24130*/
/* 24118*/      OPC_CheckChild1Same, 0,
/* 24120*/      OPC_CheckChild2Same, 1,
/* 24122*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24123*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24130*/     0, /*End of Scope*/
/* 24131*/    /*Scope*/ 33, /*->24165*/
/* 24132*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24134*/     OPC_MoveParent,
/* 24135*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24137*/     OPC_Scope, 12, /*->24151*/ // 2 children in Scope
/* 24139*/      OPC_CheckChild1Same, 0,
/* 24141*/      OPC_CheckChild2Same, 1,
/* 24143*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24144*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24151*/     /*Scope*/ 12, /*->24164*/
/* 24152*/      OPC_CheckChild1Same, 1,
/* 24154*/      OPC_CheckChild2Same, 0,
/* 24156*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24157*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24164*/     0, /*End of Scope*/
/* 24165*/    /*Scope*/ 33, /*->24199*/
/* 24166*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24168*/     OPC_MoveParent,
/* 24169*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24171*/     OPC_Scope, 12, /*->24185*/ // 2 children in Scope
/* 24173*/      OPC_CheckChild1Same, 0,
/* 24175*/      OPC_CheckChild2Same, 1,
/* 24177*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24178*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24185*/     /*Scope*/ 12, /*->24198*/
/* 24186*/      OPC_CheckChild1Same, 1,
/* 24188*/      OPC_CheckChild2Same, 0,
/* 24190*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24191*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24198*/     0, /*End of Scope*/
/* 24199*/    /*Scope*/ 33, /*->24233*/
/* 24200*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24202*/     OPC_MoveParent,
/* 24203*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24205*/     OPC_Scope, 12, /*->24219*/ // 2 children in Scope
/* 24207*/      OPC_CheckChild1Same, 1,
/* 24209*/      OPC_CheckChild2Same, 0,
/* 24211*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24212*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24219*/     /*Scope*/ 12, /*->24232*/
/* 24220*/      OPC_CheckChild1Same, 0,
/* 24222*/      OPC_CheckChild2Same, 1,
/* 24224*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24225*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24232*/     0, /*End of Scope*/
/* 24233*/    /*Scope*/ 33, /*->24267*/
/* 24234*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24236*/     OPC_MoveParent,
/* 24237*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 24239*/     OPC_Scope, 12, /*->24253*/ // 2 children in Scope
/* 24241*/      OPC_CheckChild1Same, 1,
/* 24243*/      OPC_CheckChild2Same, 0,
/* 24245*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24246*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24253*/     /*Scope*/ 12, /*->24266*/
/* 24254*/      OPC_CheckChild1Same, 0,
/* 24256*/      OPC_CheckChild2Same, 1,
/* 24258*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24259*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 24266*/     0, /*End of Scope*/
/* 24267*/    0, /*End of Scope*/
/* 24268*/   /*Scope*/ 46|128,2/*302*/, /*->24572*/
/* 24270*/    OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24273*/    OPC_RecordChild1, // #1 = $lhs
/* 24274*/    OPC_Scope, 36, /*->24312*/ // 8 children in Scope
/* 24276*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24278*/     OPC_MoveParent,
/* 24279*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24282*/     OPC_Scope, 13, /*->24297*/ // 2 children in Scope
/* 24284*/      OPC_CheckChild1Same, 0,
/* 24286*/      OPC_CheckChild2Same, 1,
/* 24288*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24289*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24297*/     /*Scope*/ 13, /*->24311*/
/* 24298*/      OPC_CheckChild1Same, 1,
/* 24300*/      OPC_CheckChild2Same, 0,
/* 24302*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24303*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24311*/     0, /*End of Scope*/
/* 24312*/    /*Scope*/ 36, /*->24349*/
/* 24313*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24315*/     OPC_MoveParent,
/* 24316*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24319*/     OPC_Scope, 13, /*->24334*/ // 2 children in Scope
/* 24321*/      OPC_CheckChild1Same, 0,
/* 24323*/      OPC_CheckChild2Same, 1,
/* 24325*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24326*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24334*/     /*Scope*/ 13, /*->24348*/
/* 24335*/      OPC_CheckChild1Same, 1,
/* 24337*/      OPC_CheckChild2Same, 0,
/* 24339*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24340*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24348*/     0, /*End of Scope*/
/* 24349*/    /*Scope*/ 36, /*->24386*/
/* 24350*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24352*/     OPC_MoveParent,
/* 24353*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24356*/     OPC_Scope, 13, /*->24371*/ // 2 children in Scope
/* 24358*/      OPC_CheckChild1Same, 1,
/* 24360*/      OPC_CheckChild2Same, 0,
/* 24362*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24363*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24371*/     /*Scope*/ 13, /*->24385*/
/* 24372*/      OPC_CheckChild1Same, 0,
/* 24374*/      OPC_CheckChild2Same, 1,
/* 24376*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24377*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24385*/     0, /*End of Scope*/
/* 24386*/    /*Scope*/ 36, /*->24423*/
/* 24387*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24389*/     OPC_MoveParent,
/* 24390*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24393*/     OPC_Scope, 13, /*->24408*/ // 2 children in Scope
/* 24395*/      OPC_CheckChild1Same, 1,
/* 24397*/      OPC_CheckChild2Same, 0,
/* 24399*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24400*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24408*/     /*Scope*/ 13, /*->24422*/
/* 24409*/      OPC_CheckChild1Same, 0,
/* 24411*/      OPC_CheckChild2Same, 1,
/* 24413*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24414*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24422*/     0, /*End of Scope*/
/* 24423*/    /*Scope*/ 36, /*->24460*/
/* 24424*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24426*/     OPC_MoveParent,
/* 24427*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24430*/     OPC_Scope, 13, /*->24445*/ // 2 children in Scope
/* 24432*/      OPC_CheckChild1Same, 0,
/* 24434*/      OPC_CheckChild2Same, 1,
/* 24436*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24437*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24445*/     /*Scope*/ 13, /*->24459*/
/* 24446*/      OPC_CheckChild1Same, 1,
/* 24448*/      OPC_CheckChild2Same, 0,
/* 24450*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24451*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24459*/     0, /*End of Scope*/
/* 24460*/    /*Scope*/ 36, /*->24497*/
/* 24461*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24463*/     OPC_MoveParent,
/* 24464*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24467*/     OPC_Scope, 13, /*->24482*/ // 2 children in Scope
/* 24469*/      OPC_CheckChild1Same, 0,
/* 24471*/      OPC_CheckChild2Same, 1,
/* 24473*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24474*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24482*/     /*Scope*/ 13, /*->24496*/
/* 24483*/      OPC_CheckChild1Same, 1,
/* 24485*/      OPC_CheckChild2Same, 0,
/* 24487*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24488*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24496*/     0, /*End of Scope*/
/* 24497*/    /*Scope*/ 36, /*->24534*/
/* 24498*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24500*/     OPC_MoveParent,
/* 24501*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24504*/     OPC_Scope, 13, /*->24519*/ // 2 children in Scope
/* 24506*/      OPC_CheckChild1Same, 1,
/* 24508*/      OPC_CheckChild2Same, 0,
/* 24510*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24511*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24519*/     /*Scope*/ 13, /*->24533*/
/* 24520*/      OPC_CheckChild1Same, 0,
/* 24522*/      OPC_CheckChild2Same, 1,
/* 24524*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24525*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24533*/     0, /*End of Scope*/
/* 24534*/    /*Scope*/ 36, /*->24571*/
/* 24535*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24537*/     OPC_MoveParent,
/* 24538*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24541*/     OPC_Scope, 13, /*->24556*/ // 2 children in Scope
/* 24543*/      OPC_CheckChild1Same, 1,
/* 24545*/      OPC_CheckChild2Same, 0,
/* 24547*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24548*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24556*/     /*Scope*/ 13, /*->24570*/
/* 24557*/      OPC_CheckChild1Same, 0,
/* 24559*/      OPC_CheckChild2Same, 1,
/* 24561*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24562*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24570*/     0, /*End of Scope*/
/* 24571*/    0, /*End of Scope*/
/* 24572*/   /*Scope*/ 21|128,2/*277*/, /*->24851*/
/* 24574*/    OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 24576*/    OPC_RecordChild1, // #1 = $lhs
/* 24577*/    OPC_Scope, 33, /*->24612*/ // 8 children in Scope
/* 24579*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24581*/     OPC_MoveParent,
/* 24582*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24584*/     OPC_Scope, 12, /*->24598*/ // 2 children in Scope
/* 24586*/      OPC_CheckChild1Same, 0,
/* 24588*/      OPC_CheckChild2Same, 1,
/* 24590*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24591*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24598*/     /*Scope*/ 12, /*->24611*/
/* 24599*/      OPC_CheckChild1Same, 1,
/* 24601*/      OPC_CheckChild2Same, 0,
/* 24603*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24604*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24611*/     0, /*End of Scope*/
/* 24612*/    /*Scope*/ 33, /*->24646*/
/* 24613*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24615*/     OPC_MoveParent,
/* 24616*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24618*/     OPC_Scope, 12, /*->24632*/ // 2 children in Scope
/* 24620*/      OPC_CheckChild1Same, 0,
/* 24622*/      OPC_CheckChild2Same, 1,
/* 24624*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24625*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24632*/     /*Scope*/ 12, /*->24645*/
/* 24633*/      OPC_CheckChild1Same, 1,
/* 24635*/      OPC_CheckChild2Same, 0,
/* 24637*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24645*/     0, /*End of Scope*/
/* 24646*/    /*Scope*/ 33, /*->24680*/
/* 24647*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24649*/     OPC_MoveParent,
/* 24650*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24652*/     OPC_Scope, 12, /*->24666*/ // 2 children in Scope
/* 24654*/      OPC_CheckChild1Same, 1,
/* 24656*/      OPC_CheckChild2Same, 0,
/* 24658*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24659*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24666*/     /*Scope*/ 12, /*->24679*/
/* 24667*/      OPC_CheckChild1Same, 0,
/* 24669*/      OPC_CheckChild2Same, 1,
/* 24671*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24672*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24679*/     0, /*End of Scope*/
/* 24680*/    /*Scope*/ 33, /*->24714*/
/* 24681*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24683*/     OPC_MoveParent,
/* 24684*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24686*/     OPC_Scope, 12, /*->24700*/ // 2 children in Scope
/* 24688*/      OPC_CheckChild1Same, 1,
/* 24690*/      OPC_CheckChild2Same, 0,
/* 24692*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24693*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24700*/     /*Scope*/ 12, /*->24713*/
/* 24701*/      OPC_CheckChild1Same, 0,
/* 24703*/      OPC_CheckChild2Same, 1,
/* 24705*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24706*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24713*/     0, /*End of Scope*/
/* 24714*/    /*Scope*/ 33, /*->24748*/
/* 24715*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24717*/     OPC_MoveParent,
/* 24718*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24720*/     OPC_Scope, 12, /*->24734*/ // 2 children in Scope
/* 24722*/      OPC_CheckChild1Same, 0,
/* 24724*/      OPC_CheckChild2Same, 1,
/* 24726*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24727*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24734*/     /*Scope*/ 12, /*->24747*/
/* 24735*/      OPC_CheckChild1Same, 1,
/* 24737*/      OPC_CheckChild2Same, 0,
/* 24739*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24740*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24747*/     0, /*End of Scope*/
/* 24748*/    /*Scope*/ 33, /*->24782*/
/* 24749*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24751*/     OPC_MoveParent,
/* 24752*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24754*/     OPC_Scope, 12, /*->24768*/ // 2 children in Scope
/* 24756*/      OPC_CheckChild1Same, 0,
/* 24758*/      OPC_CheckChild2Same, 1,
/* 24760*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24761*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24768*/     /*Scope*/ 12, /*->24781*/
/* 24769*/      OPC_CheckChild1Same, 1,
/* 24771*/      OPC_CheckChild2Same, 0,
/* 24773*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24774*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24781*/     0, /*End of Scope*/
/* 24782*/    /*Scope*/ 33, /*->24816*/
/* 24783*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24785*/     OPC_MoveParent,
/* 24786*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24788*/     OPC_Scope, 12, /*->24802*/ // 2 children in Scope
/* 24790*/      OPC_CheckChild1Same, 1,
/* 24792*/      OPC_CheckChild2Same, 0,
/* 24794*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24795*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24802*/     /*Scope*/ 12, /*->24815*/
/* 24803*/      OPC_CheckChild1Same, 0,
/* 24805*/      OPC_CheckChild2Same, 1,
/* 24807*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24815*/     0, /*End of Scope*/
/* 24816*/    /*Scope*/ 33, /*->24850*/
/* 24817*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24819*/     OPC_MoveParent,
/* 24820*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24822*/     OPC_Scope, 12, /*->24836*/ // 2 children in Scope
/* 24824*/      OPC_CheckChild1Same, 1,
/* 24826*/      OPC_CheckChild2Same, 0,
/* 24828*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24829*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24836*/     /*Scope*/ 12, /*->24849*/
/* 24837*/      OPC_CheckChild1Same, 0,
/* 24839*/      OPC_CheckChild2Same, 1,
/* 24841*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24842*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24849*/     0, /*End of Scope*/
/* 24850*/    0, /*End of Scope*/
/* 24851*/   0, /*End of Scope*/
/* 24852*/  /*Scope*/ 27, /*->24880*/
/* 24853*/   OPC_RecordChild0, // #0 = $c
/* 24854*/   OPC_RecordChild1, // #1 = $v1
/* 24855*/   OPC_RecordChild2, // #2 = $v2
/* 24856*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->24867
/* 24859*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 24867*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->24879
/* 24870*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 24879*/   0, // EndSwitchType
/* 24880*/  0, /*End of Scope*/
/* 24881*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->24900
/* 24884*/  OPC_RecordChild0, // #0 = $src
/* 24885*/  OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24887*/  OPC_RecordChild1, // #1 = $mask
/* 24888*/  OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 24890*/  OPC_CheckType, /*MVT::v16i8*/39, 
/* 24892*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24893*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 24900*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->24942
/* 24903*/  OPC_RecordChild0, // #0 = $v
/* 24904*/  OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->24914
/* 24907*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24908*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 24914*/  /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->24923
/* 24916*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24917*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 24923*/  /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->24932
/* 24925*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24926*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 24932*/  /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->24941
/* 24934*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24935*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 24941*/  0, // EndSwitchType
/* 24942*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->24969
/* 24945*/  OPC_RecordChild0, // #0 = $lhs
/* 24946*/  OPC_RecordChild1, // #1 = $rhs
/* 24947*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24958
/* 24950*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24951*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24958*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24968
/* 24960*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24961*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24968*/  0, // EndSwitchType
/* 24969*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->24996
/* 24972*/  OPC_RecordChild0, // #0 = $lhs
/* 24973*/  OPC_RecordChild1, // #1 = $rhs
/* 24974*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24985
/* 24977*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24978*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24985*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24995
/* 24987*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24988*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24995*/  0, // EndSwitchType
/* 24996*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SSUBSAT),// ->25023
/* 24999*/  OPC_RecordChild0, // #0 = $lhs
/* 25000*/  OPC_RecordChild1, // #1 = $rhs
/* 25001*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->25012
/* 25004*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25012*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25022
/* 25014*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25015*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25022*/  0, // EndSwitchType
/* 25023*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::USUBSAT),// ->25050
/* 25026*/  OPC_RecordChild0, // #0 = $lhs
/* 25027*/  OPC_RecordChild1, // #1 = $rhs
/* 25028*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->25039
/* 25031*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25032*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25039*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25049
/* 25041*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25042*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25049*/  0, // EndSwitchType
/* 25050*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->25087
/* 25053*/  OPC_RecordChild0, // #0 = $lhs
/* 25054*/  OPC_RecordChild1, // #1 = $rhs
/* 25055*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->25066
/* 25058*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25059*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25066*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25076
/* 25068*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25069*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25076*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->25086
/* 25078*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25079*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25086*/  0, // EndSwitchType
/* 25087*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->25124
/* 25090*/  OPC_RecordChild0, // #0 = $lhs
/* 25091*/  OPC_RecordChild1, // #1 = $rhs
/* 25092*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->25103
/* 25095*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25096*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25103*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25113
/* 25105*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25106*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25113*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->25123
/* 25115*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25116*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25123*/  0, // EndSwitchType
/* 25124*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->25161
/* 25127*/  OPC_RecordChild0, // #0 = $lhs
/* 25128*/  OPC_RecordChild1, // #1 = $rhs
/* 25129*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->25140
/* 25132*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25133*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25140*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25150
/* 25142*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25143*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25150*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->25160
/* 25152*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25153*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25160*/  0, // EndSwitchType
/* 25161*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->25198
/* 25164*/  OPC_RecordChild0, // #0 = $lhs
/* 25165*/  OPC_RecordChild1, // #1 = $rhs
/* 25166*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->25177
/* 25169*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25170*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 25177*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->25187
/* 25179*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25180*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 25187*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->25197
/* 25189*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25190*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 25197*/  0, // EndSwitchType
/* 25198*/ /*SwitchOpcode*/ 9, TARGET_VAL(WebAssemblyISD::DOT),// ->25210
/* 25201*/  OPC_RecordChild0, // #0 = $lhs
/* 25202*/  OPC_RecordChild1, // #1 = $rhs
/* 25203*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_dot:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
            // Dst: (DOT:{ *:[v4i32] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 25210*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->25226
/* 25213*/  OPC_RecordChild0, // #0 = $vec
/* 25214*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25217*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 25219*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25220*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25226*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->25242
/* 25229*/  OPC_RecordChild0, // #0 = $vec
/* 25230*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25233*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 25235*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25236*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 25242*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->25281
/* 25245*/  OPC_RecordChild0, // #0 = $vec
/* 25246*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25258
/* 25249*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25251*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25252*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25258*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25269
/* 25260*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25262*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25263*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25269*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25280
/* 25271*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25273*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25274*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25280*/  0, // EndSwitchType
/* 25281*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->25320
/* 25284*/  OPC_RecordChild0, // #0 = $vec
/* 25285*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25297
/* 25288*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25290*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25291*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25297*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25308
/* 25299*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25301*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25302*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25308*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25319
/* 25310*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25312*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25313*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25319*/  0, // EndSwitchType
/* 25320*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->25359
/* 25323*/  OPC_RecordChild0, // #0 = $vec
/* 25324*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25336
/* 25327*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25329*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25330*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25336*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25347
/* 25338*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25340*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25341*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25347*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25358
/* 25349*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25351*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25352*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25358*/  0, // EndSwitchType
/* 25359*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->25398
/* 25362*/  OPC_RecordChild0, // #0 = $vec
/* 25363*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->25375
/* 25366*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 25368*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25369*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 25375*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->25386
/* 25377*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25379*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25380*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 25386*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->25397
/* 25388*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25390*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25391*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 25397*/  0, // EndSwitchType
/* 25398*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->25432
/* 25401*/  OPC_RecordChild0, // #0 = $left
/* 25402*/  OPC_SwitchType /*2 cases */, 12, /*MVT::v16i8*/39, // ->25417
/* 25405*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 25407*/   OPC_RecordChild1, // #1 = $right
/* 25408*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 25410*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 25417*/  /*SwitchType*/ 12, /*MVT::v8i16*/50, // ->25431
/* 25419*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25421*/   OPC_RecordChild1, // #1 = $right
/* 25422*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 25424*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 25431*/  0, // EndSwitchType
/* 25432*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->25449
/* 25435*/  OPC_RecordChild0, // #0 = $vec
/* 25436*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25438*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25441*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25442*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 25449*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->25466
/* 25452*/  OPC_RecordChild0, // #0 = $vec
/* 25453*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 25455*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25458*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25459*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 25466*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->25482
/* 25469*/  OPC_RecordChild0, // #0 = $vec
/* 25470*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25473*/  OPC_CheckType, /*MVT::v4f32*/111, 
/* 25475*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25476*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 25482*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->25499
/* 25485*/  OPC_RecordChild0, // #0 = $vec
/* 25486*/  OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 25488*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 25491*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 25492*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 25499*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 25501 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 362
  // #OPC_RecordNode                           = 329
  // #OPC_RecordChild                          = 763
  // #OPC_RecordMemRef                         = 43
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 299
  // #OPC_MoveSibling                          = 327
  // #OPC_MoveParent                           = 622
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 195
  // #OPC_CheckPatternPredicate                = 769
  // #OPC_CheckPredicate                       = 599
  // #OPC_CheckOpcode                          = 549
  // #OPC_SwitchOpcode                         = 16
  // #OPC_CheckType                            = 608
  // #OPC_SwitchType                           = 184
  // #OPC_CheckChildType                       = 470
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 105
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 165
  // #OPC_CheckValueType                       = 17
  // #OPC_CheckComplexPat                      = 338
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 6
  // #OPC_EmitInteger                          = 388
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 356
  // #OPC_EmitMergeInputChains                 = 459
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 44
  // #OPC_MorphNodeTo                          = 1276

  #undef COVERAGE_IDX_VAL
  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemoryOpt());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasFP16());
  case 17: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 18: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasExceptionHandling());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_aext_8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_load_zext_8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_truncstorei8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_aext_16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_load_zext_16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_truncstorei16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_truncstorei32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_atomic_load_zext
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 14: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 15: {
    // Predicate_atomic_load_aext
    SDNode *N = Node;
    (void)N;
if (cast<AtomicSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 17: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 18: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 19: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 20: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
